/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs
#define yylval          cf_lval
#define yychar          cf_char

/* First part of user prologue.  */
#line 61 "conf/gen_parser.m4"

#line 9 "conf/confbase.Y"
/* Headers from conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/bfd.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from conf/confbase.Y */

static void
check_u16(uint val)
{
  if (val > 0xFFFF)
    cf_error("Value %u out of range (0-65535)", val);
}

#define cf_assert(cond, ...) do { if (!(cond)) cf_error(__VA_ARGS__); } while (0)
static inline void cf_assert_symbol(const struct symbol *sym, uint class) {
  switch (class) {
    case SYM_PROTO: cf_assert(sym->class == SYM_PROTO, "Protocol name required"); break;
    case SYM_TEMPLATE: cf_assert(sym->class == SYM_TEMPLATE, "Protocol template name required"); break;
    case SYM_FUNCTION: cf_assert(sym->class == SYM_FUNCTION, "Function name required"); break;
    case SYM_FILTER: cf_assert(sym->class == SYM_FILTER, "Filter name required"); break;
    case SYM_TABLE: cf_assert(sym->class == SYM_TABLE, "Table name required"); break;
    case SYM_ATTRIBUTE: cf_assert(sym->class == SYM_ATTRIBUTE, "Custom attribute name required"); break;
    case SYM_MPLS_DOMAIN: cf_assert(sym->class == SYM_MPLS_DOMAIN, "MPLS domain name required"); break;
    case SYM_MPLS_RANGE: cf_assert(sym->class == SYM_MPLS_RANGE, "MPLS range name required"); break;
    case SYM_VARIABLE: cf_assert((sym->class & ~0xff) == SYM_VARIABLE, "Variable name required"); break;
    case SYM_CONSTANT: cf_assert((sym->class & ~0xff) == SYM_CONSTANT, "Constant name required"); break;
    default: bug("This shall not happen");
  }
}

#line 9 "conf/flowspec.Y"
/* Headers from conf/flowspec.Y */

#define PARSER 1

#include "nest/bird.h"
#include "lib/flowspec.h"


/* Defines from conf/flowspec.Y */

struct flow_builder *this_flow;


#line 11 "filter/config.Y"
/* Headers from filter/config.Y */

#include "filter/f-inst.h"
#include "filter/data.h"

/* Defines from filter/config.Y */

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }

static struct symbol *this_function;
static struct sym_scope *this_for_scope;

static struct f_method_scope {
  struct f_inst *object;
  struct sym_scope *main;
  struct sym_scope scope;
} f_method_scope_stack[32];
static int f_method_scope_pos = -1;

#define FM  (f_method_scope_stack[f_method_scope_pos])

static inline void f_method_call_start(struct f_inst *object)
{
  if (object->type == T_VOID)
    cf_error("Can't infer type to properly call a method, please assign the value to a variable");
  if (++f_method_scope_pos >= (int) ARRAY_SIZE(f_method_scope_stack))
    cf_error("Too many nested method calls");

  struct sym_scope *scope = f_type_method_scope(object->type);
  if (!scope)
    cf_error("No methods defined for type %s", f_type_name(object->type));

  FM = (struct f_method_scope) {
    .object = object,
    .main = new_config->current_scope,
    .scope = {
      .next = global_root_scope,
      .hash = scope->hash,
      .active = 1,
      .block = 1,
      .readonly = 1,
    },
  };
  new_config->current_scope = &FM.scope;
}

static inline void f_method_call_args(void)
{
  ASSERT_DIE(FM.scope.active);
  FM.scope.active = 0;

  new_config->current_scope = FM.main;
}

static inline void f_method_call_end(void)
{
  ASSERT_DIE(f_method_scope_pos >= 0);
  if (FM.scope.active) {
    ASSERT_DIE(&FM.scope == new_config->current_scope);
    new_config->current_scope = FM.main;

    FM.scope.active = 0;
  }

  f_method_scope_pos--;
}

static int
f_new_var(struct sym_scope *s)
{
  /*
   * - A variable is an offset on vstack from vbase.
   * - Vbase is set on filter start / function call.
   * - Scopes contain (non-frame) block scopes inside filter/function scope
   * - Each scope knows number of vars in that scope
   * - Offset is therefore a sum of 'slots' up to filter/function scope
   * - New variables are added on top of vstk, so intermediate values cannot
   *   be there during FI_VAR_INIT. I.e. no 'var' inside 'term'.
   * - Also, each f_line must always have its scope, otherwise a variable may
   *   be defined but not initialized if relevant f_line is not executed.
   */

  int offset = s->slots++;

  while (s->block)
  {
    s = s->next;
    ASSERT(s);
    offset += s->slots;
  }

  if (offset >= 0xff)
    cf_error("Too many variables, at most 255 allowed");

  return offset;
}

/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
  case T_LC:
  case T_RD:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *lst = NULL;
  int i;

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define CC_ALL 0xFFFF
#define EC_ALL 0xFFFFFFFF
#define LC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if ((kind != EC_GENERIC) && (ipv4_used || (key >= 0x10000))) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static struct f_tree *
f_new_lc_item(u32 f1, u32 t1, u32 f2, u32 t2, u32 f3, u32 t3)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_LC;
  t->from.val.lc = (lcomm) {f1, f2, f3};
  t->to.val.lc = (lcomm) {t1, t2, t3};
  return t;
}

static inline struct f_inst *
f_const_empty(enum f_type t)
{
  switch (t) {
    case T_PATH:
    case T_CLIST:
    case T_ECLIST:
    case T_LCLIST:
      return f_new_inst(FI_CONSTANT, (struct f_val) {
	.type = t,
	.val.ad = &null_adata,
      });
    case T_ROUTE:
      return f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_ROUTE });
    default:
      return f_new_inst(FI_CONSTANT, (struct f_val) {});
  }
}

/*
 * Remove all new lines and doubled whitespaces
 * and convert all tabulators to spaces
 * and return a copy of string
 */
char *
assert_copy_expr(const char *start, size_t len)
{
  /* XXX: Allocates maybe a little more memory than we really finally need */
  char *str = cfg_alloc(len + 1);

  char *dst = str;
  const char *src = start - 1;
  const char *end = start + len;
  while (++src < end)
  {
    if (*src == '\n')
      continue;

    /* Skip doubled whitespaces */
    if (src != start)
    {
      const char *prev = src - 1;
      if ((*src == ' ' || *src == '\t') && (*prev == ' ' || *prev == '\t'))
	continue;
    }

    if (*src == '\t')
      *dst = ' ';
    else
      *dst = *src;

    dst++;
  }
  *dst = '\0';

  return str;
}

/*
 * assert_done - create f_instruction of bt_assert
 * @expr: expression in bt_assert()
 * @start: pointer to first char of test expression
 * @end: pointer to the last char of test expression
 */
static struct f_inst *
assert_done(struct f_inst *expr, const char *start, const char *end)
{
  return f_new_inst(FI_ASSERT, expr,
    (end >= start) ?
      assert_copy_expr(start, end - start + 1)
    : "???");
}

static struct f_inst *
f_lval_getter(struct f_lval *lval)
{
  switch (lval->type) {
    case F_LVAL_VARIABLE:	return f_new_inst(FI_VAR_GET, lval->sym);
    case F_LVAL_SA:		return f_new_inst(FI_RTA_GET, lval->rte, lval->sa);
    case F_LVAL_EA:		return f_new_inst(FI_EA_GET, lval->rte, lval->da);
    default:			bug("Unknown lval type");
  }
}

static struct f_inst *
f_lval_setter(struct f_lval *lval, struct f_inst *expr)
{
  switch (lval->type) {
    case F_LVAL_VARIABLE:	return f_new_inst(FI_VAR_SET, expr, lval->sym);
    case F_LVAL_SA:		return f_new_inst(FI_RTA_SET, expr, lval->sa);
    case F_LVAL_EA:		return f_new_inst(FI_EA_SET, expr, lval->da);
    default:			bug("Unknown lval type");
  }
}

static struct f_inst *
assert_assign(struct f_lval *lval, struct f_inst *expr, const char *start, const char *end)
{
  struct f_inst *setter = f_lval_setter(lval, expr),
		*getter = f_lval_getter(lval);

  struct f_inst *checker = f_new_inst(FI_EQ, expr, getter);
  setter->next = checker;

  return assert_done(setter, start, end);
}

#line 10 "nest/config.Y"
/* Headers from nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "nest/mpls.h"
#include "lib/lists.h"
#include "lib/mac.h"

/* Defines from nest/config.Y */

static struct rtable_config *this_table;
static struct proto_config *this_proto;
static struct channel_config *this_channel;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
/* static struct roa_table_config *this_roa_table; */
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;
static struct bfd_options *this_bfd_opts;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->prefix.type)
      cf_error("Interface name/mask expected, not IP prefix");
}

static inline void
init_password_list(void)
{
   if (!this_p_list) {
      this_p_list = cfg_allocz(sizeof(list));
      init_list(this_p_list);
      password_id = 1;
   }
}

static inline void
init_password(const void *key, uint length, uint id)
{
   this_p_item = cfg_allocz(sizeof (struct password_item));
   this_p_item->password = key;
   this_p_item->length = length;
   this_p_item->genfrom = 0;
   this_p_item->gento = TIME_INFINITY;
   this_p_item->accfrom = 0;
   this_p_item->accto = TIME_INFINITY;
   this_p_item->id = id;
   this_p_item->alg = ALG_UNDEFINED;
   add_tail(this_p_list, &this_p_item->n);
}

static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

static inline void
init_bfd_opts(struct bfd_options **opts)
{
  cf_check_bfd(1);

  if (! *opts)
    *opts = bfd_new_options();
}

static inline void
open_bfd_opts(struct bfd_options **opts)
{
  init_bfd_opts(opts);
  this_bfd_opts = *opts;
}

static inline void
close_bfd_opts(void)
{
  this_bfd_opts = NULL;
}

static void
proto_postconfig(void)
{
  CALL(this_proto->protocol->postconfig, this_proto);
  this_channel = NULL;
  this_proto = NULL;
}


#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

#line 10 "nest/mpls.Y"
/* Headers from nest/mpls.Y */

#include "nest/mpls.h"

/* Defines from nest/mpls.Y */

static struct mpls_domain_config *this_mpls_domain;
static struct mpls_range_config *this_mpls_range;

#define MPLS_CC ((struct mpls_channel_config *) this_channel)

#line 11 "proto/aggregator/config.Y"
/* Headers from proto/aggregator/config.Y */

#include "proto/aggregator/aggregator.h"

/* Defines from proto/aggregator/config.Y */

#define AGGREGATOR_CFG ((struct aggregator_config *) this_proto)
#define AGGR_ITEM_ALLOC ((struct aggr_item_node *) cfg_allocz(sizeof(struct aggr_item_node)))


#line 8 "proto/bfd/config.Y"
/* Headers from proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

#line 13 "proto/babel/config.Y"
/* Headers from proto/babel/config.Y */

#include "proto/babel/babel.h"
#include "nest/iface.h"

/* Defines from proto/babel/config.Y */

#define BABEL_CFG ((struct babel_config *) this_proto)
#define BABEL_IFACE ((struct babel_iface_config *) this_ipatt)

#line 9 "proto/bgp/config.Y"
/* Headers from proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)
#define BGP_CC ((struct bgp_channel_config *) this_channel)

static struct ao_config *this_ao_key;
static struct ao_config **next_ao_key;

#line 10 "proto/l3vpn/config.Y"
/* Headers from proto/l3vpn/config.Y */

#include "proto/l3vpn/l3vpn.h"


/* Defines from proto/l3vpn/config.Y */

#define L3VPN_CFG ((struct l3vpn_config *) this_proto)

static void
f_tree_only_rt(struct f_tree *t)
{
  /* Parsed degenerate trees have link to the last node in t->right */
  t->right = NULL;

  while (t)
  {
    uint type1 = t->from.val.ec >> 48;
    uint type2 = t->to.val.ec >> 48;
    ASSERT(type1 == type2);

    if (!ec_type_is_rt(type1))
      cf_error("Extended community is not route target");

    ASSERT(!t->right);
    t = t->left;
  }
}


#line 10 "proto/mrt/config.Y"
/* Headers from proto/mrt/config.Y */

#include "proto/mrt/mrt.h"

/* Defines from proto/mrt/config.Y */

#define MRT_CFG ((struct mrt_config *) this_proto)

#line 9 "proto/ospf/config.Y"
/* Headers from proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if (ospf_cfg_is_v2() && (ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    cf_warn("Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    cf_warn("Password option without authentication option does not make sense");

  if (ip->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *ip->passwords)
    {
      if (pass->alg && (ip->autype != OSPF_AUTH_CRYPT))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default OSPF crypto algorithms */
      if (!pass->alg && (ip->autype == OSPF_AUTH_CRYPT))
	pass->alg = ospf_cfg_is_v2() ? ALG_MD5 : ALG_HMAC_SHA256;

      if (ospf_cfg_is_v3() && ip->autype && (pass->alg < ALG_HMAC))
	cf_error("Keyed hash algorithms are not allowed, use HMAC algorithms");
    }
  }
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;
  struct ospf_area_config *ac;
  struct ospf_iface_patt *ic;

  /* Define default channel */
  if (! proto_cf_main_channel(this_proto))
  {
    uint net_type = this_proto->net_type = ospf_cfg_is_v2() ? NET_IP4 : NET_IP6;
    channel_config_new(NULL, net_label[net_type], net_type, this_proto);
  }

  /* Propagate global instance ID to interfaces */
  if (cf->instance_id_set)
  {
    WALK_LIST(ac, cf->area_list)
      WALK_LIST(ic, ac->patt_list)
	if (!ic->instance_id_set)
	{ ic->instance_id = cf->instance_id; ic->instance_id_set = 1; }

    WALK_LIST(ic, cf->vlink_list)
      if (!ic->instance_id_set)
      { ic->instance_id = cf->instance_id; ic->instance_id_set = 1; }
  }

  if (ospf_cfg_is_v3())
  {
    uint ipv4 = (this_proto->net_type == NET_IP4);
    uint base = (ipv4 ? 64 : 0) + (cf->af_mc ? 32 : 0);

    /* RFC 5838 - OSPFv3-AF */
    if (cf->af_ext)
    {
      /* RFC 5838 2.1 - instance IDs based on AFs */
      WALK_LIST(ac, cf->area_list)
	WALK_LIST(ic, ac->patt_list)
	{
	  if (!ic->instance_id_set)
	    ic->instance_id = base;
	  else if (ic->instance_id >= 128)
	    cf_warn("Instance ID %d from unassigned/private range", ic->instance_id);
	  else if ((ic->instance_id < base) || (ic->instance_id >= (base + 32)))
	    cf_error("Instance ID %d invalid for given channel type", ic->instance_id);
	}

      /* RFC 5838 2.8 - vlinks limited to IPv6 unicast */
      if ((ipv4 || cf->af_mc) && !EMPTY_LIST(cf->vlink_list))
	cf_error("Vlinks not supported in AFs other than IPv6 unicast");
    }
    else
    {
      if (ipv4 || cf->af_mc)
	cf_error("Different channel type");
    }
  }

  if (EMPTY_LIST(cf->area_list))
    cf_error("No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (proto_cf_main_channel(this_proto)->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%u", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Plaintext authentication not supported in OSPFv3");
}


#line 9 "proto/perf/config.Y"
/* Headers from proto/perf/config.Y */

#include "filter/filter.h"
#include "proto/perf/perf.h"

/* Defines from proto/perf/config.Y */

#define PERF_CFG ((struct perf_config *) this_proto)

#line 9 "proto/pipe/config.Y"
/* Headers from proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

#line 10 "proto/radv/config.Y"
/* Headers from proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */

static inline void
radv_add_to_custom_list(list *l, int type, const struct adata *payload)
{
  if (type < 0 || type > 255) cf_error("RA cusom type must be in range 0-255");
  struct radv_custom_config *cf = cfg_allocz(sizeof(struct radv_custom_config));
  add_tail(l, NODE cf);
  cf->type = type;
  cf->payload = payload;
}

#line 12 "proto/rip/config.Y"
/* Headers from proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


#line 9 "proto/rpki/config.Y"
/* Headers from proto/rpki/config.Y */

#include "proto/rpki/rpki.h"

/* Defines from proto/rpki/config.Y */

#define RPKI_CFG ((struct rpki_config *) this_proto)
#define RPKI_TR_TCP_CFG ((struct rpki_tr_tcp_config *) RPKI_CFG->tr_config.spec)
#define RPKI_TR_SSH_CFG ((struct rpki_tr_ssh_config *) RPKI_CFG->tr_config.spec)

static void
rpki_check_unused_hostname(void)
{
  if (RPKI_CFG->hostname != NULL)
    cf_error("Only one cache server per protocol allowed");
}

static void
rpki_check_unused_transport(void)
{
  if (RPKI_CFG->tr_config.spec != NULL)
    cf_error("At the most one transport per protocol allowed");
}

#line 9 "proto/static/config.Y"
/* Headers from proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_snh;
static struct f_inst *this_srt_cmds, *this_srt_last_cmd;
static uint this_srt_aspa_max;

static struct static_route *
static_nexthop_new(void)
{
  struct static_route *nh = this_srt;

  if (this_snh)
  {
    /* Additional next hop */
    nh = cfg_allocz(sizeof(struct static_route));
    nh->net = this_srt->net;
    this_snh->mp_next = nh;
  }

  nh->dest = RTD_UNICAST;
  nh->mp_head = this_srt;
  return nh;
};

static void
static_route_finish(void)
{
  if (net_type_match(this_srt->net, NB_DEST) == !this_srt->dest)
    cf_error("Unexpected or missing nexthop/type");

  this_srt->cmds = f_linearize(this_srt_cmds, 0);
}

#line 9 "sysdep/linux/netlink.Y"
/* Headers from sysdep/linux/netlink.Y */

#line 9 "sysdep/unix/config.Y"
/* Headers from sysdep/unix/config.Y */

#include "sysdep/unix/unix.h"
#include <stdio.h>

/* Defines from sysdep/unix/config.Y */

static struct log_config *this_log;
static struct cli_config *this_cli_config;

#line 9 "sysdep/unix/krt.Y"
/* Headers from sysdep/unix/krt.Y */

#include "sysdep/unix/krt.h"

/* Defines from sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)
#define KIF_IFACE ((struct kif_iface_config *) this_ipatt)

static void
kif_set_preferred(ip_addr ip)
{
  if (ipa_is_ip4(ip))
    KIF_IFACE->pref_v4 = ip;
  else if (!ipa_is_link_local(ip))
    KIF_IFACE->pref_v6 = ip;
  else
    KIF_IFACE->pref_ll = ip;
}

#line 61 "conf/gen_parser.m4"

#line 1047 "obj/conf/cf-parse.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "cf-parse.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_QUIT = 3,                       /* QUIT  */
  YYSYMBOL_EXIT = 4,                       /* EXIT  */
  YYSYMBOL_HELP = 5,                       /* HELP  */
  YYSYMBOL_END = 6,                        /* END  */
  YYSYMBOL_CLI_MARKER = 7,                 /* CLI_MARKER  */
  YYSYMBOL_INVALID_TOKEN = 8,              /* INVALID_TOKEN  */
  YYSYMBOL_ELSECOL = 9,                    /* ELSECOL  */
  YYSYMBOL_DDOT = 10,                      /* DDOT  */
  YYSYMBOL_GEQ = 11,                       /* GEQ  */
  YYSYMBOL_LEQ = 12,                       /* LEQ  */
  YYSYMBOL_NEQ = 13,                       /* NEQ  */
  YYSYMBOL_AND = 14,                       /* AND  */
  YYSYMBOL_OR = 15,                        /* OR  */
  YYSYMBOL_IMP = 16,                       /* IMP  */
  YYSYMBOL_PO = 17,                        /* PO  */
  YYSYMBOL_PC = 18,                        /* PC  */
  YYSYMBOL_NUM = 19,                       /* NUM  */
  YYSYMBOL_ENUM_TOKEN = 20,                /* ENUM_TOKEN  */
  YYSYMBOL_IP4 = 21,                       /* IP4  */
  YYSYMBOL_IP6 = 22,                       /* IP6  */
  YYSYMBOL_VPN_RD = 23,                    /* VPN_RD  */
  YYSYMBOL_CF_SYM_KNOWN = 24,              /* CF_SYM_KNOWN  */
  YYSYMBOL_CF_SYM_UNDEFINED = 25,          /* CF_SYM_UNDEFINED  */
  YYSYMBOL_CF_SYM_METHOD_BARE = 26,        /* CF_SYM_METHOD_BARE  */
  YYSYMBOL_CF_SYM_METHOD_ARGS = 27,        /* CF_SYM_METHOD_ARGS  */
  YYSYMBOL_TEXT = 28,                      /* TEXT  */
  YYSYMBOL_BYTETEXT = 29,                  /* BYTETEXT  */
  YYSYMBOL_PREFIX_DUMMY = 30,              /* PREFIX_DUMMY  */
  YYSYMBOL_31_ = 31,                       /* '='  */
  YYSYMBOL_32_ = 32,                       /* '<'  */
  YYSYMBOL_33_ = 33,                       /* '>'  */
  YYSYMBOL_34_ = 34,                       /* '~'  */
  YYSYMBOL_NMA = 35,                       /* NMA  */
  YYSYMBOL_36_ = 36,                       /* '+'  */
  YYSYMBOL_37_ = 37,                       /* '-'  */
  YYSYMBOL_38_ = 38,                       /* '*'  */
  YYSYMBOL_39_ = 39,                       /* '/'  */
  YYSYMBOL_40_ = 40,                       /* '%'  */
  YYSYMBOL_41_ = 41,                       /* '!'  */
  YYSYMBOL_42_ = 42,                       /* '.'  */
  YYSYMBOL_DEFINE = 43,                    /* DEFINE  */
  YYSYMBOL_ON = 44,                        /* ON  */
  YYSYMBOL_OFF = 45,                       /* OFF  */
  YYSYMBOL_YES = 46,                       /* YES  */
  YYSYMBOL_NO = 47,                        /* NO  */
  YYSYMBOL_S = 48,                         /* S  */
  YYSYMBOL_MS = 49,                        /* MS  */
  YYSYMBOL_US = 50,                        /* US  */
  YYSYMBOL_PORT = 51,                      /* PORT  */
  YYSYMBOL_VPN = 52,                       /* VPN  */
  YYSYMBOL_MPLS = 53,                      /* MPLS  */
  YYSYMBOL_FROM = 54,                      /* FROM  */
  YYSYMBOL_MAX = 55,                       /* MAX  */
  YYSYMBOL_AS = 56,                        /* AS  */
  YYSYMBOL_57_ = 57,                       /* ';'  */
  YYSYMBOL_58_ = 58,                       /* '('  */
  YYSYMBOL_59_ = 59,                       /* ')'  */
  YYSYMBOL_FLOW4 = 60,                     /* FLOW4  */
  YYSYMBOL_FLOW6 = 61,                     /* FLOW6  */
  YYSYMBOL_DST = 62,                       /* DST  */
  YYSYMBOL_SRC = 63,                       /* SRC  */
  YYSYMBOL_PROTO = 64,                     /* PROTO  */
  YYSYMBOL_NEXT = 65,                      /* NEXT  */
  YYSYMBOL_HEADER = 66,                    /* HEADER  */
  YYSYMBOL_DPORT = 67,                     /* DPORT  */
  YYSYMBOL_SPORT = 68,                     /* SPORT  */
  YYSYMBOL_ICMP = 69,                      /* ICMP  */
  YYSYMBOL_TYPE = 70,                      /* TYPE  */
  YYSYMBOL_CODE = 71,                      /* CODE  */
  YYSYMBOL_TCP = 72,                       /* TCP  */
  YYSYMBOL_FLAGS = 73,                     /* FLAGS  */
  YYSYMBOL_LENGTH = 74,                    /* LENGTH  */
  YYSYMBOL_DSCP = 75,                      /* DSCP  */
  YYSYMBOL_DONT_FRAGMENT = 76,             /* DONT_FRAGMENT  */
  YYSYMBOL_IS_FRAGMENT = 77,               /* IS_FRAGMENT  */
  YYSYMBOL_FIRST_FRAGMENT = 78,            /* FIRST_FRAGMENT  */
  YYSYMBOL_LAST_FRAGMENT = 79,             /* LAST_FRAGMENT  */
  YYSYMBOL_FRAGMENT = 80,                  /* FRAGMENT  */
  YYSYMBOL_LABEL = 81,                     /* LABEL  */
  YYSYMBOL_OFFSET = 82,                    /* OFFSET  */
  YYSYMBOL_83_ = 83,                       /* ','  */
  YYSYMBOL_84_ = 84,                       /* '{'  */
  YYSYMBOL_85_ = 85,                       /* '}'  */
  YYSYMBOL_IN = 86,                        /* IN  */
  YYSYMBOL_FUNCTION = 87,                  /* FUNCTION  */
  YYSYMBOL_PRINT = 88,                     /* PRINT  */
  YYSYMBOL_PRINTN = 89,                    /* PRINTN  */
  YYSYMBOL_UNSET = 90,                     /* UNSET  */
  YYSYMBOL_RETURN = 91,                    /* RETURN  */
  YYSYMBOL_ACCEPT = 92,                    /* ACCEPT  */
  YYSYMBOL_REJECT = 93,                    /* REJECT  */
  YYSYMBOL_ERROR = 94,                     /* ERROR  */
  YYSYMBOL_INT = 95,                       /* INT  */
  YYSYMBOL_BOOL = 96,                      /* BOOL  */
  YYSYMBOL_IP = 97,                        /* IP  */
  YYSYMBOL_PREFIX = 98,                    /* PREFIX  */
  YYSYMBOL_RD = 99,                        /* RD  */
  YYSYMBOL_PAIR = 100,                     /* PAIR  */
  YYSYMBOL_QUAD = 101,                     /* QUAD  */
  YYSYMBOL_EC = 102,                       /* EC  */
  YYSYMBOL_LC = 103,                       /* LC  */
  YYSYMBOL_ENUM = 104,                     /* ENUM  */
  YYSYMBOL_SET = 105,                      /* SET  */
  YYSYMBOL_STRING = 106,                   /* STRING  */
  YYSYMBOL_BYTESTRING = 107,               /* BYTESTRING  */
  YYSYMBOL_BGPMASK = 108,                  /* BGPMASK  */
  YYSYMBOL_BGPPATH = 109,                  /* BGPPATH  */
  YYSYMBOL_CLIST = 110,                    /* CLIST  */
  YYSYMBOL_ECLIST = 111,                   /* ECLIST  */
  YYSYMBOL_LCLIST = 112,                   /* LCLIST  */
  YYSYMBOL_IF = 113,                       /* IF  */
  YYSYMBOL_THEN = 114,                     /* THEN  */
  YYSYMBOL_ELSE = 115,                     /* ELSE  */
  YYSYMBOL_CASE = 116,                     /* CASE  */
  YYSYMBOL_FOR = 117,                      /* FOR  */
  YYSYMBOL_DO = 118,                       /* DO  */
  YYSYMBOL_TRUE = 119,                     /* TRUE  */
  YYSYMBOL_FALSE = 120,                    /* FALSE  */
  YYSYMBOL_RT = 121,                       /* RT  */
  YYSYMBOL_RO = 122,                       /* RO  */
  YYSYMBOL_UNKNOWN = 123,                  /* UNKNOWN  */
  YYSYMBOL_GENERIC = 124,                  /* GENERIC  */
  YYSYMBOL_GW = 125,                       /* GW  */
  YYSYMBOL_NET = 126,                      /* NET  */
  YYSYMBOL_SOURCE = 127,                   /* SOURCE  */
  YYSYMBOL_SCOPE = 128,                    /* SCOPE  */
  YYSYMBOL_DEST = 129,                     /* DEST  */
  YYSYMBOL_IFNAME = 130,                   /* IFNAME  */
  YYSYMBOL_IFINDEX = 131,                  /* IFINDEX  */
  YYSYMBOL_WEIGHT = 132,                   /* WEIGHT  */
  YYSYMBOL_GW_MPLS = 133,                  /* GW_MPLS  */
  YYSYMBOL_GW_MPLS_STACK = 134,            /* GW_MPLS_STACK  */
  YYSYMBOL_ONLINK = 135,                   /* ONLINK  */
  YYSYMBOL_PREFERENCE = 136,               /* PREFERENCE  */
  YYSYMBOL_ROA_CHECK = 137,                /* ROA_CHECK  */
  YYSYMBOL_ASPA_CHECK = 138,               /* ASPA_CHECK  */
  YYSYMBOL_DEFINED = 139,                  /* DEFINED  */
  YYSYMBOL_ADD = 140,                      /* ADD  */
  YYSYMBOL_DELETE = 141,                   /* DELETE  */
  YYSYMBOL_RESET = 142,                    /* RESET  */
  YYSYMBOL_PREPEND = 143,                  /* PREPEND  */
  YYSYMBOL_EMPTY = 144,                    /* EMPTY  */
  YYSYMBOL_FILTER = 145,                   /* FILTER  */
  YYSYMBOL_WHERE = 146,                    /* WHERE  */
  YYSYMBOL_EVAL = 147,                     /* EVAL  */
  YYSYMBOL_ATTRIBUTE = 148,                /* ATTRIBUTE  */
  YYSYMBOL_FROM_HEX = 149,                 /* FROM_HEX  */
  YYSYMBOL_BT_ASSERT = 150,                /* BT_ASSERT  */
  YYSYMBOL_BT_TEST_SUITE = 151,            /* BT_TEST_SUITE  */
  YYSYMBOL_BT_CHECK_ASSIGN = 152,          /* BT_CHECK_ASSIGN  */
  YYSYMBOL_BT_TEST_SAME = 153,             /* BT_TEST_SAME  */
  YYSYMBOL_FORMAT = 154,                   /* FORMAT  */
  YYSYMBOL_155_ = 155,                     /* ':'  */
  YYSYMBOL_156_ = 156,                     /* '['  */
  YYSYMBOL_157_ = 157,                     /* ']'  */
  YYSYMBOL_158_ = 158,                     /* '?'  */
  YYSYMBOL_ROUTER = 159,                   /* ROUTER  */
  YYSYMBOL_ID = 160,                       /* ID  */
  YYSYMBOL_HOSTNAME = 161,                 /* HOSTNAME  */
  YYSYMBOL_PROTOCOL = 162,                 /* PROTOCOL  */
  YYSYMBOL_TEMPLATE = 163,                 /* TEMPLATE  */
  YYSYMBOL_DISABLED = 164,                 /* DISABLED  */
  YYSYMBOL_DEBUG = 165,                    /* DEBUG  */
  YYSYMBOL_ALL = 166,                      /* ALL  */
  YYSYMBOL_DIRECT = 167,                   /* DIRECT  */
  YYSYMBOL_INTERFACE = 168,                /* INTERFACE  */
  YYSYMBOL_IMPORT = 169,                   /* IMPORT  */
  YYSYMBOL_EXPORT = 170,                   /* EXPORT  */
  YYSYMBOL_NONE = 171,                     /* NONE  */
  YYSYMBOL_VRF = 172,                      /* VRF  */
  YYSYMBOL_DEFAULT = 173,                  /* DEFAULT  */
  YYSYMBOL_TABLE = 174,                    /* TABLE  */
  YYSYMBOL_TABLES = 175,                   /* TABLES  */
  YYSYMBOL_STATES = 176,                   /* STATES  */
  YYSYMBOL_ROUTES = 177,                   /* ROUTES  */
  YYSYMBOL_FILTERS = 178,                  /* FILTERS  */
  YYSYMBOL_IPV4 = 179,                     /* IPV4  */
  YYSYMBOL_IPV6 = 180,                     /* IPV6  */
  YYSYMBOL_VPN4 = 181,                     /* VPN4  */
  YYSYMBOL_VPN6 = 182,                     /* VPN6  */
  YYSYMBOL_ROA4 = 183,                     /* ROA4  */
  YYSYMBOL_ROA6 = 184,                     /* ROA6  */
  YYSYMBOL_SADR = 185,                     /* SADR  */
  YYSYMBOL_ASPA = 186,                     /* ASPA  */
  YYSYMBOL_RECEIVE = 187,                  /* RECEIVE  */
  YYSYMBOL_LIMIT = 188,                    /* LIMIT  */
  YYSYMBOL_ACTION = 189,                   /* ACTION  */
  YYSYMBOL_WARN = 190,                     /* WARN  */
  YYSYMBOL_BLOCK = 191,                    /* BLOCK  */
  YYSYMBOL_RESTART = 192,                  /* RESTART  */
  YYSYMBOL_DISABLE = 193,                  /* DISABLE  */
  YYSYMBOL_KEEP = 194,                     /* KEEP  */
  YYSYMBOL_FILTERED = 195,                 /* FILTERED  */
  YYSYMBOL_RPKI = 196,                     /* RPKI  */
  YYSYMBOL_PASSWORD = 197,                 /* PASSWORD  */
  YYSYMBOL_KEY = 198,                      /* KEY  */
  YYSYMBOL_PASSIVE = 199,                  /* PASSIVE  */
  YYSYMBOL_TO = 200,                       /* TO  */
  YYSYMBOL_EVENTS = 201,                   /* EVENTS  */
  YYSYMBOL_PACKETS = 202,                  /* PACKETS  */
  YYSYMBOL_PROTOCOLS = 203,                /* PROTOCOLS  */
  YYSYMBOL_CHANNELS = 204,                 /* CHANNELS  */
  YYSYMBOL_INTERFACES = 205,               /* INTERFACES  */
  YYSYMBOL_ALGORITHM = 206,                /* ALGORITHM  */
  YYSYMBOL_KEYED = 207,                    /* KEYED  */
  YYSYMBOL_HMAC = 208,                     /* HMAC  */
  YYSYMBOL_MD5 = 209,                      /* MD5  */
  YYSYMBOL_SHA1 = 210,                     /* SHA1  */
  YYSYMBOL_SHA256 = 211,                   /* SHA256  */
  YYSYMBOL_SHA384 = 212,                   /* SHA384  */
  YYSYMBOL_SHA512 = 213,                   /* SHA512  */
  YYSYMBOL_BLAKE2S128 = 214,               /* BLAKE2S128  */
  YYSYMBOL_BLAKE2S256 = 215,               /* BLAKE2S256  */
  YYSYMBOL_BLAKE2B256 = 216,               /* BLAKE2B256  */
  YYSYMBOL_BLAKE2B512 = 217,               /* BLAKE2B512  */
  YYSYMBOL_PRIMARY = 218,                  /* PRIMARY  */
  YYSYMBOL_STATS = 219,                    /* STATS  */
  YYSYMBOL_COUNT = 220,                    /* COUNT  */
  YYSYMBOL_COMMANDS = 221,                 /* COMMANDS  */
  YYSYMBOL_PREEXPORT = 222,                /* PREEXPORT  */
  YYSYMBOL_NOEXPORT = 223,                 /* NOEXPORT  */
  YYSYMBOL_EXPORTED = 224,                 /* EXPORTED  */
  YYSYMBOL_GENERATE = 225,                 /* GENERATE  */
  YYSYMBOL_BGP = 226,                      /* BGP  */
  YYSYMBOL_PASSWORDS = 227,                /* PASSWORDS  */
  YYSYMBOL_DESCRIPTION = 228,              /* DESCRIPTION  */
  YYSYMBOL_RELOAD = 229,                   /* RELOAD  */
  YYSYMBOL_OUT = 230,                      /* OUT  */
  YYSYMBOL_MRTDUMP = 231,                  /* MRTDUMP  */
  YYSYMBOL_MESSAGES = 232,                 /* MESSAGES  */
  YYSYMBOL_RESTRICT = 233,                 /* RESTRICT  */
  YYSYMBOL_MEMORY = 234,                   /* MEMORY  */
  YYSYMBOL_IGP_METRIC = 235,               /* IGP_METRIC  */
  YYSYMBOL_CLASS = 236,                    /* CLASS  */
  YYSYMBOL_TIMEFORMAT = 237,               /* TIMEFORMAT  */
  YYSYMBOL_ISO = 238,                      /* ISO  */
  YYSYMBOL_SHORT = 239,                    /* SHORT  */
  YYSYMBOL_LONG = 240,                     /* LONG  */
  YYSYMBOL_ROUTE = 241,                    /* ROUTE  */
  YYSYMBOL_BASE = 242,                     /* BASE  */
  YYSYMBOL_LOG = 243,                      /* LOG  */
  YYSYMBOL_GRACEFUL = 244,                 /* GRACEFUL  */
  YYSYMBOL_WAIT = 245,                     /* WAIT  */
  YYSYMBOL_CHECK = 246,                    /* CHECK  */
  YYSYMBOL_LINK = 247,                     /* LINK  */
  YYSYMBOL_SORTED = 248,                   /* SORTED  */
  YYSYMBOL_TRIE = 249,                     /* TRIE  */
  YYSYMBOL_MIN = 250,                      /* MIN  */
  YYSYMBOL_SETTLE = 251,                   /* SETTLE  */
  YYSYMBOL_TIME = 252,                     /* TIME  */
  YYSYMBOL_GC = 253,                       /* GC  */
  YYSYMBOL_THRESHOLD = 254,                /* THRESHOLD  */
  YYSYMBOL_PERIOD = 255,                   /* PERIOD  */
  YYSYMBOL_MPLS_LABEL = 256,               /* MPLS_LABEL  */
  YYSYMBOL_MPLS_POLICY = 257,              /* MPLS_POLICY  */
  YYSYMBOL_MPLS_CLASS = 258,               /* MPLS_CLASS  */
  YYSYMBOL_ASPA_PROVIDERS = 259,           /* ASPA_PROVIDERS  */
  YYSYMBOL_IPV4_MC = 260,                  /* IPV4_MC  */
  YYSYMBOL_IPV4_MPLS = 261,                /* IPV4_MPLS  */
  YYSYMBOL_IPV6_MC = 262,                  /* IPV6_MC  */
  YYSYMBOL_IPV6_MPLS = 263,                /* IPV6_MPLS  */
  YYSYMBOL_IPV6_SADR = 264,                /* IPV6_SADR  */
  YYSYMBOL_VPN4_MC = 265,                  /* VPN4_MC  */
  YYSYMBOL_VPN4_MPLS = 266,                /* VPN4_MPLS  */
  YYSYMBOL_VPN6_MC = 267,                  /* VPN6_MC  */
  YYSYMBOL_VPN6_MPLS = 268,                /* VPN6_MPLS  */
  YYSYMBOL_PRI = 269,                      /* PRI  */
  YYSYMBOL_SEC = 270,                      /* SEC  */
  YYSYMBOL_NET_TYPE = 271,                 /* NET_TYPE  */
  YYSYMBOL_RTS = 272,                      /* RTS  */
  YYSYMBOL_RTD = 273,                      /* RTD  */
  YYSYMBOL_ROA = 274,                      /* ROA  */
  YYSYMBOL_AF = 275,                       /* AF  */
  YYSYMBOL_SHOW = 276,                     /* SHOW  */
  YYSYMBOL_STATUS = 277,                   /* STATUS  */
  YYSYMBOL_SUMMARY = 278,                  /* SUMMARY  */
  YYSYMBOL_SYMBOLS = 279,                  /* SYMBOLS  */
  YYSYMBOL_DUMP = 280,                     /* DUMP  */
  YYSYMBOL_RESOURCES = 281,                /* RESOURCES  */
  YYSYMBOL_SOCKETS = 282,                  /* SOCKETS  */
  YYSYMBOL_AO = 283,                       /* AO  */
  YYSYMBOL_KEYS = 284,                     /* KEYS  */
  YYSYMBOL_NEIGHBORS = 285,                /* NEIGHBORS  */
  YYSYMBOL_ATTRIBUTES = 286,               /* ATTRIBUTES  */
  YYSYMBOL_ECHO = 287,                     /* ECHO  */
  YYSYMBOL_ENABLE = 288,                   /* ENABLE  */
  YYSYMBOL_DOMAIN = 289,                   /* DOMAIN  */
  YYSYMBOL_RANGE = 290,                    /* RANGE  */
  YYSYMBOL_STATIC = 291,                   /* STATIC  */
  YYSYMBOL_DYNAMIC = 292,                  /* DYNAMIC  */
  YYSYMBOL_START = 293,                    /* START  */
  YYSYMBOL_POLICY = 294,                   /* POLICY  */
  YYSYMBOL_AGGREGATE = 295,                /* AGGREGATE  */
  YYSYMBOL_RANGES = 296,                   /* RANGES  */
  YYSYMBOL_AGGREGATOR = 297,               /* AGGREGATOR  */
  YYSYMBOL_PEER = 298,                     /* PEER  */
  YYSYMBOL_MERGE = 299,                    /* MERGE  */
  YYSYMBOL_BY = 300,                       /* BY  */
  YYSYMBOL_BABEL = 301,                    /* BABEL  */
  YYSYMBOL_METRIC = 302,                   /* METRIC  */
  YYSYMBOL_RXCOST = 303,                   /* RXCOST  */
  YYSYMBOL_HELLO = 304,                    /* HELLO  */
  YYSYMBOL_UPDATE = 305,                   /* UPDATE  */
  YYSYMBOL_WIRED = 306,                    /* WIRED  */
  YYSYMBOL_WIRELESS = 307,                 /* WIRELESS  */
  YYSYMBOL_BUFFER = 308,                   /* BUFFER  */
  YYSYMBOL_PRIORITY = 309,                 /* PRIORITY  */
  YYSYMBOL_HOP = 310,                      /* HOP  */
  YYSYMBOL_BABEL_METRIC = 311,             /* BABEL_METRIC  */
  YYSYMBOL_ENTRIES = 312,                  /* ENTRIES  */
  YYSYMBOL_RANDOMIZE = 313,                /* RANDOMIZE  */
  YYSYMBOL_MAC = 314,                      /* MAC  */
  YYSYMBOL_PERMISSIVE = 315,               /* PERMISSIVE  */
  YYSYMBOL_EXTENDED = 316,                 /* EXTENDED  */
  YYSYMBOL_TUNNEL = 317,                   /* TUNNEL  */
  YYSYMBOL_RTT = 318,                      /* RTT  */
  YYSYMBOL_DECAY = 319,                    /* DECAY  */
  YYSYMBOL_SEND = 320,                     /* SEND  */
  YYSYMBOL_TIMESTAMPS = 321,               /* TIMESTAMPS  */
  YYSYMBOL_COST = 322,                     /* COST  */
  YYSYMBOL_DELAY = 323,                    /* DELAY  */
  YYSYMBOL_PREFER = 324,                   /* PREFER  */
  YYSYMBOL_NATIVE = 325,                   /* NATIVE  */
  YYSYMBOL_BFD = 326,                      /* BFD  */
  YYSYMBOL_IDLE = 327,                     /* IDLE  */
  YYSYMBOL_RX = 328,                       /* RX  */
  YYSYMBOL_TX = 329,                       /* TX  */
  YYSYMBOL_INTERVAL = 330,                 /* INTERVAL  */
  YYSYMBOL_MULTIPLIER = 331,               /* MULTIPLIER  */
  YYSYMBOL_ADDRESS = 332,                  /* ADDRESS  */
  YYSYMBOL_MULTIHOP = 333,                 /* MULTIHOP  */
  YYSYMBOL_NEIGHBOR = 334,                 /* NEIGHBOR  */
  YYSYMBOL_DEV = 335,                      /* DEV  */
  YYSYMBOL_LOCAL = 336,                    /* LOCAL  */
  YYSYMBOL_AUTHENTICATION = 337,           /* AUTHENTICATION  */
  YYSYMBOL_SIMPLE = 338,                   /* SIMPLE  */
  YYSYMBOL_METICULOUS = 339,               /* METICULOUS  */
  YYSYMBOL_STRICT = 340,                   /* STRICT  */
  YYSYMBOL_BIND = 341,                     /* BIND  */
  YYSYMBOL_ZERO = 342,                     /* ZERO  */
  YYSYMBOL_UDP6 = 343,                     /* UDP6  */
  YYSYMBOL_CHECKSUM = 344,                 /* CHECKSUM  */
  YYSYMBOL_SESSIONS = 345,                 /* SESSIONS  */
  YYSYMBOL_HOLD = 346,                     /* HOLD  */
  YYSYMBOL_CONNECT = 347,                  /* CONNECT  */
  YYSYMBOL_RETRY = 348,                    /* RETRY  */
  YYSYMBOL_KEEPALIVE = 349,                /* KEEPALIVE  */
  YYSYMBOL_STARTUP = 350,                  /* STARTUP  */
  YYSYMBOL_VIA = 351,                      /* VIA  */
  YYSYMBOL_SELF = 352,                     /* SELF  */
  YYSYMBOL_PATH = 353,                     /* PATH  */
  YYSYMBOL_FORGET = 354,                   /* FORGET  */
  YYSYMBOL_AFTER = 355,                    /* AFTER  */
  YYSYMBOL_BGP_PATH = 356,                 /* BGP_PATH  */
  YYSYMBOL_BGP_LOCAL_PREF = 357,           /* BGP_LOCAL_PREF  */
  YYSYMBOL_BGP_MED = 358,                  /* BGP_MED  */
  YYSYMBOL_BGP_ORIGIN = 359,               /* BGP_ORIGIN  */
  YYSYMBOL_BGP_NEXT_HOP = 360,             /* BGP_NEXT_HOP  */
  YYSYMBOL_BGP_ATOMIC_AGGR = 361,          /* BGP_ATOMIC_AGGR  */
  YYSYMBOL_BGP_AGGREGATOR = 362,           /* BGP_AGGREGATOR  */
  YYSYMBOL_BGP_COMMUNITY = 363,            /* BGP_COMMUNITY  */
  YYSYMBOL_BGP_EXT_COMMUNITY = 364,        /* BGP_EXT_COMMUNITY  */
  YYSYMBOL_BGP_LARGE_COMMUNITY = 365,      /* BGP_LARGE_COMMUNITY  */
  YYSYMBOL_RR = 366,                       /* RR  */
  YYSYMBOL_RS = 367,                       /* RS  */
  YYSYMBOL_CLIENT = 368,                   /* CLIENT  */
  YYSYMBOL_CLUSTER = 369,                  /* CLUSTER  */
  YYSYMBOL_AS4 = 370,                      /* AS4  */
  YYSYMBOL_ADVERTISE = 371,                /* ADVERTISE  */
  YYSYMBOL_CAPABILITIES = 372,             /* CAPABILITIES  */
  YYSYMBOL_OLDER = 373,                    /* OLDER  */
  YYSYMBOL_MISSING = 374,                  /* MISSING  */
  YYSYMBOL_LLADDR = 375,                   /* LLADDR  */
  YYSYMBOL_DROP = 376,                     /* DROP  */
  YYSYMBOL_IGNORE = 377,                   /* IGNORE  */
  YYSYMBOL_ENHANCED = 378,                 /* ENHANCED  */
  YYSYMBOL_REFRESH = 379,                  /* REFRESH  */
  YYSYMBOL_INTERPRET = 380,                /* INTERPRET  */
  YYSYMBOL_COMMUNITIES = 381,              /* COMMUNITIES  */
  YYSYMBOL_BGP_ORIGINATOR_ID = 382,        /* BGP_ORIGINATOR_ID  */
  YYSYMBOL_BGP_CLUSTER_LIST = 383,         /* BGP_CLUSTER_LIST  */
  YYSYMBOL_IGP = 384,                      /* IGP  */
  YYSYMBOL_GATEWAY = 385,                  /* GATEWAY  */
  YYSYMBOL_RECURSIVE = 386,                /* RECURSIVE  */
  YYSYMBOL_MED = 387,                      /* MED  */
  YYSYMBOL_TTL = 388,                      /* TTL  */
  YYSYMBOL_SECURITY = 389,                 /* SECURITY  */
  YYSYMBOL_DETERMINISTIC = 390,            /* DETERMINISTIC  */
  YYSYMBOL_SECONDARY = 391,                /* SECONDARY  */
  YYSYMBOL_ALLOW = 392,                    /* ALLOW  */
  YYSYMBOL_PATHS = 393,                    /* PATHS  */
  YYSYMBOL_AWARE = 394,                    /* AWARE  */
  YYSYMBOL_SETKEY = 395,                   /* SETKEY  */
  YYSYMBOL_CONFEDERATION = 396,            /* CONFEDERATION  */
  YYSYMBOL_MEMBER = 397,                   /* MEMBER  */
  YYSYMBOL_MULTICAST = 398,                /* MULTICAST  */
  YYSYMBOL_LIVED = 399,                    /* LIVED  */
  YYSYMBOL_STALE = 400,                    /* STALE  */
  YYSYMBOL_IBGP = 401,                     /* IBGP  */
  YYSYMBOL_EBGP = 402,                     /* EBGP  */
  YYSYMBOL_MANDATORY = 403,                /* MANDATORY  */
  YYSYMBOL_INTERNAL = 404,                 /* INTERNAL  */
  YYSYMBOL_EXTERNAL = 405,                 /* EXTERNAL  */
  YYSYMBOL_SETS = 406,                     /* SETS  */
  YYSYMBOL_NAME = 407,                     /* NAME  */
  YYSYMBOL_DIGITS = 408,                   /* DIGITS  */
  YYSYMBOL_BGP_AIGP = 409,                 /* BGP_AIGP  */
  YYSYMBOL_AIGP = 410,                     /* AIGP  */
  YYSYMBOL_ORIGINATE = 411,                /* ORIGINATE  */
  YYSYMBOL_ENFORCE = 412,                  /* ENFORCE  */
  YYSYMBOL_FIRST = 413,                    /* FIRST  */
  YYSYMBOL_FREE = 414,                     /* FREE  */
  YYSYMBOL_VALIDATE = 415,                 /* VALIDATE  */
  YYSYMBOL_ROLE = 416,                     /* ROLE  */
  YYSYMBOL_ROLES = 417,                    /* ROLES  */
  YYSYMBOL_PROVIDER = 418,                 /* PROVIDER  */
  YYSYMBOL_CUSTOMER = 419,                 /* CUSTOMER  */
  YYSYMBOL_RS_SERVER = 420,                /* RS_SERVER  */
  YYSYMBOL_RS_CLIENT = 421,                /* RS_CLIENT  */
  YYSYMBOL_REQUIRE = 422,                  /* REQUIRE  */
  YYSYMBOL_BGP_OTC = 423,                  /* BGP_OTC  */
  YYSYMBOL_GLOBAL = 424,                   /* GLOBAL  */
  YYSYMBOL_RECV = 425,                     /* RECV  */
  YYSYMBOL_SINGLE = 426,                   /* SINGLE  */
  YYSYMBOL_DOUBLE = 427,                   /* DOUBLE  */
  YYSYMBOL_SECRET = 428,                   /* SECRET  */
  YYSYMBOL_DEPRECATED = 429,               /* DEPRECATED  */
  YYSYMBOL_PREFERRED = 430,                /* PREFERRED  */
  YYSYMBOL_CMAC = 431,                     /* CMAC  */
  YYSYMBOL_AES128 = 432,                   /* AES128  */
  YYSYMBOL_CEASE = 433,                    /* CEASE  */
  YYSYMBOL_HIT = 434,                      /* HIT  */
  YYSYMBOL_ADMINISTRATIVE = 435,           /* ADMINISTRATIVE  */
  YYSYMBOL_SHUTDOWN = 436,                 /* SHUTDOWN  */
  YYSYMBOL_CONFIGURATION = 437,            /* CONFIGURATION  */
  YYSYMBOL_CHANGE = 438,                   /* CHANGE  */
  YYSYMBOL_DECONFIGURED = 439,             /* DECONFIGURED  */
  YYSYMBOL_CONNECTION = 440,               /* CONNECTION  */
  YYSYMBOL_REJECTED = 441,                 /* REJECTED  */
  YYSYMBOL_COLLISION = 442,                /* COLLISION  */
  YYSYMBOL_OF = 443,                       /* OF  */
  YYSYMBOL_ASPA_CHECK_UPSTREAM = 444,      /* ASPA_CHECK_UPSTREAM  */
  YYSYMBOL_ASPA_CHECK_DOWNSTREAM = 445,    /* ASPA_CHECK_DOWNSTREAM  */
  YYSYMBOL_L3VPN = 446,                    /* L3VPN  */
  YYSYMBOL_TARGET = 447,                   /* TARGET  */
  YYSYMBOL_DISTINGUISHER = 448,            /* DISTINGUISHER  */
  YYSYMBOL_MRT = 449,                      /* MRT  */
  YYSYMBOL_FILENAME = 450,                 /* FILENAME  */
  YYSYMBOL_ALWAYS = 451,                   /* ALWAYS  */
  YYSYMBOL_V2 = 452,                       /* V2  */
  YYSYMBOL_V3 = 453,                       /* V3  */
  YYSYMBOL_OSPF = 454,                     /* OSPF  */
  YYSYMBOL_OSPF_METRIC1 = 455,             /* OSPF_METRIC1  */
  YYSYMBOL_OSPF_METRIC2 = 456,             /* OSPF_METRIC2  */
  YYSYMBOL_OSPF_TAG = 457,                 /* OSPF_TAG  */
  YYSYMBOL_OSPF_ROUTER_ID = 458,           /* OSPF_ROUTER_ID  */
  YYSYMBOL_AREA = 459,                     /* AREA  */
  YYSYMBOL_RFC1583COMPAT = 460,            /* RFC1583COMPAT  */
  YYSYMBOL_STUB = 461,                     /* STUB  */
  YYSYMBOL_TICK = 462,                     /* TICK  */
  YYSYMBOL_COST2 = 463,                    /* COST2  */
  YYSYMBOL_RETRANSMIT = 464,               /* RETRANSMIT  */
  YYSYMBOL_TRANSMIT = 465,                 /* TRANSMIT  */
  YYSYMBOL_DEAD = 466,                     /* DEAD  */
  YYSYMBOL_BROADCAST = 467,                /* BROADCAST  */
  YYSYMBOL_BCAST = 468,                    /* BCAST  */
  YYSYMBOL_NONBROADCAST = 469,             /* NONBROADCAST  */
  YYSYMBOL_NBMA = 470,                     /* NBMA  */
  YYSYMBOL_POINTOPOINT = 471,              /* POINTOPOINT  */
  YYSYMBOL_PTP = 472,                      /* PTP  */
  YYSYMBOL_POINTOMULTIPOINT = 473,         /* POINTOMULTIPOINT  */
  YYSYMBOL_PTMP = 474,                     /* PTMP  */
  YYSYMBOL_CRYPTOGRAPHIC = 475,            /* CRYPTOGRAPHIC  */
  YYSYMBOL_ELIGIBLE = 476,                 /* ELIGIBLE  */
  YYSYMBOL_POLL = 477,                     /* POLL  */
  YYSYMBOL_NETWORKS = 478,                 /* NETWORKS  */
  YYSYMBOL_HIDDEN = 479,                   /* HIDDEN  */
  YYSYMBOL_VIRTUAL = 480,                  /* VIRTUAL  */
  YYSYMBOL_ONLY = 481,                     /* ONLY  */
  YYSYMBOL_LARGE = 482,                    /* LARGE  */
  YYSYMBOL_NORMAL = 483,                   /* NORMAL  */
  YYSYMBOL_STUBNET = 484,                  /* STUBNET  */
  YYSYMBOL_TAG = 485,                      /* TAG  */
  YYSYMBOL_LSADB = 486,                    /* LSADB  */
  YYSYMBOL_ECMP = 487,                     /* ECMP  */
  YYSYMBOL_NSSA = 488,                     /* NSSA  */
  YYSYMBOL_TRANSLATOR = 489,               /* TRANSLATOR  */
  YYSYMBOL_STABILITY = 490,                /* STABILITY  */
  YYSYMBOL_LSID = 491,                     /* LSID  */
  YYSYMBOL_INSTANCE = 492,                 /* INSTANCE  */
  YYSYMBOL_REAL = 493,                     /* REAL  */
  YYSYMBOL_NETMASK = 494,                  /* NETMASK  */
  YYSYMBOL_LSA = 495,                      /* LSA  */
  YYSYMBOL_SUPPRESSION = 496,              /* SUPPRESSION  */
  YYSYMBOL_RFC5838 = 497,                  /* RFC5838  */
  YYSYMBOL_PE = 498,                       /* PE  */
  YYSYMBOL_TOPOLOGY = 499,                 /* TOPOLOGY  */
  YYSYMBOL_STATE = 500,                    /* STATE  */
  YYSYMBOL_PERF = 501,                     /* PERF  */
  YYSYMBOL_EXP = 502,                      /* EXP  */
  YYSYMBOL_REPEAT = 503,                   /* REPEAT  */
  YYSYMBOL_MODE = 504,                     /* MODE  */
  YYSYMBOL_PIPE = 505,                     /* PIPE  */
  YYSYMBOL_RADV = 506,                     /* RADV  */
  YYSYMBOL_RA = 507,                       /* RA  */
  YYSYMBOL_SOLICITED = 508,                /* SOLICITED  */
  YYSYMBOL_UNICAST = 509,                  /* UNICAST  */
  YYSYMBOL_MANAGED = 510,                  /* MANAGED  */
  YYSYMBOL_OTHER = 511,                    /* OTHER  */
  YYSYMBOL_CONFIG = 512,                   /* CONFIG  */
  YYSYMBOL_LINGER = 513,                   /* LINGER  */
  YYSYMBOL_MTU = 514,                      /* MTU  */
  YYSYMBOL_REACHABLE = 515,                /* REACHABLE  */
  YYSYMBOL_RETRANS = 516,                  /* RETRANS  */
  YYSYMBOL_TIMER = 517,                    /* TIMER  */
  YYSYMBOL_CURRENT = 518,                  /* CURRENT  */
  YYSYMBOL_VALID = 519,                    /* VALID  */
  YYSYMBOL_MULT = 520,                     /* MULT  */
  YYSYMBOL_LIFETIME = 521,                 /* LIFETIME  */
  YYSYMBOL_SKIP = 522,                     /* SKIP  */
  YYSYMBOL_AUTONOMOUS = 523,               /* AUTONOMOUS  */
  YYSYMBOL_RDNSS = 524,                    /* RDNSS  */
  YYSYMBOL_DNSSL = 525,                    /* DNSSL  */
  YYSYMBOL_NS = 526,                       /* NS  */
  YYSYMBOL_TRIGGER = 527,                  /* TRIGGER  */
  YYSYMBOL_SENSITIVE = 528,                /* SENSITIVE  */
  YYSYMBOL_LOW = 529,                      /* LOW  */
  YYSYMBOL_MEDIUM = 530,                   /* MEDIUM  */
  YYSYMBOL_HIGH = 531,                     /* HIGH  */
  YYSYMBOL_PROPAGATE = 532,                /* PROPAGATE  */
  YYSYMBOL_RA_PREFERENCE = 533,            /* RA_PREFERENCE  */
  YYSYMBOL_RA_LIFETIME = 534,              /* RA_LIFETIME  */
  YYSYMBOL_CUSTOM = 535,                   /* CUSTOM  */
  YYSYMBOL_OPTION = 536,                   /* OPTION  */
  YYSYMBOL_VALUE = 537,                    /* VALUE  */
  YYSYMBOL_NG = 538,                       /* NG  */
  YYSYMBOL_RIP = 539,                      /* RIP  */
  YYSYMBOL_INFINITY = 540,                 /* INFINITY  */
  YYSYMBOL_TIMEOUT = 541,                  /* TIMEOUT  */
  YYSYMBOL_GARBAGE = 542,                  /* GARBAGE  */
  YYSYMBOL_VERSION = 543,                  /* VERSION  */
  YYSYMBOL_SPLIT = 544,                    /* SPLIT  */
  YYSYMBOL_HORIZON = 545,                  /* HORIZON  */
  YYSYMBOL_POISON = 546,                   /* POISON  */
  YYSYMBOL_REVERSE = 547,                  /* REVERSE  */
  YYSYMBOL_PLAINTEXT = 548,                /* PLAINTEXT  */
  YYSYMBOL_DEMAND = 549,                   /* DEMAND  */
  YYSYMBOL_CIRCUIT = 550,                  /* CIRCUIT  */
  YYSYMBOL_RIP_METRIC = 551,               /* RIP_METRIC  */
  YYSYMBOL_RIP_TAG = 552,                  /* RIP_TAG  */
  YYSYMBOL_REMOTE = 553,                   /* REMOTE  */
  YYSYMBOL_BIRD = 554,                     /* BIRD  */
  YYSYMBOL_PRIVATE = 555,                  /* PRIVATE  */
  YYSYMBOL_PUBLIC = 556,                   /* PUBLIC  */
  YYSYMBOL_SSH = 557,                      /* SSH  */
  YYSYMBOL_TRANSPORT = 558,                /* TRANSPORT  */
  YYSYMBOL_USER = 559,                     /* USER  */
  YYSYMBOL_EXPIRE = 560,                   /* EXPIRE  */
  YYSYMBOL_PROHIBIT = 561,                 /* PROHIBIT  */
  YYSYMBOL_BLACKHOLE = 562,                /* BLACKHOLE  */
  YYSYMBOL_UNREACHABLE = 563,              /* UNREACHABLE  */
  YYSYMBOL_TRANSIT = 564,                  /* TRANSIT  */
  YYSYMBOL_PROVIDERS = 565,                /* PROVIDERS  */
  YYSYMBOL_KERNEL = 566,                   /* KERNEL  */
  YYSYMBOL_NETLINK = 567,                  /* NETLINK  */
  YYSYMBOL_KRT_PREFSRC = 568,              /* KRT_PREFSRC  */
  YYSYMBOL_KRT_REALM = 569,                /* KRT_REALM  */
  YYSYMBOL_KRT_SCOPE = 570,                /* KRT_SCOPE  */
  YYSYMBOL_KRT_MTU = 571,                  /* KRT_MTU  */
  YYSYMBOL_KRT_WINDOW = 572,               /* KRT_WINDOW  */
  YYSYMBOL_KRT_RTT = 573,                  /* KRT_RTT  */
  YYSYMBOL_KRT_RTTVAR = 574,               /* KRT_RTTVAR  */
  YYSYMBOL_KRT_SSTHRESH = 575,             /* KRT_SSTHRESH  */
  YYSYMBOL_KRT_CWND = 576,                 /* KRT_CWND  */
  YYSYMBOL_KRT_ADVMSS = 577,               /* KRT_ADVMSS  */
  YYSYMBOL_KRT_REORDERING = 578,           /* KRT_REORDERING  */
  YYSYMBOL_KRT_HOPLIMIT = 579,             /* KRT_HOPLIMIT  */
  YYSYMBOL_KRT_INITCWND = 580,             /* KRT_INITCWND  */
  YYSYMBOL_KRT_RTO_MIN = 581,              /* KRT_RTO_MIN  */
  YYSYMBOL_KRT_INITRWND = 582,             /* KRT_INITRWND  */
  YYSYMBOL_KRT_QUICKACK = 583,             /* KRT_QUICKACK  */
  YYSYMBOL_KRT_CONGCTL = 584,              /* KRT_CONGCTL  */
  YYSYMBOL_KRT_FASTOPEN_NO_COOKIE = 585,   /* KRT_FASTOPEN_NO_COOKIE  */
  YYSYMBOL_KRT_LOCK_MTU = 586,             /* KRT_LOCK_MTU  */
  YYSYMBOL_KRT_LOCK_WINDOW = 587,          /* KRT_LOCK_WINDOW  */
  YYSYMBOL_KRT_LOCK_RTT = 588,             /* KRT_LOCK_RTT  */
  YYSYMBOL_KRT_LOCK_RTTVAR = 589,          /* KRT_LOCK_RTTVAR  */
  YYSYMBOL_KRT_LOCK_SSTHRESH = 590,        /* KRT_LOCK_SSTHRESH  */
  YYSYMBOL_KRT_LOCK_CWND = 591,            /* KRT_LOCK_CWND  */
  YYSYMBOL_KRT_LOCK_ADVMSS = 592,          /* KRT_LOCK_ADVMSS  */
  YYSYMBOL_KRT_LOCK_REORDERING = 593,      /* KRT_LOCK_REORDERING  */
  YYSYMBOL_KRT_LOCK_HOPLIMIT = 594,        /* KRT_LOCK_HOPLIMIT  */
  YYSYMBOL_KRT_LOCK_INITCWND = 595,        /* KRT_LOCK_INITCWND  */
  YYSYMBOL_KRT_LOCK_RTO_MIN = 596,         /* KRT_LOCK_RTO_MIN  */
  YYSYMBOL_KRT_LOCK_INITRWND = 597,        /* KRT_LOCK_INITRWND  */
  YYSYMBOL_KRT_LOCK_QUICKACK = 598,        /* KRT_LOCK_QUICKACK  */
  YYSYMBOL_KRT_LOCK_CONGCTL = 599,         /* KRT_LOCK_CONGCTL  */
  YYSYMBOL_KRT_LOCK_FASTOPEN_NO_COOKIE = 600, /* KRT_LOCK_FASTOPEN_NO_COOKIE  */
  YYSYMBOL_KRT_FEATURE_ECN = 601,          /* KRT_FEATURE_ECN  */
  YYSYMBOL_KRT_FEATURE_ALLFRAG = 602,      /* KRT_FEATURE_ALLFRAG  */
  YYSYMBOL_KRT_SSTRESH = 603,              /* KRT_SSTRESH  */
  YYSYMBOL_KRT_LOCK_SSTRESH = 604,         /* KRT_LOCK_SSTRESH  */
  YYSYMBOL_SYSLOG = 605,                   /* SYSLOG  */
  YYSYMBOL_STDERR = 606,                   /* STDERR  */
  YYSYMBOL_UDP = 607,                      /* UDP  */
  YYSYMBOL_CLI = 608,                      /* CLI  */
  YYSYMBOL_TRACE = 609,                    /* TRACE  */
  YYSYMBOL_INFO = 610,                     /* INFO  */
  YYSYMBOL_WARNING = 611,                  /* WARNING  */
  YYSYMBOL_AUTH = 612,                     /* AUTH  */
  YYSYMBOL_FATAL = 613,                    /* FATAL  */
  YYSYMBOL_BUG = 614,                      /* BUG  */
  YYSYMBOL_LATENCY = 615,                  /* LATENCY  */
  YYSYMBOL_WATCHDOG = 616,                 /* WATCHDOG  */
  YYSYMBOL_THREADS = 617,                  /* THREADS  */
  YYSYMBOL_CONFIGURE = 618,                /* CONFIGURE  */
  YYSYMBOL_SOFT = 619,                     /* SOFT  */
  YYSYMBOL_CONFIRM = 620,                  /* CONFIRM  */
  YYSYMBOL_UNDO = 621,                     /* UNDO  */
  YYSYMBOL_DOWN = 622,                     /* DOWN  */
  YYSYMBOL_PERSIST = 623,                  /* PERSIST  */
  YYSYMBOL_SCAN = 624,                     /* SCAN  */
  YYSYMBOL_LEARN = 625,                    /* LEARN  */
  YYSYMBOL_DEVICE = 626,                   /* DEVICE  */
  YYSYMBOL_KRT_SOURCE = 627,               /* KRT_SOURCE  */
  YYSYMBOL_KRT_METRIC = 628,               /* KRT_METRIC  */
  YYSYMBOL_YYACCEPT = 629,                 /* $accept  */
  YYSYMBOL_cli_cmd = 630,                  /* cli_cmd  */
  YYSYMBOL_cmd_QUIT = 631,                 /* cmd_QUIT  */
  YYSYMBOL_cmd_EXIT = 632,                 /* cmd_EXIT  */
  YYSYMBOL_cmd_HELP = 633,                 /* cmd_HELP  */
  YYSYMBOL_config = 634,                   /* config  */
  YYSYMBOL_conf_entries = 635,             /* conf_entries  */
  YYSYMBOL_conf = 636,                     /* conf  */
  YYSYMBOL_definition = 637,               /* definition  */
  YYSYMBOL_expr = 638,                     /* expr  */
  YYSYMBOL_expr_us = 639,                  /* expr_us  */
  YYSYMBOL_symbol = 640,                   /* symbol  */
  YYSYMBOL_symbol_known = 641,             /* symbol_known  */
  YYSYMBOL_bool = 642,                     /* bool  */
  YYSYMBOL_ipa = 643,                      /* ipa  */
  YYSYMBOL_ipa_scope = 644,                /* ipa_scope  */
  YYSYMBOL_pxlen4 = 645,                   /* pxlen4  */
  YYSYMBOL_net_ip4_ = 646,                 /* net_ip4_  */
  YYSYMBOL_net_ip6_ = 647,                 /* net_ip6_  */
  YYSYMBOL_net_ip6_sadr_ = 648,            /* net_ip6_sadr_  */
  YYSYMBOL_net_vpn4_ = 649,                /* net_vpn4_  */
  YYSYMBOL_net_vpn6_ = 650,                /* net_vpn6_  */
  YYSYMBOL_net_roa4_ = 651,                /* net_roa4_  */
  YYSYMBOL_net_roa6_ = 652,                /* net_roa6_  */
  YYSYMBOL_net_mpls_ = 653,                /* net_mpls_  */
  YYSYMBOL_net_aspa_ = 654,                /* net_aspa_  */
  YYSYMBOL_net_ip_ = 655,                  /* net_ip_  */
  YYSYMBOL_net_vpn_ = 656,                 /* net_vpn_  */
  YYSYMBOL_net_roa_ = 657,                 /* net_roa_  */
  YYSYMBOL_net_ = 658,                     /* net_  */
  YYSYMBOL_net_ip4 = 659,                  /* net_ip4  */
  YYSYMBOL_net_ip6 = 660,                  /* net_ip6  */
  YYSYMBOL_net_ip = 661,                   /* net_ip  */
  YYSYMBOL_net_any = 662,                  /* net_any  */
  YYSYMBOL_net_or_ipa = 663,               /* net_or_ipa  */
  YYSYMBOL_label_stack_start = 664,        /* label_stack_start  */
  YYSYMBOL_label_stack = 665,              /* label_stack  */
  YYSYMBOL_time = 666,                     /* time  */
  YYSYMBOL_text = 667,                     /* text  */
  YYSYMBOL_opttext = 668,                  /* opttext  */
  YYSYMBOL_text_or_ipa = 669,              /* text_or_ipa  */
  YYSYMBOL_bytestring = 670,               /* bytestring  */
  YYSYMBOL_bytestring_text = 671,          /* bytestring_text  */
  YYSYMBOL_bytestring_expr = 672,          /* bytestring_expr  */
  YYSYMBOL_flow_num_op = 673,              /* flow_num_op  */
  YYSYMBOL_flow_logic_op = 674,            /* flow_logic_op  */
  YYSYMBOL_flow_num_type_ = 675,           /* flow_num_type_  */
  YYSYMBOL_flow_num_type = 676,            /* flow_num_type  */
  YYSYMBOL_flow_flag_type = 677,           /* flow_flag_type  */
  YYSYMBOL_flow_frag_type = 678,           /* flow_frag_type  */
  YYSYMBOL_flow_srcdst = 679,              /* flow_srcdst  */
  YYSYMBOL_flow_num_opts = 680,            /* flow_num_opts  */
  YYSYMBOL_flow_num_opt_ext_expr = 681,    /* flow_num_opt_ext_expr  */
  YYSYMBOL_flow_num_opt_ext = 682,         /* flow_num_opt_ext  */
  YYSYMBOL_flow_bmk_opts = 683,            /* flow_bmk_opts  */
  YYSYMBOL_flow_neg = 684,                 /* flow_neg  */
  YYSYMBOL_flow_frag_val = 685,            /* flow_frag_val  */
  YYSYMBOL_flow_frag_opts = 686,           /* flow_frag_opts  */
  YYSYMBOL_flow4_item = 687,               /* flow4_item  */
  YYSYMBOL_flow6_item = 688,               /* flow6_item  */
  YYSYMBOL_flow4_opts = 689,               /* flow4_opts  */
  YYSYMBOL_flow6_opts = 690,               /* flow6_opts  */
  YYSYMBOL_flow_builder_init = 691,        /* flow_builder_init  */
  YYSYMBOL_flow_builder_set_ipv4 = 692,    /* flow_builder_set_ipv4  */
  YYSYMBOL_flow_builder_set_ipv6 = 693,    /* flow_builder_set_ipv6  */
  YYSYMBOL_net_flow4_ = 694,               /* net_flow4_  */
  YYSYMBOL_net_flow6_ = 695,               /* net_flow6_  */
  YYSYMBOL_net_flow_ = 696,                /* net_flow_  */
  YYSYMBOL_KEYWORD = 697,                  /* KEYWORD  */
  YYSYMBOL_enum_type = 698,                /* enum_type  */
  YYSYMBOL_filter_def = 699,               /* filter_def  */
  YYSYMBOL_700_1 = 700,                    /* $@1  */
  YYSYMBOL_filter_eval = 701,              /* filter_eval  */
  YYSYMBOL_custom_attr = 702,              /* custom_attr  */
  YYSYMBOL_bt_test_suite = 703,            /* bt_test_suite  */
  YYSYMBOL_bt_test_same = 704,             /* bt_test_same  */
  YYSYMBOL_type = 705,                     /* type  */
  YYSYMBOL_function_argsn = 706,           /* function_argsn  */
  YYSYMBOL_function_args = 707,            /* function_args  */
  YYSYMBOL_function_vars = 708,            /* function_vars  */
  YYSYMBOL_function_type = 709,            /* function_type  */
  YYSYMBOL_filter_body = 710,              /* filter_body  */
  YYSYMBOL_filter = 711,                   /* filter  */
  YYSYMBOL_712_2 = 712,                    /* $@2  */
  YYSYMBOL_where_filter = 713,             /* where_filter  */
  YYSYMBOL_function_body = 714,            /* function_body  */
  YYSYMBOL_function_def = 715,             /* function_def  */
  YYSYMBOL_716_3 = 716,                    /* $@3  */
  YYSYMBOL_717_4 = 717,                    /* $@4  */
  YYSYMBOL_cmds = 718,                     /* cmds  */
  YYSYMBOL_cmds_scoped = 719,              /* cmds_scoped  */
  YYSYMBOL_720_5 = 720,                    /* $@5  */
  YYSYMBOL_cmd_var = 721,                  /* cmd_var  */
  YYSYMBOL_cmd_prep = 722,                 /* cmd_prep  */
  YYSYMBOL_cmds_int = 723,                 /* cmds_int  */
  YYSYMBOL_fipa = 724,                     /* fipa  */
  YYSYMBOL_set_atom0 = 725,                /* set_atom0  */
  YYSYMBOL_set_atom = 726,                 /* set_atom  */
  YYSYMBOL_switch_atom = 727,              /* switch_atom  */
  YYSYMBOL_cnum = 728,                     /* cnum  */
  YYSYMBOL_pair_item = 729,                /* pair_item  */
  YYSYMBOL_ec_kind = 730,                  /* ec_kind  */
  YYSYMBOL_ec_item = 731,                  /* ec_item  */
  YYSYMBOL_lc_item = 732,                  /* lc_item  */
  YYSYMBOL_set_item = 733,                 /* set_item  */
  YYSYMBOL_switch_item = 734,              /* switch_item  */
  YYSYMBOL_ec_items = 735,                 /* ec_items  */
  YYSYMBOL_set_items = 736,                /* set_items  */
  YYSYMBOL_switch_items = 737,             /* switch_items  */
  YYSYMBOL_fprefix = 738,                  /* fprefix  */
  YYSYMBOL_fprefix_set = 739,              /* fprefix_set  */
  YYSYMBOL_switch_body = 740,              /* switch_body  */
  YYSYMBOL_bgp_path_expr = 741,            /* bgp_path_expr  */
  YYSYMBOL_bgp_path = 742,                 /* bgp_path  */
  YYSYMBOL_bgp_path_tail = 743,            /* bgp_path_tail  */
  YYSYMBOL_constant = 744,                 /* constant  */
  YYSYMBOL_constructor = 745,              /* constructor  */
  YYSYMBOL_var_list_r = 746,               /* var_list_r  */
  YYSYMBOL_var_list = 747,                 /* var_list  */
  YYSYMBOL_function_call = 748,            /* function_call  */
  YYSYMBOL_symbol_value = 749,             /* symbol_value  */
  YYSYMBOL_static_attr = 750,              /* static_attr  */
  YYSYMBOL_term_dot_method = 751,          /* term_dot_method  */
  YYSYMBOL_752_6 = 752,                    /* $@6  */
  YYSYMBOL_method_name_cont = 753,         /* method_name_cont  */
  YYSYMBOL_754_7 = 754,                    /* $@7  */
  YYSYMBOL_term = 755,                     /* term  */
  YYSYMBOL_term_bs = 756,                  /* term_bs  */
  YYSYMBOL_break_command = 757,            /* break_command  */
  YYSYMBOL_var = 758,                      /* var  */
  YYSYMBOL_for_var = 759,                  /* for_var  */
  YYSYMBOL_cmd = 760,                      /* cmd  */
  YYSYMBOL_761_8 = 761,                    /* $@8  */
  YYSYMBOL_762_9 = 762,                    /* $@9  */
  YYSYMBOL_763_10 = 763,                   /* $@10  */
  YYSYMBOL_764_11 = 764,                   /* $@11  */
  YYSYMBOL_get_cf_position = 765,          /* get_cf_position  */
  YYSYMBOL_lvalue = 766,                   /* lvalue  */
  YYSYMBOL_rtrid = 767,                    /* rtrid  */
  YYSYMBOL_idval = 768,                    /* idval  */
  YYSYMBOL_hostname_override = 769,        /* hostname_override  */
  YYSYMBOL_gr_opts = 770,                  /* gr_opts  */
  YYSYMBOL_net_type_base = 771,            /* net_type_base  */
  YYSYMBOL_net_type = 772,                 /* net_type  */
  YYSYMBOL_table = 773,                    /* table  */
  YYSYMBOL_table_start = 774,              /* table_start  */
  YYSYMBOL_table_sorted = 775,             /* table_sorted  */
  YYSYMBOL_table_opt = 776,                /* table_opt  */
  YYSYMBOL_table_opts = 777,               /* table_opts  */
  YYSYMBOL_table_opt_list = 778,           /* table_opt_list  */
  YYSYMBOL_proto_start = 779,              /* proto_start  */
  YYSYMBOL_proto_name = 780,               /* proto_name  */
  YYSYMBOL_proto_item = 781,               /* proto_item  */
  YYSYMBOL_channel_start = 782,            /* channel_start  */
  YYSYMBOL_channel_item_ = 783,            /* channel_item_  */
  YYSYMBOL_channel_item = 784,             /* channel_item  */
  YYSYMBOL_channel_opts = 785,             /* channel_opts  */
  YYSYMBOL_channel_opt_list = 786,         /* channel_opt_list  */
  YYSYMBOL_channel_end = 787,              /* channel_end  */
  YYSYMBOL_proto_channel = 788,            /* proto_channel  */
  YYSYMBOL_rtable = 789,                   /* rtable  */
  YYSYMBOL_imexport = 790,                 /* imexport  */
  YYSYMBOL_limit_action = 791,             /* limit_action  */
  YYSYMBOL_limit_spec = 792,               /* limit_spec  */
  YYSYMBOL_debug_default = 793,            /* debug_default  */
  YYSYMBOL_timeformat_base = 794,          /* timeformat_base  */
  YYSYMBOL_timeformat_which = 795,         /* timeformat_which  */
  YYSYMBOL_timeformat_spec = 796,          /* timeformat_spec  */
  YYSYMBOL_iface_patt_node_init = 797,     /* iface_patt_node_init  */
  YYSYMBOL_iface_patt_node_body = 798,     /* iface_patt_node_body  */
  YYSYMBOL_iface_negate = 799,             /* iface_negate  */
  YYSYMBOL_iface_patt_node = 800,          /* iface_patt_node  */
  YYSYMBOL_iface_patt_list = 801,          /* iface_patt_list  */
  YYSYMBOL_iface_patt_list_nopx = 802,     /* iface_patt_list_nopx  */
  YYSYMBOL_iface_patt_init = 803,          /* iface_patt_init  */
  YYSYMBOL_iface_patt = 804,               /* iface_patt  */
  YYSYMBOL_tos = 805,                      /* tos  */
  YYSYMBOL_proto = 806,                    /* proto  */
  YYSYMBOL_dev_proto_start = 807,          /* dev_proto_start  */
  YYSYMBOL_dev_proto = 808,                /* dev_proto  */
  YYSYMBOL_dev_iface_init = 809,           /* dev_iface_init  */
  YYSYMBOL_dev_iface_patt = 810,           /* dev_iface_patt  */
  YYSYMBOL_debug_mask = 811,               /* debug_mask  */
  YYSYMBOL_debug_list = 812,               /* debug_list  */
  YYSYMBOL_debug_flag = 813,               /* debug_flag  */
  YYSYMBOL_mrtdump_mask = 814,             /* mrtdump_mask  */
  YYSYMBOL_mrtdump_list = 815,             /* mrtdump_list  */
  YYSYMBOL_mrtdump_flag = 816,             /* mrtdump_flag  */
  YYSYMBOL_password_list = 817,            /* password_list  */
  YYSYMBOL_password_list_body = 818,       /* password_list_body  */
  YYSYMBOL_password_items = 819,           /* password_items  */
  YYSYMBOL_password_item = 820,            /* password_item  */
  YYSYMBOL_pass_key = 821,                 /* pass_key  */
  YYSYMBOL_password_item_begin = 822,      /* password_item_begin  */
  YYSYMBOL_password_item_params = 823,     /* password_item_params  */
  YYSYMBOL_password_algorithm = 824,       /* password_algorithm  */
  YYSYMBOL_password_item_end = 825,        /* password_item_end  */
  YYSYMBOL_bfd_opts = 826,                 /* bfd_opts  */
  YYSYMBOL_cmd_SHOW_STATUS = 827,          /* cmd_SHOW_STATUS  */
  YYSYMBOL_cmd_SHOW_MEMORY = 828,          /* cmd_SHOW_MEMORY  */
  YYSYMBOL_cmd_SHOW_PROTOCOLS = 829,       /* cmd_SHOW_PROTOCOLS  */
  YYSYMBOL_cmd_SHOW_PROTOCOLS_ALL = 830,   /* cmd_SHOW_PROTOCOLS_ALL  */
  YYSYMBOL_optproto = 831,                 /* optproto  */
  YYSYMBOL_cmd_SHOW_INTERFACES = 832,      /* cmd_SHOW_INTERFACES  */
  YYSYMBOL_cmd_SHOW_INTERFACES_SUMMARY = 833, /* cmd_SHOW_INTERFACES_SUMMARY  */
  YYSYMBOL_cmd_SHOW_ROUTE = 834,           /* cmd_SHOW_ROUTE  */
  YYSYMBOL_r_args = 835,                   /* r_args  */
  YYSYMBOL_r_args_for = 836,               /* r_args_for  */
  YYSYMBOL_r_args_for_val = 837,           /* r_args_for_val  */
  YYSYMBOL_export_mode = 838,              /* export_mode  */
  YYSYMBOL_channel_sym = 839,              /* channel_sym  */
  YYSYMBOL_channel_arg = 840,              /* channel_arg  */
  YYSYMBOL_cmd_SHOW_SYMBOLS = 841,         /* cmd_SHOW_SYMBOLS  */
  YYSYMBOL_sym_args = 842,                 /* sym_args  */
  YYSYMBOL_cmd_DUMP_RESOURCES = 843,       /* cmd_DUMP_RESOURCES  */
  YYSYMBOL_cmd_DUMP_SOCKETS = 844,         /* cmd_DUMP_SOCKETS  */
  YYSYMBOL_cmd_DUMP_AO_KEYS = 845,         /* cmd_DUMP_AO_KEYS  */
  YYSYMBOL_cmd_DUMP_EVENTS = 846,          /* cmd_DUMP_EVENTS  */
  YYSYMBOL_cmd_DUMP_INTERFACES = 847,      /* cmd_DUMP_INTERFACES  */
  YYSYMBOL_cmd_DUMP_NEIGHBORS = 848,       /* cmd_DUMP_NEIGHBORS  */
  YYSYMBOL_cmd_DUMP_ATTRIBUTES = 849,      /* cmd_DUMP_ATTRIBUTES  */
  YYSYMBOL_cmd_DUMP_ROUTES = 850,          /* cmd_DUMP_ROUTES  */
  YYSYMBOL_cmd_DUMP_PROTOCOLS = 851,       /* cmd_DUMP_PROTOCOLS  */
  YYSYMBOL_cmd_DUMP_FILTER_ALL = 852,      /* cmd_DUMP_FILTER_ALL  */
  YYSYMBOL_cmd_EVAL = 853,                 /* cmd_EVAL  */
  YYSYMBOL_cmd_ECHO = 854,                 /* cmd_ECHO  */
  YYSYMBOL_echo_mask = 855,                /* echo_mask  */
  YYSYMBOL_echo_size = 856,                /* echo_size  */
  YYSYMBOL_cmd_DISABLE = 857,              /* cmd_DISABLE  */
  YYSYMBOL_cmd_ENABLE = 858,               /* cmd_ENABLE  */
  YYSYMBOL_cmd_RESTART = 859,              /* cmd_RESTART  */
  YYSYMBOL_cmd_RELOAD = 860,               /* cmd_RELOAD  */
  YYSYMBOL_cmd_RELOAD_IN = 861,            /* cmd_RELOAD_IN  */
  YYSYMBOL_cmd_RELOAD_OUT = 862,           /* cmd_RELOAD_OUT  */
  YYSYMBOL_cmd_DEBUG = 863,                /* cmd_DEBUG  */
  YYSYMBOL_debug_args = 864,               /* debug_args  */
  YYSYMBOL_cmd_MRTDUMP = 865,              /* cmd_MRTDUMP  */
  YYSYMBOL_cmd_RESTRICT = 866,             /* cmd_RESTRICT  */
  YYSYMBOL_cmd_TIMEFORMAT = 867,           /* cmd_TIMEFORMAT  */
  YYSYMBOL_proto_patt = 868,               /* proto_patt  */
  YYSYMBOL_proto_patt2 = 869,              /* proto_patt2  */
  YYSYMBOL_dynamic_attr = 870,             /* dynamic_attr  */
  YYSYMBOL_mpls_domain = 871,              /* mpls_domain  */
  YYSYMBOL_mpls_domain_start = 872,        /* mpls_domain_start  */
  YYSYMBOL_mpls_domain_opt = 873,          /* mpls_domain_opt  */
  YYSYMBOL_mpls_domain_opts = 874,         /* mpls_domain_opts  */
  YYSYMBOL_mpls_domain_opt_list = 875,     /* mpls_domain_opt_list  */
  YYSYMBOL_mpls_domain_end = 876,          /* mpls_domain_end  */
  YYSYMBOL_mpls_range = 877,               /* mpls_range  */
  YYSYMBOL_mpls_range_start = 878,         /* mpls_range_start  */
  YYSYMBOL_mpls_range_opt = 879,           /* mpls_range_opt  */
  YYSYMBOL_mpls_range_opts = 880,          /* mpls_range_opts  */
  YYSYMBOL_mpls_range_opt_list = 881,      /* mpls_range_opt_list  */
  YYSYMBOL_mpls_range_end = 882,           /* mpls_range_end  */
  YYSYMBOL_mpls_channel = 883,             /* mpls_channel  */
  YYSYMBOL_mpls_channel_start = 884,       /* mpls_channel_start  */
  YYSYMBOL_mpls_label_policy = 885,        /* mpls_label_policy  */
  YYSYMBOL_mpls_channel_opt = 886,         /* mpls_channel_opt  */
  YYSYMBOL_mpls_channel_opts = 887,        /* mpls_channel_opts  */
  YYSYMBOL_mpls_channel_opt_list = 888,    /* mpls_channel_opt_list  */
  YYSYMBOL_mpls_channel_end = 889,         /* mpls_channel_end  */
  YYSYMBOL_890_12 = 890,                   /* $@12  */
  YYSYMBOL_show_mpls_ranges_args = 891,    /* show_mpls_ranges_args  */
  YYSYMBOL_cmd_SHOW_MPLS_RANGES = 892,     /* cmd_SHOW_MPLS_RANGES  */
  YYSYMBOL_aggregator_proto_start = 893,   /* aggregator_proto_start  */
  YYSYMBOL_aggregator_proto_item = 894,    /* aggregator_proto_item  */
  YYSYMBOL_895_13 = 895,                   /* $@13  */
  YYSYMBOL_aggregator_proto_opts = 896,    /* aggregator_proto_opts  */
  YYSYMBOL_aggregator_proto = 897,         /* aggregator_proto  */
  YYSYMBOL_aggr_list = 898,                /* aggr_list  */
  YYSYMBOL_aggr_item = 899,                /* aggr_item  */
  YYSYMBOL_babel_proto_start = 900,        /* babel_proto_start  */
  YYSYMBOL_babel_proto_item = 901,         /* babel_proto_item  */
  YYSYMBOL_babel_proto_opts = 902,         /* babel_proto_opts  */
  YYSYMBOL_babel_proto = 903,              /* babel_proto  */
  YYSYMBOL_babel_iface_start = 904,        /* babel_iface_start  */
  YYSYMBOL_babel_iface_finish = 905,       /* babel_iface_finish  */
  YYSYMBOL_babel_iface_item = 906,         /* babel_iface_item  */
  YYSYMBOL_babel_iface_opts = 907,         /* babel_iface_opts  */
  YYSYMBOL_babel_iface_opt_list = 908,     /* babel_iface_opt_list  */
  YYSYMBOL_babel_iface = 909,              /* babel_iface  */
  YYSYMBOL_cmd_SHOW_BABEL_INTERFACES = 910, /* cmd_SHOW_BABEL_INTERFACES  */
  YYSYMBOL_cmd_SHOW_BABEL_NEIGHBORS = 911, /* cmd_SHOW_BABEL_NEIGHBORS  */
  YYSYMBOL_cmd_SHOW_BABEL_ENTRIES = 912,   /* cmd_SHOW_BABEL_ENTRIES  */
  YYSYMBOL_cmd_SHOW_BABEL_ROUTES = 913,    /* cmd_SHOW_BABEL_ROUTES  */
  YYSYMBOL_bfd_proto_start = 914,          /* bfd_proto_start  */
  YYSYMBOL_bfd_proto_item = 915,           /* bfd_proto_item  */
  YYSYMBOL_bfd_proto_opts = 916,           /* bfd_proto_opts  */
  YYSYMBOL_bfd_proto = 917,                /* bfd_proto  */
  YYSYMBOL_bfd_accept_item = 918,          /* bfd_accept_item  */
  YYSYMBOL_bfd_accept = 919,               /* bfd_accept  */
  YYSYMBOL_bfd_iface_start = 920,          /* bfd_iface_start  */
  YYSYMBOL_bfd_iface_finish = 921,         /* bfd_iface_finish  */
  YYSYMBOL_bfd_iface_item = 922,           /* bfd_iface_item  */
  YYSYMBOL_bfd_auth_type = 923,            /* bfd_auth_type  */
  YYSYMBOL_bfd_iface_opts = 924,           /* bfd_iface_opts  */
  YYSYMBOL_bfd_iface_opt_list = 925,       /* bfd_iface_opt_list  */
  YYSYMBOL_bfd_iface = 926,                /* bfd_iface  */
  YYSYMBOL_bfd_multihop = 927,             /* bfd_multihop  */
  YYSYMBOL_bfd_neigh_iface = 928,          /* bfd_neigh_iface  */
  YYSYMBOL_bfd_neigh_local = 929,          /* bfd_neigh_local  */
  YYSYMBOL_bfd_neigh_multihop = 930,       /* bfd_neigh_multihop  */
  YYSYMBOL_bfd_neighbor = 931,             /* bfd_neighbor  */
  YYSYMBOL_bfd_item = 932,                 /* bfd_item  */
  YYSYMBOL_bfd_items = 933,                /* bfd_items  */
  YYSYMBOL_bfd_opts_start = 934,           /* bfd_opts_start  */
  YYSYMBOL_bfd_opts_end = 935,             /* bfd_opts_end  */
  YYSYMBOL_cmd_SHOW_BFD_SESSIONS = 936,    /* cmd_SHOW_BFD_SESSIONS  */
  YYSYMBOL_bfd_show_sessions_args = 937,   /* bfd_show_sessions_args  */
  YYSYMBOL_bgp_proto_start = 938,          /* bgp_proto_start  */
  YYSYMBOL_bgp_loc_opts = 939,             /* bgp_loc_opts  */
  YYSYMBOL_bgp_nbr_opts = 940,             /* bgp_nbr_opts  */
  YYSYMBOL_bgp_cease_mask = 941,           /* bgp_cease_mask  */
  YYSYMBOL_bgp_cease_list = 942,           /* bgp_cease_list  */
  YYSYMBOL_bgp_cease_flag = 943,           /* bgp_cease_flag  */
  YYSYMBOL_bgp_auth_type = 944,            /* bgp_auth_type  */
  YYSYMBOL_bgp_role_name = 945,            /* bgp_role_name  */
  YYSYMBOL_bgp_proto = 946,                /* bgp_proto  */
  YYSYMBOL_947_14 = 947,                   /* $@14  */
  YYSYMBOL_948_15 = 948,                   /* $@15  */
  YYSYMBOL_bgp_afi = 949,                  /* bgp_afi  */
  YYSYMBOL_tcp_ao_key_start = 950,         /* tcp_ao_key_start  */
  YYSYMBOL_tcp_ao_key_opt = 951,           /* tcp_ao_key_opt  */
  YYSYMBOL_tcp_ao_algorithm = 952,         /* tcp_ao_algorithm  */
  YYSYMBOL_tcp_ao_key_opts = 953,          /* tcp_ao_key_opts  */
  YYSYMBOL_tcp_ao_key_end = 954,           /* tcp_ao_key_end  */
  YYSYMBOL_tcp_ao_key = 955,               /* tcp_ao_key  */
  YYSYMBOL_tcp_ao_keys = 956,              /* tcp_ao_keys  */
  YYSYMBOL_tcp_ao_key_list = 957,          /* tcp_ao_key_list  */
  YYSYMBOL_958_16 = 958,                   /* $@16  */
  YYSYMBOL_tcp_ao_end = 959,               /* tcp_ao_end  */
  YYSYMBOL_bgp_channel_start = 960,        /* bgp_channel_start  */
  YYSYMBOL_bgp_nh = 961,                   /* bgp_nh  */
  YYSYMBOL_bgp_llnh = 962,                 /* bgp_llnh  */
  YYSYMBOL_bgp_lladdr = 963,               /* bgp_lladdr  */
  YYSYMBOL_bgp_channel_item = 964,         /* bgp_channel_item  */
  YYSYMBOL_bgp_channel_opts = 965,         /* bgp_channel_opts  */
  YYSYMBOL_bgp_channel_opt_list = 966,     /* bgp_channel_opt_list  */
  YYSYMBOL_bgp_channel_end = 967,          /* bgp_channel_end  */
  YYSYMBOL_bgp_proto_channel = 968,        /* bgp_proto_channel  */
  YYSYMBOL_l3vpn_channel_start = 969,      /* l3vpn_channel_start  */
  YYSYMBOL_l3vpn_channel = 970,            /* l3vpn_channel  */
  YYSYMBOL_l3vpn_proto_start = 971,        /* l3vpn_proto_start  */
  YYSYMBOL_l3vpn_proto_item = 972,         /* l3vpn_proto_item  */
  YYSYMBOL_l3vpn_proto_opts = 973,         /* l3vpn_proto_opts  */
  YYSYMBOL_l3vpn_proto = 974,              /* l3vpn_proto  */
  YYSYMBOL_l3vpn_targets = 975,            /* l3vpn_targets  */
  YYSYMBOL_mrt_proto_start = 976,          /* mrt_proto_start  */
  YYSYMBOL_mrt_proto_item = 977,           /* mrt_proto_item  */
  YYSYMBOL_mrt_proto_opts = 978,           /* mrt_proto_opts  */
  YYSYMBOL_mrt_proto = 979,                /* mrt_proto  */
  YYSYMBOL_cmd_MRT_DUMP = 980,             /* cmd_MRT_DUMP  */
  YYSYMBOL_mrt_dump_args = 981,            /* mrt_dump_args  */
  YYSYMBOL_ospf_variant = 982,             /* ospf_variant  */
  YYSYMBOL_ospf_proto_start = 983,         /* ospf_proto_start  */
  YYSYMBOL_ospf_proto = 984,               /* ospf_proto  */
  YYSYMBOL_ospf_af_mc = 985,               /* ospf_af_mc  */
  YYSYMBOL_ospf_channel_start = 986,       /* ospf_channel_start  */
  YYSYMBOL_ospf_channel = 987,             /* ospf_channel  */
  YYSYMBOL_ospf_proto_item = 988,          /* ospf_proto_item  */
  YYSYMBOL_ospf_area_start = 989,          /* ospf_area_start  */
  YYSYMBOL_ospf_area = 990,                /* ospf_area  */
  YYSYMBOL_ospf_area_opts = 991,           /* ospf_area_opts  */
  YYSYMBOL_ospf_area_item = 992,           /* ospf_area_item  */
  YYSYMBOL_993_17 = 993,                   /* $@17  */
  YYSYMBOL_994_18 = 994,                   /* $@18  */
  YYSYMBOL_ospf_stubnet = 995,             /* ospf_stubnet  */
  YYSYMBOL_ospf_stubnet_start = 996,       /* ospf_stubnet_start  */
  YYSYMBOL_ospf_stubnet_opts = 997,        /* ospf_stubnet_opts  */
  YYSYMBOL_ospf_stubnet_item = 998,        /* ospf_stubnet_item  */
  YYSYMBOL_ospf_vlink = 999,               /* ospf_vlink  */
  YYSYMBOL_ospf_vlink_opts = 1000,         /* ospf_vlink_opts  */
  YYSYMBOL_ospf_vlink_item = 1001,         /* ospf_vlink_item  */
  YYSYMBOL_ospf_vlink_start = 1002,        /* ospf_vlink_start  */
  YYSYMBOL_ospf_iface_item = 1003,         /* ospf_iface_item  */
  YYSYMBOL_pref_list = 1004,               /* pref_list  */
  YYSYMBOL_pref_item = 1005,               /* pref_item  */
  YYSYMBOL_pref_base = 1006,               /* pref_base  */
  YYSYMBOL_pref_opt = 1007,                /* pref_opt  */
  YYSYMBOL_nbma_list = 1008,               /* nbma_list  */
  YYSYMBOL_nbma_eligible = 1009,           /* nbma_eligible  */
  YYSYMBOL_nbma_item = 1010,               /* nbma_item  */
  YYSYMBOL_ospf_iface_start = 1011,        /* ospf_iface_start  */
  YYSYMBOL_ospf_instance_id = 1012,        /* ospf_instance_id  */
  YYSYMBOL_ospf_iface_patt_list = 1013,    /* ospf_iface_patt_list  */
  YYSYMBOL_1014_19 = 1014,                 /* $@19  */
  YYSYMBOL_ospf_iface_opts = 1015,         /* ospf_iface_opts  */
  YYSYMBOL_ospf_iface_opt_list = 1016,     /* ospf_iface_opt_list  */
  YYSYMBOL_ospf_iface = 1017,              /* ospf_iface  */
  YYSYMBOL_cmd_SHOW_OSPF = 1018,           /* cmd_SHOW_OSPF  */
  YYSYMBOL_cmd_SHOW_OSPF_NEIGHBORS = 1019, /* cmd_SHOW_OSPF_NEIGHBORS  */
  YYSYMBOL_cmd_SHOW_OSPF_INTERFACE = 1020, /* cmd_SHOW_OSPF_INTERFACE  */
  YYSYMBOL_cmd_SHOW_OSPF_TOPOLOGY = 1021,  /* cmd_SHOW_OSPF_TOPOLOGY  */
  YYSYMBOL_cmd_SHOW_OSPF_TOPOLOGY_ALL = 1022, /* cmd_SHOW_OSPF_TOPOLOGY_ALL  */
  YYSYMBOL_cmd_SHOW_OSPF_STATE = 1023,     /* cmd_SHOW_OSPF_STATE  */
  YYSYMBOL_cmd_SHOW_OSPF_STATE_ALL = 1024, /* cmd_SHOW_OSPF_STATE_ALL  */
  YYSYMBOL_cmd_SHOW_OSPF_LSADB = 1025,     /* cmd_SHOW_OSPF_LSADB  */
  YYSYMBOL_lsadb_args = 1026,              /* lsadb_args  */
  YYSYMBOL_perf_proto_start = 1027,        /* perf_proto_start  */
  YYSYMBOL_perf_proto = 1028,              /* perf_proto  */
  YYSYMBOL_perf_proto_item = 1029,         /* perf_proto_item  */
  YYSYMBOL_pipe_proto_start = 1030,        /* pipe_proto_start  */
  YYSYMBOL_1031_20 = 1031,                 /* $@20  */
  YYSYMBOL_pipe_proto = 1032,              /* pipe_proto  */
  YYSYMBOL_radv_proto_start = 1033,        /* radv_proto_start  */
  YYSYMBOL_radv_proto_item = 1034,         /* radv_proto_item  */
  YYSYMBOL_1035_21 = 1035,                 /* $@21  */
  YYSYMBOL_1036_22 = 1036,                 /* $@22  */
  YYSYMBOL_radv_proto_opts = 1037,         /* radv_proto_opts  */
  YYSYMBOL_radv_proto = 1038,              /* radv_proto  */
  YYSYMBOL_radv_iface_start = 1039,        /* radv_iface_start  */
  YYSYMBOL_radv_iface_item = 1040,         /* radv_iface_item  */
  YYSYMBOL_1041_23 = 1041,                 /* $@23  */
  YYSYMBOL_1042_24 = 1042,                 /* $@24  */
  YYSYMBOL_radv_preference = 1043,         /* radv_preference  */
  YYSYMBOL_radv_iface_finish = 1044,       /* radv_iface_finish  */
  YYSYMBOL_radv_iface_opts = 1045,         /* radv_iface_opts  */
  YYSYMBOL_radv_iface_opt_list = 1046,     /* radv_iface_opt_list  */
  YYSYMBOL_radv_iface = 1047,              /* radv_iface  */
  YYSYMBOL_radv_prefix_start = 1048,       /* radv_prefix_start  */
  YYSYMBOL_radv_prefix_item = 1049,        /* radv_prefix_item  */
  YYSYMBOL_radv_prefix_finish = 1050,      /* radv_prefix_finish  */
  YYSYMBOL_radv_prefix_opts = 1051,        /* radv_prefix_opts  */
  YYSYMBOL_radv_prefix_opt_list = 1052,    /* radv_prefix_opt_list  */
  YYSYMBOL_radv_prefix = 1053,             /* radv_prefix  */
  YYSYMBOL_radv_rdnss_node = 1054,         /* radv_rdnss_node  */
  YYSYMBOL_radv_rdnss_start = 1055,        /* radv_rdnss_start  */
  YYSYMBOL_radv_rdnss_item = 1056,         /* radv_rdnss_item  */
  YYSYMBOL_radv_rdnss_finish = 1057,       /* radv_rdnss_finish  */
  YYSYMBOL_radv_rdnss_opts = 1058,         /* radv_rdnss_opts  */
  YYSYMBOL_radv_rdnss = 1059,              /* radv_rdnss  */
  YYSYMBOL_radv_dnssl_node = 1060,         /* radv_dnssl_node  */
  YYSYMBOL_radv_dnssl_start = 1061,        /* radv_dnssl_start  */
  YYSYMBOL_radv_dnssl_item = 1062,         /* radv_dnssl_item  */
  YYSYMBOL_radv_dnssl_finish = 1063,       /* radv_dnssl_finish  */
  YYSYMBOL_radv_dnssl_opts = 1064,         /* radv_dnssl_opts  */
  YYSYMBOL_radv_dnssl = 1065,              /* radv_dnssl  */
  YYSYMBOL_radv_mult = 1066,               /* radv_mult  */
  YYSYMBOL_radv_sensitive = 1067,          /* radv_sensitive  */
  YYSYMBOL_rip_variant = 1068,             /* rip_variant  */
  YYSYMBOL_rip_proto_start = 1069,         /* rip_proto_start  */
  YYSYMBOL_rip_proto_item = 1070,          /* rip_proto_item  */
  YYSYMBOL_rip_proto_opts = 1071,          /* rip_proto_opts  */
  YYSYMBOL_rip_proto = 1072,               /* rip_proto  */
  YYSYMBOL_rip_iface_start = 1073,         /* rip_iface_start  */
  YYSYMBOL_rip_iface_finish = 1074,        /* rip_iface_finish  */
  YYSYMBOL_rip_iface_item = 1075,          /* rip_iface_item  */
  YYSYMBOL_rip_auth = 1076,                /* rip_auth  */
  YYSYMBOL_rip_iface_opts = 1077,          /* rip_iface_opts  */
  YYSYMBOL_rip_iface_opt_list = 1078,      /* rip_iface_opt_list  */
  YYSYMBOL_rip_iface = 1079,               /* rip_iface  */
  YYSYMBOL_cmd_SHOW_RIP_INTERFACES = 1080, /* cmd_SHOW_RIP_INTERFACES  */
  YYSYMBOL_cmd_SHOW_RIP_NEIGHBORS = 1081,  /* cmd_SHOW_RIP_NEIGHBORS  */
  YYSYMBOL_rpki_proto_start = 1082,        /* rpki_proto_start  */
  YYSYMBOL_rpki_proto = 1083,              /* rpki_proto  */
  YYSYMBOL_rpki_proto_opts = 1084,         /* rpki_proto_opts  */
  YYSYMBOL_rpki_proto_item = 1085,         /* rpki_proto_item  */
  YYSYMBOL_rpki_keep_interval = 1086,      /* rpki_keep_interval  */
  YYSYMBOL_rpki_proto_item_port = 1087,    /* rpki_proto_item_port  */
  YYSYMBOL_rpki_cache_addr = 1088,         /* rpki_cache_addr  */
  YYSYMBOL_rpki_transport = 1089,          /* rpki_transport  */
  YYSYMBOL_rpki_transport_tcp_init = 1090, /* rpki_transport_tcp_init  */
  YYSYMBOL_rpki_transport_tcp_opts_list = 1091, /* rpki_transport_tcp_opts_list  */
  YYSYMBOL_rpki_transport_tcp_opts = 1092, /* rpki_transport_tcp_opts  */
  YYSYMBOL_rpki_transport_tcp_item = 1093, /* rpki_transport_tcp_item  */
  YYSYMBOL_rpki_transport_tcp_check = 1094, /* rpki_transport_tcp_check  */
  YYSYMBOL_rpki_transport_ssh_init = 1095, /* rpki_transport_ssh_init  */
  YYSYMBOL_rpki_transport_ssh_opts = 1096, /* rpki_transport_ssh_opts  */
  YYSYMBOL_rpki_transport_ssh_item = 1097, /* rpki_transport_ssh_item  */
  YYSYMBOL_rpki_transport_ssh_check = 1098, /* rpki_transport_ssh_check  */
  YYSYMBOL_static_proto_start = 1099,      /* static_proto_start  */
  YYSYMBOL_static_proto = 1100,            /* static_proto  */
  YYSYMBOL_stat_nexthop = 1101,            /* stat_nexthop  */
  YYSYMBOL_stat_nexthops = 1102,           /* stat_nexthops  */
  YYSYMBOL_stat_mpls = 1103,               /* stat_mpls  */
  YYSYMBOL_stat_route0 = 1104,             /* stat_route0  */
  YYSYMBOL_1105_25 = 1105,                 /* $@25  */
  YYSYMBOL_stat_route = 1106,              /* stat_route  */
  YYSYMBOL_1107_26 = 1107,                 /* $@26  */
  YYSYMBOL_stat_aspa_provider = 1108,      /* stat_aspa_provider  */
  YYSYMBOL_stat_aspa_providers = 1109,     /* stat_aspa_providers  */
  YYSYMBOL_stat_route_item = 1110,         /* stat_route_item  */
  YYSYMBOL_stat_route_opts = 1111,         /* stat_route_opts  */
  YYSYMBOL_stat_route_opt_list = 1112,     /* stat_route_opt_list  */
  YYSYMBOL_cmd_SHOW_STATIC = 1113,         /* cmd_SHOW_STATIC  */
  YYSYMBOL_kern_proto = 1114,              /* kern_proto  */
  YYSYMBOL_kern_sys_item = 1115,           /* kern_sys_item  */
  YYSYMBOL_log_begin = 1116,               /* log_begin  */
  YYSYMBOL_log_config = 1117,              /* log_config  */
  YYSYMBOL_syslog_name = 1118,             /* syslog_name  */
  YYSYMBOL_log_limit = 1119,               /* log_limit  */
  YYSYMBOL_log_file = 1120,                /* log_file  */
  YYSYMBOL_log_udp_host = 1121,            /* log_udp_host  */
  YYSYMBOL_log_udp_port = 1122,            /* log_udp_port  */
  YYSYMBOL_log_mask = 1123,                /* log_mask  */
  YYSYMBOL_log_mask_list = 1124,           /* log_mask_list  */
  YYSYMBOL_log_cat = 1125,                 /* log_cat  */
  YYSYMBOL_mrtdump_base = 1126,            /* mrtdump_base  */
  YYSYMBOL_cli = 1127,                     /* cli  */
  YYSYMBOL_cli_opts = 1128,                /* cli_opts  */
  YYSYMBOL_cli_opts_begin = 1129,          /* cli_opts_begin  */
  YYSYMBOL_cli_opts_block = 1130,          /* cli_opts_block  */
  YYSYMBOL_debug_unix = 1131,              /* debug_unix  */
  YYSYMBOL_cmd_CONFIGURE = 1132,           /* cmd_CONFIGURE  */
  YYSYMBOL_cmd_CONFIGURE_SOFT = 1133,      /* cmd_CONFIGURE_SOFT  */
  YYSYMBOL_cmd_CONFIGURE_CONFIRM = 1134,   /* cmd_CONFIGURE_CONFIRM  */
  YYSYMBOL_cmd_CONFIGURE_UNDO = 1135,      /* cmd_CONFIGURE_UNDO  */
  YYSYMBOL_cmd_CONFIGURE_STATUS = 1136,    /* cmd_CONFIGURE_STATUS  */
  YYSYMBOL_cmd_CONFIGURE_CHECK = 1137,     /* cmd_CONFIGURE_CHECK  */
  YYSYMBOL_cmd_DOWN = 1138,                /* cmd_DOWN  */
  YYSYMBOL_cmd_GRACEFUL_RESTART = 1139,    /* cmd_GRACEFUL_RESTART  */
  YYSYMBOL_cfg_name = 1140,                /* cfg_name  */
  YYSYMBOL_cfg_timeout = 1141,             /* cfg_timeout  */
  YYSYMBOL_kern_proto_start = 1142,        /* kern_proto_start  */
  YYSYMBOL_kern_learn = 1143,              /* kern_learn  */
  YYSYMBOL_kern_mp_limit = 1144,           /* kern_mp_limit  */
  YYSYMBOL_kern_channel = 1145,            /* kern_channel  */
  YYSYMBOL_kern_item = 1146,               /* kern_item  */
  YYSYMBOL_kif_proto_start = 1147,         /* kif_proto_start  */
  YYSYMBOL_kif_proto = 1148,               /* kif_proto  */
  YYSYMBOL_kif_item = 1149,                /* kif_item  */
  YYSYMBOL_kif_iface_start = 1150,         /* kif_iface_start  */
  YYSYMBOL_kif_iface_item = 1151,          /* kif_iface_item  */
  YYSYMBOL_kif_iface_opts = 1152,          /* kif_iface_opts  */
  YYSYMBOL_kif_iface_opt_list = 1153,      /* kif_iface_opt_list  */
  YYSYMBOL_kif_iface = 1154                /* kif_iface  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
# define YYCOPY_NEEDED 1
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  83
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   12409

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  629
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  526
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2290
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  3762

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   862


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    41,     2,     2,     2,    40,     2,     2,
      58,    59,    38,    36,    83,    37,    42,    39,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   155,    57,
      32,    31,    33,   158,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   156,     2,   157,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    84,     2,    85,    34,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    35,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,   149,   150,   153,   155,   158,   163,   166,   174,
     175,   176,   182,   183,   184,   187,   187,   187,   188,   193,
     194,   195,   196,   197,   198,   205,   206,   207,   214,   215,
     222,   228,   238,   251,   270,   276,   282,   290,   298,   304,
     310,   310,   311,   311,   312,   312,   315,   316,   317,   318,
     319,   320,   321,   328,   329,   337,   338,   346,   347,   355,
     356,   364,   365,   366,   367,   368,   378,   386,   387,   396,
     404,   405,   412,   413,   417,   418,   419,   420,   427,   435,
     436,   440,   441,   442,   450,   451,   452,    37,    38,    39,
      40,    41,    42,    43,    44,    48,    49,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    65,    66,    67,
      70,    71,    75,    79,    83,    84,    88,    92,   101,   102,
     106,   110,   114,   121,   122,   126,   127,   128,   129,   133,
     136,   139,   145,   149,   150,   151,   155,   159,   165,   166,
     167,   170,   172,   175,   177,   181,   188,   189,   191,   197,
     203,   203,     9,     9,    10,    10,    11,    11,   400,   402,
     402,   415,   417,   420,   421,   425,   427,   438,   440,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   492,   496,   497,
     506,   507,   515,   516,   523,   524,   527,   530,   534,   534,
     547,   554,   560,   563,   567,   563,   594,   595,   598,   598,
     600,   600,   602,   610,   611,   628,   629,   642,   643,   644,
     645,   646,   654,   655,   664,   668,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   685,   686,   687,   688,
     692,   693,   694,   698,   699,   700,   701,   702,   703,   704,
     705,   710,   711,   712,   713,   714,   718,   719,   720,   721,
     722,   726,   727,   731,   732,   736,   737,   741,   742,   743,
     744,   752,   753,   756,   757,   764,   774,   775,   779,   783,
     784,   785,   786,   790,   791,   792,   793,   794,   798,   799,
     800,   801,   802,   803,   804,   805,   806,   807,   812,   813,
     817,   818,   819,   820,   826,   827,   828,   831,   847,   856,
     875,   876,   877,   878,   879,   880,   881,   882,   883,   884,
     885,   886,   887,   888,   891,   891,   893,   896,   896,   901,
     906,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   932,   933,
     934,   936,   938,   940,   942,   943,   944,   945,   947,   948,
     949,   950,   952,   953,   954,   956,   958,   959,   963,   967,
     968,   969,   973,   977,   984,   985,   989,   992,   995,   998,
    1004,  1006,   998,  1011,  1023,  1039,  1042,  1047,  1050,  1059,
    1062,  1065,  1068,  1069,  1072,  1072,  1078,  1079,  1083,  1088,
    1101,  1102,   167,   170,   171,   175,   176,   177,   178,   188,
     190,   192,   194,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   213,   214,   220,   222,   224,   229,   231,
     235,   236,   237,   242,   243,   244,   245,   248,   250,   253,
     255,   261,   264,   265,   269,   275,   279,   289,   299,   301,
     302,   303,   304,   305,   306,   307,   308,   312,   318,   323,
     324,   325,   326,   327,   328,   329,   330,   335,   336,   339,
     341,   344,   346,   350,   357,   360,   363,   364,   365,   366,
     370,   371,   372,   373,   374,   378,   379,   383,   386,   387,
     388,   389,   394,   397,   401,   402,   403,   404,   408,   409,
     410,   411,   412,   413,   414,   415,   422,   430,   431,   435,
     436,   440,   445,   446,   450,   452,   460,   464,   465,   470,
     472,   479,   480,   481,   482,   483,   487,   495,   501,   502,
     503,   507,   508,   512,   513,   514,   515,   516,   517,   523,
     524,   525,   529,   530,   534,   535,   541,   545,   546,   549,
     551,   555,   556,   559,   559,   561,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   601,
     607,   613,   613,   616,   616,   619,   619,   622,   622,   626,
     627,   630,   630,   633,   633,   637,   637,   658,   664,   670,
     676,   683,   689,   696,   701,   706,   711,   716,   720,   724,
     728,   738,   745,   754,   758,   765,   769,   770,   771,   772,
     776,   780,   784,   798,   799,   800,   801,   804,   805,   806,
     807,   812,   813,   814,   815,   816,   817,   818,   819,   820,
     821,   822,   823,   824,   825,   826,   827,   828,   829,   830,
     831,   832,   836,   846,   846,   856,   859,   860,   861,   862,
     863,   864,   868,   868,   870,   870,   872,   872,   874,   874,
     876,   876,   878,   878,   880,   880,   882,   882,   884,   884,
     886,   886,   889,   889,   893,   893,   899,   900,   901,   905,
     906,   912,   912,   914,   914,   916,   916,   918,   918,   920,
     920,   922,   922,   926,   926,   939,   940,   944,   944,   947,
     947,   951,   951,   961,   962,   963,   967,   968,   969,   972,
     974,   976,   977,   978,    31,    33,    35,    38,    41,    43,
      46,    48,    51,    54,    56,    67,    68,    71,    73,    76,
      78,    82,    95,    97,   117,   118,   119,   120,   124,   125,
     126,   127,   128,   129,   132,   134,   137,   139,   142,   142,
     147,   153,   176,   184,   194,   194,    29,    31,    41,    42,
      43,    44,    74,    74,    84,    84,    85,    89,    90,   101,
     106,   120,   125,    36,    38,    48,    49,    50,    51,    52,
      53,    54,    57,    59,    63,    67,    68,    69,    70,    74,
      78,    82,    96,   116,   117,   118,   119,   120,   121,   122,
     123,   127,   128,   129,   130,   131,   132,   135,   137,   140,
     142,   146,   149,   154,   155,   156,   160,   161,   165,   166,
     169,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     201,   203,   207,   210,   230,   236,   236,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,    34,    36,    44,
      45,    46,    47,    50,    52,    56,    60,    81,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   176,   178,   181,   183,
     188,   190,   194,   194,   197,   197,   200,   200,   203,   203,
      54,    56,    94,    96,    97,   100,   102,   103,   104,   105,
     110,   111,   115,   116,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   132,   133,   134,   138,   139,   140,   141,
     142,   146,   147,   148,   149,   150,   151,   155,   156,   162,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   245,   245,   246,   247,   248,   249,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   267,   278,   284,   289,   294,   299,   315,   320,   328,
     329,   332,   334,   337,   349,   351,   353,   357,   357,   361,
     379,   407,   408,   409,   413,   414,   415,   418,   418,   418,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   464,
     476,   478,   481,   483,   487,   494,   497,   499,   501,   503,
     505,   507,   509,   511,   513,   515,   517,   519,   521,   523,
     526,   543,   554,    49,    52,    65,    67,    74,    75,    76,
      77,    78,    79,    80,    81,    84,    86,    90,    94,    95,
      26,    28,    34,    35,    36,    37,    38,    39,    40,    41,
      44,    46,    50,    53,    53,    62,    63,    64,    65,    66,
      67,   212,   215,   216,   217,   220,   236,   237,   241,   242,
     246,   255,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   275,   290,   293,
     295,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   308,   309,   309,   310,   311,   312,   316,   317,   321,
     329,   331,   335,   336,   337,   341,   342,   345,   347,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     363,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     423,   425,   428,   430,   438,   440,   441,   444,   446,   450,
     451,   454,   464,   486,   488,   492,   492,   495,   497,   500,
     502,   506,   509,   510,   511,   512,   515,   515,   518,   518,
     521,   521,   526,   526,   529,   529,   534,   534,   537,   537,
     541,   541,   558,   561,   562,   563,   564,   565,   566,   567,
     568,    24,    26,    40,    41,    42,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    23,    26,    25,    40,
      41,    42,    43,    53,    55,    68,    69,    70,    71,    72,
      72,    73,    73,    74,    75,    76,    79,    81,    85,    89,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   128,   132,   133,   134,   135,   136,   137,   137,   138,
     138,   139,   140,   141,   142,   146,   147,   148,   151,   189,
     191,   194,   196,   200,   203,   215,   216,   217,   218,   222,
     229,   237,   239,   242,   244,   248,   252,   262,   267,   268,
     269,   273,   285,   287,   291,   292,   296,   309,   314,   315,
     316,   320,   332,   334,   338,   339,   344,   345,   349,   350,
     353,   354,    47,    50,    51,    54,    68,    69,    70,    71,
      72,    73,    76,    78,    82,    86,   111,   141,   142,   143,
     144,   145,   146,   147,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   174,   175,   176,   177,   180,   182,
     185,   187,   191,   194,   195,   199,   199,   202,   202,    43,
      45,    54,    56,    58,    62,    63,    64,    65,    66,    67,
      68,    69,    75,    81,    87,    88,    92,    99,   100,   103,
     105,   123,   124,   128,   134,   136,   139,   141,   145,   146,
     147,   151,   157,   167,   169,   173,   174,   175,   179,    56,
      58,    65,    66,    67,    68,    69,    70,    78,    82,    87,
      92,    95,    98,   103,   107,   115,   116,   119,   121,   124,
     124,   137,   138,   142,   147,   148,   149,   150,   151,   152,
     153,   153,   158,   167,   180,   180,   183,   192,   194,   197,
     199,   203,   203,    31,    34,    35,    36,    39,    40,    41,
      43,    44,    45,    46,    47,    48,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    63,    64,    65,    66,
      67,    68,    70,    71,    72,    73,    74,    76,    77,    78,
      79,    80,    82,    83,    32,    34,    36,    38,    45,    46,
      49,    51,    55,    65,    66,    67,    75,    85,    86,    90,
      91,    95,    96,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   112,   115,   116,   126,   128,   134,   134,   136,
     144,   146,   149,   152,   153,   154,   155,   163,   163,   166,
     166,   173,   173,   176,   176,   179,   179,   182,   182,   185,
     185,   190,   190,   195,   196,   200,   201,   202,    43,    45,
      50,    51,    54,    55,    59,    60,    65,    66,    70,    71,
      72,    73,    77,    84,    85,    96,    98,   101,   102,   105,
     106,   107,   114,   121,   124,   126,   129,   131,   135,   138,
     139
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "QUIT", "EXIT", "HELP",
  "END", "CLI_MARKER", "INVALID_TOKEN", "ELSECOL", "DDOT", "GEQ", "LEQ",
  "NEQ", "AND", "OR", "IMP", "PO", "PC", "NUM", "ENUM_TOKEN", "IP4", "IP6",
  "VPN_RD", "CF_SYM_KNOWN", "CF_SYM_UNDEFINED", "CF_SYM_METHOD_BARE",
  "CF_SYM_METHOD_ARGS", "TEXT", "BYTETEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "NMA", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'",
  "DEFINE", "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "VPN",
  "MPLS", "FROM", "MAX", "AS", "';'", "'('", "')'", "FLOW4", "FLOW6",
  "DST", "SRC", "PROTO", "NEXT", "HEADER", "DPORT", "SPORT", "ICMP",
  "TYPE", "CODE", "TCP", "FLAGS", "LENGTH", "DSCP", "DONT_FRAGMENT",
  "IS_FRAGMENT", "FIRST_FRAGMENT", "LAST_FRAGMENT", "FRAGMENT", "LABEL",
  "OFFSET", "','", "'{'", "'}'", "IN", "FUNCTION", "PRINT", "PRINTN",
  "UNSET", "RETURN", "ACCEPT", "REJECT", "ERROR", "INT", "BOOL", "IP",
  "PREFIX", "RD", "PAIR", "QUAD", "EC", "LC", "ENUM", "SET", "STRING",
  "BYTESTRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST", "LCLIST", "IF",
  "THEN", "ELSE", "CASE", "FOR", "DO", "TRUE", "FALSE", "RT", "RO",
  "UNKNOWN", "GENERIC", "GW", "NET", "SOURCE", "SCOPE", "DEST", "IFNAME",
  "IFINDEX", "WEIGHT", "GW_MPLS", "GW_MPLS_STACK", "ONLINK", "PREFERENCE",
  "ROA_CHECK", "ASPA_CHECK", "DEFINED", "ADD", "DELETE", "RESET",
  "PREPEND", "EMPTY", "FILTER", "WHERE", "EVAL", "ATTRIBUTE", "FROM_HEX",
  "BT_ASSERT", "BT_TEST_SUITE", "BT_CHECK_ASSIGN", "BT_TEST_SAME",
  "FORMAT", "':'", "'['", "']'", "'?'", "ROUTER", "ID", "HOSTNAME",
  "PROTOCOL", "TEMPLATE", "DISABLED", "DEBUG", "ALL", "DIRECT",
  "INTERFACE", "IMPORT", "EXPORT", "NONE", "VRF", "DEFAULT", "TABLE",
  "TABLES", "STATES", "ROUTES", "FILTERS", "IPV4", "IPV6", "VPN4", "VPN6",
  "ROA4", "ROA6", "SADR", "ASPA", "RECEIVE", "LIMIT", "ACTION", "WARN",
  "BLOCK", "RESTART", "DISABLE", "KEEP", "FILTERED", "RPKI", "PASSWORD",
  "KEY", "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS", "CHANNELS",
  "INTERFACES", "ALGORITHM", "KEYED", "HMAC", "MD5", "SHA1", "SHA256",
  "SHA384", "SHA512", "BLAKE2S128", "BLAKE2S256", "BLAKE2B256",
  "BLAKE2B512", "PRIMARY", "STATS", "COUNT", "COMMANDS", "PREEXPORT",
  "NOEXPORT", "EXPORTED", "GENERATE", "BGP", "PASSWORDS", "DESCRIPTION",
  "RELOAD", "OUT", "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY",
  "IGP_METRIC", "CLASS", "TIMEFORMAT", "ISO", "SHORT", "LONG", "ROUTE",
  "BASE", "LOG", "GRACEFUL", "WAIT", "CHECK", "LINK", "SORTED", "TRIE",
  "MIN", "SETTLE", "TIME", "GC", "THRESHOLD", "PERIOD", "MPLS_LABEL",
  "MPLS_POLICY", "MPLS_CLASS", "ASPA_PROVIDERS", "IPV4_MC", "IPV4_MPLS",
  "IPV6_MC", "IPV6_MPLS", "IPV6_SADR", "VPN4_MC", "VPN4_MPLS", "VPN6_MC",
  "VPN6_MPLS", "PRI", "SEC", "NET_TYPE", "RTS", "RTD", "ROA", "AF", "SHOW",
  "STATUS", "SUMMARY", "SYMBOLS", "DUMP", "RESOURCES", "SOCKETS", "AO",
  "KEYS", "NEIGHBORS", "ATTRIBUTES", "ECHO", "ENABLE", "DOMAIN", "RANGE",
  "STATIC", "DYNAMIC", "START", "POLICY", "AGGREGATE", "RANGES",
  "AGGREGATOR", "PEER", "MERGE", "BY", "BABEL", "METRIC", "RXCOST",
  "HELLO", "UPDATE", "WIRED", "WIRELESS", "BUFFER", "PRIORITY", "HOP",
  "BABEL_METRIC", "ENTRIES", "RANDOMIZE", "MAC", "PERMISSIVE", "EXTENDED",
  "TUNNEL", "RTT", "DECAY", "SEND", "TIMESTAMPS", "COST", "DELAY",
  "PREFER", "NATIVE", "BFD", "IDLE", "RX", "TX", "INTERVAL", "MULTIPLIER",
  "ADDRESS", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL", "AUTHENTICATION",
  "SIMPLE", "METICULOUS", "STRICT", "BIND", "ZERO", "UDP6", "CHECKSUM",
  "SESSIONS", "HOLD", "CONNECT", "RETRY", "KEEPALIVE", "STARTUP", "VIA",
  "SELF", "PATH", "FORGET", "AFTER", "BGP_PATH", "BGP_LOCAL_PREF",
  "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP", "BGP_ATOMIC_AGGR",
  "BGP_AGGREGATOR", "BGP_COMMUNITY", "BGP_EXT_COMMUNITY",
  "BGP_LARGE_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4",
  "ADVERTISE", "CAPABILITIES", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "ENHANCED", "REFRESH", "INTERPRET", "COMMUNITIES",
  "BGP_ORIGINATOR_ID", "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE",
  "MED", "TTL", "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "PATHS",
  "AWARE", "SETKEY", "CONFEDERATION", "MEMBER", "MULTICAST", "LIVED",
  "STALE", "IBGP", "EBGP", "MANDATORY", "INTERNAL", "EXTERNAL", "SETS",
  "NAME", "DIGITS", "BGP_AIGP", "AIGP", "ORIGINATE", "ENFORCE", "FIRST",
  "FREE", "VALIDATE", "ROLE", "ROLES", "PROVIDER", "CUSTOMER", "RS_SERVER",
  "RS_CLIENT", "REQUIRE", "BGP_OTC", "GLOBAL", "RECV", "SINGLE", "DOUBLE",
  "SECRET", "DEPRECATED", "PREFERRED", "CMAC", "AES128", "CEASE", "HIT",
  "ADMINISTRATIVE", "SHUTDOWN", "CONFIGURATION", "CHANGE", "DECONFIGURED",
  "CONNECTION", "REJECTED", "COLLISION", "OF", "ASPA_CHECK_UPSTREAM",
  "ASPA_CHECK_DOWNSTREAM", "L3VPN", "TARGET", "DISTINGUISHER", "MRT",
  "FILENAME", "ALWAYS", "V2", "V3", "OSPF", "OSPF_METRIC1", "OSPF_METRIC2",
  "OSPF_TAG", "OSPF_ROUTER_ID", "AREA", "RFC1583COMPAT", "STUB", "TICK",
  "COST2", "RETRANSMIT", "TRANSMIT", "DEAD", "BROADCAST", "BCAST",
  "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "ONLY", "LARGE", "NORMAL", "STUBNET", "TAG", "LSADB", "ECMP", "NSSA",
  "TRANSLATOR", "STABILITY", "LSID", "INSTANCE", "REAL", "NETMASK", "LSA",
  "SUPPRESSION", "RFC5838", "PE", "TOPOLOGY", "STATE", "PERF", "EXP",
  "REPEAT", "MODE", "PIPE", "RADV", "RA", "SOLICITED", "UNICAST",
  "MANAGED", "OTHER", "CONFIG", "LINGER", "MTU", "REACHABLE", "RETRANS",
  "TIMER", "CURRENT", "VALID", "MULT", "LIFETIME", "SKIP", "AUTONOMOUS",
  "RDNSS", "DNSSL", "NS", "TRIGGER", "SENSITIVE", "LOW", "MEDIUM", "HIGH",
  "PROPAGATE", "RA_PREFERENCE", "RA_LIFETIME", "CUSTOM", "OPTION", "VALUE",
  "NG", "RIP", "INFINITY", "TIMEOUT", "GARBAGE", "VERSION", "SPLIT",
  "HORIZON", "POISON", "REVERSE", "PLAINTEXT", "DEMAND", "CIRCUIT",
  "RIP_METRIC", "RIP_TAG", "REMOTE", "BIRD", "PRIVATE", "PUBLIC", "SSH",
  "TRANSPORT", "USER", "EXPIRE", "PROHIBIT", "BLACKHOLE", "UNREACHABLE",
  "TRANSIT", "PROVIDERS", "KERNEL", "NETLINK", "KRT_PREFSRC", "KRT_REALM",
  "KRT_SCOPE", "KRT_MTU", "KRT_WINDOW", "KRT_RTT", "KRT_RTTVAR",
  "KRT_SSTHRESH", "KRT_CWND", "KRT_ADVMSS", "KRT_REORDERING",
  "KRT_HOPLIMIT", "KRT_INITCWND", "KRT_RTO_MIN", "KRT_INITRWND",
  "KRT_QUICKACK", "KRT_CONGCTL", "KRT_FASTOPEN_NO_COOKIE", "KRT_LOCK_MTU",
  "KRT_LOCK_WINDOW", "KRT_LOCK_RTT", "KRT_LOCK_RTTVAR",
  "KRT_LOCK_SSTHRESH", "KRT_LOCK_CWND", "KRT_LOCK_ADVMSS",
  "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT", "KRT_LOCK_INITCWND",
  "KRT_LOCK_RTO_MIN", "KRT_LOCK_INITRWND", "KRT_LOCK_QUICKACK",
  "KRT_LOCK_CONGCTL", "KRT_LOCK_FASTOPEN_NO_COOKIE", "KRT_FEATURE_ECN",
  "KRT_FEATURE_ALLFRAG", "KRT_SSTRESH", "KRT_LOCK_SSTRESH", "SYSLOG",
  "STDERR", "UDP", "CLI", "TRACE", "INFO", "WARNING", "AUTH", "FATAL",
  "BUG", "LATENCY", "WATCHDOG", "THREADS", "CONFIGURE", "SOFT", "CONFIRM",
  "UNDO", "DOWN", "PERSIST", "SCAN", "LEARN", "DEVICE", "KRT_SOURCE",
  "KRT_METRIC", "$accept", "cli_cmd", "cmd_QUIT", "cmd_EXIT", "cmd_HELP",
  "config", "conf_entries", "conf", "definition", "expr", "expr_us",
  "symbol", "symbol_known", "bool", "ipa", "ipa_scope", "pxlen4",
  "net_ip4_", "net_ip6_", "net_ip6_sadr_", "net_vpn4_", "net_vpn6_",
  "net_roa4_", "net_roa6_", "net_mpls_", "net_aspa_", "net_ip_",
  "net_vpn_", "net_roa_", "net_", "net_ip4", "net_ip6", "net_ip",
  "net_any", "net_or_ipa", "label_stack_start", "label_stack", "time",
  "text", "opttext", "text_or_ipa", "bytestring", "bytestring_text",
  "bytestring_expr", "flow_num_op", "flow_logic_op", "flow_num_type_",
  "flow_num_type", "flow_flag_type", "flow_frag_type", "flow_srcdst",
  "flow_num_opts", "flow_num_opt_ext_expr", "flow_num_opt_ext",
  "flow_bmk_opts", "flow_neg", "flow_frag_val", "flow_frag_opts",
  "flow4_item", "flow6_item", "flow4_opts", "flow6_opts",
  "flow_builder_init", "flow_builder_set_ipv4", "flow_builder_set_ipv6",
  "net_flow4_", "net_flow6_", "net_flow_", "KEYWORD", "enum_type",
  "filter_def", "$@1", "filter_eval", "custom_attr", "bt_test_suite",
  "bt_test_same", "type", "function_argsn", "function_args",
  "function_vars", "function_type", "filter_body", "filter", "$@2",
  "where_filter", "function_body", "function_def", "$@3", "$@4", "cmds",
  "cmds_scoped", "$@5", "cmd_var", "cmd_prep", "cmds_int", "fipa",
  "set_atom0", "set_atom", "switch_atom", "cnum", "pair_item", "ec_kind",
  "ec_item", "lc_item", "set_item", "switch_item", "ec_items", "set_items",
  "switch_items", "fprefix", "fprefix_set", "switch_body", "bgp_path_expr",
  "bgp_path", "bgp_path_tail", "constant", "constructor", "var_list_r",
  "var_list", "function_call", "symbol_value", "static_attr",
  "term_dot_method", "$@6", "method_name_cont", "$@7", "term", "term_bs",
  "break_command", "var", "for_var", "cmd", "$@8", "$@9", "$@10", "$@11",
  "get_cf_position", "lvalue", "rtrid", "idval", "hostname_override",
  "gr_opts", "net_type_base", "net_type", "table", "table_start",
  "table_sorted", "table_opt", "table_opts", "table_opt_list",
  "proto_start", "proto_name", "proto_item", "channel_start",
  "channel_item_", "channel_item", "channel_opts", "channel_opt_list",
  "channel_end", "proto_channel", "rtable", "imexport", "limit_action",
  "limit_spec", "debug_default", "timeformat_base", "timeformat_which",
  "timeformat_spec", "iface_patt_node_init", "iface_patt_node_body",
  "iface_negate", "iface_patt_node", "iface_patt_list",
  "iface_patt_list_nopx", "iface_patt_init", "iface_patt", "tos", "proto",
  "dev_proto_start", "dev_proto", "dev_iface_init", "dev_iface_patt",
  "debug_mask", "debug_list", "debug_flag", "mrtdump_mask", "mrtdump_list",
  "mrtdump_flag", "password_list", "password_list_body", "password_items",
  "password_item", "pass_key", "password_item_begin",
  "password_item_params", "password_algorithm", "password_item_end",
  "bfd_opts", "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS",
  "cmd_SHOW_PROTOCOLS_ALL", "optproto", "cmd_SHOW_INTERFACES",
  "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE", "r_args", "r_args_for",
  "r_args_for_val", "export_mode", "channel_sym", "channel_arg",
  "cmd_SHOW_SYMBOLS", "sym_args", "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS",
  "cmd_DUMP_AO_KEYS", "cmd_DUMP_EVENTS", "cmd_DUMP_INTERFACES",
  "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES",
  "cmd_DUMP_PROTOCOLS", "cmd_DUMP_FILTER_ALL", "cmd_EVAL", "cmd_ECHO",
  "echo_mask", "echo_size", "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART",
  "cmd_RELOAD", "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG",
  "debug_args", "cmd_MRTDUMP", "cmd_RESTRICT", "cmd_TIMEFORMAT",
  "proto_patt", "proto_patt2", "dynamic_attr", "mpls_domain",
  "mpls_domain_start", "mpls_domain_opt", "mpls_domain_opts",
  "mpls_domain_opt_list", "mpls_domain_end", "mpls_range",
  "mpls_range_start", "mpls_range_opt", "mpls_range_opts",
  "mpls_range_opt_list", "mpls_range_end", "mpls_channel",
  "mpls_channel_start", "mpls_label_policy", "mpls_channel_opt",
  "mpls_channel_opts", "mpls_channel_opt_list", "mpls_channel_end", "$@12",
  "show_mpls_ranges_args", "cmd_SHOW_MPLS_RANGES",
  "aggregator_proto_start", "aggregator_proto_item", "$@13",
  "aggregator_proto_opts", "aggregator_proto", "aggr_list", "aggr_item",
  "babel_proto_start", "babel_proto_item", "babel_proto_opts",
  "babel_proto", "babel_iface_start", "babel_iface_finish",
  "babel_iface_item", "babel_iface_opts", "babel_iface_opt_list",
  "babel_iface", "cmd_SHOW_BABEL_INTERFACES", "cmd_SHOW_BABEL_NEIGHBORS",
  "cmd_SHOW_BABEL_ENTRIES", "cmd_SHOW_BABEL_ROUTES", "bfd_proto_start",
  "bfd_proto_item", "bfd_proto_opts", "bfd_proto", "bfd_accept_item",
  "bfd_accept", "bfd_iface_start", "bfd_iface_finish", "bfd_iface_item",
  "bfd_auth_type", "bfd_iface_opts", "bfd_iface_opt_list", "bfd_iface",
  "bfd_multihop", "bfd_neigh_iface", "bfd_neigh_local",
  "bfd_neigh_multihop", "bfd_neighbor", "bfd_item", "bfd_items",
  "bfd_opts_start", "bfd_opts_end", "cmd_SHOW_BFD_SESSIONS",
  "bfd_show_sessions_args", "bgp_proto_start", "bgp_loc_opts",
  "bgp_nbr_opts", "bgp_cease_mask", "bgp_cease_list", "bgp_cease_flag",
  "bgp_auth_type", "bgp_role_name", "bgp_proto", "$@14", "$@15", "bgp_afi",
  "tcp_ao_key_start", "tcp_ao_key_opt", "tcp_ao_algorithm",
  "tcp_ao_key_opts", "tcp_ao_key_end", "tcp_ao_key", "tcp_ao_keys",
  "tcp_ao_key_list", "$@16", "tcp_ao_end", "bgp_channel_start", "bgp_nh",
  "bgp_llnh", "bgp_lladdr", "bgp_channel_item", "bgp_channel_opts",
  "bgp_channel_opt_list", "bgp_channel_end", "bgp_proto_channel",
  "l3vpn_channel_start", "l3vpn_channel", "l3vpn_proto_start",
  "l3vpn_proto_item", "l3vpn_proto_opts", "l3vpn_proto", "l3vpn_targets",
  "mrt_proto_start", "mrt_proto_item", "mrt_proto_opts", "mrt_proto",
  "cmd_MRT_DUMP", "mrt_dump_args", "ospf_variant", "ospf_proto_start",
  "ospf_proto", "ospf_af_mc", "ospf_channel_start", "ospf_channel",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "$@17", "$@18", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_base", "pref_opt",
  "nbma_list", "nbma_eligible", "nbma_item", "ospf_iface_start",
  "ospf_instance_id", "ospf_iface_patt_list", "$@19", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "perf_proto_start", "perf_proto", "perf_proto_item",
  "pipe_proto_start", "$@20", "pipe_proto", "radv_proto_start",
  "radv_proto_item", "$@21", "$@22", "radv_proto_opts", "radv_proto",
  "radv_iface_start", "radv_iface_item", "$@23", "$@24", "radv_preference",
  "radv_iface_finish", "radv_iface_opts", "radv_iface_opt_list",
  "radv_iface", "radv_prefix_start", "radv_prefix_item",
  "radv_prefix_finish", "radv_prefix_opts", "radv_prefix_opt_list",
  "radv_prefix", "radv_rdnss_node", "radv_rdnss_start", "radv_rdnss_item",
  "radv_rdnss_finish", "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node",
  "radv_dnssl_start", "radv_dnssl_item", "radv_dnssl_finish",
  "radv_dnssl_opts", "radv_dnssl", "radv_mult", "radv_sensitive",
  "rip_variant", "rip_proto_start", "rip_proto_item", "rip_proto_opts",
  "rip_proto", "rip_iface_start", "rip_iface_finish", "rip_iface_item",
  "rip_auth", "rip_iface_opts", "rip_iface_opt_list", "rip_iface",
  "cmd_SHOW_RIP_INTERFACES", "cmd_SHOW_RIP_NEIGHBORS", "rpki_proto_start",
  "rpki_proto", "rpki_proto_opts", "rpki_proto_item", "rpki_keep_interval",
  "rpki_proto_item_port", "rpki_cache_addr", "rpki_transport",
  "rpki_transport_tcp_init", "rpki_transport_tcp_opts_list",
  "rpki_transport_tcp_opts", "rpki_transport_tcp_item",
  "rpki_transport_tcp_check", "rpki_transport_ssh_init",
  "rpki_transport_ssh_opts", "rpki_transport_ssh_item",
  "rpki_transport_ssh_check", "static_proto_start", "static_proto",
  "stat_nexthop", "stat_nexthops", "stat_mpls", "stat_route0", "$@25",
  "stat_route", "$@26", "stat_aspa_provider", "stat_aspa_providers",
  "stat_route_item", "stat_route_opts", "stat_route_opt_list",
  "cmd_SHOW_STATIC", "kern_proto", "kern_sys_item", "log_begin",
  "log_config", "syslog_name", "log_limit", "log_file", "log_udp_host",
  "log_udp_port", "log_mask", "log_mask_list", "log_cat", "mrtdump_base",
  "cli", "cli_opts", "cli_opts_begin", "cli_opts_block", "debug_unix",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM",
  "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_STATUS", "cmd_CONFIGURE_CHECK",
  "cmd_DOWN", "cmd_GRACEFUL_RESTART", "cfg_name", "cfg_timeout",
  "kern_proto_start", "kern_learn", "kern_mp_limit", "kern_channel",
  "kern_item", "kif_proto_start", "kif_proto", "kif_item",
  "kif_iface_start", "kif_iface_item", "kif_iface_opts",
  "kif_iface_opt_list", "kif_iface", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-3174)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1603)

#define yytable_value_is_error(Yyn) \
  ((Yyn) == YYTABLE_NINF)

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     232,    49,   226,   234,   240,   398,   429,  9191,   681,   682,
     682,   147,   682,   506,   142,   328,   222,  1849,   449,   682,
     292,    19,   576, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174,  5831,   380, -3174, -3174, -3174,
    5831,  5831,  9191,  3059,   565,   716,   622,   653, -3174, -3174,
     -10, -3174,   610, -3174, -3174, -3174, -3174, -3174,   175,   789,
   -3174,   612,   653,  -322,   822, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174,   675, -3174,   614,
    1229, -3174, -3174, -3174,  6457,  2842, -3174,   798,  6457, -3174,
    6457, -3174,  6457, -3174,  6457, 11987,  6457, -3174,  6457, -3174,
    6457,  1458,  6457,  1917,   818,  2072,  6457, -3174,  6457, -3174,
    6457, -3174,  6457,  1876,   120, -3174, -3174, -3174, -3174,  6457,
    6457,   -36, -3174, -3174, -3174,  1319, -3174, -3174,   932,   947,
    1135, -3174, -3174, -3174,   883,   365,  9191,   988, -3174,  4341,
     973,   983, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174,  1020,  1036,  1068,
    1081,  1104,  1112,  1122,  1144,  1166,  1344,  1213, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,  1177,  1196,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174,  1218,  1228,  1235,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174,  4223, -3174, -3174,  1269, -3174, -3174,   854,  1308,
     854, -3174,  1290,  1290,   682,   682,  1316,   875, -3174,   822,
     571,  1321,  1324,  1057,   797,   146,  1331, -3174,  1375, -3174,
    1362,   582,  1056,   103,   509,  1239,   653,   653,   653,   653,
     653,   653,  1154,   653,   653, -3174,   -19, -3174,  1393,  1290,
   -3174, -3174,  1413,  1445,  1413,  1451,  1457,   926, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174,  1473, -3174,  5831, -3174, -3174,  4210, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174,   -12, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174,   822, -3174,  7083,  1493,  1493,  1128,
   -3174, -3174,  1464,   854,   854,   854,   822,  1121, -3174,   875,
    1467, -3174, -3174, -3174, -3174,   142,    14,  1286, -3174,   822,
     822, -3174,  9191,  1478, -3174,  5831, -3174,  1468, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174,   759, -3174, -3174,
   -3174,  1016, -3174, -3174, -3174, -3174,  1533,  1505,  1502, -3174,
    1402,   653,  1652,   854, -3174,   184,   653,   875,  1323, -3174,
    1527,  1504,  1536,  1549, -3174, -3174,  1531,  1534,  1540,  1542,
   -3174,   692, -3174, -3174, -3174,   259,  1296,  1578,  1615,   909,
      40,    71,    81,    88,   337,   653,  1652,  1248,  1459,  1411,
     -22,  1577,   507,  1270,  1356,  1339,  1327,  1097,  1023,   346,
      98,    35,  1363,  1456,   -80,  1462,  1365,  1416,  1022,  1357,
    1567,  1652,  1368,  1427,  1431,  1353,  1367,   160,  1652,   111,
    1333,  1409,   734,  1694,  1698,  1672, -3174,  1674,  1702,  1677,
    1678,  1680,  1267, -3174, -3174,  1579,  1381,  1450,  1652,  1613,
     822,  1652,  1627,  1652,  1395, -3174,  1504, -3174,  1734,  1710,
   -3174,  1712, -3174,  1652,   122,  1780,   144,  1781,  1246,  1746,
   -3174,  1752, -3174, -3174,   822,  1188,  1486,  1789,  1633,  1591,
    1648,  1775,  1776,  1750,  1753,  1755,  1757, -3174,  1037,  1589,
    1676,  1797,  1799,  1810,    96,  1785, -3174,  1679,  1479,   822,
    1707,  1548,  1652,  1630,  1300, -3174, -3174, -3174,  1834, -3174,
    1835,  1816,  1818, -3174, -3174,  1654, -3174,  1850,   747,  1319,
    1319,  9191,  1544,  1319, -3174,  1319,  1890, -3174,  1891, -3174,
    1892,   932,  1873, -3174, -3174,  1879,   550,  1884,  1874, -3174,
   -3174, -3174,  1911, -3174,  1848,  3469, -3174, -3174,  1789,  1789,
    9191,  9191,  9191,  9191,  9191,  9191,  9191, -3174, -3174,  1873,
   -3174,  3699, -3174, -3174, -3174, -3174,   828, -3174, -3174,  1922,
   -3174, -3174, -3174, -3174,   378, -3174,   624, -3174,  1789,  1789,
    9191,  1915,  1916, -3174,  9191,  9191,  9191,  9191,  9191,  9191,
    9191,  9191,  9191,  9191,  9191,  9191,  9191,  9191, -3174,  2619,
   -3174,   933, -3174, -3174, -3174, -3174, -3174,  1932,  1936,  1937,
    1938, -3174, -3174,   597, -3174,  1945,  1935,  1374,  1526, -3174,
   -3174, -3174, -3174, -3174,   995,  1958, -3174,  1969, -3174,  2573,
   -3174,  1265, -3174,  1970,  1362,  1362,  1362,  1362, -3174,  1362,
    1362, -3174,   307,   334,  1973,  1362,  1362,   653,  1974,  1975,
    1976,  1977,  1978,  1980,   653,  1983,  1984, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174,   857, -3174, -3174,  1985,
    1986,   229,  1989, -3174,   926, -3174, -3174,   822,  1990,  9191,
   -3174,  1927, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174,  3274,  1130,  1941,  1918,  1920, -3174,
   -3174, -3174, -3174,  9191,  1942, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174,   822, -3174, -3174,  1947, -3174,  1948,
    1599, -3174,  1376,   822,   141,   822, -3174,   418,  1397, -3174,
   -3174,  3991, -3174, -3174, -3174, -3174, -3174, -3174,  6457, -3174,
   -3174,  1988, -3174,  1450, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174,  1652, -3174, -3174, -3174, -3174, -3174,  1018, -3174,
   -3174, -3174, -3174, -3174,  1608,  1817,  1756,  1765,  1318, -3174,
    1961,   822,   822, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174,  1652,    24,  1966,  1967,   -37,   295,  1652,  1628,  1836,
    1782,  1784, -3174,  1981,  1653,  1801,  1652,  1798,    89,  1792,
    1793,  1652,  1994,  2004,  1962, -3174,  2006, -3174, -3174, -3174,
    1470,  2007,   106,   561,  2007,  1332, -3174, -3174, -3174,  2015,
    1652,   822,  1821,  1822,   822,  1831,  1652,  1652,  1924,  1652,
    1652,  2031,  1652,  1652,  1652,  1652,  1652,  1684,  2035,  1652,
    1652,  2037,  1652,  2038,  2036,  1652,  1652,  1706,  1727,  1923,
    1877,  1652,  1867,  1652, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174,  1652,   404,  1652, -3174, -3174,  1652,
   -3174,  1928,   822, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174,   822,   822, -3174,  2091,  2093, -3174, -3174, -3174, -3174,
   -3174, -3174,  1493,  9191, -3174, -3174,  1513,  1925, -3174, -3174,
    1513, -3174, -3174, -3174,  1513,  1652,  1789, -3174, -3174, -3174,
   -3174, -3174, -3174,   947,  1135, -3174, -3174, -3174,  1652,  1789,
   -3174, -3174, -3174, -3174,  1632, -3174,  1318, -3174, -3174, -3174,
   -3174, -3174,   299,  1767, -3174,  2062,  1652,  1652, -3174,   822,
    1813, -3174,   822, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174,   822, -3174,  2104, -3174, -3174, -3174,  4060, -3174,
   -3174,  1319,   655, -3174, -3174, -3174, -3174,  2070,  2106, -3174,
    1992,  2090, -3174, -3174,  9191, -3174,  9191, -3174, -3174,   813,
    2043,  4297,  3560,  3613,  3763,  3775,  4375,  4487,  2045,   423,
    2046,  4499, -3174, -3174,  2114,  1645,  1795, -3174,  1135, -3174,
    2079,  2080,  2057,  2083,  4210,  2088,  2095,  2238,  2238,  2238,
    2662,  2662,  2238,  2238,  2238,  2238,  2238,   987,   987,  1874,
    1874, 11435, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
    1190, -3174, -3174, -3174, -3174, -3174, -3174, -3174,  1223, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174,   306,  2149, -3174, -3174,
   -3174,  1037,  1699,  1493,  1493, -3174,  1993,  1996,   388, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,  2134, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174,  1290,  1290,  1290,
    1290,   689,  1290,  1290,   115,  1362,  1290,  1362,  1290, -3174,
    1290,  1290,  2153, -3174, -3174, -3174, -3174, -3174, -3174,  2154,
   -3174, -3174,   -19, -3174, -3174, -3174, -3174,  1493,  1126,   653,
   -3174, -3174,  2169, -3174, -3174,  4309,  2119,  2163,  2239, -3174,
   -3174,  7083, -3174,   653,  1493, -3174,  2123,  4536, -3174, -3174,
   -3174, -3174,   653, -3174, -3174, -3174, -3174, -3174,  9191, -3174,
    2130,   653, -3174,   -19, -3174,  2125,  2126, -3174, -3174, -3174,
   -3174, -3174, -3174,   826, -3174, -3174, -3174,  2165, -3174,  2122,
    2150,  1420, -3174,  1919, -3174,  2155, -3174,  2127,  1364,  1982,
    1620,  1814,  1963,   822,   822,  2159, -3174,  2160,  2161,  2162,
    1652,  1503, -3174, -3174,  2028,  1971,   822,  2164,  2170,  2171,
    1829,  1991,   822,   822, -3174, -3174,  1652,  1652,  2173,  1843,
     822,  2175,   822,   822,  2177, -3174, -3174,  2230, -3174, -3174,
   -3174, -3174, -3174,  5831, -3174,   822,   822, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174,  2183, -3174,   822,   822, -3174,
   -3174,  2188,  2190,   822,   822,  2191,   822,  2196,  2198,  1450,
    2199,  2200, -3174,  2201,  2204,  2205,  2206,  2208,  1652,  1429,
    2209,  2210, -3174,  2221, -3174,  1652,  2222,  2224,  2040,  1652,
    1652,  1652,  2225,  1906,  2229,  1404, -3174, -3174,  2442, -3174,
    2764,   745, -3174,   822, -3174, -3174, -3174, -3174,   822, -3174,
   -3174,   238, -3174, -3174, -3174, -3174, -3174, -3174, -3174,  4210,
   -3174,  2098, -3174,  1652, -3174, -3174, -3174,  2232,   905,   465,
     381,  2237,  2235,  2240, -3174,  2007,  2241,  2277,  2279,   822,
    1652,  1652,  2271,   299,  9941, -3174, -3174,  2116, -3174,   822,
   -3174,  2122,  2218, -3174,  1319, -3174, -3174,  1319,  2284, -3174,
    2272,  2273,  3861,  3506, -3174, -3174, -3174,  9191,  9191, -3174,
    9191,  9191,  9191,  9191, -3174, -3174,  5069,  9191,  7695,  9191,
   -3174,  2228,  9191, -3174, -3174, -3174, -3174, -3174,  9191, -3174,
    2293,  2294, -3174, -3174, -3174, -3174, -3174,   933, -3174,   597,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174,   932,   193,  1559,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
    2291,  2291, -3174, -3174,  1269, -3174, -3174,  2311,  2312,  2314,
    2315, -3174, -3174, -3174, -3174,   653, -3174, -3174,  1491, -3174,
     653,  2316,  2318, -3174, -3174,  2306,  1450, -3174, -3174, -3174,
    1450,  1450,  1290,  2320,  1290,  2321,  2322,  2323, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,  3274,  3274,
   -3174,  9566,  7083,  2274,  2295,  2249,  2122, -3174, -3174, -3174,
    4548,  2333, -3174, -3174,  1266, -3174, -3174,    93,  2102, -3174,
     854,  1652,  1652,  2105,  1350,  2298, -3174,  2329, -3174, -3174,
   -3174,   854, -3174,  2301,  5831, -3174, -3174, -3174, -3174,  2317,
    2185,  2060, -3174, -3174,  2305, -3174, -3174,  2207, -3174, -3174,
    2307, -3174, -3174, -3174, -3174,  1318,  2022,  2025, -3174,  2308,
    2117,   822,  2288,  2319, -3174, -3174, -3174, -3174,  2324,   438,
   -3174,  2325,   608,   822,  2328, -3174, -3174, -3174,  2140,   822,
    2340,  2346,   485, -3174,  2348,  2351, -3174,  1652,  2352, -3174,
    2353,  2355, -3174,  2289, -3174,  2357,   164, -3174,   213, -3174,
   -3174, -3174,  1352, -3174, -3174, -3174, -3174,  2359,  2360, -3174,
    2361, -3174, -3174,  2365, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174,  2366, -3174,  2367, -3174, -3174, -3174,  2368, -3174, -3174,
    2186,  2369,  2372,  2374, -3174,  1652, -3174,   898, -3174,  1493,
   -3174,  2376, -3174,  2146,  2128, -3174,  2044,  1141,  1437,  2042,
    2262,  2247,  2110,  2212,  2382,   822,  2073,  2275,   -20,  1652,
    1652,   264,  1652,    43, -3174,  2393, -3174,  2430,  2008,  2011,
    1162, -3174, -3174, -3174,  1504, -3174,  2397, -3174,  1493,  1227,
     822,   653,  2327, -3174, -3174,  2403, -3174, -3174, -3174, -3174,
     -98,  1652, -3174,   948, -3174,  2214,  1470, -3174,   114,  2405,
   -3174,  1972, -3174,  1635, -3174, -3174, -3174, -3174,  1338, -3174,
   -3174, -3174,  1338,  2286,  1933, -3174, -3174,  2411, -3174, -3174,
    1652,   822, -3174, -3174,  2418,   822,  1934, -3174,  1940,  2144,
    2285,  2423,  2285,  1376,    -1,  2285, -3174, -3174,  2424, -3174,
     822, -3174, -3174, -3174, -3174,  2279, -3174, -3174,  2401, -3174,
   -3174,  2446, -3174, -3174, -3174, -3174,  2444, -3174, -3174,  9191,
    9191,  2432,  9191, -3174, -3174, -3174,  9191,  9191, -3174,  2433,
    2434,   906,  2445,  2470,  9191, -3174,  2462,  2479, -3174,   822,
   -3174, -3174, -3174, -3174, -3174, -3174,  2475,  2478, -3174,  9191,
   -3174,  9191,  2326,  2431,  3876,  3949,  4590,  4602,  4651,  4700,
    1013,   774,  4210,  2435,  1041,   925,  2436,  2498,  4499,  4210,
   -3174, -3174,  2463, -3174, -3174,  2500,   932,  1873,  1269, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174,   932,  1873, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,  2518,
   -3174,  2519, -3174, -3174, -3174,  7083,  2421, -3174,  7083,  2443,
   -3174, -3174,  9566, -3174, -3174,  2472, -3174, -3174,  2511, -3174,
   -3174, -3174,  2474, -3174,  2280, -3174, -3174, -3174,  2281,   822,
     822, -3174,  1520,  1491, -3174, -3174, -3174, -3174, -3174,   116,
   -3174, 10689,  1789, -3174, -3174, -3174, -3174,  2375, -3174,   600,
   -3174, -3174,  2450, -3174,    51, -3174,  1652,  2192, -3174,   822,
    2480,   822, -3174, -3174,  2350,  2096,  2103, -3174,     7,  2107,
    1171,  1348, -3174, -3174,  2484,  2486,  2487, -3174,   822,  2489,
   -3174, -3174, -3174, -3174,  2466,  2490, -3174, -3174,  2494, -3174,
   -3174, -3174, -3174,   986, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174,  1652, -3174, -3174, -3174,  2499,
     167,   424, -3174, -3174,  2156,   476,   773,  1652,  1652,   -31,
    1789,  1652,  2492,  2166,  2248, -3174,   755,  1789, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174,  2168,  2497, -3174, -3174,   159,
     159,   159,  2536, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
    2211, -3174, -3174, -3174,   822,   822,  1652, -3174,  2485,   822,
   -3174,  2488,  1450, -3174, -3174,  2491,   822, -3174, -3174,   822,
    2493, -3174, -3174, -3174, -3174, -3174, -3174, -3174,  2496, -3174,
   -3174, -3174,  1093,   244, -3174,  1652,  2501, -3174, -3174, -3174,
    2380, -3174, -3174, -3174,   822,   822,  1318, -3174,   822,  2502,
     822, -3174,  2522, -3174, -3174, -3174,   822, -3174, -3174,  2446,
    2277,  2551,  2503,  9566,   474,   783,  3612,  4834,  3064,  3295,
    2089, -3174, -3174,  9191, -3174,  9191,   980, -3174,  9191, -3174,
      58,  2555,  2544,  4734,  4769, -3174, -3174, -3174, -3174,  2517,
   -3174, -3174,  1550,  2512, -3174, -3174, -3174, -3174, -3174, -3174,
    1846,  2543,  2543,  1071,  2529, -3174,  1846,  2543,  2543,  1338,
    2530,  9191,  9191, -3174, -3174, -3174, -3174, -3174,  2552,  9191,
   -3174,  8069, -3174,  2554,  9191,  2579,  8443,  8817,  2508,  9191,
   -3174, -3174, -3174,  1419, -3174, -3174,  1025, -3174, -3174, -3174,
    2539, -3174,   822,   822, -3174, -3174, -3174,   822, -3174,   822,
    2545, -3174,  9191, -3174, -3174,  2520, -3174, -3174, -3174,  2516,
    1652, -3174, -3174, -3174, -3174, -3174,  2450, -3174, -3174,  5831,
     653,  2265, -3174,  2278,  2548, -3174,  2556,  2174,  2334, -3174,
   -3174, -3174, -3174, -3174, -3174,   438, -3174, -3174, -3174, -3174,
    2557, -3174, -3174, -3174, -3174, -3174, -3174, -3174,  1652,  2533,
   -3174,  1305,  2290,   822,   822,   359, -3174, -3174, -3174,  1010,
    2534,  2563,  2564, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174,  2223,   718,  2203,  1318,   718, -3174, -3174, -3174,
   -3174, -3174,  2438,  2370, -3174, -3174,  2330,  2231,  1652, -3174,
   -3174, -3174, -3174, -3174,  1652,  2331,  1763,  2566, -3174, -3174,
   -3174, -3174, -3174, -3174,  1652,  2122,  2541, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
    2553, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
     822,  2558,   822, -3174, -3174, -3174, -3174,  1652, -3174, -3174,
    2559,  2560, -3174, -3174, -3174, -3174, -3174, -3174, -3174,  2569,
    2576, -3174, 10316, -3174, -3174,  7083,  2546,  9191, 11062,  5135,
    5215, -3174, 11435,  5227, -3174,  1318,  2582, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174,  2626,   822,  1631, -3174,  2562, -3174,   839,
     822,  1880,   982, -3174, -3174, -3174, -3174,  1631,   839,   982,
    2567, -3174,  4801,  4939,  2589,  2593,  1054,   827,  2595,  1063,
    2597,  2598,   890,  2599,   897, -3174,  2601, -3174, -3174,  9191,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174,  4974, 10689, -3174,
   -3174, -3174, -3174, -3174,  1172, -3174, -3174, -3174,  1318,  2332,
    1652, -3174, -3174, -3174, -3174, -3174, -3174,   525, -3174, -3174,
    1475,  2337,  2338,  2341, -3174, -3174, -3174,  1471, -3174,  2449,
   -3174, -3174, -3174,  9191, -3174, -3174, -3174, -3174,   923, -3174,
   -3174, -3174,  2409, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
    1652,   822,  2509,  2410, -3174, -3174,  1652, -3174,   656, -3174,
    1972, -3174, -3174,   977,  1084,    12,   523,   181, -3174, -3174,
   -3174, -3174, -3174,  2133, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174,  2607,  2620,  2570,  1398, -3174, -3174,  4210, -3174, -3174,
   -3174, -3174, -3174, -3174,  2630, -3174, -3174, -3174,   822, -3174,
   -3174,   822,  1361,   822, -3174,  2543,  2543,  2649, -3174, -3174,
   -3174, -3174, -3174,  2543,  2543,  2672, -3174, -3174, -3174, -3174,
   -3174,  2664,  9191, -3174, -3174, -3174,  2665,  9191, -3174,  9191,
    2695, -3174,  9191, -3174, -3174,  5263, -3174, -3174,  1585, -3174,
   -3174, -3174,  1652,  1359,  2377,   822,   822,   359, -3174,  2652,
   -3174,  1652, -3174, -3174, -3174,   822,   539,  2561,  2565,  1010,
    2654,  2655, -3174,  2628,  2659,   822,   822,   822, -3174, -3174,
    1481,  5023,  2689,   173,   822,  2689,  1732,   201,  2635,   822,
   -3174, -3174,   297,   822, -3174,  2566, -3174, -3174,  1979, -3174,
   -3174, -3174,   203, -3174, -3174,  1652,   822,  1652,  2666, -3174,
     822,   822,   -21,   822,  2414,   178, -3174,  2669, -3174,  1652,
    2213,  2217,  1652,  1652,  2671,   291, -3174,    -2,    16,   863,
     247, -3174,    70, -3174,    27, -3174, -3174, 10316, -3174, -3174,
   -3174,  2730, -3174, -3174, -3174, -3174,   495,  9191,  2682,  2661,
   -3174, -3174,  2562,   822, -3174,   822,   822,   822,  1880,  1880,
   -3174,  2686,  2687,  2690,  2667,  2692,  2694,  2697, -3174,   822,
    2447,  1014, -3174,   822,  2506,   822,  2437,  2441,  2683,   430,
    2439,  2453,   567,   -17, -3174,  2705, -3174,  2448,  2451,  2452,
   -3174, -3174, -3174, -3174, -3174, -3174,  2706,  1651,  1714, -3174,
   -3174, -3174, -3174,  2342, -3174,  2708,   822,   822,  2709, -3174,
   -3174, -3174,  1475, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
    2715,  2689,  2689,  2716,  2718,  2719,  2689,  2689, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174,  1500, -3174,   822,  2507,
    2282,  2696,   822,   822,   822,  1652,  2471,   599,    -5,  2335,
    2394,  1652,   822,  2465,   711,  -144,   822,  2653,  2339, -3174,
    2732, -3174,   822,  2733, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174,   822,   822, -3174, -3174, -3174,   822,
     822, -3174, -3174, -3174,  2287, -3174,    38,   -41,   -26,  2297,
    -172,  2300,  1652,  2296,  2568,  2292,  2504,  2477,  2482,  2283,
    2758, -3174,    87,  1318,  2765, -3174,  2793,    87,  2766, -3174,
   -3174, -3174,   822, -3174,  1652,     1,   822,  2577,  1652,  2523,
     616,  1318,   -45,  2454,  2578,  2700,  -194,  2583,  2584,    90,
    2302,  2303,  2304, -3174,  2771, -3174,   653,   615,  2777, -3174,
    2299,  2310,   653,  2780, -3174, -3174,  1717,  1875, -3174,  4210,
    2784,  9191, -3174,  2803,  2809, -3174, -3174, -3174, -3174, -3174,
   -3174,  9191, -3174,  9191, -3174, -3174,   204, -3174, -3174, -3174,
   -3174,  1652, -3174,   822,   822,  2549,   822,   822,   822,   822,
    1652,   822,   822,   822,   822,   822, -3174, -3174,  2538, -3174,
     822,   822,   822, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174,  2794,  2799, -3174, -3174,
     923,  2801,  2805,   923,   923,   923,  2810,  2811, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,  1652,  2364,
   -3174, -3174, -3174, -3174, -3174,   118,   822,   822, -3174, -3174,
   -3174, -3174,  1652,   869, -3174, -3174,   822,   822, -3174,  1652,
    1652, -3174,   822,  1652, -3174, -3174, -3174, -3174, -3174,  2343,
    2343,  2540,  2614, -3174,  1067,   822,  1067,  2617,   822,   822,
     822,  2542,  2381, -3174,  1652,   822,   822,  2685,  1652,  1093,
    1652,   244,   117, -3174, -3174,   822, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174,  1652,  1652, -3174,   822,
   -3174,   822,   822,   822, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174,   899,   822,   822, -3174, -3174,   822,   822,  1652, -3174,
    1652,  1652,  1652, -3174, -3174, -3174, -3174, -3174, -3174,  2678,
    2679, -3174, -3174, -3174, -3174, -3174,  2760, -3174,  5103,   822,
     822,  2832,  2812,  1318,  1318,    20, -3174, -3174, -3174,  1652,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174,   923,   923, -3174,
   -3174, -3174,   923,   923, -3174,  1652,  1106, -3174, -3174, -3174,
   -3174, -3174, -3174,  2415, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174,  1652, -3174, -3174,   822,   822, -3174, -3174, -3174, -3174,
    2343, -3174,   822,  2343, -3174, -3174,   822,  1652, -3174, -3174,
   -3174,   822, -3174, -3174, -3174, -3174,   822,  1652, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174,  2416, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174,   653,   653, 10316,  2835, -3174,
   -3174, -3174,  9191, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174,  2422, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174,  2362, -3174, -3174, -3174,
   -3174, -3174, -3174,  2817, -3174,  2844,   863,  9191, -3174, -3174,
    2845, -3174
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
     584,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2253,     0,   583,   732,   734,   736,  1161,  1163,  1165,
    1167,  1171,  1173,  1175,  1233,  1242,  1244,  1246,  1248,  1250,
    1252,  1254,  1256,  1258,  1260,  1262,  1264,  1271,  1273,  1275,
    1277,  1279,  1281,  1283,  1287,  1289,  1291,  1344,  1482,  1484,
    1486,  1488,  1425,  1733,  1876,  1878,  1880,  1882,  1884,  1886,
    1888,  1890,  2065,  2067,  2151,  2237,  2239,  2241,  2243,  2245,
    2247,  2249,  2251,     1,   582,     0,  1004,   586,  1000,  1001,
       0,     0,     0,     0,     0,     0,     0,     0,  1022,  1023,
       0,   993,   994,   996,   997,   998,   999,  1002,     0,     0,
    2196,     0,     0,     0,     0,   585,   587,   738,   741,   743,
     745,   747,   782,   982,   989,   991,  1003,     0,  1005,  1008,
       0,  1067,  1072,  1021,  1024,  1028,  1304,  1310,  1024,  1346,
    1024,  1437,  1024,  1363,  1024,  1028,  1024,  1703,  1024,  1720,
    1024,  1028,  1024,  1028,     0,  1028,  1024,  1923,  1024,  2012,
    1024,  2069,  1024,  1028,  1028,  2195,  2222,  2225,  2232,  1024,
    1024,  1028,   733,   735,   737,   867,   868,   879,   795,   796,
     874,   598,   871,   872,     0,     0,     0,     0,   890,     0,
       0,     0,   893,   869,   870,   891,   892,   894,   895,   896,
     897,   898,   899,   901,   902,   903,   900,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1299,  1301,
    1302,  1303,  1300,  1481,  1687,  1690,  1689,  1686,  1688,  1691,
    1692,  1693,  1696,  1698,  1694,  1695,  1697,  1699,     0,     0,
    1872,  1873,  1874,  1875,  2010,  2011,  2063,  2064,  2157,  2158,
    2159,  2160,  2161,  2162,  2163,  2164,  2166,  2167,  2168,  2169,
    2170,  2171,  2172,  2173,  2174,  2175,  2176,  2177,  2178,  2179,
    2180,  2182,  2183,  2184,  2185,  2186,  2187,  2188,  2189,  2190,
    2191,  2192,  2193,  2165,  2181,  2289,  2290,   889,   620,   621,
     630,   622,   623,   624,   625,   631,   632,   626,   627,   628,
     875,   730,   731,   629,   873,   883,   929,   930,   947,   928,
     931,   933,     0,   946,   932,  1293,  1295,  1294,     0,     0,
       0,  1293,   653,   653,     0,     0,     0,     0,  1290,  1078,
       0,     0,     0,     0,  1297,     0,     0,  1177,     0,  1235,
    1170,     0,     0,  1170,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1267,     0,  1266,  1269,   653,
    1735,  2254,  2253,     0,  2253,     0,     0,  2255,  2250,    39,
      40,    41,   596,   595,     2,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,     0,   597,     0,   783,   739,   742,   749,   750,   751,
     753,   752,   754,   755,   756,   757,     0,   758,   759,   760,
     761,   762,   763,   764,     0,   765,     0,     0,     0,     0,
     651,   650,     0,     0,     0,     0,     0,   604,   995,     0,
       0,  1075,  1074,  1076,  1077,     0,     0,     0,  2229,     0,
       0,   589,     0,     0,   591,     0,  1009,  1019,  1100,  2070,
    1491,  2110,  1347,  1438,  1364,  1706,  1721,  1742,  1902,  1917,
    1924,  2013,  2259,  2276,  1745,  2015,    13,  1025,     0,  1099,
       0,     0,   604,     0,  1106,     0,     0,     0,     0,  1037,
       0,  1051,     0,     0,  1308,  1312,     0,     0,     0,     0,
    1323,     0,  1619,  1620,  1490,     0,     0,     0,     0,     0,
    1609,  1610,     0,     0,     0,     0,   604,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   604,     0,  1495,
    1492,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   604,     0,     0,     0,     0,     0,     0,   604,     0,
       0,     0,     0,     0,     0,  1336,  1640,  1682,     0,     0,
       0,     0,     0,  1004,  1741,     0,     0,     0,   604,     0,
       0,   604,     0,   604,  1748,  1752,  1051,  1753,     0,     0,
    1766,     0,  1901,   604,     0,     0,     0,     0,     0,     0,
    1906,     0,  1919,  1916,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2109,     0,     0,
       0,     0,     0,     0,  2134,  2149,  2258,     0,     0,     0,
       0,     0,   604,     0,   604,  2268,  2266,  2267,     0,  2269,
       0,     0,     0,  2275,  2282,     0,  2279,     0,   867,   867,
     867,     0,     0,   867,   889,   867,     0,   856,     0,   611,
       0,     0,     0,   614,   615,     0,     0,     0,   926,   618,
     816,   817,     0,   819,     0,     0,   725,   725,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   797,   800,   796,
     799,     0,   876,   803,   620,   621,   847,   798,   802,   834,
     831,   832,   833,   843,     0,   851,     0,   619,     0,     0,
     884,     0,     0,  1263,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   904,     0,
    1109,     0,  1108,  1286,  1284,  1285,   652,     0,     0,     0,
       0,  1278,  1120,     0,  1119,     0,     0,  1080,  1083,  1292,
    2252,  1340,  1296,  1298,  1297,     0,  1172,     0,  1164,     0,
    1162,     0,  1169,     0,  1170,  1170,  1170,  1170,  1427,  1170,
    1170,  1892,  1170,  1170,     0,  1170,  1170,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2218,  2213,  2216,
    2214,  2215,  2217,  2219,  2220,  2221,     0,  2211,  1270,     0,
       0,     0,     0,  2246,  2255,  2242,  2244,  2256,     0,     0,
    1306,     0,   772,   574,   577,   579,   572,   573,   575,   576,
     578,   580,   581,   767,     0,   766,     0,     0,     0,   985,
     987,   988,  1095,     0,     0,   990,  1070,  1068,  1069,  1071,
     600,   602,   601,   603,     0,   599,  2233,     0,  2224,     0,
    2199,  2204,     0,  2200,     0,     0,  2226,     0,     0,  2236,
    2235,     0,  2194,  1007,  1017,  1006,  1743,  1744,  1024,  2014,
    1026,     0,  1101,     0,  1033,  1029,  1030,  1086,  1036,  1035,
    1034,  1031,   604,  1102,  1049,  1053,  1103,  1104,     0,  1305,
    1354,  1443,  1372,  1521,     0,     0,     0,     0,     0,  1539,
       0,     0,     0,  1613,  1611,  1614,  1612,  1615,  1617,  1616,
    1618,   604,     0,     0,     0,     0,   604,   604,     0,     0,
       0,     0,  1637,     0,     0,     0,   604,     0,     0,     0,
       0,   604,     0,     0,     0,  1540,     0,   605,   606,   607,
       0,   608,     0,     0,   608,     0,  1513,  1514,  1515,     0,
     604,     0,     0,     0,     0,     0,   604,   604,     0,   604,
     604,     0,   604,   604,   604,   604,   604,     0,     0,   604,
     604,     0,   604,     0,     0,   604,   604,     0,     0,     0,
       0,   604,     0,   604,  1522,  1524,  1334,  1338,  1680,  1684,
    1523,  1715,  1730,  1746,   604,   604,   604,  1767,  1754,   604,
    1764,  1761,     0,  1755,  1749,  1750,  1053,  1747,  1769,  1903,
    1913,     0,     0,  1912,     0,     0,  1909,  1914,  1915,  1905,
    1904,  1044,   778,     0,  1058,  1059,     0,     0,  1057,  1039,
       0,  1040,  1055,  1038,     0,   604,     0,  1920,  1921,  1936,
    2022,  2072,  2111,     0,     0,   640,   639,  2129,   604,     0,
    2112,  2113,  2114,  2136,     0,  2135,     0,  2139,  2137,  2138,
    2142,  2140,  2125,  2131,  2147,     0,   604,   604,  2155,     0,
       0,  2270,     0,  2263,  2262,  2272,  2153,  2261,  2260,  2277,
    1086,  2280,     0,  2278,     0,   859,   865,   863,     0,   795,
     796,   867,     0,   864,   866,   858,   610,   612,     0,   934,
       0,     0,   935,   818,     0,   911,     0,   726,   727,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   805,   848,   849,     0,     0,     0,   877,     0,   878,
       0,     0,   887,     0,   885,     0,     0,   923,   921,   919,
     916,   917,   918,   920,   922,   924,   925,   912,   913,   914,
     915,     0,  1228,  1226,  1227,  1211,  1214,  1218,  1221,  1224,
    1225,  1229,  1212,  1213,  1215,  1216,  1217,  1219,  1220,  1222,
    1223,  1230,  1231,  1232,  1113,  1114,  1115,  1117,  1118,  1116,
       0,  1111,  1276,  1272,  1280,  1282,  1124,  1125,     0,  1122,
    1288,  1079,  1081,  1082,  1084,  1085,     0,     0,  1166,  1174,
    1176,     0,     0,   778,     0,  1187,     0,  1208,     0,  1189,
    1188,  1193,  1194,  1207,  1209,  1210,  1178,  1186,     0,  1234,
    1241,  1238,  1237,  1239,  1240,  1236,  2152,   653,   653,   653,
     653,     0,   653,   653,     0,  1170,   653,  1170,   653,  1877,
     653,   653,     0,  1257,  1249,  1259,  1251,  1243,  1245,     0,
    1253,  1255,     0,  1268,  1265,  1274,  1734,   778,     0,     0,
    1739,  2248,     0,  2257,  2238,     0,   768,   774,     0,   740,
     776,     0,   744,     0,     0,  1086,     0,     0,   983,  2234,
    2223,  1073,     0,  2203,   655,   656,   657,   654,     0,  2206,
    2207,     0,  2202,     0,  2209,     0,     0,  2228,  2230,   592,
     593,   594,   590,     0,  1918,  1027,  1032,  1089,  1092,  1107,
       0,     0,  1054,     0,  1311,     0,  1307,  1319,  1028,  1028,
    1028,     0,     0,     0,     0,     0,  1530,     0,     0,     0,
     604,   604,  1579,  1581,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1635,  1639,   604,   604,     0,     0,
       0,     0,     0,     0,     0,  1601,  1600,  1422,  1603,  1541,
     638,   637,  1495,     0,  1495,     0,     0,  1527,  1498,  1499,
    1516,  1517,  1518,  1519,  1520,     0,  1492,     0,     0,  1525,
    1577,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1576,     0,     0,     0,     0,     0,   604,     0,
       0,     0,  1580,     0,  1534,   604,     0,     0,     0,   604,
     604,   604,     0,     0,     0,     0,  1322,  1053,     0,  1685,
    1028,  1028,  1756,     0,  1759,  1758,  1763,  1757,     0,  1765,
    1751,     0,  1911,  1910,  1907,  1908,   777,  1056,   772,   780,
    1066,  1060,  1042,   604,  1043,  1041,  1046,     0,  1028,  1028,
    1028,  2127,     0,     0,  2119,   608,  2132,     0,     0,     0,
     604,   604,     0,  2126,     0,  2117,  2273,  2264,  2154,     0,
    2271,  1094,  2286,  2281,   867,   857,   861,   867,     0,   612,
       0,     0,     0,     0,   721,   723,   942,     0,     0,   927,
       0,     0,     0,     0,   948,   945,     0,     0,     0,     0,
     801,     0,     0,   835,   844,   852,  1702,  1701,     0,   888,
       0,     0,   906,   907,   909,   905,   910,     0,  1110,     0,
    1121,  1345,  1342,  1343,  1341,  1168,  1180,  1205,  1206,     0,
    1202,  1203,  1204,  1198,  1196,  1197,  1179,  1195,  1185,  1192,
       0,     0,  1182,  1181,   598,  1190,  1191,     0,     0,     0,
       0,  1426,  1428,  1432,  1435,     0,  1433,  1434,     0,  1436,
       0,     0,     0,  1891,  1900,     0,     0,  1895,  1898,  1893,
       0,     0,   653,     0,   653,     0,     0,     0,  1261,  1247,
    2212,  1738,  1737,  1736,  1740,  2240,   588,   770,     0,     0,
     784,   786,     0,     0,     0,     0,  1096,   984,   986,  2198,
       0,     0,  2205,  2201,     0,  2197,   992,     0,     0,  1020,
       0,   604,   604,     0,     0,     0,  1090,   653,  1086,  1105,
    1052,     0,  1047,     0,     0,  1309,  1317,  1321,  1356,     0,
       0,     0,  1348,  1349,     0,  1445,  1446,     0,  1439,  1440,
       0,  1374,  1379,  1381,  1381,     0,     0,     0,  1365,     0,
       0,     0,     0,     0,  1553,  1552,  1551,  1608,     0,     0,
    1500,     0,   604,     0,     0,  1589,  1588,  1599,     0,     0,
       0,     0,     0,  1578,     0,     0,  1566,   604,     0,  1542,
       0,     0,  1549,     0,  1420,     0,     0,   609,     0,  1496,
    1497,  1606,     0,  1493,  1494,  1544,  1536,     0,     0,  1557,
       0,  1546,  1532,     0,  1533,  1568,  1582,  1548,  1547,  1598,
    1550,     0,  1583,     0,  1585,  1586,  1535,     0,  1545,  1573,
       0,     0,     0,     0,  1571,   604,  1607,     0,  1337,     0,
    1328,     0,  1339,     0,     0,  1683,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   604,
     604,   604,   604,     0,  1650,     0,  1717,     0,     0,     0,
       0,  1704,  1707,  1709,  1051,  1708,     0,  1732,   778,     0,
       0,     0,     0,  1726,  1722,     0,  1760,  1762,  1768,  1862,
       0,   604,  1782,   604,  1780,     0,     0,  1772,   604,     0,
    1786,  1863,   779,     0,  1065,  1045,  1922,  1938,     0,  1939,
    1929,  1931,     0,     0,     0,  1925,  1926,     0,  2024,  2025,
     604,     0,  2016,  2017,     0,     0,     0,  2071,     0,     0,
    2087,     0,  2087,     0,     0,  2087,  2074,  2075,     0,  2078,
       0,  2130,  2115,  2116,  2118,     0,  2143,  2144,  2141,   646,
     647,  2121,  2123,  2122,  2124,  2120,   598,   788,  2150,   884,
     884,     0,     0,   949,   950,   951,     0,     0,   959,     0,
       0,     0,     0,   980,   884,  2146,     0,   981,  2148,     0,
    2274,  2156,  2284,  2288,   860,   862,     0,     0,   936,     0,
     880,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   805,     0,     0,     0,     0,     0,     0,   886,
     616,   617,     0,  1112,  1123,     0,  1199,  1200,     0,  1183,
    1184,  1489,  1483,  1485,  1487,  1430,   643,   644,   645,   641,
     642,  1429,  1431,  1881,  1879,  1896,  1899,  1894,  1897,     0,
    1883,     0,  1887,  2066,  2068,     0,   775,   772,     0,     0,
     792,   793,   787,   790,   791,     0,  1700,   746,     0,   658,
    2208,  2210,     0,  2231,     0,  1011,  1010,  1012,     0,     0,
       0,  1018,  1087,     0,  1091,  1093,  1048,  1050,  1314,     0,
    1313,     0,     0,  1352,  1355,  1086,  1441,     0,  1444,  1366,
    1086,  1367,  1399,  1368,  1403,  1369,   604,     0,  1373,     0,
       0,     0,  1560,  1562,     0,     0,     0,  1504,     0,     0,
       0,     0,  1502,  1563,     0,     0,     0,  1590,     0,     0,
    1537,  1558,  1638,  1621,     0,     0,  1564,  1567,     0,  1543,
    1554,  1559,  1160,     0,  1604,  1529,  1528,  1526,  1555,  1556,
    1538,  1531,  1587,  1584,  1605,   604,  1569,  1574,  1572,     0,
       0,     0,  1329,  1335,     0,     0,   604,   604,   604,     0,
       0,   604,     0,     0,     0,  1677,     0,     0,  1658,  1659,
    1660,  1656,  1676,  1675,  1661,     0,     0,  1681,  1710,     0,
       0,     0,     0,  1053,  1716,  1725,  1724,  1723,  1728,  1727,
       0,  1731,  1086,  1785,     0,     0,   604,  1773,     0,     0,
    1771,     0,     0,  1789,  1784,  1788,     0,  1778,  1770,     0,
    1796,  1061,  1062,  1063,  1064,   636,   635,  1974,  1983,  1928,
    1086,  1927,     0,     0,  1934,   604,     0,  1937,  1086,  2021,
    2018,  2020,  2023,  2089,     0,     0,     0,  2088,     0,     0,
       0,  2090,  2076,  2093,  2102,  2080,     0,  2073,  2128,  2133,
       0,     0,     0,   786,     0,     0,     0,     0,     0,     0,
       0,   978,   978,     0,   972,     0,     0,   974,     0,  2265,
       0,     0,     0,     0,     0,   679,   690,   691,   677,     0,
     680,   681,     0,     0,   684,   685,   689,   686,   728,   687,
       0,   703,   703,     0,     0,   729,     0,   703,   703,     0,
       0,     0,     0,   939,   940,   938,   941,   814,     0,     0,
     812,     0,   808,     0,     0,   806,     0,     0,     0,   884,
    1201,  1885,  1889,     0,   766,   785,     0,   781,   794,   773,
       0,  2227,     0,     0,  1015,  1016,  1088,     0,  1320,     0,
       0,  1360,     0,  1362,  1361,  1351,  1357,  1350,   772,  1478,
     604,  1377,  1375,  1376,  1378,  1380,  1399,  1397,  1382,     0,
       0,  1406,  1370,     0,     0,  1592,     0,     0,     0,  1507,
    1508,  1506,  1510,  1509,  1511,     0,  1501,  1594,  1593,  1595,
       0,  1591,  1631,  1636,  1565,  1423,  1133,  1134,   604,     0,
    1417,     0,     0,     0,     0,     0,  1419,  1126,  1128,     0,
    1159,     0,     0,  1570,  1331,  1332,  1330,  1325,  1327,  1324,
    1326,  1333,     0,   604,     0,     0,   604,  1669,  1670,  1671,
    1673,  1674,     0,     0,  1679,  1662,     0,     0,   604,  1647,
    1648,  1649,  1657,  1678,   604,     0,     0,     0,  1718,  1712,
    1713,  1714,  1711,  1705,   604,  1865,  1869,  1775,  1776,  1774,
    1850,  1777,  1850,  1810,  1790,  1779,  1864,  1797,  1981,  1980,
    1971,  1987,  1986,  1994,  1930,  1996,  1997,  2004,  1932,  1935,
       0,  2060,     0,  2086,  2085,  2079,  2082,   604,  2081,  2077,
    2094,     0,  2083,  2145,   648,   956,   789,   970,   971,     0,
       0,   964,     0,   853,   955,     0,     0,     0,     0,     0,
       0,   969,     0,     0,  2287,     0,     0,   613,   937,   881,
     882,   678,   682,   683,   688,   673,   671,   669,   668,   670,
     672,   667,   674,   696,     0,   713,   698,   694,   704,   714,
       0,     0,   715,   634,   633,   712,   722,   718,   719,   720,
     716,   724,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   850,     0,   769,   771,     0,
     953,   748,  1014,  1013,  1316,  1315,  1318,     0,     0,  1353,
    1476,  1447,  1442,  1382,     0,  1402,  1404,  1405,     0,  1408,
     604,  1597,  1561,  1505,  1512,  1503,  1596,     0,  1424,  1416,
    1129,     0,     0,     0,  1411,  1415,  1391,     0,  1392,     0,
    1418,   662,   661,     0,  1135,   663,   664,   665,  1136,  1132,
    1421,  1575,     0,  1642,  1643,  1641,  1653,  1654,  1651,  1652,
     604,     0,     0,     0,  1667,  1672,   604,   841,     0,  1729,
    1863,  1867,  1871,     0,     0,     0,  1799,     0,  1985,  1969,
    1968,  1992,  2002,     0,  2058,  2026,  2019,  2084,  2096,  2101,
    2103,     0,     0,   957,     0,   954,   960,   978,   979,   980,
     978,   981,   963,   966,     0,   965,  2283,  2285,     0,   692,
     676,   675,     0,     0,   675,   703,   703,     0,   705,   706,
     707,   708,   709,   703,   703,     0,   943,   944,   829,   813,
     811,     0,     0,   809,   827,   807,     0,     0,   825,     0,
     823,   822,     0,   820,   908,     0,  1359,  1358,  1448,  1480,
    1401,  1400,   604,     0,     0,     0,     0,     0,  1390,     0,
    1407,   604,  1410,  1371,  1633,     0,     0,     0,     0,     0,
       0,     0,  1632,     0,     0,     0,     0,     0,  1393,  1394,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1663,  1664,     0,     0,  1668,     0,  1719,  1866,     0,  1783,
    1853,  1851,  1854,  1781,  1787,   604,     0,   604,     0,  1795,
       0,     0,     0,     0,     0,     0,  1809,     0,  1984,   604,
       0,     0,   604,   604,     0,     0,  1973,  1988,  1998,     0,
       0,  2062,     0,  2091,     0,   968,   967,     0,   788,   973,
     804,   839,   836,   837,   838,   845,     0,     0,     0,     0,
     975,   697,   695,     0,   699,     0,     0,     0,     0,     0,
     717,     0,     0,     0,     0,     0,     0,     0,   952,     0,
       0,     0,  1479,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1475,     0,  1388,     0,     0,     0,
    1383,  1387,  1389,  1398,  1409,  1634,     0,     0,     0,  1155,
    1156,  1157,  1158,     0,  1629,     0,     0,     0,     0,  1627,
    1628,  1127,  1129,  1412,  1413,  1414,  1395,  1396,   666,   649,
       0,     0,     0,     0,     0,     0,     0,     0,  1159,  1666,
    1644,  1645,  1646,  1655,  1665,   842,     0,  1870,     0,     0,
       0,     0,     0,     0,     0,   604,     0,     0,     0,     0,
       0,   604,     0,     0,     0,     0,     0,     0,     0,  1849,
       0,  1855,     0,     0,  1793,  1794,  1792,  1791,  1803,  1800,
    1806,  1807,  1808,  1801,     0,     0,  1804,  1798,  1976,     0,
       0,  1975,  1977,  1982,     0,  1972,     0,     0,     0,     0,
       0,     0,   604,     0,     0,     0,     0,  1957,  1959,     0,
       0,  1991,     0,     0,     0,  2001,     0,     0,     0,   659,
    1933,   660,     0,  2061,   604,     0,     0,     0,   604,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2053,     0,  2095,     0,     0,     0,  2108,
       0,     0,     0,     0,   958,   855,     0,     0,   788,   961,
       0,     0,   693,     0,     0,   700,   711,   710,   828,   810,
     826,     0,   824,     0,   821,  1449,     0,  1452,  1453,  1454,
    1451,   604,  1450,     0,     0,     0,     0,     0,     0,     0,
     604,     0,     0,     0,     0,     0,  1459,  1467,  1468,  1477,
       0,     0,     0,  1622,  1145,  1146,  1147,  1148,  1149,  1150,
    1151,  1152,  1153,  1154,  1630,  1625,     0,     0,  1626,  1130,
    1136,     0,     0,  1136,  1136,  1136,     0,     0,  1131,  1818,
    1819,  1820,  1821,  1822,  1823,  1824,  1825,  1815,   604,     0,
    1857,  1812,  1830,  1811,  1848,     0,     0,     0,  1843,  1837,
    1838,  1839,   604,   604,  1832,  1814,     0,     0,  1816,   604,
     604,  1813,     0,   604,  1868,  1856,  1852,  1802,  1805,  2008,
    2008,     0,     0,  1956,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1944,   604,     0,     0,     0,   604,     0,
     604,     0,     0,  1970,  1995,     0,  2006,  1990,  1989,  1993,
    2005,  1999,  2000,  2003,  2032,  2030,   604,   604,  2027,     0,
    2051,     0,     0,     0,  2046,  2031,  2054,  2057,  2056,  2055,
    2052,   604,     0,     0,  2028,  2029,     0,     0,   604,  2033,
     604,   604,   604,  2059,  2100,  2098,  2099,  2097,  2092,     0,
       0,  2107,  2104,   840,   846,   854,     0,   976,     0,     0,
       0,     0,     0,     0,     0,     0,  1461,  1455,  1456,   604,
    1471,  1470,  1473,  1472,  1474,  1457,  1458,  1098,  1097,  1460,
    1469,  1384,  1385,  1386,  1623,  1624,  1141,  1136,  1136,  1143,
    1142,  1144,  1136,  1136,  1833,   604,     0,  1841,  1840,  1842,
    1845,  1844,  1831,     0,  1846,  1829,  1817,  1828,  1827,  1834,
    1826,   604,  1979,  1978,     0,     0,  1965,  1966,  1967,  1952,
    2008,  1953,     0,  2008,  1946,  1942,     0,   604,  1945,  1947,
    1948,     0,  1962,  1958,  1963,  1960,     0,   604,  2007,  2050,
    2037,  2039,  2044,  2045,  2047,     0,  2048,  2042,  2043,  2040,
    2041,  2034,  2035,  2036,  2038,     0,     0,     0,     0,   702,
     701,   815,     0,  1462,  1463,  1465,  1464,  1466,  1139,  1140,
    1137,  1138,  1835,  1836,  1859,  1858,  1847,  2009,  1941,  1954,
    1950,  1955,  1951,  1940,  1943,  1949,     0,  1964,  2049,  2106,
    2105,   962,   977,     0,  1860,     0,     0,     0,  1861,  1961,
       0,   830
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,  -106,
    -983,   -69,    -7,  2176, -1057, -1430, -3174,  -160,  -179,  1174,
    1175,  1176, -3174, -3174, -3174, -3174,  -214, -3174, -3174, -1103,
   -3174, -2243, -1437, -1226,   416, -3174,   546, -2463,   -97,  -298,
     559,  -843,  -235, -3173,  -177, -1759, -3174,   503,   504,   505,
     508,   206,  -174,  -171,   207, -2363, -1544,   208, -3174, -3174,
   -3174, -3174,  1723, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174,   -89, -3174, -3174, -3174,
   -3174,   963, -1682, -3174, -1250, -2368, -3174, -3174, -3174,   265,
   -3034, -3174, -3174,   460, -3174,  -213, -2987,  1282,  -487, -1959,
   -2959,  2751, -2497, -2943,  1285,  -485, -3174,  1769, -3174,  1291,
   -3174, -3174, -3174, -3174, -1106, -3174, -3174, -1160,   214, -1965,
    -169, -1638, -3174, -3174,    30, -3174,    48, -2788, -3174, -3174,
   -3174, -1964, -3174, -3174, -3174, -3174, -2625,    36, -3174, -1083,
   -3174, -3174,     2,  2804, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174,   -62,  -105, -3174,  -141,  -751, -3174, -1093, -1510,  -136,
   -1174, -1104, -3174,  -279, -3174, -3174, -3174,  1998, -3174, -3174,
   -3174,   808, -1397, -1826, -3174, -3174, -2728, -3174, -3174, -3174,
   -3174, -3174,  -311, -3174,   910,  -769, -3174,   911, -2718, -3174,
    -334, -2866, -3174, -3174, -2268,  -207,  -347, -3174, -3174, -3174,
   -3174, -3174,  -251, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -1581, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,   219,
    1682, -1640, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174,  -145, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
     -25, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174,   788,   -29, -3174,  -170, -3174,   192, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
    1064,  -404, -3174, -3174,   174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174,   135, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174,  -884, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174,   101, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174,   -76, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174,  -571, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174,  -390,  -406, -3174, -3174, -3174, -3174,
    -581,  -407, -3174, -3174, -3174, -3174,  -580,  -403, -2955, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -1134,   324, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174,  1396, -3174, -3174, -3174, -3174, -3174, -3174,   318,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174,  1167,  1209, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174,  1133,  1659, -3174, -3174, -3174, -3174, -3174, -3174, -3174,
   -3174, -3174, -3174, -3174, -3174, -3174
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    23,    24,    25,    26,     2,     3,   115,   116,  1375,
    1389,  1017,   994,  3035,  2882,  1894,  1189,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
    2955,  2637,  3180,  1577,  2451,  2370,  2371,  3300,   972,  1267,
    1819,  3390,  3024,  3025,  2944,  3092,  2709,  2710,  2711,  2712,
    2713,  2945,  2946,  2947,  2949,  2950,  3102,  2952,  2714,  2720,
    2412,  2413,  1637,  2014,  2015,   301,   302,   303,   942,  1353,
     117,  1342,   118,   119,   120,   121,  2468,  2118,  1797,  1798,
    2120,  1799,  1967,  1968,  1558,  1800,   122,  1341,  2467,  2469,
    2672,  2673,  2470,  2471,  2472,   304,  1228,  1229,  3221,  1649,
    1230,  1650,  1231,  1232,  1233,  3225,  3048,  1234,  3226,  1235,
    1236,  3074,  1185,   305,  1186,   306,   307,  1662,  1663,   308,
     309,   310,   311,  1681,  2045,  2432,  2422,   313,  2394,  2473,
    2916,  2474,  2680,  3227,  3616,  2922,  2917,  2396,   123,  1364,
     124,   125,  1029,   127,   128,   129,   997,  2145,  1833,  1395,
     130,  1018,  1030,  1031,  2152,  2153,  1841,  1415,  1842,  1032,
    1563,  1559,  2324,  1972,   131,   132,   985,   331,  1837,  2494,
    2147,  1838,  2001,  2002,  1805,  1806,  3466,   133,   134,   135,
    1407,  1033,  1263,  1710,  1711,  1275,  1718,  1719,  2816,  2817,
    3153,  2818,  2819,  2820,  3168,  3284,  3029,  1888,    27,    28,
      29,    30,  1293,    31,    32,    33,  1289,  2066,  2067,  1748,
    1703,   318,    34,  1291,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,   358,  1329,    47,    48,
      49,    50,    51,    52,    53,   319,    54,    55,    56,   320,
    1285,   314,   136,   137,  1845,  1418,  1035,  1419,  1846,  1847,
    2760,  2499,  2157,  2500,  1094,  1095,  2831,  2261,  1945,  1517,
    1946,  1947,  1726,    57,   138,  2164,  2768,  1848,   139,  2765,
    2766,   140,  2170,  1849,   141,  2505,  3129,  3265,  3128,  2991,
    2506,    58,    59,    60,    61,   142,  2179,  1850,   143,  2775,
    2509,  2510,  2995,  3139,  3020,  2994,  2778,  2511,  2513,  2781,
    2999,  3142,  2515,  2821,  2553,  2214,  3008,    62,  1761,   144,
    1475,  1472,  2191,  2531,  2532,  1479,  1905,   145,  1464,  2215,
    1096,  2544,  3152,  3285,  3007,  3275,  2545,  2202,  1453,  1874,
    2203,  1097,  3036,  3313,  2852,  2285,  1948,  1519,  1949,  1098,
    2294,  2295,   146,  2296,  1950,   147,  2859,   148,  2305,  1951,
     149,    63,  1331,  1014,   150,   151,  1535,  1116,  1117,  1118,
    1119,  1120,  1961,  2319,  2621,  2618,  2624,  2625,  3055,  3188,
    2320,  3056,  3197,  2321,  3340,  3053,  3181,  3182,  3343,  3656,
    3755,  3735,  2612,  2630,  2866,  3050,  3178,  3052,  2613,    64,
      65,    66,    67,    68,    69,    70,    71,  1764,   152,   153,
    1131,   154,  1398,   155,   156,  2337,  2642,  2643,  1978,   157,
    2640,  3380,  3559,  3561,  3679,  3206,  3205,  3060,  2641,  2638,
    3204,  3058,  3057,  2879,  2639,  2883,  3061,  3384,  3564,  3207,
    2884,  2887,  3062,  3388,  3570,  3208,  2888,  3567,  3672,  1015,
     158,  2344,  1979,   159,  2648,  3211,  3414,  3590,  3210,  3065,
    2649,    72,    73,   160,   161,  1980,  2358,  2658,  2359,  2662,
    2665,  2900,  3069,  3212,  3418,  3213,  2901,  3214,  3423,  3608,
     162,   163,  1592,  1593,  2361,  1154,  1981,  1155,  1987,  2367,
    2368,  2398,  1994,  1595,    74,   164,  1168,   986,   165,  1813,
    1822,  1384,  1820,  2132,  1825,  1326,  1327,   166,   167,  1386,
    1387,  2137,   168,    75,    76,    77,    78,    79,    80,    81,
      82,   367,  1338,   169,  1605,  2400,  1169,  1170,   170,   171,
    1177,  1610,  2926,  2690,  2403,  1611
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     287,  1194,  1226,  1227,   966,   126,  1187,  1390,   993,  1265,
    1839,   980,  1471,  1474,  1142,   988,   941,  1130,  1153,  1167,
    1193,   944,   945,  1536,  1527,  1268,  1960,  1152,  1166,  2392,
    2395,  3027,  1561,  1892,  1639,  1640,  3391,  1225,   970,  1747,
    1093,  2046,   971,  2044,  1906,  1576,  1115,   361,  1129,  1173,
    1141,  2068,     4,     5,     6,   312,  1224,  2918,  1151,  1165,
    1192,  1330,  2635,  1746,  1660,  1661,  1176,  2421,  2423,  2425,
    2426,  2663,  1615,  1616,  1617,  1317,  1036,  1623,  1037,  1624,
    1038,  1790,  1039,  3381,  1099,   287,  1100,  3220,  1101,  2644,
    1121,  2779,  1304,  1433,  1143,  3544,  1144,  3184,  1145,  2745,
    1146,  3385,  2858,  2858,  2858,  2111,   991,  1171,  1172,   991,
    3546,   181,  3419,   970,   181,  3222,  1343,   971,  1860,  1467,
    1468,  2093,  1469,  1020,  1435,  1021,  3586,  1292,  1022,  1023,
     991,  3224,  1174,   991,  1437,   181,  1025,   991,   181,  2094,
     946,  1439,   181,  2924,  3154,   992,  1318,  2588,   992,  2790,
    3350,  3550,  1286,   126,  3467,  3415,  2392,  1895,  1370,  1371,
    1372,  1373,  1896,  1897,  3587,   973,  3519,  2076,  1184,   992,
     329,   321,   992,  1040,  1344,   316,   992,  1541,  2482,   287,
      88,    89,   287,  2595,  3425,  2095,  1576,  3696,  3529,  1583,
    2757,   181,  1026,   974,   975,  1027,     7,   991,  1544,   970,
    3725,  2758,   181,   971,  3594,  1156,  1476,  1864,   970,  1223,
    1377,   976,   971,  2842,     8,  1895,  1497,  2856,  1448,   989,
    1896,  2555,  1449,  1276,  2614,  1823,    83,  3301,   322,   323,
     326,   327,  1190,   324,  1198,  1786,   992,  1205,   359,     1,
      84,     9,    10,  1482,  1477,  1345,   172,  2435,  3576,  1308,
    1309,  1310,  1311,  1312,  1313,  3306,  1315,  1316,  1411,  1346,
    1347,  1348,  1349,  1350,  1895,   362,  3198,  3416,  1483,  1896,
    2556,  1299,  2885,  3595,  2096,   333,  3138,    85,    11,  1020,
      12,  1021,    13,   991,  1022,  1023,    14,    86,   181,   990,
    3185,    87,  1025,    15,    88,    89,   363,  3468,  3392,   101,
     102,   103,   104,   105,   106,  3386,   107,  1824,  1370,  1371,
    1372,  1373,  2051,   317,   991,  2857,  3199,  3351,  1478,   181,
    1836,    90,   992,  2308,  1450,    16,  2483,  1451,  2886,    17,
     181,  1292,  3393,  3520,  3186,  3551,    18,    19,  3196,  1370,
    1371,  1372,  1373,  3577,  1545,  3726,  3364,  1351,  1026,  2951,
    3530,  1027,  1988,   992,  2397,  2951,  2393,  1408,  1292,  2596,
    3047,  3027,  2097,  1865,  1157,  2615,  2589,  1467,  1468,  2843,
    1469,  1855,  1542,  3302,  1787,  1553,  3365,   325,   979,    91,
     330,    92,    93,  3623,  3624,    94,  2780,    95,  1300,  3366,
    2616,  1809,  1977,    96,  3615,    97,    98,    99,  3355,   100,
    2989,  3307,  1196,  1788,   173,  1983,  2309,  3417,  2126,  2759,
    3264,  2310,   181,   101,   102,   103,   104,   105,   106,  1158,
     107,  3027,  1159,   991,  1287,   334,  3154,   335,   181,  1789,
    3588,  1989,  2345,  2027,  1990,   174,  2346,  2262,  1434,  3220,
    3220,    88,    89,  2791,  2806,  2807,  3394,  1584,  1370,  1371,
    1372,  1373,  3228,  3697,  3352,  3229,   336,  1861,  2824,  2825,
    3339,  1656,   992,   337,  3367,   108,  2347,  2098,  3222,  1436,
    3521,   109,  1585,  1765,  2809,  1827,  2960,   110,   111,  1438,
    3545,  2397,  1586,  2393,  3224,  3456,  1440,  3547,  2925,  2439,
    2440,  3187,  3413,  3395,   355,  3548,  1498,  1880,    20,   338,
    1767,   339,  1828,  3589,  1426,  2056,  2028,  2392,  1502,  1197,
    1898,  1899,   328,   340,  1473,  2006,  2311,  1499,  1500,  3382,
     332,  1352,  2827,   341,  3383,    88,    89,  1985,  3625,  1986,
    3016,  2907,  3368,   356,  1319,  1657,  2524,  3387,  3369,  2099,
    1020,  3370,  1021,  1269,  1270,  1022,  1023,  1866,   342,  3396,
    2338,  3542,  3397,  1025,  2072,  2364,  2664,  2038,  1962,  1963,
     101,   102,   103,   104,   105,   106,  3017,   107,  1898,  1899,
    2542,  3598,   360,  3398,  2100,  3399,  3400,  3223,  3427,  3401,
    3420,  3421,   368,  3391,  3402,  3673,  3422,  1630,  1175,  1301,
    1320,  1321,  1322,  1323,  1324,  1325,  2828,  2052,  2053,  3518,
    3657,  3658,  1302,  1303,  2626,   977,  2101,  3565,  3189,  1026,
    3144,  3200,  1027,  1427,  2113,   357,  2605,  1898,  1899,  1380,
    1381,  1382,  3310,   967,  1020,  1991,  1021,   991,  1576,  1022,
    1023,  2348,   181,  2339,  1992,  3403,  1470,  1025,   364,   365,
     366,  3462,  3463,  2312,   101,   102,   103,   104,   105,   106,
    3428,   107,  1370,  1371,  1372,  1373,  1953,  1587,  1588,  1589,
    1590,  1591,  1366,  1367,  1368,  1441,   992,    21,  2525,   943,
    2833,    22,  3584,  3516,  3463,  2592,   343,   970,  3315,  2769,
    3457,   971,  3341,  2543,  2776,  3145,  1160,  1161,  3342,  1867,
    3582,  3463,  1442,  1026,  1631,  2081,  1027,  3018,  3019,  2313,
    3201,  2303,  3304,  3202,  3203,   315,   321,  1658,  2392,   316,
     316,  3404,  1406,  2082,  1305,  2829,  2314,  2349,  2315,  2830,
    2806,  2807,  2316,  3311,  3312,  3740,  2317,  2318,  3742,  2350,
     991,  3146,  3235,  3236,  3405,   181,  2526,   991,  1656,  3175,
    3238,  3239,   181,  1162,  1163,  1164,  3277,  3278,  1454,  3458,
    2809,  3406,  3459,  3279,  3280,  3281,  3282,  1614,  2351,  1294,
    2352,   344,  1370,  1371,  1372,  1373,  1178,  2771,  3190,   992,
    2965,   181,  2967,  1716,   968,  2969,   992,  2972,  2974,  2772,
    2773,  1659,   969,  1179,  2729,  1180,  3605,  1295,  3407,  3408,
    3409,  3410,   991,  3411,  1306,   978,  3412,   181,  1954,  3371,
    2834,  3372,  3373,  3464,   987,  1181,  3374,  3375,  2835,  3376,
    1277,  1278,  2007,  3176,  2880,  3377,  3378,  1370,  1371,  1372,
    1373,  1282,  2891,  1455,  3606,  1283,  3379,  3191,  2836,  1717,
    2297,   992,  2397,  2730,  2393,  3464,  2233,  3112,  3491,  3492,
    2908,   991,   112,  3496,  3497,  3147,   181,   317,   317,   995,
     113,   114,  3464,  3090,  3094,  2083,  2084,  2085,  1354,  1900,
    3192,  2764,   996,  2763,  1652,  1653,  2038,  1296,  2086,  2087,
    1369,  2527,  2016,  2528,  1340,  2529,  3465,  1456,  2530,  2623,
     992,  2138,  1034,  1388,  1388,  1457,  3113,   181,   991,  1383,
    2298,  1553,  3389,   181,  1297,  1506,  2017,  1356,  2404,  1260,
    3119,  2405,  1132,  1182,  1020,  1183,  1021,  3122,  3517,  1022,
    1023,  2139,  1654,  1370,  1371,  1372,  1373,  1025,   991,  2299,
    1272,  3023,  3095,   181,  1404,  3583,  1393,   992,  1409,  1410,
    3223,  3527,  1424,  2774,  2353,  2734,  1425,  2683,  1261,  2354,
    1782,  2355,  1783,  1370,  1371,  1372,  1373,  2392,  3073,  3120,
    3148,   981,  2340,  3149,  3150,  3151,  3123,   992,  1443,  1273,
    1357,  1358,  1466,  1284,  1240,    88,    89,   991,  3027,  1227,
    3283,  1188,   181,  1026,  1507,  1508,  1027,  3162,  1509,  1901,
    1902,  1903,  1904,  1503,  2735,   287,  1190,  3193,  3194,  3195,
    2327,  2140,  1370,  1371,  1372,  1373,  3090,  3094,  1191,  1192,
    2300,  1890,  2534,  2328,  1530,  2341,   992,  1199,  2736,  1187,
    1187,  1187,   214,  2456,  1187,  3163,  1187,  2457,  2458,  1282,
    1262,  2088,  2089,  1283,  2090,  1256,  1257,  1195,  1551,  1258,
     982,   983,   984,  2397,   181,  2393,  2910,  2921,  3021,  3022,
    1391,  1274,   991,  1757,  1758,  1759,  1760,   181,  1762,  1763,
    1510,  1766,  1768,  1598,  1770,  1771,  2979,  1206,  1191,  1573,
    1574,  1575,  3179,  2038,  1020,  3103,  1021,  1207,  3023,  1022,
    1023,  2805,  2727,  2329,  2141,  2142,  2143,  1025,  1208,  2144,
    1465,   992,  2980,  3164,   101,   102,   103,   104,   105,   106,
     187,   107,  1191,  2863,  1209,  2953,  2728,   190,   191,  1843,
    2732,  2837,  2838,  1844,  1511,  1191,  1192,  2849,  1890,  1704,
    1705,  1706,  1512,  3110,  1467,  1468,   991,  1469,  2514,  3033,
    3034,   181,  3115,  3165,  2733,  2607,  1210,  1467,  1468,  3166,
    1469,  2850,  2851,  1026,  1707,  1708,  1027,  3111,  1709,  1211,
     991,  1370,  1371,  1372,  1373,   181,  3116,  1359,  3167,  1360,
    1562,  1513,  1361,  3242,  2112,   992,  1191,  1192,  3244,   214,
    3245,   -60,  1212,  3247,  1561,  1370,  1371,  1372,  1373,  3183,
    1213,  1184,  1184,  1184,   287,  1223,  1184,  2881,  1184,   992,
    1214, -1602,  1362,  2806,  2807,  2808,  1363,   -60,  2570,   -60,
    3096,  3733,  2571,  3104,  2260,  2301,  2302,  2284,  3663,  3096,
    3104,  2603,  1215,   287,   287,   287,   287,   287,   287,   287,
    1772,  1396,  1397,  2809,   287,  2865,   -60,  1779,  2660,  2674,
    2675,  2666,  3646,   217,  1216,  3649,  3650,  3651,  3705,  1618,
    2810,  1793,  1237,   287,  2686,  1238,  2811,   287,   287,   287,
     287,   287,   287,   287,   287,   287,   287,   287,   287,   287,
     287,  1562,  2392,  3424,  1239,  2606,  1891,  3131,  1641,  1642,
    1643,  1644,  1645,  1646,  1647,  1801,  1431,  1432,  1388,  1651,
    2619,  1749,  2397,  2047,  2393,  2048,  1240,  1821,  3081,  1826,
    3079,  1974,  2046,  1241,  2044,  1975,  1552,  1553,  1664,  1750,
    1242,  1225,  1667,  1668,  1669,  1670,  1671,  1672,  1673,  1674,
    1675,  1676,  1677,  1678,  1679,  1680,  2049,  1554,  2050,  1374,
    1224,  1259,  1555,  2812,  1264,  2577,  2813,  2814,  1266,   991,
    3447,  3448,  1271,  2815,   181,  1857,  1858,  1279,  2767,  1556,
    1280,  3449,   287,  1552,  1553,  1557,  1834,  1288,  1178,  1467,
    1468,  1462,  1469,   181,  1370,  1371,  1372,  1373,  2764,  1782,
    2763,  2481,  1751,  1281,  1554,  1179,   287,  1180,   992,  1555,
    1192,  1881,  2635,  1217,  1218,   178,  1219,  1220,   181,  2806,
    2807,  3132,  2935,  2936,  2937,  1912,  1556,  1181,  1915,  3728,
    3729,  1290,  1557,  1907,  3730,  3731,  1292,  1795,  1908,  1909,
    1487,  1488,  2938,  2939,  2940,  1194,   998,  1814,  1815,  2809,
    1816,  1298,  1221,  1907,  1817,  1307,  2844,  3218,  1908,  2557,
    1752,  1807,  1328,  2853,  1193,  1547,  1548,  1217,  1218,  1619,
    1620,  1220,  3133,  1722,  1723,   999,  1959,  1753,  1754,  2330,
    2331,  2795,  2332,  2796,  1818,  1388,  1388,  2333,  1314,  1755,
    2334,   361,  1227,  1227,  1226,  1829,  1830,  1831,   991,  2158,
    1971,  1333,  1187,   181,  1971,  1000,  1221,  1335,  1971,  2077,
    2078,  2079,  2080,  1336,  2091,  2092,  1603,  1337,  2103,  1359,
    2105,  1360,  2106,  2107,  1361,  1182,  2977,  1183,  2978,  1225,
    2941,  2942,  3621,  3219,  3622,  2257,  2242,   992,  2216,  2258,
    2218,  1191,  1192,  1998,  1890,  1332,  2000,  1334,  1224,  3134,
    1134,  1222,  3135,  3136,  1339,  2150,  2003,  2755,  1363,  3137,
    1102,  1103,  2446,  2447,  2102,  2448,  2104,   181,    88,    89,
    1001,  1365,   991,  1020,  1378,  1021,  1002,   181,  1022,  1023,
    1003,  1385,   991,  1135,  1136,  1392,  1025,   181,  1137,  2873,
    1134,  -652,  -652,  1104,  -652,  1966,   287,  1370,  1371,  1372,
    1373,  1138,  1394,  2062,  1399,  1004,  1134,  1400,  1970,  1401,
    1139,   992,  1403,  1217,  1218,  1619,  1620,  1220,   181,  2151,
    1412,   992,  2061,  1135,  1136,  1724,  1725,  2397,  1137,  2393,
    2436,  2437,  1552,  1553,  1413,  2151,  1402,  2189,  1414,  1135,
    1136,  1138,  1026,  1416,  1137,  1027,  3676,  3677,  3678,  2895,
    1139,  1969,  1221,  1554,  2489,  2490,  1417,  1138,  1555,  2601,
    2602,  2578,  2793,  2794,  1184,  1420,  1139,  1020,  1421,  1021,
    2932,  2933,  1022,  1023,  1422,  1560,  1423,   287,  1428,   287,
    1025,  1552,  1553,  3011,  3012,  1429,  3249,   101,   102,   103,
     104,   105,   106,  1430,   107,  3090,  3091,  1445,  1223,  1223,
    3250,  1446,  1554,  1467,  1468,  3251,  1469,  1555,  1447,  2159,
    1984,  1452,  2160,  2161,  1217,  1218,  1619,  1620,  1220,   181,
    3252,   991,  2806,  2807,  1560,  1005,   181,  1458,  1006,  1459,
    3158,  3159,  2012,  1007,  2013,  1460,  1026,  3267,  3268,  1027,
    3296,  3297,  2114,  2259,  3436,  3437,  1370,  1371,  1372,  1373,
    1461,  1621,  1105,  2032,  1480,  2171,  2124,  2163,  1481,  2122,
     992,  1485,  2172,  2169,  1484,  2129,  2860,  2861,  1486,  2054,
    2057,  2058,  2059,  2060,  2133,  1489,  1966,  2069,  1490,  1493,
    1008,  2073,  2123,  1494,  1009,  1010,  1217,  1218,  1619,  1620,
    1220,  2075,  1495,  2162,  2168,  2178,  1504,  2182,  2183,  1492,
    1505,  1514,  2392,  3751,  1496,  1515,  1516,  1106,  1518,  1520,
    2194,  1521,  1522,  3753,  1523,  1524,  2200,  2201,  1011,  2982,
    2983,  1525,  1529,  3253,  2208,  2032,  2210,  2211,  3038,  1020,
    1966,  1021,  2806,  2807,  1022,  1023,  1526,  1532,  2173,  2219,
    2220,  1537,  1025,  1534,  1538,  1012,  1539,  2125,  3760,  1543,
    1546,  2223,  2224,  1549,  2459,  2293,  2461,  2227,  2228,  1550,
    2230,   287,  2809,  1562,  1217,  1218,  1619,  1620,  1220,   181,
    1565,  1564,  1566,  2243,  2217,  2631,  2632,  2633,  2634,  2485,
    3014,  3254,  1567,  1568,  1569,  1187,  1578,  1570,  1187,  1571,
    2496,  1572,  2336,  2343,  2357,  2292,  2304,  2306,  1026,  2493,
    1579,  1027,  2307,  1221,  1580,  1013,  1581,  2935,  2936,  2937,
    3474,  3475,  3476,  3477,  3478,   991,  2130,  1582,  3086,  1594,
     181,  1596,  1597,  2335,  2342,  2356,  1600,  2938,  2939,  2940,
    1194,  1599,  1602,  2372,  1200,  1201,  1202,  1203,  3255,  3256,
    3257,  1606,  1607,  2401,  1217,  1218,  1619,  1620,  1220,  1193,
    1608,  3258,  1609,  3259,   992,  3260,  1612,  1613,  1625,  2450,
    1626,  1627,  1628,  3261,  3262,  1629,  1258,  1107,  1108,  1109,
    1110,  1632,  3263,  3479,  3480,  3481,  3482,  3483,  2449,  1040,
    1633,  1634,  1655,  1221,  1665,  1666,    88,    89,  1712,  3277,
    3278,  3140,  1713,  1714,  1715,  1111,  3279,  3280,  3281,  3282,
    1112,  1720,  2291,  2174,  2175,  1113,  3098,  3099,  3100,  3101,
    2176,  1147,  2177,  1721,  1728,  2941,  2942,  3499,  3500,  3501,
    3502,  3503,  3504,  3505,  3506,  1729,  1756,    88,    89,  1769,
    1773,  1774,  1775,  1776,  1777,  1796,  1778,  2391,  2445,  1780,
    1781,  1784,  1785,  2452,   345,  1791,  1794,  1184,  1802,  1808,
    1184,  1803,  1122,  1804,  1810,  1811,  1812,  1851,  1853,  1852,
     287,   287,  1835,   287,   287,   287,   287,  1854,  1856,   287,
     287,   287,   287,  1862,  1863,   287,   346,  1870,  1871,  2465,
    2466,   287,  1876,  1877,  1872,  1020,  1873,  1021,  1875,  1879,
    1022,  1023,    88,    89,  1882,  1883,  1887,  1893,  1025,  3316,
     347,  1885,   348,  2475,   349,   101,   102,   103,   104,   105,
     106,  1886,   107,  1889,  3317,  2414,  2415,  2165,  2416,  2417,
    2418,  2419,  1910,  1913,  1914,  2520,  1020,  2397,  1021,  2393,
    2428,  1022,  1023,  1916,  1919,  2498,  2429,  2536,  1922,  1025,
    1928,  1929,  1935,  2539,  1932,  1934,   101,   102,   103,   104,
     105,   106,  1891,   107,  1026,  1938,  1939,  1027,  1943,  1941,
    1964,  1123,  1965,  2914,  2391,  1940,  1958,  1148,  1584,  1995,
    1973,  1999,  1149,  2004,  2008,  2009,  2018,  2011,  2026,  2029,
     350,   351,   352,  2031,   353,   354,  2010,  1225,  2036,  2037,
    2038,  1020,  2039,  1021,  2040,  1026,  1022,  1023,  1027,  2636,
    2166,  2041,  3270,  2636,  1025,  2055,  1224,  1133,  2074,  2108,
    2109,   101,   102,   103,   104,   105,   106,  2070,   107,  2585,
    2071,  1124,  3293,  3294,  3295,  2115,  2806,  2807,  2117,  2119,
    2127,  2131,  2135,  2136,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,  2608,   957,   958,   959,   960,   961,
     962,   963,  2146,  1125,  2609,  2148,  2809,  2149,  1134,  2154,
    1026,  2156,  2155,  1027,  2180,  2181,  2184,  2185,  2186,  2187,
    2192,  2195,  2207,  2193,  3318,  3319,  3320,  2196,  2197,  2198,
    2206,  1020,  2209,  1021,  2212,  2651,  1022,  1023,  2213,  2653,
    2221,  1135,  1136,  2199,  1025,  2225,  1137,  2226,  2229, -1603,
   -1603, -1603,  2572,  2231,  2668,  2232,  2234,  2235,  2236,  1138,
    1150,  2237,  2238,  2239,  3321,  2240,  2244,  2245,  1139, -1603,
   -1603, -1603, -1603, -1603,  1254,  1255,  1256,  1257,  2246,  2248,
    1258,  2249,  2254,  3322,  2250,  2255,  2256,  2323,  3323,  2326,
    2360,  1966,  2362,  2689,  2365,  2167,  2366,  2363,  2369,  2375,
    1026,  3324,  2402,  1027,  2399,  3325,  2406,  3326,  3327,  2407,
    2408,  2427,  2430,  2431,  2450,  2438,  3328,  2441,  2442,  3329,
    2443,  2444,  2453,  2121,  2454,  2455,  2460,  2462,  2463,  2464,
     965,  2476,  2478,  2449,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,  3585,   957,   958,   959,   960,   961,
     962,   963,  2480,  2484,  2477,  2491,  2488,  2492,  2497,  2502,
    2503,  2501,  2504,  2516,  2508,  2518,  2507,  3330,  2517,  2519,
    1140,  2521,   287,   287,  2552,   287,  2522,  2695,  2565,   287,
     287,  2523,  2533,  2754,  1388,  2537,  2574,   287,  2696,  2697,
    2698,  2699,  2538,  2700,  2701,  2702,  2743,  2540,  2703,  2746,
    2704,  2705,   287,  2541,   287,  2546,  2706,  2707,  2547,  2549,
    2550,  2708,  2551,  2784,  2554,  2786,  2558,  2559,  2560,  1126,
    1127,  1128,  2561,  2562,  2563,  2564,  2566,  1664,  1664,  2567,
    2677,  2568,  2800,  2573,  2678,  2679,  2580,  2576,  2575,  2581,
    3331,  2579,  1664,  3332,  3333,  3334,  2582,  2584,  2586,  2587,
    2597,  3335,  2583,  2598,  2604,  2599,  3336,  2693,  2600,  2694,
    2611,  2622,  2628,  2645,  2629,  2391,  3337,  2610,  2647,  2646,
    3627,  3628,  3338,  3630,  3631,  2652,  2656,  2654,  2659,  2657,
     965,  2667,  2695,  2655,  2670,  2671,  -979,  3641,  3642,  3643,
    2676,  2681,  2682,  2696,  2697,  2698,  2699,  2263,  2700,  2701,
    2702,  2685,  2684,  2703,  2687,  2704,  2705,  2264,  2867,  2868,
    2688,  2706,  2707,  2871,  2691,  2692,  2715,  2738,  2731,  2737,
    2875,  2739,  2740,  2876,  2741,  2742,  2744,  2265,  2747,  2749,
    2750,  2751,  2752,  2753,  2777,  2770,  2783,  2785,  2787,  2788,
    2636,  2797,  2789,  2798,  2799,  2792,  2801,  2803,  2893,  2894,
    2802,  2804,  2896,  2954,  2898,  2832,  2823,  2846,  2848,  2862,
    2902,  2854,  2855,  2826,  2864,  2847,  3723,  3724,  2892,  2870,
    2904,  2890,  2872,  2345,  2927,  2874,  2897,  2877,  1134,  1730,
    2878,  2928,  2266,  2931,  2948,  2934,  2956,  2961,  2905,  2970,
    2964,  2915,  2968,  2975,  1191,  1573,  1574,  1575,  2981,  3734,
    2990,  2998,  2986,  2988,  2943,  3001,  3000,  2151,  3003,  3707,
    2943,  2267,  2268,  3002,  3006,  3004,  1137,  3010,  3028,  3013,
    3030,  3031,  3041,  3032,  2856,  3051,   187,  3037,  3071,  1138,
    3040,  3043,  3076,   190,   191,  3072,  3088,  3059,  1139,  3087,
    3042,  3046,  3064,  3068,  3070,  3093,  1388,  1388,  3108,  3105,
    3026,  2984,  3109,  2985,  3114,  3117,  3160,  3118,  3121,  1731,
    3124,  3169,  3173,  3172,  3215,  3141,  2391,  3155,  3156,  2909,
    3209,  3157,  1682,  1244,  1245,  1246,   287,  3216,   287,  1683,
    1684,   287,  2269,  2997,  2270,  3217,  2271,  3230,  3237,  2272,
    1732,  3240,  2273,  1249,  1250,  1251,  1252,  1253,  1254,  1255,
    1256,  1257,  3241,  3243,  1258,  3246,  3269,  1388,  3015,  3273,
    2996,  3289,  3290,  3291,   287,   287,  3292,  3299,  1733,  1553,
    3308,  3286,   287,  3347,   287,  3287,  3357,   287,  3363,   287,
     287,  2919,   287,  2920,  3359,  1734,  2923,  3354,  3360,  1735,
    3426,  3430,  1736,  1737,  3431,  3438,  3439,  1738,  3455,  3440,
    3441,  3442,  3443,  3451,  3508,   287,  3444,  3446,  2274,   217,
    3460,  3461,  3469,  3473,  2275,  3485,  3488,  3453,  1739,  2962,
    2963,  3454,  3490,  3493,  3484,  3494,  3495,  3509,  3470,  3515,
    3510,  3471,  3472,  3523,  3063,  3532,  3066,  1664,  3526,  3534,
    3536,  1740,  1741,  1742,  3541,  1743,  1744,  1745,  1685,  1686,
    1687,  1688,  1689,  1690,  3522,  1691,  3533,  3552,  3554,  3556,
    2987,  3549,  1184,  3558,  3557,  3563,  2276,  1040,  3560,  3562,
    3555,  2885,  3569,  3573,    88,    89,  2277,  2278,  3603,  3579,
    3592,  3581,  3593,  2279,  3607,  3596,  3597,  3612,  3089,  1891,
    1891,  3617,  3619,  3591,  3097,  2280,  3075,  3600,  3620,  2286,
    3601,  3644,  2281,  3640,  3602,  3609,  3645,  2282,  3647,  3629,
    3655,  1227,  3648,  2287,  2283,  3610,  3675,  3652,  3653,  3682,
    3674,  3671,  3686,  3691,  1225,  1225,  3715,  3716,  3717,  1692,
    1693,  1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,  1702,
    3687,  3721,  3752,  1224,  1224,  3722,  3736,  3748,  3754,  3756,
    3757,  3758,    88,    89,  3761,  2391,  2063,  2064,  2065,  2756,
     287,  2669,  2661,  3759,  3288,  3233,  2716,  2717,  2718,  3234,
    3232,  2719,  2957,  1020,  2958,  1021,  2959,  1019,  1022,  1023,
    1638,  2322,  2748,  2288,  2289,  3171,  1025,  2033,  2906,  3613,
    1204,  2034,  3614,   101,   102,   103,   104,   105,   106,  2035,
     107,  1622,  3084,  2976,  3080,  1114,  2495,  2433,  3489,  3305,
    2434,  3498,  2512,  3127,  3130,  3077,  1727,  3272,  2993,  3005,
    2222,  3039,   287,  3054,  3177,  3681,  3543,  3568,  3693,  3571,
    3026,  3695,  3231,  1379,  3572,  2943,  2899,  2943,  2903,  1993,
    2134,  2110,  1026,  1792,     0,  1027,     0,     0,     0,     0,
       0,  1020,     0,  1021,     0,  2290,  1022,  1023,     0,     0,
    1024,     0,     0,     0,  1025,     0,   287,     0,     0,     0,
       0,   101,   102,   103,   104,   105,   106,  3125,   107,  1388,
    3271,     0,     0,     0,     0,     0,     0,     0,     0,  3276,
    3026,     0,     0,     0,     0,     0,     0,     0,     0,  1388,
    1388,  1388,     0,     0,     0,     0,     0,     0,  3303,     0,
       0,     0,     0,  3309,     0,     0,     0,  3314,     0,     0,
    1026,  3161,     0,  1027,     0,  1244,  1245,  1246,  1247,  1248,
    3345,     0,     0,     0,  3348,  3349,     0,  3353,  1028,  3356,
       0,     0,     0,     0,     0,  1249,  1250,  1251,  1252,  1253,
    1254,  1255,  1256,  1257,     0,   287,  1258,     0,     0,     0,
     287,     0,   287,     0,     0,   287,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3432,     0,  3433,
    3434,  3435,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1184,  3445,     0,     0,     0,  3450,     0,  3452,
       0,     0,     0,  1376,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,     0,   957,   958,   959,   960,   961,
     962,   963,     0,     0,     0,     0,     0,     0,  2912,     0,
    3486,  3487,     0,     0,     0,     0,     0,  2636,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1405,     0,
       0,     0,  1184,     0,     0,     0,     0,     0,     0,     0,
    2391,     0,  3507,  1227,  1227,     0,  3511,  3512,  3513,     0,
     287,     0,     0,     0,     0,     0,  3525,     0,  3528,     0,
    3531,     0,  1444,     0,     0,     0,  3535,     0,     0,     0,
       0,     0,     0,  1463,     0,     0,     0,     0,  3537,  3538,
       0,     0,     0,  3539,  3540,     0,     0,  1491,     0,     0,
       0,     0,     0,     0,  1501,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3429,  3566,     0,     0,     0,
       0,  3566,     0,     0,  1528,   964,  3574,  1531,     0,  1533,
    3578,     0,     0,     0,     0,     0,     0,     0,     0,  1540,
     965,     0,     0,  3599,     0,     0,  1244,  1245,  1246,  1247,
    1248,     0,     0,     0,     0,     0,     0,     0,     0,  3604,
       0,     0,     0,     0,     0,  3611,  1249,  1250,  1251,  1252,
    1253,  1254,  1255,  1256,  1257,     0,     0,  1258,  1601,     0,
    1604,     0,     0,     0,     0,     0,     0,  1388,  1388,     0,
    1388,  1388,  3632,  3633,     0,  3635,  3636,  3637,  3638,  3639,
       0,     0,     0,     0,  1388,  1388,  1388,     0,     0,   947,
     948,   949,   950,   951,   952,   953,   954,   955,   956,  2913,
     957,   958,   959,   960,   961,   962,   963,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3659,
    3660,  3661,     0,     0,     0,     0,     0,     0,     0,     0,
    3665,  3666,     0,     0,   287,     0,  3669,     0,     0,     0,
       0,     0,     0,     0,   287,     0,   287,     0,     0,  3680,
       0,     0,  3683,  3684,  3685,     0,     0,     0,     0,  3689,
    3690,     0,     0,     0,     0,     0,     0,     0,     0,  3698,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3701,     0,  3702,  3703,  3704,     0,  3618,
    1244,  1245,  1246,  1247,  1248,     0,  1388,  3708,     0,     0,
    3709,  3710,     0,     0,     0,     0,     0,     0,     0,     0,
    1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,  1257,     0,
       0,  1258,     0,  3719,  3720,   965,     0,  1244,  1245,  1246,
    1247,  1248,     0,     0,     0,     0,     0,     0,  1635,     0,
       0,     0,     0,     0,     0,     0,     0,  1249,  1250,  1251,
    1252,  1253,  1254,  1255,  1256,  1257,     0,     0,  1258,     0,
       0,     0,  1636,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2410,     0,     0,  3738,  3739,
       0,  1244,  1245,  1246,  1247,  1248,  3741,     0,     0,     0,
    3743,     0,     0,     0,     0,  3745,     0,  3026,  1840,  2411,
    3746,  1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,  1257,
       0,     0,  1258,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1859,  3749,  3750,
       0,     0,  1868,  1869,  1244,  1245,  1246,  1247,  1248,     0,
       0,     0,  1878,     0,     0,     0,   181,  1884,     0,     0,
       0,     0,     0,  2020,  1249,  1250,  1251,  1252,  1253,  1254,
    1255,  1256,  1257,     0,     0,  1258,  1911,     0,     0,     0,
       0,     0,  1917,  1918,     0,  1920,  1921,     0,  1923,  1924,
    1925,  1926,  1927,     0,     0,  1930,  1931,     0,  1933,     0,
       0,  1936,  1937,     0,     0,     0,     0,  1942,     0,  1944,
       0,     0,     0,     0,     0,     0,  2021,     0,     0,     0,
    1952,  1955,  1956,     0,     0,  1957,     0,     0,     0,     0,
    2391,     0,     0,     0,     0,   287,   175,     0,   176,   177,
     178,   179,   180,   181,     0,     0,     0,   182,   183,     0,
       0,     0,     0,     0,     0,   184,   185,  1648,     0,     0,
     186,  1976,     0,     0,     0,     0,     0,     0,     0,  1184,
     287,     0,   187,   188,  1982,     0,     0,   189,     0,   190,
     191,     0,     0,   192,     0,     0,     0,     0,     0,     0,
       0,     0,  1996,  1997,  1244,  1245,  1246,  1247,  1248,     0,
       0,     0,     0,     0,     0,     0,  1244,  1245,  1246,  1247,
    1248,     0,     0,     0,  1249,  1250,  1251,  1252,  1253,  1254,
    1255,  1256,  1257,     0,     0,  1258,  1249,  1250,  1251,  1252,
    1253,  1254,  1255,  1256,  1257,     0,     0,  1258,   193,   194,
    1200,  1201,  1202,  1203,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,     0,   212,     0,   213,     0,  2022,   218,   214,     0,
       0,     0,     0,   215,     0,   216,     0,     0,  2023,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   219,   220,
     221,   222,  1244,  1245,  1246,  1247,  1248,     0,     0,     0,
       0,     0,     0,     0,     0,   217,     0,  1244,  1245,  1246,
    1247,  1248,  1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,
    1257,     0,     0,  1258,     0,     0,     0,  1249,  1250,  1251,
    1252,  1253,  1254,  1255,  1256,  1257,     0,     0,  1258,     0,
       0,     0,     0,   223,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   218,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2409,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   219,   220,   221,   222,  2721,
    1244,  1245,  1246,  1247,  1248,     0,     0,     0,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,     0,     0,
    1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,  1257,     0,
       0,  1258,     0,     0,   234,   235,     0,     0,     0,     0,
       0,     0,  1244,  1245,  1246,  1247,  1248,     0,     0,     0,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,  1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,
    1257,     0,  2722,  1258,     0,   237,  2188,  2190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1832,     0,  2204,  2205,     0,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,     0,     0,   240,   241,   242,
     243,  1244,  1245,  1246,  1247,  1248,     0,     0,     0,     0,
       0,   234,   235,     0,     0,     0,     0,     0,     0,     0,
       0,  1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,  1257,
       0,     0,  1258,     0,  2241,     0,     0,     0,   236,     0,
       0,  2247,     0,     0,     0,  2251,  2252,  2253,     0,  2005,
       0,     0,   237,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   238,   239,   244,   245,     0,     0,  2325,
       0,     0,     0,     0,   240,   241,   242,   243,     0,     0,
       0,     0,     0,   246,   247,     0,  2373,  2374,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,     0,     0,     0,
       0,  1244,  1245,  1246,  1247,  1248,     0,     0,     0,  1243,
       0,     0,   244,   245,  1244,  1245,  1246,  1247,  1248,   285,
     286,  1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,  1257,
     246,   247,  1258,     0,  1249,  1250,  1251,  1252,  1253,  1254,
    1255,  1256,  1257,     0,     0,  1258,     0,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,     0,     0,     0,     0,  1244,  1245,
    1246,  1247,  1248,     0,     0,     0,     0,  2486,  2487,     0,
    1244,  1245,  1246,  1247,  1248,     0,   285,   286,  1249,  1250,
    1251,  1252,  1253,  1254,  1255,  1256,  1257,     0,     0,  1258,
    1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,  1257,     0,
       0,  1258,     0,     0,     0,     0,  2019,     0,   175,     0,
     176,   177,   178,   179,   180,   181,  2116,     0,  2535,   182,
     183,     0,     0,     0,     0,     0,     0,   184,   185,     0,
       0,     0,   186,  2548,     0,     0,  1244,  1245,  1246,  1247,
    1248,     0,     0,     0,   187,   188,     0,     0,     0,   189,
       0,   190,   191,     0,     0,   192,  1249,  1250,  1251,  1252,
    1253,  1254,  1255,  1256,  1257,     0,     0,  1258,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2569,     0,     0,  2024,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2590,  2591,  2593,  2594,     0,
     193,   194,  1200,  1201,  1202,  1203,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,     0,   212,     0,   213,  2617,     0,  2620,
     214,     0,     0,     0,  2627,   215,     0,   216,  1244,  1245,
    1246,  1247,  1248,     0,     0,     0,     0,     0,     0,     0,
    1244,  1245,  1246,  1247,  1248,     0,  2650,     0,  1249,  1250,
    1251,  1252,  1253,  1254,  1255,  1256,  1257,   217,     0,  1258,
    1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,  1257,     0,
       0,  1258,     0,     0,     0,     0,  2025,  1244,  1245,  1246,
    1247,  1248,     0,     0,     0,     0,     0,     0,  2030,  1244,
    1245,  1246,  1247,  1248,     0,     0,     0,  1249,  1250,  1251,
    1252,  1253,  1254,  1255,  1256,  1257,   218,     0,  1258,  1249,
    1250,  1251,  1252,  1253,  1254,  1255,  1256,  1257,     0,     0,
    1258,     0,     0,     0,     0,  2128,     0,   219,   220,   221,
     222,  1244,  1245,  1246,  1247,  1248,     0,  2479,     0,     0,
       0,     0,     0,  1244,  1245,  1246,  1247,  1248,     0,     0,
       0,  1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,  1257,
       0,     0,  1258,  1249,  1250,  1251,  1252,  1253,  1254,  1255,
    1256,  1257,     0,     0,  1258,     0,     0,     0,     0,  2723,
       0,     0,   223,     0,     0,     0,     0,     0,     0,     0,
       0,  2724,  1244,  1245,  1246,  1247,  1248,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,
    1257,     0,  2782,  1258,     0,     0,     0,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,     0,     0,     0,
    2725,  1244,  1245,  1246,  1247,  1248,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,     0,     0,     0,     0,
       0,  1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,  1257,
       0,  2822,  1258,     0,     0,  1244,  1245,  1246,  1247,  1248,
     236,     0,  2839,  2840,  2841,     0,     0,  2845,     0,  2726,
       0,     0,     0,     0,   237,  1249,  1250,  1251,  1252,  1253,
    1254,  1255,  1256,  1257,     0,     0,  1258,     0,     0,     0,
    1244,  1245,  1246,  1247,  1248,   238,   239,     0,     0,     0,
       0,     0,  2869,  2929,     0,     0,   240,   241,   242,   243,
    1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,  1257,     0,
       0,  1258,  1244,  1245,  1246,  1247,  1248,     0,     0,     0,
       0,  2889,     0,     0,     0,     0,     0,     0,  2930,     0,
       0,     0,  1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,
    1257,     0,     0,  1258,     0,  1244,  1245,  1246,  1247,  1248,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3106,     0,     0,     0,     0,  1249,  1250,  1251,  1252,  1253,
    1254,  1255,  1256,  1257,   244,   245,  1258,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2911,   246,   247,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,  2992,     0,     0,     0,
    1244,  1245,  1246,  1247,  1248,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   285,   286,
    1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,  1257,     0,
       0,  1258,     0,     0,  3009,  1244,  1245,  1246,  1247,  1248,
       0,     0,     0,     0,     0,     0,     0,     0,  3107,     0,
       0,     0,     0,     0,     0,  1249,  1250,  1251,  1252,  1253,
    1254,  1255,  1256,  1257,     0,     0,  1258,     0,     0,     0,
       0,     0,     0,     0,  3044,     0,     0,     0,     0,     0,
    3045,     0,     0,  3126,  1244,  1245,  1246,  1247,  1248,     0,
    3049,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1249,  1250,  1251,  1252,  1253,  1254,
    1255,  1256,  1257,     0,     0,  1258,     0,     0,     0,     0,
       0,     0,     0,  3067,     0,     0,     0,     0,     0,     0,
       0,     0,  3298,     0,     0,     0,   175,     0,   176,   177,
     178,   179,   180,   181,     0,     0,     0,   182,   183,     0,
       0,     0,     0,     0,     0,   184,   185,  2420,     0,     0,
     186,     0,     0,     0,  1244,  1245,  1246,  1247,  1248,     0,
       0,     0,   187,   188,     0,     0,     0,   189,     0,   190,
     191,     0,     0,   192,  1249,  1250,  1251,  1252,  1253,  1254,
    1255,  1256,  1257,     0,     0,  1258,  1244,  1245,  1246,  1247,
    1248,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3718,     0,     0,     0,  1249,  1250,  1251,  1252,
    1253,  1254,  1255,  1256,  1257,     0,  3143,  1258,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   193,   194,
       0,     0,  3082,     0,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,     0,   212,     0,   213,     0,  3170,     0,   214,     0,
       0,     0,  3174,   215,     0,   216,  1244,  1245,  1246,  1247,
    1248,     0,     0,     0,     0,     0,     0,     0,  1244,  1245,
    1246,  1247,  1248,     0,     0,     0,  1249,  1250,  1251,  1252,
    1253,  1254,  1255,  1256,  1257,   217,     0,  1258,  1249,  1250,
    1251,  1252,  1253,  1254,  1255,  1256,  1257,     0,     0,  1258,
       0,     0,  3083,     0,  1244,  1245,  1246,  1247,  1248,     0,
       0,     0,     0,     0,  3085,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1249,  1250,  1251,  1252,  1253,  1254,
    1255,  1256,  1257,     0,   218,  1258,     0,     0,  3266,     0,
       0,     0,     0,     0,     0,     0,     0,  3274,     0,     0,
    3248,     0,     0,     0,     0,   219,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3344,     0,  3346,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3358,     0,     0,  3361,  3362,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   237,     0,     0,     0,     0,     0,     0,     0,
       0,  3514,     0,     0,     0,     0,     0,  3524,     0,     0,
       0,     0,     0,   238,   239,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   240,   241,   242,   243,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3553,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3575,     0,     0,     0,  3580,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     246,   247,     0,     0,     0,     0,     0,  3626,     0,     0,
       0,     0,     0,     0,     0,     0,  3634,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3654,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   285,   286,  3662,  3664,
       0,     0,     0,     0,     0,  3667,  3668,     0,     0,  3670,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3688,     0,     0,     0,  3692,     0,  3694,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3699,  3700,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3706,     0,     0,
       0,     0,     0,     0,  3711,     0,  3712,  3713,  3714,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3727,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3732,     0,     0,   369,   370,   371,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3737,     0,     0,
       0,     0,     0,     0,     0,   372,   373,     0,     0,     0,
       0,     0,     0,  3744,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3747,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,     0,
       0,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,     0,     0,     0,     0,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,     0,     0,     0,     0,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,     0,     0,     0,     0,     0,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,   747,   748,   749,   750,   751,   752,   753,
     754,   755,   756,   757,   758,   759,   760,   761,   762,   763,
     764,   765,   766,     0,     0,   767,   768,   769,   770,   771,
     772,   773,   774,   775,   776,   777,   778,   779,   780,   781,
     782,   783,   784,   785,   786,   787,   788,   789,   790,   791,
     792,   793,   794,   795,   796,   797,   798,   799,   800,   801,
     802,   803,   804,   805,   806,   807,   808,   809,   810,   811,
     812,   813,   814,   815,   816,   817,   818,   819,   820,   821,
     822,   823,   824,   825,   826,   827,   828,   829,   830,   831,
     832,   833,   834,   835,   836,   837,   838,   839,   840,   841,
     842,   843,   844,   845,   846,   847,   848,   849,   850,     0,
     851,   852,   853,   854,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,   865,   866,   867,   868,   869,   870,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   880,
     881,   882,   883,   884,   885,   886,   887,   888,   889,   890,
     891,   892,   893,   894,   895,   896,   897,   898,   899,   900,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
     911,   912,   913,   914,   915,   916,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,   927,   928,   929,   930,
     931,   932,   933,   934,   935,   936,   937,   938,   939,   940,
     369,   370,   371,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   372,   373,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,  1016,   386,   387,     0,     0,     0,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
       0,     0,     0,     0,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,     0,     0,     0,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,     0,     0,
       0,     0,     0,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,   756,   757,
     758,   759,   760,   761,   762,   763,   764,   765,   766,     0,
       0,   767,   768,   769,   770,   771,   772,   773,   774,   775,
     776,   777,   778,   779,   780,   781,   782,   783,   784,   785,
     786,   787,   788,   789,   790,   791,   792,   793,   794,   795,
     796,   797,   798,   799,   800,   801,   802,   803,   804,   805,
     806,   807,   808,   809,   810,   811,   812,   813,   814,   815,
     816,   817,   818,   819,   820,   821,   822,   823,   824,   825,
     826,   827,   828,   829,   830,   831,   832,   833,   834,   835,
     836,   837,   838,   839,   840,   841,   842,   843,   844,   845,
     846,   847,   848,   849,   850,     0,   851,   852,   853,   854,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
     865,   866,   867,   868,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,   881,   882,   883,   884,
     885,   886,   887,   888,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,   899,   900,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,   911,   912,   913,   914,
     915,   916,   917,   918,   919,   920,   921,   922,   923,   924,
     925,   926,   927,   928,   929,   930,   931,   932,   933,   934,
     935,   936,   937,   938,   939,   940,   369,   370,   371,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   372,   373,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,     0,     0,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,     0,     0,     0,     0,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,  1355,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,     0,     0,
       0,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,     0,     0,     0,     0,     0,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,   756,   757,   758,   759,   760,   761,
     762,   763,   764,   765,   766,     0,     0,   767,   768,   769,
     770,   771,   772,   773,   774,   775,   776,   777,   778,   779,
     780,   781,   782,   783,   784,   785,   786,   787,   788,   789,
     790,   791,   792,   793,   794,   795,   796,   797,   798,   799,
     800,   801,   802,   803,   804,   805,   806,   807,   808,   809,
     810,   811,   812,   813,   814,   815,   816,   817,   818,   819,
     820,   821,   822,   823,   824,   825,   826,   827,   828,   829,
     830,   831,   832,   833,   834,   835,   836,   837,   838,   839,
     840,   841,   842,   843,   844,   845,   846,   847,   848,   849,
     850,     0,   851,   852,   853,   854,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,   865,   866,   867,   868,
     869,   870,   871,   872,   873,   874,   875,   876,   877,   878,
     879,   880,   881,   882,   883,   884,   885,   886,   887,   888,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
     899,   900,   901,   902,   903,   904,   905,   906,   907,   908,
     909,   910,   911,   912,   913,   914,   915,   916,   917,   918,
     919,   920,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,   931,   932,   933,   934,   935,   936,   937,   938,
     939,   940,   175,     0,   176,   177,   178,   179,   180,   181,
       0,     0,     0,   182,   183,     0,     0,     0,     0,     0,
       0,   184,   185,  2424,     0,     0,   186,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   187,   188,
       0,     0,     0,   189,     0,   190,   191,     0,     0,   192,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   193,   194,     0,     0,     0,     0,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,     0,   212,     0,
     213,     0,     0,     0,   214,     0,     0,     0,     0,   215,
       0,   216,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   217,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     218,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   219,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
       0,     0,     0,     0,     0,     0,   175,     0,   176,   177,
     178,   179,   180,   181,     0,     0,     0,   182,   183,     0,
       0,     0,     0,     0,   236,   184,   185,  2966,     0,     0,
     186,     0,     0,     0,     0,     0,     0,     0,   237,     0,
       0,     0,   187,   188,     0,     0,     0,   189,     0,   190,
     191,     0,     0,   192,     0,     0,     0,     0,     0,   238,
     239,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     240,   241,   242,   243,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   193,   194,
       0,     0,     0,     0,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,     0,   212,     0,   213,     0,     0,     0,   214,     0,
       0,     0,     0,   215,     0,   216,     0,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   217,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
       0,     0,     0,     0,   218,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   285,   286,     0,   219,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,     0,     0,     0,     0,     0,     0,
     175,     0,   176,   177,   178,   179,   180,   181,     0,     0,
       0,   182,   183,     0,     0,     0,     0,     0,   236,   184,
     185,  2971,     0,     0,   186,     0,     0,     0,     0,     0,
       0,     0,   237,     0,     0,     0,   187,   188,     0,     0,
       0,   189,     0,   190,   191,     0,     0,   192,     0,     0,
       0,     0,     0,   238,   239,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   240,   241,   242,   243,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   193,   194,     0,     0,     0,     0,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,     0,   212,     0,   213,     0,
       0,     0,   214,     0,     0,     0,     0,   215,     0,   216,
       0,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   217,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,     0,     0,     0,     0,   218,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   285,   286,     0,   219,
     220,   221,   222,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   223,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   234,   235,     0,     0,     0,
       0,     0,     0,     0,   175,     0,   176,   177,   178,   179,
     180,   181,     0,     0,     0,   182,   183,     0,     0,     0,
       0,     0,   236,   184,   185,  2973,     0,     0,   186,     0,
       0,     0,     0,     0,     0,     0,   237,     0,     0,     0,
     187,   188,     0,     0,     0,   189,     0,   190,   191,     0,
       0,   192,     0,     0,     0,     0,     0,   238,   239,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   240,   241,
     242,   243,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   193,   194,     0,     0,
       0,     0,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,     0,
     212,     0,   213,     0,     0,     0,   214,     0,     0,     0,
       0,   215,     0,   216,     0,     0,   244,   245,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   217,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,     0,     0,
       0,     0,   218,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     285,   286,     0,   219,   220,   221,   222,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   223,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   234,
     235,     0,     0,     0,     0,     0,     0,     0,   175,     0,
     176,   177,   178,   179,   180,   181,     0,     0,     0,   182,
     183,     0,     0,     0,     0,     0,   236,   184,   185,     0,
       0,     0,   186,     0,     0,     0,     0,     0,     0,     0,
     237,     0,     0,     0,   187,   188,     0,     0,     0,   189,
       0,   190,   191,     0,     0,   192,     0,     0,     0,     0,
       0,   238,   239,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   240,   241,   242,   243,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     193,   194,     0,     0,     0,     0,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,     0,   212,     0,   213,     0,     0,     0,
     214,     0,     0,     0,     0,   215,     0,   216,     0,     0,
     244,   245,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   217,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,     0,     0,     0,     0,   218,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   285,   286,     0,   219,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2376,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   237,     0,     0,     0,     0,     0,
     188,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,     0,     0,     0,     0,   238,   239,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   240,   241,   242,   243,
    2377,     0,     0,     0,  2379,  2380,  2381,  2382,  2383,  2384,
    2385,   947,   948,   949,   950,   951,   952,   953,   954,   955,
     956,     0,   957,   958,   959,   960,   961,   962,   963,  2386,
       0,     0,  2387,  2388,     0,     0,     0,     0,     0,     0,
       0,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2389,     0,  2390,     0,
       0,     0,     0,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   246,   247,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,     0,     0,     0,     0,
       0,   218,     0,     0,     0,     0,     0,   965,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   285,   286,
       0,     0,   219,   220,   221,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   223,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   234,   235,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2376,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   237,
       0,     0,     0,     0,     0,   188,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   240,   241,   242,   243,  2377,  2378,     0,     0,  2379,
    2380,  2381,  2382,  2383,  2384,  2385,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2386,     0,     0,  2387,  2388,     0,
       0,     0,     0,     0,     0,     0,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2389,     0,  2390,     0,     0,     0,     0,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   246,   247,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,     0,     0,     0,     0,     0,   218,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   285,   286,     0,     0,   219,   220,   221,
     222,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   234,   235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2376,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   237,     0,     0,     0,     0,     0,
     188,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   240,   241,   242,   243,
    2377,     0,     0,     0,  2379,  2380,  2381,  2382,  2383,  2384,
    2385,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2386,
       0,     0,  2387,  2388,     0,     0,     0,     0,     0,     0,
       0,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2389,     0,  2390,     0,
       0,     0,     0,     0,   244,   245,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   246,   247,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,     0,     0,     0,     0,
       0,   218,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   285,   286,
       0,     0,   219,   220,   221,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   223,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   234,   235,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2761,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   237,
       0,     0,     0,   188,     0,     0,     0,  2762,     0,     0,
       0,     0,     0,   192,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   240,   241,   242,   243,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   244,
     245,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   246,   247,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,     0,     0,     0,   218,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   285,   286,   219,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     223,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   234,   235,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3078,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   237,     0,     0,     0,   188,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   192,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   240,   241,   242,   243,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   244,   245,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     246,   247,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,     0,     0,     0,   218,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   285,   286,   219,   220,
     221,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   223,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   234,   235,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2042,  2043,     0,     0,     0,     0,     0,     0,     0,
       0,   236,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   237,     0,     0,     0,   188,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   240,   241,   242,
     243,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   244,   245,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   246,   247,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,     0,     0,     0,
     218,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   285,
     286,   219,   220,   221,   222,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   223,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   234,   235,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   237,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     240,   241,   242,   243,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   244,   245,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   246,   247,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
    1040,     0,  1041,     0,     0,     0,     0,  1042,  1043,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   285,   286,     0,     0,     0,     0,     0,     0,
       0,     0,  1044,     0,     0,     0,     0,     0,     0,     0,
       0,  1045,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1046,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1020,     0,  1021,     0,
       0,  1022,  1023,     0,  1047,  1048,     0,     0,     0,  1025,
    1049,     0,     0,     0,     0,     0,  1050,  1051,  1052,  1053,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1054,     0,     0,     0,  1055,     0,  1056,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1026,     0,     0,  1027,     0,
       0,     0,     0,     0,     0,     0,     0,  1057,     0,     0,
       0,  1058,     0,  1059,     0,     0,     0,  1060,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1061,     0,     0,     0,  1062,     0,     0,     0,  1063,
    1064,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1065,     0,     0,
       0,  1066,     0,  1067,     0,     0,     0,     0,     0,     0,
    1068,  1069,     0,  1070,  1071,     0,     0,  1072,     0,     0,
       0,     0,     0,  1073,  1074,     0,  1075,  1076,     0,     0,
    1077,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1078,  1079,     0,     0,     0,  1080,  1081,
       0,     0,     0,     0,     0,     0,     0,  1082,     0,     0,
       0,  1083,     0,     0,  1084,  1085,     0,  1086,     0,  1087,
       0,     0,  1088,  1089,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1090,
       0,  1091,     0,     0,     0,     0,     0,     0,     0,  1092
};

static const yytype_int16 yycheck[] =
{
       7,   180,   216,   216,    93,     3,   175,   990,   114,   320,
    1407,   108,  1069,  1070,   155,   112,    85,   153,   163,   164,
     180,    90,    91,  1116,  1107,   323,  1536,   163,   164,  1994,
    1994,  2819,  1136,  1470,  1208,  1209,  3209,   216,    24,  1289,
     145,  1681,    28,  1681,  1474,  1148,   151,    28,   153,    85,
     155,  1733,     3,     4,     5,     7,   216,  2682,   163,   164,
      22,   359,    24,  1289,  1238,  1239,   171,  2026,  2027,  2028,
    2029,    72,  1178,  1179,  1180,    94,   138,  1183,   140,  1185,
     142,  1331,   144,    85,   146,    92,   148,  3074,   150,  2332,
     152,    40,   343,    53,   156,   136,   158,    85,   160,  2467,
     162,    85,  2599,  2600,  2601,  1787,    19,   169,   170,    19,
     136,    24,    85,    24,    24,  3074,   128,    28,    94,    21,
      22,     6,    24,   159,    53,   161,   171,    24,   164,   165,
      19,  3074,   168,    19,    53,    24,   172,    19,    24,    24,
      92,    53,    24,    85,  3010,    58,   165,   167,    58,   142,
     171,   323,     6,   151,   171,    85,  2121,    51,    44,    45,
      46,    47,    56,    57,   209,   175,   171,  1748,   175,    58,
      28,    24,    58,    53,   186,    28,    58,    55,    85,   186,
      60,    61,   189,   140,  3218,    70,  1289,    70,   332,    93,
      74,    24,   228,   203,   204,   231,   147,    19,    54,    24,
     180,    85,    24,    28,   398,    85,   171,   244,    24,   216,
     979,   221,    28,   244,   165,    51,    56,    58,   240,   541,
      56,    57,   244,   329,   322,    84,     0,    54,     9,    10,
      11,    12,    39,    86,   186,     6,    58,   189,    19,     7,
       6,   192,   193,   323,   209,   257,     6,    54,   247,   346,
     347,   348,   349,   350,   351,    54,   353,   354,  1027,   271,
     272,   273,   274,   275,    51,   246,    85,   197,   348,    56,
      57,   168,    28,   467,   159,    53,  2994,    43,   229,   159,
     231,   161,   233,    19,   164,   165,   237,    53,    24,   611,
     278,    57,   172,   244,    60,    61,   277,   314,    51,   179,
     180,   181,   182,   183,   184,   289,   186,   166,    44,    45,
      46,    47,     6,   166,    19,   156,   135,   338,   283,    24,
    1403,    87,    58,    85,   346,   276,   233,   349,    84,   280,
      24,    24,    85,   338,   322,   507,   287,   288,  3056,    44,
      45,    46,    47,   342,   200,   325,    55,   359,   228,  2712,
     494,   231,    53,    58,  1994,  2718,  1994,   173,    24,   316,
    2857,  3149,   247,   400,   244,   463,   386,    21,    22,   400,
      24,  1428,   250,   200,   145,   146,    85,   230,   203,   145,
     238,   147,   148,   179,   180,   151,   335,   153,   285,    98,
     488,  1374,  1566,   159,  3428,   161,   162,   163,   220,   165,
    2768,   200,    37,   174,     6,  1579,   168,   337,  1805,   293,
    3128,   173,    24,   179,   180,   181,   182,   183,   184,   299,
     186,  3209,   302,    19,   278,   203,  3292,   205,    24,   200,
     475,   132,    51,    10,   135,     6,    55,  1947,   398,  3426,
    3427,    60,    61,   436,   197,   198,   199,   351,    44,    45,
      46,    47,  3077,   336,   475,  3080,   234,   433,   291,   292,
    3178,    83,    58,   241,   173,   231,    85,   352,  3427,   398,
     475,   237,   376,   166,   227,    57,  2719,   243,   244,   398,
     521,  2121,   386,  2121,  3427,    55,   398,   513,   430,  2070,
    2071,   479,  3210,   246,    45,   521,   336,   408,   449,   277,
     166,   279,    84,   548,   245,  1731,    83,  2472,   397,   144,
     404,   405,     6,   291,   416,  1621,   278,   357,   358,   521,
     192,   533,    98,   301,   526,    60,    61,  1584,   324,  1586,
     171,    57,   241,    84,   553,   157,    98,   521,   247,   424,
     159,   250,   161,   324,   325,   164,   165,   252,   326,   302,
      85,   513,   305,   172,   166,  1985,   557,    83,  1541,  1542,
     179,   180,   181,   182,   183,   184,   207,   186,   404,   405,
      85,   481,   280,   326,   459,   328,   329,  3074,    83,   332,
     553,   554,     6,  3756,   337,  3540,   559,    37,   624,   486,
     609,   610,   611,   612,   613,   614,   172,   291,   292,  3327,
     482,   483,   499,   500,   490,   615,   491,   520,    85,   228,
      85,   430,   231,   354,  1788,   166,  2298,   404,   405,   605,
     606,   607,   325,    58,   159,   326,   161,    19,  1731,   164,
     165,   250,    24,   168,   335,   388,   290,   172,   619,   620,
     621,    74,    75,   405,   179,   180,   181,   182,   183,   184,
     155,   186,    44,    45,    46,    47,   252,   561,   562,   563,
     564,   565,   973,   974,   975,   328,    58,   618,   230,   289,
     194,   622,  3400,    74,    75,   411,   454,    24,  3175,  2505,
     250,    28,   479,   198,  2510,   160,   566,   567,   485,   394,
      74,    75,   355,   228,   144,     6,   231,   338,   339,   461,
     519,  1951,  3165,   522,   523,    24,    24,    83,  2673,    28,
      28,   464,  1023,    24,   205,   291,   478,   336,   480,   295,
     197,   198,   484,   426,   427,  3680,   488,   489,  3683,   348,
      19,   206,  3095,  3096,   487,    24,   298,    19,    83,    83,
    3103,  3104,    24,   623,   624,   625,   207,   208,   241,   319,
     227,   504,   322,   214,   215,   216,   217,    10,   377,   177,
     379,   539,    44,    45,    46,    47,    19,   167,   245,    58,
    2729,    24,  2731,   176,    58,  2734,    58,  2736,  2737,   179,
     180,   157,   160,    36,    10,    38,   171,   205,   541,   542,
     543,   544,    19,   546,   285,   185,   549,    24,   394,   508,
     324,   510,   511,   236,   192,    58,   515,   516,   332,   518,
     239,   240,   157,   157,  2640,   524,   525,    44,    45,    46,
      47,    24,  2648,   316,   209,    28,   535,   304,   352,   232,
      85,    58,  2472,    59,  2472,   236,  1919,    10,  3301,  3302,
      57,    19,   608,  3306,  3307,   320,    24,   166,   166,   174,
     616,   617,   236,    14,    15,   166,   167,   168,   964,   298,
     337,  2501,   248,  2501,    36,    37,    83,   285,   179,   180,
     976,   433,    59,   435,   943,   437,   309,   370,   440,  2316,
      58,    55,    84,   989,   990,   378,    59,    24,    19,   986,
     145,   146,    29,    24,   312,   161,    83,   966,  2004,    45,
      10,  2007,    84,   156,   159,   158,   161,    10,   309,   164,
     165,    85,    84,    44,    45,    46,    47,   172,    19,   174,
      45,    58,    83,    24,  1021,   309,   995,    58,  1025,  1026,
    3427,   220,   240,   333,   553,    10,   244,    31,    84,   558,
      83,   560,    85,    44,    45,    46,    47,  2912,  2912,    59,
     425,   162,   487,   428,   429,   430,    59,    58,  1055,    84,
     967,   968,  1068,   166,    58,    60,    61,    19,  3756,  1182,
     431,    39,    24,   228,   240,   241,   231,    54,   244,   418,
     419,   420,   421,  1089,    59,   992,    39,   464,   465,   466,
      85,   165,    44,    45,    46,    47,    14,    15,    21,    22,
     255,    24,   394,    98,  1110,   540,    58,    19,    83,  1178,
    1179,  1180,   149,  2096,  1183,    92,  1185,  2100,  2101,    24,
     166,   332,   333,    28,   335,    38,    39,   144,  1134,    42,
     241,   242,   243,  2673,    24,  2673,  2676,    57,    28,    29,
     992,   166,    19,  1294,  1295,  1296,  1297,    24,  1299,  1300,
     316,  1302,  1303,  1159,  1305,  1306,    31,    84,    21,    22,
      23,    24,    85,    83,   159,    83,   161,    84,    58,   164,
     165,    85,    59,   168,   248,   249,   250,   172,    58,   253,
      57,    58,    57,   160,   179,   180,   181,   182,   183,   184,
      53,   186,    21,  2603,    58,    24,    83,    60,    61,    81,
      59,   328,   329,    85,   370,    21,    22,   352,    24,   176,
     177,   178,   378,    59,    21,    22,    19,    24,  2175,   401,
     402,    24,    59,   200,    83,  2299,    58,    21,    22,   206,
      24,   376,   377,   228,   201,   202,   231,    83,   205,    58,
      19,    44,    45,    46,    47,    24,    83,    19,   225,    21,
      24,   417,    24,  3112,    28,    58,    21,    22,  3117,   149,
    3119,    31,    58,  3122,  2268,    44,    45,    46,    47,    85,
      58,  1178,  1179,  1180,  1181,  1182,  1183,    84,  1185,    58,
      58,    84,    54,   197,   198,   199,    58,    57,   290,    59,
    2949,    85,   294,  2952,  1945,   450,   451,  1948,   329,  2958,
    2959,  2294,    58,  1210,  1211,  1212,  1213,  1214,  1215,  1216,
    1307,   452,   453,   227,  1221,  2612,    86,  1314,  2352,  2379,
    2380,  2355,  3490,   186,    58,  3493,  3494,  3495,   329,  1181,
     244,  1337,    19,  1240,  2394,    58,   250,  1244,  1245,  1246,
    1247,  1248,  1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,
    1257,    24,  3217,  3217,    58,    28,  1470,    85,  1210,  1211,
    1212,  1213,  1214,  1215,  1216,  1354,   357,   358,  1374,  1221,
     322,     6,  2912,    83,  2912,    85,    58,  1383,  2918,  1385,
    2918,  1560,  2922,    55,  2922,  1564,   145,   146,  1240,    24,
      55,  1470,  1244,  1245,  1246,  1247,  1248,  1249,  1250,  1251,
    1252,  1253,  1254,  1255,  1256,  1257,    83,   166,    85,   188,
    1470,    42,   171,   327,     6,   174,   330,   331,    28,    19,
     306,   307,     6,   337,    24,  1431,  1432,     6,  2502,   188,
       6,   317,  1339,   145,   146,   194,  1398,     6,    19,    21,
      22,   244,    24,    24,    44,    45,    46,    47,  2988,    83,
    2988,    85,    87,   296,   166,    36,  1363,    38,    58,   171,
      22,  1458,    24,    19,    20,    21,    22,    23,    24,   197,
     198,   199,    11,    12,    13,  1481,   188,    58,  1484,  3647,
    3648,     6,   194,    51,  3652,  3653,    24,  1339,    56,    57,
     368,   369,    31,    32,    33,  1574,   167,    21,    22,   227,
      24,   345,    58,    51,    28,   166,  2580,     9,    56,    57,
     145,  1363,    19,  2587,  1574,   169,   170,    19,    20,    21,
      22,    23,   250,    49,    50,   196,  1532,   162,   163,   524,
     525,    83,   527,    85,    58,  1541,  1542,   532,   284,   174,
     535,    28,  1655,  1656,  1658,    48,    49,    50,    19,    85,
    1556,     6,  1621,    24,  1560,   226,    58,     6,  1564,  1757,
    1758,  1759,  1760,     6,  1762,  1763,   166,   541,  1766,    19,
    1768,    21,  1770,  1771,    24,   156,    57,   158,    59,  1658,
     119,   120,  3441,    85,  3443,    81,    57,    58,  1892,    85,
    1894,    21,    22,  1599,    24,   362,  1602,   364,  1658,   327,
     136,   157,   330,   331,    31,    85,  1612,  2490,    58,   337,
      52,    53,    21,    22,  1765,    24,  1767,    24,    60,    61,
     291,    57,    19,   159,    57,   161,   297,    24,   164,   165,
     301,   245,    19,   169,   170,    57,   172,    24,   174,  2622,
     136,    21,    22,    85,    24,  1552,  1553,    44,    45,    46,
      47,   187,    84,  1732,   538,   326,   136,    24,    45,    54,
     196,    58,   160,    19,    20,    21,    22,    23,    24,   165,
     247,    58,  1732,   169,   170,    49,    50,  3217,   174,  3217,
      21,    22,   145,   146,    57,   165,    84,    84,    84,   169,
     170,   187,   228,    57,   174,   231,   529,   530,   531,  2656,
     196,  1553,    58,   166,   254,   255,    57,   187,   171,   447,
     448,   174,   441,   442,  1621,    84,   196,   159,    84,   161,
      70,    71,   164,   165,    84,   188,    84,  1634,   332,  1636,
     172,   145,   146,   328,   329,    57,    51,   179,   180,   181,
     182,   183,   184,    28,   186,    14,    15,   399,  1655,  1656,
      65,   192,   166,    21,    22,    70,    24,   171,   247,   295,
      28,    84,   298,   299,    19,    20,    21,    22,    23,    24,
      85,    19,   197,   198,   188,   446,    24,   407,   449,   323,
     209,   210,  1634,   454,  1636,   346,   228,   328,   329,   231,
     209,   210,  1789,   289,  3238,  3239,    44,    45,    46,    47,
     373,   157,   244,    58,   341,    85,  1803,  1848,   252,  1798,
      58,   346,    92,  1849,   252,  1812,  2600,  2601,   302,  1726,
      21,    22,    23,    24,  1821,   368,  1733,  1734,   161,   302,
     501,  1738,  1801,   302,   505,   506,    19,    20,    21,    22,
      23,  1748,   389,  1848,  1849,  1850,   413,  1853,  1854,   381,
     341,    57,  3717,  3717,   387,    57,    84,   299,    84,    57,
    1866,    84,    84,  3722,    84,   498,  1872,  1873,   539,  2752,
    2753,   192,   159,   188,  1880,    58,  1882,  1883,  2835,   159,
    1787,   161,   197,   198,   164,   165,   405,   160,   168,  1895,
    1896,    57,   172,   398,    84,   566,    84,  1804,  3757,    19,
      19,  1907,  1908,    57,  2102,  1950,  2104,  1913,  1914,    57,
    1916,  1818,   227,    24,    19,    20,    21,    22,    23,    24,
     229,   188,   174,  1929,  1893,   190,   191,   192,   193,  2140,
    2813,   246,    57,    57,    84,  2004,   247,    84,  2007,    84,
    2151,    84,  1978,  1979,  1980,  1950,  1951,  1953,   228,  2147,
     174,   231,  1958,    58,    57,   626,    57,    11,    12,    13,
     209,   210,   211,   212,   213,    19,  1818,    57,  2925,    84,
      24,   192,   393,  1978,  1979,  1980,   328,    31,    32,    33,
    2059,   174,   252,  1989,   121,   122,   123,   124,   303,   304,
     305,    57,    57,  1999,    19,    20,    21,    22,    23,  2059,
      84,   316,    84,   318,    58,   320,   252,    57,    18,  2088,
      19,    19,    39,   328,   329,    36,    42,   459,   460,   461,
     462,    37,   337,   209,   210,   211,   212,   213,  2088,    53,
      19,    83,    10,    58,    19,    19,    60,    61,     6,   207,
     208,  2998,     6,     6,     6,   487,   214,   215,   216,   217,
     492,     6,  1950,   333,   334,   497,    76,    77,    78,    79,
     340,    85,   342,    28,     6,   119,   120,   467,   468,   469,
     470,   471,   472,   473,   474,     6,     6,    60,    61,     6,
       6,     6,     6,     6,     6,    58,     6,  1994,  2085,     6,
       6,     6,     6,  2090,   145,     6,     6,  2004,    57,    57,
    2007,    83,    85,    83,    57,    57,   407,   399,   252,   192,
    2017,  2018,    24,  2020,  2021,  2022,  2023,   252,    57,  2026,
    2027,  2028,  2029,    57,    57,  2032,   177,   399,   192,  2118,
    2119,  2038,   379,   232,   252,   159,   252,   161,    57,   241,
     164,   165,    60,    61,   252,   252,    84,    40,   172,    70,
     201,    57,   203,  2122,   205,   179,   180,   181,   182,   183,
     184,    57,   186,    57,    85,  2017,  2018,    85,  2020,  2021,
    2022,  2023,    57,   252,   252,  2181,   159,  3717,   161,  3717,
    2032,   164,   165,   252,   160,  2154,  2038,  2193,    57,   172,
     406,    56,    56,  2199,    57,    57,   179,   180,   181,   182,
     183,   184,  2316,   186,   228,   399,   379,   231,   241,   232,
      19,   194,    19,    24,  2121,   192,   188,   241,   351,    57,
     195,   308,   246,    19,    54,    19,    83,    37,    83,    83,
     281,   282,   283,    19,   285,   286,   144,  2316,    59,    59,
      83,   159,    59,   161,    56,   228,   164,   165,   231,  2328,
     168,    56,  3135,  2332,   172,     6,  2316,    85,    24,     6,
       6,   179,   180,   181,   182,   183,   184,   174,   186,  2275,
     174,   254,  3155,  3156,  3157,     6,   197,   198,    59,    16,
      57,    51,    57,    57,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,  2300,   106,   107,   108,   109,   110,
     111,   112,    37,   286,  2301,    83,   227,    57,   136,   290,
     228,    84,    57,   231,   400,   252,    57,    57,    57,    57,
     192,    57,   379,   252,   245,   246,   247,    57,    57,   400,
      57,   159,    57,   161,    57,  2341,   164,   165,     8,  2345,
      57,   169,   170,   252,   172,    57,   174,    57,    57,    11,
      12,    13,  2259,    57,  2360,    57,    57,    57,    57,   187,
     384,    57,    57,    57,   285,    57,    57,    57,   196,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    57,    57,
      42,    57,    57,   304,   244,   379,    57,   189,   309,    57,
      53,  2298,    57,  2399,    53,   313,    19,    57,    19,    28,
     228,   322,    84,   231,   188,   326,    22,   328,   329,    37,
      37,    83,    19,    19,  2493,    24,   337,     6,     6,   340,
       6,     6,     6,    84,     6,    19,     6,     6,     6,     6,
     241,    57,    83,  2493,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,  3401,   106,   107,   108,   109,   110,
     111,   112,    19,   251,    59,    57,   251,    28,    57,   174,
     300,    44,    57,   341,    57,    57,   159,   388,   343,   252,
     298,    83,  2379,  2380,    85,  2382,    57,    51,   192,  2386,
    2387,    57,    57,  2489,  2490,    57,   240,  2394,    62,    63,
      64,    65,   252,    67,    68,    69,  2465,    57,    72,  2468,
      74,    75,  2409,    57,  2411,    57,    80,    81,    57,    57,
      57,    85,    57,  2519,    57,  2521,    57,    57,    57,   502,
     503,   504,    57,    57,    57,    57,    57,  2379,  2380,    57,
    2382,    57,  2538,    57,  2386,  2387,   174,   393,   310,   192,
     461,   399,  2394,   464,   465,   466,   336,    65,   375,   174,
      57,   472,   240,    23,    57,   447,   477,  2409,   447,  2411,
      57,   247,    57,   177,   492,  2472,   487,   140,    57,   536,
    3453,  3454,   493,  3456,  3457,    57,   332,   543,    55,   194,
     241,    57,    51,   543,    83,    39,    42,  3470,  3471,  3472,
      58,    58,    58,    62,    63,    64,    65,    55,    67,    68,
      69,    31,    57,    72,    42,    74,    75,    65,  2614,  2615,
      31,    80,    81,  2619,    39,    37,    85,    19,    83,    83,
    2626,    58,    22,  2629,     6,     6,   105,    85,    85,    57,
      19,    57,   252,   252,    84,   160,   344,    57,   188,   443,
    2719,    57,   439,    57,    57,   438,    57,    57,  2654,  2655,
      84,    57,  2658,  2713,  2660,   399,    57,    65,   310,    23,
    2666,   393,    65,  2570,   353,   399,  3623,  3624,   188,    84,
      19,    70,    84,    51,    19,    84,    74,    84,   136,     6,
      84,    37,   140,    66,    41,    73,    57,    57,    85,    10,
      38,  2680,    38,    85,    21,    22,    23,    24,    59,  3656,
      84,   336,    57,    83,  2710,    57,   328,   165,   434,  3592,
    2716,   169,   170,    57,    57,   281,   174,    84,    84,   329,
      57,    57,   252,   400,    58,    84,    53,   424,    59,   187,
     192,   400,    86,    60,    61,    59,    10,    84,   196,    57,
     310,   310,    84,    84,    84,    83,  2752,  2753,    59,    82,
    2819,  2757,    59,  2759,    59,    58,   207,    59,    59,    86,
      59,   252,   252,   154,    57,   333,  2673,   330,   330,  2676,
     537,   330,    53,    11,    12,    13,  2683,    57,  2685,    60,
      61,  2688,   240,  2780,   242,   115,   244,    57,    39,   247,
     117,    19,   250,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    38,    38,    42,    10,   329,  2813,  2814,    57,
    2779,    57,    57,    85,  2721,  2722,    57,    28,   145,   146,
      85,   160,  2729,    57,  2731,   160,    57,  2734,    57,  2736,
    2737,  2683,  2739,  2685,   521,   162,  2688,   323,   521,   166,
      10,    59,   169,   170,    83,    59,    59,   174,    65,    59,
      83,    59,    58,   247,   247,  2762,    59,   310,   316,   186,
     321,   308,    57,    57,   322,    57,    57,   330,   195,  2721,
    2722,   330,    57,    57,   432,    57,    57,   495,   330,   308,
      84,   330,   330,   389,  2890,   132,  2892,  2739,   323,    57,
      57,   218,   219,   220,   507,   222,   223,   224,   179,   180,
     181,   182,   183,   184,   469,   186,   467,   507,   512,   517,
    2762,   514,  2819,   336,   310,    57,   374,    53,   336,   536,
     252,    28,    57,    57,    60,    61,   384,   385,    57,   252,
     252,   308,   132,   391,    57,   252,   252,    57,  2944,  3053,
    3054,    57,    39,   389,  2950,   403,  2915,   545,    39,    85,
     547,    57,   410,   315,   550,   556,    57,   415,    57,   310,
     496,  3074,    57,    99,   422,   555,   252,    57,    57,   252,
     330,   528,   330,   188,  3053,  3054,   198,   198,   118,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     509,    59,    57,  3053,  3054,    83,   481,   481,   476,   537,
      83,    57,    60,    61,    59,  2912,  1732,  1732,  1732,  2493,
    2917,  2365,  2353,  3756,  3149,  3092,  2413,  2413,  2413,  3093,
    3091,  2413,  2716,   159,  2717,   161,  2718,    85,   164,   165,
    1207,  1968,  2472,   169,   170,  3041,   172,  1655,  2673,  3426,
     189,  1656,  3427,   179,   180,   181,   182,   183,   184,  1658,
     186,  1182,  2922,  2739,  2918,   151,  2148,  2047,  3292,  3166,
    2049,  3308,  2174,  2988,  2993,  2917,  1284,  3137,  2776,  2795,
    1906,  2836,  2979,  2872,  3050,  3546,  3366,  3383,  3559,  3386,
    3149,  3561,  3088,   985,  3387,  3091,  2662,  3093,  2670,  1593,
    1823,  1782,   228,  1334,    -1,   231,    -1,    -1,    -1,    -1,
      -1,   159,    -1,   161,    -1,   241,   164,   165,    -1,    -1,
     168,    -1,    -1,    -1,   172,    -1,  3023,    -1,    -1,    -1,
      -1,   179,   180,   181,   182,   183,   184,  2979,   186,  3135,
    3136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3145,
    3209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3155,
    3156,  3157,    -1,    -1,    -1,    -1,    -1,    -1,  3164,    -1,
      -1,    -1,    -1,  3169,    -1,    -1,    -1,  3173,    -1,    -1,
     228,  3023,    -1,   231,    -1,    11,    12,    13,    14,    15,
    3186,    -1,    -1,    -1,  3190,  3191,    -1,  3193,   246,  3195,
      -1,    -1,    -1,    -1,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,  3112,    42,    -1,    -1,    -1,
    3117,    -1,  3119,    -1,    -1,  3122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3233,    -1,  3235,
    3236,  3237,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3149,  3249,    -1,    -1,    -1,  3253,    -1,  3255,
      -1,    -1,    -1,   977,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,    -1,   106,   107,   108,   109,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,
    3286,  3287,    -1,    -1,    -1,    -1,    -1,  3366,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1022,    -1,
      -1,    -1,  3209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3217,    -1,  3318,  3426,  3427,    -1,  3322,  3323,  3324,    -1,
    3227,    -1,    -1,    -1,    -1,    -1,  3332,    -1,  3334,    -1,
    3336,    -1,  1056,    -1,    -1,    -1,  3342,    -1,    -1,    -1,
      -1,    -1,    -1,  1067,    -1,    -1,    -1,    -1,  3354,  3355,
      -1,    -1,    -1,  3359,  3360,    -1,    -1,  1081,    -1,    -1,
      -1,    -1,    -1,    -1,  1088,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3227,  3382,    -1,    -1,    -1,
      -1,  3387,    -1,    -1,  1108,   226,  3392,  1111,    -1,  1113,
    3396,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1123,
     241,    -1,    -1,  3409,    -1,    -1,    11,    12,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3416,
      -1,    -1,    -1,    -1,    -1,  3422,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    -1,    42,  1162,    -1,
    1164,    -1,    -1,    -1,    -1,    -1,    -1,  3453,  3454,    -1,
    3456,  3457,  3458,  3459,    -1,  3461,  3462,  3463,  3464,  3465,
      -1,    -1,    -1,    -1,  3470,  3471,  3472,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,    84,
     106,   107,   108,   109,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3515,
    3516,  3517,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3526,  3527,    -1,    -1,  3431,    -1,  3532,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3441,    -1,  3443,    -1,    -1,  3545,
      -1,    -1,  3548,  3549,  3550,    -1,    -1,    -1,    -1,  3555,
    3556,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3565,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3579,    -1,  3581,  3582,  3583,    -1,  3431,
      11,    12,    13,    14,    15,    -1,  3592,  3593,    -1,    -1,
    3596,  3597,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      -1,    42,    -1,  3619,  3620,   241,    -1,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    59,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    -1,    42,    -1,
      -1,    -1,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    59,    -1,    -1,  3674,  3675,
      -1,    11,    12,    13,    14,    15,  3682,    -1,    -1,    -1,
    3686,    -1,    -1,    -1,    -1,  3691,    -1,  3756,  1412,    83,
    3696,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1441,  3715,  3716,
      -1,    -1,  1446,  1447,    11,    12,    13,    14,    15,    -1,
      -1,    -1,  1456,    -1,    -1,    -1,    24,  1461,    -1,    -1,
      -1,    -1,    -1,    83,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    -1,    42,  1480,    -1,    -1,    -1,
      -1,    -1,  1486,  1487,    -1,  1489,  1490,    -1,  1492,  1493,
    1494,  1495,  1496,    -1,    -1,  1499,  1500,    -1,  1502,    -1,
      -1,  1505,  1506,    -1,    -1,    -1,    -1,  1511,    -1,  1513,
      -1,    -1,    -1,    -1,    -1,    -1,    83,    -1,    -1,    -1,
    1524,  1525,  1526,    -1,    -1,  1529,    -1,    -1,    -1,    -1,
    3717,    -1,    -1,    -1,    -1,  3722,    17,    -1,    19,    20,
      21,    22,    23,    24,    -1,    -1,    -1,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    36,    37,    38,    -1,    -1,
      41,  1565,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3756,
    3757,    -1,    53,    54,  1578,    -1,    -1,    58,    -1,    60,
      61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1596,  1597,    11,    12,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    11,    12,    13,    14,
      15,    -1,    -1,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    -1,    42,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    -1,    42,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,    -1,   145,    -1,    83,   235,   149,    -1,
      -1,    -1,    -1,   154,    -1,   156,    -1,    -1,    83,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   256,   257,
     258,   259,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   186,    -1,    11,    12,    13,
      14,    15,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    -1,    42,    -1,    -1,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    -1,    42,    -1,
      -1,    -1,    -1,   311,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    83,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   256,   257,   258,   259,    83,
      11,    12,    13,    14,    15,    -1,    -1,    -1,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      -1,    42,    -1,    -1,   382,   383,    -1,    -1,    -1,    -1,
      -1,    -1,    11,    12,    13,    14,    15,    -1,    -1,    -1,
     311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   409,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    83,    42,    -1,   423,  1860,  1861,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      59,    -1,  1876,  1877,    -1,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,    -1,   455,   456,   457,
     458,    11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,   382,   383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    -1,    42,    -1,  1928,    -1,    -1,    -1,   409,    -1,
      -1,  1935,    -1,    -1,    -1,  1939,  1940,  1941,    -1,    59,
      -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   444,   445,   533,   534,    -1,    -1,  1973,
      -1,    -1,    -1,    -1,   455,   456,   457,   458,    -1,    -1,
      -1,    -1,    -1,   551,   552,    -1,  1990,  1991,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,    -1,    -1,    -1,
      -1,    11,    12,    13,    14,    15,    -1,    -1,    -1,     6,
      -1,    -1,   533,   534,    11,    12,    13,    14,    15,   627,
     628,    31,    32,    33,    34,    35,    36,    37,    38,    39,
     551,   552,    42,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    -1,    42,    -1,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,    -1,    -1,    -1,    -1,    11,    12,
      13,    14,    15,    -1,    -1,    -1,    -1,  2141,  2142,    -1,
      11,    12,    13,    14,    15,    -1,   627,   628,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    -1,    42,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      -1,    42,    -1,    -1,    -1,    -1,    59,    -1,    17,    -1,
      19,    20,    21,    22,    23,    24,    57,    -1,  2192,    28,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    36,    37,    -1,
      -1,    -1,    41,  2207,    -1,    -1,    11,    12,    13,    14,
      15,    -1,    -1,    -1,    53,    54,    -1,    -1,    -1,    58,
      -1,    60,    61,    -1,    -1,    64,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2255,    -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2279,  2280,  2281,  2282,    -1,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,    -1,   145,  2311,    -1,  2313,
     149,    -1,    -1,    -1,  2318,   154,    -1,   156,    11,    12,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      11,    12,    13,    14,    15,    -1,  2340,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,   186,    -1,    42,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      -1,    42,    -1,    -1,    -1,    -1,    59,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    59,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,   235,    -1,    42,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    -1,    -1,
      42,    -1,    -1,    -1,    -1,    59,    -1,   256,   257,   258,
     259,    11,    12,    13,    14,    15,    -1,    59,    -1,    -1,
      -1,    -1,    -1,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    -1,    42,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    -1,    42,    -1,    -1,    -1,    -1,    59,
      -1,    -1,   311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    59,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,  2516,    42,    -1,    -1,    -1,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,    -1,
      59,    11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   382,   383,    -1,    -1,    -1,    -1,    -1,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,  2565,    42,    -1,    -1,    11,    12,    13,    14,    15,
     409,    -1,  2576,  2577,  2578,    -1,    -1,  2581,    -1,    59,
      -1,    -1,    -1,    -1,   423,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    -1,    42,    -1,    -1,    -1,
      11,    12,    13,    14,    15,   444,   445,    -1,    -1,    -1,
      -1,    -1,  2616,    59,    -1,    -1,   455,   456,   457,   458,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      -1,    42,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,  2645,    -1,    -1,    -1,    -1,    -1,    -1,    59,    -1,
      -1,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    -1,    42,    -1,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      59,    -1,    -1,    -1,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,   533,   534,    42,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    57,   551,   552,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,  2770,    -1,    -1,    -1,
      11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   627,   628,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      -1,    42,    -1,    -1,  2808,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    59,    -1,
      -1,    -1,    -1,    -1,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    -1,    42,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2848,    -1,    -1,    -1,    -1,    -1,
    2854,    -1,    -1,    59,    11,    12,    13,    14,    15,    -1,
    2864,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    -1,    42,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2897,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    59,    -1,    -1,    -1,    17,    -1,    19,    20,
      21,    22,    23,    24,    -1,    -1,    -1,    28,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    36,    37,    38,    -1,    -1,
      41,    -1,    -1,    -1,    11,    12,    13,    14,    15,    -1,
      -1,    -1,    53,    54,    -1,    -1,    -1,    58,    -1,    60,
      61,    -1,    -1,    64,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    -1,    42,    11,    12,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    59,    -1,    -1,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,  3000,    42,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,   120,
      -1,    -1,    57,    -1,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,    -1,   145,    -1,  3040,    -1,   149,    -1,
      -1,    -1,  3046,   154,    -1,   156,    11,    12,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    11,    12,
      13,    14,    15,    -1,    -1,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,   186,    -1,    42,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    -1,    42,
      -1,    -1,    57,    -1,    11,    12,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,   235,    42,    -1,    -1,  3132,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3141,    -1,    -1,
      57,    -1,    -1,    -1,    -1,   256,   257,   258,   259,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3185,    -1,  3187,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3199,    -1,    -1,  3202,  3203,
     311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   382,   383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   409,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3325,    -1,    -1,    -1,    -1,    -1,  3331,    -1,    -1,
      -1,    -1,    -1,   444,   445,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   455,   456,   457,   458,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3372,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3394,    -1,    -1,    -1,  3398,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   533,   534,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     551,   552,    -1,    -1,    -1,    -1,    -1,  3451,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3460,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3508,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   627,   628,  3522,  3523,
      -1,    -1,    -1,    -1,    -1,  3529,  3530,    -1,    -1,  3533,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3554,    -1,    -1,    -1,  3558,    -1,  3560,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3576,  3577,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3591,    -1,    -1,
      -1,    -1,    -1,    -1,  3598,    -1,  3600,  3601,  3602,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3629,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3655,    -1,    -1,     3,     4,     5,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3671,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,  3687,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3697,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    -1,
      -1,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    -1,    -1,    -1,    -1,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,    -1,    -1,    -1,    -1,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,    -1,    -1,    -1,    -1,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,    -1,    -1,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,    -1,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
       3,     4,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    -1,    -1,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    -1,    -1,    -1,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,    -1,    -1,    -1,    -1,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,    -1,
      -1,    -1,    -1,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,    -1,
      -1,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,    -1,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,     3,     4,     5,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    -1,    -1,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    -1,    -1,    -1,    -1,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,    -1,    -1,
      -1,    -1,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,    -1,    -1,    -1,    -1,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,    -1,    -1,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,    -1,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,    17,    -1,    19,    20,    21,    22,    23,    24,
      -1,    -1,    -1,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    36,    37,    38,    -1,    -1,    41,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    53,    54,
      -1,    -1,    -1,    58,    -1,    60,    61,    -1,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   119,   120,    -1,    -1,    -1,    -1,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,    -1,   143,    -1,
     145,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,
      -1,   156,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   186,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   256,   257,   258,   259,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   311,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   382,   383,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    17,    -1,    19,    20,
      21,    22,    23,    24,    -1,    -1,    -1,    28,    29,    -1,
      -1,    -1,    -1,    -1,   409,    36,    37,    38,    -1,    -1,
      41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,    -1,
      -1,    -1,    53,    54,    -1,    -1,    -1,    58,    -1,    60,
      61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,   444,
     445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     455,   456,   457,   458,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,   120,
      -1,    -1,    -1,    -1,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,    -1,   143,    -1,   145,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,   154,    -1,   156,    -1,    -1,   533,   534,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   551,   552,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   186,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
      -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   627,   628,    -1,   256,   257,   258,   259,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   382,   383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      17,    -1,    19,    20,    21,    22,    23,    24,    -1,    -1,
      -1,    28,    29,    -1,    -1,    -1,    -1,    -1,   409,    36,
      37,    38,    -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   423,    -1,    -1,    -1,    53,    54,    -1,    -1,
      -1,    58,    -1,    60,    61,    -1,    -1,    64,    -1,    -1,
      -1,    -1,    -1,   444,   445,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   455,   456,   457,   458,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   119,   120,    -1,    -1,    -1,    -1,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,    -1,   145,    -1,
      -1,    -1,   149,    -1,    -1,    -1,    -1,   154,    -1,   156,
      -1,    -1,   533,   534,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     551,   552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,    -1,    -1,    -1,    -1,   235,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   627,   628,    -1,   256,
     257,   258,   259,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   311,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   382,   383,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    17,    -1,    19,    20,    21,    22,
      23,    24,    -1,    -1,    -1,    28,    29,    -1,    -1,    -1,
      -1,    -1,   409,    36,    37,    38,    -1,    -1,    41,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   423,    -1,    -1,    -1,
      53,    54,    -1,    -1,    -1,    58,    -1,    60,    61,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    -1,   444,   445,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   455,   456,
     457,   458,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,   120,    -1,    -1,
      -1,    -1,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    -1,
     143,    -1,   145,    -1,    -1,    -1,   149,    -1,    -1,    -1,
      -1,   154,    -1,   156,    -1,    -1,   533,   534,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   551,   552,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   186,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,    -1,    -1,
      -1,    -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     627,   628,    -1,   256,   257,   258,   259,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   311,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   382,
     383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,    -1,
      19,    20,    21,    22,    23,    24,    -1,    -1,    -1,    28,
      29,    -1,    -1,    -1,    -1,    -1,   409,    36,    37,    -1,
      -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     423,    -1,    -1,    -1,    53,    54,    -1,    -1,    -1,    58,
      -1,    60,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,
      -1,   444,   445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   455,   456,   457,   458,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     119,   120,    -1,    -1,    -1,    -1,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,    -1,   143,    -1,   145,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,   154,    -1,   156,    -1,    -1,
     533,   534,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   551,   552,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   186,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,    -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   627,   628,    -1,   256,   257,   258,
     259,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   382,   383,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    -1,    -1,    -1,   444,   445,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   455,   456,   457,   458,
      84,    -1,    -1,    -1,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,    -1,   106,   107,   108,   109,   110,   111,   112,   113,
      -1,    -1,   116,   117,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   150,    -1,   152,    -1,
      -1,    -1,    -1,    -1,   533,   534,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   551,   552,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,    -1,    -1,    -1,    -1,
      -1,   235,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   627,   628,
      -1,    -1,   256,   257,   258,   259,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   311,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   382,   383,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   409,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,
      -1,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   455,   456,   457,   458,    84,    85,    -1,    -1,    88,
      89,    90,    91,    92,    93,    94,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   113,    -1,    -1,   116,   117,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   150,    -1,   152,    -1,    -1,    -1,    -1,    -1,   533,
     534,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   551,   552,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,    -1,    -1,    -1,    -1,    -1,   235,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   627,   628,    -1,    -1,   256,   257,   258,
     259,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   382,   383,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   423,    -1,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   455,   456,   457,   458,
      84,    -1,    -1,    -1,    88,    89,    90,    91,    92,    93,
      94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
      -1,    -1,   116,   117,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   150,    -1,   152,    -1,
      -1,    -1,    -1,    -1,   533,   534,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   551,   552,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,    -1,    -1,    -1,    -1,
      -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   627,   628,
      -1,    -1,   256,   257,   258,   259,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   311,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   382,   383,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   409,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,
      -1,    -1,    -1,    54,    -1,    -1,    -1,    58,    -1,    -1,
      -1,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   455,   456,   457,   458,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   533,
     534,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   551,   552,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,    -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   627,   628,   256,   257,   258,   259,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   382,   383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   409,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   423,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   455,   456,   457,   458,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   533,   534,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     551,   552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,    -1,    -1,    -1,   235,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   627,   628,   256,   257,
     258,   259,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   311,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   382,   383,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    26,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   423,    -1,    -1,    -1,    54,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   455,   456,   457,
     458,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   533,   534,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   551,   552,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,    -1,    -1,    -1,
     235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   627,
     628,   256,   257,   258,   259,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   311,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   382,   383,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   409,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     455,   456,   457,   458,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   533,   534,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   551,   552,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
      53,    -1,    55,    -1,    -1,    -1,    -1,    60,    61,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   627,   628,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   159,    -1,   161,    -1,
      -1,   164,   165,    -1,   167,   168,    -1,    -1,    -1,   172,
     173,    -1,    -1,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     193,    -1,    -1,    -1,   197,    -1,   199,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,    -1,
      -1,   244,    -1,   246,    -1,    -1,    -1,   250,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   284,    -1,    -1,    -1,   288,    -1,    -1,    -1,   292,
     293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,    -1,    -1,
      -1,   324,    -1,   326,    -1,    -1,    -1,    -1,    -1,    -1,
     333,   334,    -1,   336,   337,    -1,    -1,   340,    -1,    -1,
      -1,    -1,    -1,   346,   347,    -1,   349,   350,    -1,    -1,
     353,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   366,   367,    -1,    -1,    -1,   371,   372,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   380,    -1,    -1,
      -1,   384,    -1,    -1,   387,   388,    -1,   390,    -1,   392,
      -1,    -1,   395,   396,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   412,
      -1,   414,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   422
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     7,   634,   635,     3,     4,     5,   147,   165,   192,
     193,   229,   231,   233,   237,   244,   276,   280,   287,   288,
     449,   618,   622,   630,   631,   632,   633,   827,   828,   829,
     830,   832,   833,   834,   841,   843,   844,   845,   846,   847,
     848,   849,   850,   851,   852,   853,   854,   857,   858,   859,
     860,   861,   862,   863,   865,   866,   867,   892,   910,   911,
     912,   913,   936,   980,  1018,  1019,  1020,  1021,  1022,  1023,
    1024,  1025,  1080,  1081,  1113,  1132,  1133,  1134,  1135,  1136,
    1137,  1138,  1139,     0,     6,    43,    53,    57,    60,    61,
      87,   145,   147,   148,   151,   153,   159,   161,   162,   163,
     165,   179,   180,   181,   182,   183,   184,   186,   231,   237,
     243,   244,   608,   616,   617,   636,   637,   699,   701,   702,
     703,   704,   715,   767,   769,   770,   771,   772,   773,   774,
     779,   793,   794,   806,   807,   808,   871,   872,   893,   897,
     900,   903,   914,   917,   938,   946,   971,   974,   976,   979,
     983,   984,  1027,  1028,  1030,  1032,  1033,  1038,  1069,  1072,
    1082,  1083,  1099,  1100,  1114,  1117,  1126,  1127,  1131,  1142,
    1147,  1148,     6,     6,     6,    17,    19,    20,    21,    22,
      23,    24,    28,    29,    36,    37,    41,    53,    54,    58,
      60,    61,    64,   119,   120,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   143,   145,   149,   154,   156,   186,   235,   256,
     257,   258,   259,   311,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   382,   383,   409,   423,   444,   445,
     455,   456,   457,   458,   533,   534,   551,   552,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   627,   628,   641,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   694,   695,   696,   724,   742,   744,   745,   748,   749,
     750,   751,   755,   756,   870,    24,    28,   166,   840,   864,
     868,    24,   868,   868,    86,   230,   868,   868,     6,    28,
     238,   796,   192,    53,   203,   205,   234,   241,   277,   279,
     291,   301,   326,   454,   539,   145,   177,   201,   203,   205,
     281,   282,   283,   285,   286,    45,    84,   166,   855,   868,
     280,    28,   246,   277,   619,   620,   621,  1140,     6,     3,
       4,     5,    24,    25,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   640,   697,   289,   640,   640,   755,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   106,   107,   108,
     109,   110,   111,   112,   226,   241,   705,    58,    58,   160,
      24,    28,   667,   175,   203,   204,   221,   615,   185,   203,
     667,   162,   241,   242,   243,   795,  1116,   192,   667,   541,
     611,    19,    58,   638,   641,   174,   248,   775,   167,   196,
     226,   291,   297,   301,   326,   446,   449,   454,   501,   505,
     506,   539,   566,   626,   982,  1068,    54,   640,   780,    85,
     159,   161,   164,   165,   168,   172,   228,   231,   246,   771,
     781,   782,   788,   810,    84,   875,   780,   780,   780,   780,
      53,    55,    60,    61,    85,    94,   127,   167,   168,   173,
     179,   180,   181,   182,   193,   197,   199,   240,   244,   246,
     250,   284,   288,   292,   293,   320,   324,   326,   333,   334,
     336,   337,   340,   346,   347,   349,   350,   353,   366,   367,
     371,   372,   380,   384,   387,   388,   390,   392,   395,   396,
     412,   414,   422,   781,   883,   884,   949,   960,   968,   780,
     780,   780,    52,    53,    85,   244,   299,   459,   460,   461,
     462,   487,   492,   497,   772,   781,   986,   987,   988,   989,
     990,   780,    85,   194,   254,   286,   502,   503,   504,   781,
     788,  1029,    84,    85,   136,   169,   170,   174,   187,   196,
     298,   781,   783,   780,   780,   780,   780,    85,   241,   246,
     384,   781,   788,   883,  1104,  1106,    85,   244,   299,   302,
     566,   567,   623,   624,   625,   781,   788,   883,  1115,  1145,
    1146,   780,   780,    85,   168,   624,   781,  1149,    19,    36,
      38,    58,   156,   158,   641,   741,   743,   749,    39,   645,
      39,    21,    22,   646,   647,   144,    37,   144,   755,    19,
     121,   122,   123,   124,   730,   755,    84,    84,    58,    58,
      58,    58,    58,    58,    58,    58,    58,    19,    20,    22,
      23,    58,   157,   641,   646,   647,   655,   724,   725,   726,
     729,   731,   732,   733,   736,   738,   739,    19,    58,    58,
      58,    55,    55,     6,    11,    12,    13,    14,    15,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    42,    42,
      45,    84,   166,   811,     6,   811,    28,   668,   668,   868,
     868,     6,    45,    84,   166,   814,   638,   239,   240,     6,
       6,   296,    24,    28,   166,   869,     6,   278,     6,   835,
       6,   842,    24,   831,   177,   205,   285,   312,   345,   168,
     285,   486,   499,   500,   831,   205,   285,   166,   667,   667,
     667,   667,   667,   667,   284,   667,   667,    94,   165,   553,
     609,   610,   611,   612,   613,   614,  1124,  1125,    19,   856,
     668,   981,  1140,     6,  1140,     6,     6,   541,  1141,    31,
     640,   716,   700,   128,   186,   257,   271,   272,   273,   274,
     275,   359,   533,   698,   638,   105,   640,   641,   641,    19,
      21,    24,    54,    58,   768,    57,   811,   811,   811,   638,
      44,    45,    46,    47,   188,   638,   642,   814,    57,   796,
     605,   606,   607,   667,  1120,   245,  1128,  1129,   638,   639,
     639,   755,    57,   640,    84,   778,   452,   453,  1031,   538,
      24,    54,    84,   160,   667,   642,   811,   809,   173,   667,
     667,   814,   247,    57,    84,   786,    57,    57,   874,   876,
      84,    84,    84,    84,   240,   244,   245,   354,   332,    57,
      28,   357,   358,    53,   398,    53,   398,    53,   398,    53,
     398,   328,   355,   667,   642,   399,   192,   247,   240,   244,
     346,   349,    84,   957,   241,   316,   370,   378,   407,   323,
     346,   373,   244,   642,   947,    57,   638,    21,    22,    24,
     290,   643,   940,   416,   643,   939,   171,   209,   283,   944,
     341,   252,   323,   348,   252,   346,   302,   368,   369,   368,
     161,   642,   381,   302,   302,   389,   387,    56,   336,   357,
     358,   642,   397,   638,   413,   341,   161,   240,   241,   244,
     316,   370,   378,   417,    57,    57,    84,   888,    84,   966,
      57,    84,    84,    84,   498,   192,   405,   768,   642,   159,
     638,   642,   160,   642,   398,   985,   786,    57,    84,    84,
     642,    55,   250,    19,    54,   200,    19,   169,   170,    57,
      57,   638,   145,   146,   166,   171,   188,   194,   713,   790,
     188,   790,    24,   789,   188,   229,   174,    57,    57,    84,
      84,    84,    84,    22,    23,    24,   658,   662,   247,   174,
      57,    57,    57,    93,   351,   376,   386,   561,   562,   563,
     564,   565,  1101,  1102,    84,  1112,   192,   393,   638,   174,
     328,   642,   252,   166,   642,  1143,    57,    57,    84,    84,
    1150,  1154,   252,    57,    10,   743,   743,   743,   755,    21,
      22,   157,   736,   743,   743,    18,    19,    19,    39,    36,
      37,   144,    37,    19,    83,    59,    83,   691,   691,   789,
     789,   755,   755,   755,   755,   755,   755,   755,    38,   728,
     730,   755,    36,    37,    84,    10,    83,   157,    83,   157,
     789,   789,   746,   747,   755,    19,    19,   755,   755,   755,
     755,   755,   755,   755,   755,   755,   755,   755,   755,   755,
     755,   752,    53,    60,    61,   179,   180,   181,   182,   183,
     184,   186,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   839,   176,   177,   178,   201,   202,   205,
     812,   813,     6,     6,     6,     6,   176,   232,   815,   816,
       6,    28,    49,    50,    49,    50,   891,   869,     6,     6,
       6,    86,   117,   145,   162,   166,   169,   170,   174,   195,
     218,   219,   220,   222,   223,   224,   662,   713,   838,     6,
      24,    87,   145,   162,   163,   174,     6,   831,   831,   831,
     831,   937,   831,   831,  1026,   166,   831,   166,   831,     6,
     831,   831,   667,     6,     6,     6,     6,     6,     6,   667,
       6,     6,    83,    85,     6,     6,     6,   145,   174,   200,
     713,     6,  1141,   638,     6,   755,    58,   707,   708,   710,
     714,   705,    57,    83,    83,   803,   804,   755,    57,   639,
      57,    57,   407,  1118,    21,    22,    24,    28,    58,   669,
    1121,   638,  1119,    84,   166,  1123,   638,    57,    84,    48,
      49,    50,    59,   777,   780,    24,   768,   797,   800,   801,
     642,   785,   787,    81,    85,   873,   877,   878,   896,   902,
     916,   399,   192,   252,   252,   643,    57,   638,   638,   642,
      94,   433,    57,    57,   244,   400,   252,   394,   642,   642,
     399,   192,   252,   252,   958,    57,   379,   232,   642,   241,
     408,   667,   252,   252,   642,    57,    57,    84,   826,    57,
      24,   655,   661,    40,   644,    51,    56,    57,   404,   405,
     298,   418,   419,   420,   421,   945,   644,    51,    56,    57,
      57,   642,   638,   252,   252,   638,   252,   642,   642,   160,
     642,   642,    57,   642,   642,   642,   642,   642,   406,    56,
     642,   642,    57,   642,    57,    56,   642,   642,   399,   379,
     192,   232,   642,   241,   642,   887,   889,   890,   965,   967,
     973,   978,   642,   252,   394,   642,   642,   642,   188,   638,
     787,   991,   639,   639,    19,    19,   641,   711,   712,   755,
      45,   638,   792,   195,   792,   792,   642,   789,  1037,  1071,
    1084,  1105,   642,   789,    28,   643,   643,  1107,    53,   132,
     135,   326,   335,  1101,  1111,    57,   642,   642,   638,   308,
     638,   801,   802,   638,    19,    59,   743,   157,    54,    19,
     144,    37,   755,   755,   692,   693,    59,    83,    83,    59,
      83,    83,    83,    83,    59,    59,    83,    10,    83,    83,
      59,    19,    58,   726,   733,   738,    59,    59,    83,    59,
      56,    56,    26,    27,   750,   753,   870,    83,    85,    83,
      85,     6,   291,   292,   641,     6,   662,    21,    22,    23,
      24,   646,   647,   648,   649,   650,   836,   837,   711,   641,
     174,   174,   166,   641,    24,   641,   840,   668,   668,   668,
     668,     6,    24,   166,   167,   168,   179,   180,   332,   333,
     335,   668,   668,     6,    24,    70,   159,   247,   352,   424,
     459,   491,   831,   668,   831,   668,   668,   668,     6,     6,
    1125,   711,    28,   789,   667,     6,    57,    59,   706,    16,
     709,    84,   705,   640,   667,   641,   801,    57,    59,   667,
     755,    51,  1122,   667,  1124,    57,    57,  1130,    55,    85,
     165,   248,   249,   250,   253,   776,    37,   799,    83,    57,
      85,   165,   783,   784,   290,    57,    84,   881,    85,   295,
     298,   299,   781,   783,   894,    85,   168,   313,   781,   788,
     901,    85,    92,   168,   333,   334,   340,   342,   781,   915,
     400,   252,   638,   638,    57,    57,    57,    57,   642,    84,
     642,   941,   192,   252,   638,    57,    57,    57,   400,   252,
     638,   638,   956,   959,   642,   642,    57,   379,   638,    57,
     638,   638,    57,     8,   934,   948,   940,   640,   940,   638,
     638,    57,   939,   638,   638,    57,    57,   638,   638,    57,
     638,    57,    57,   768,    57,    57,    57,    57,    57,    57,
      57,   642,    57,   638,    57,    57,    57,   642,    57,    57,
     244,   642,   642,   642,    57,   379,    57,    81,    85,   289,
     784,   886,   787,    55,    65,    85,   140,   169,   170,   240,
     242,   244,   247,   250,   316,   322,   374,   384,   385,   391,
     403,   410,   415,   422,   784,   964,    85,    99,   169,   170,
     241,   771,   781,   883,   969,   970,   972,    85,   145,   174,
     255,   450,   451,   713,   781,   977,   638,   638,    85,   168,
     173,   278,   405,   461,   478,   480,   484,   488,   489,   992,
     999,  1002,   710,   189,   791,   642,    57,    85,    98,   168,
     524,   525,   527,   532,   535,   781,   788,  1034,    85,   168,
     487,   540,   781,   788,  1070,    51,    55,    85,   250,   336,
     348,   377,   379,   553,   558,   560,   781,   788,  1085,  1087,
      53,  1103,    57,    57,   644,    53,    19,  1108,  1109,    19,
     664,   665,   638,   642,   642,    28,    24,    84,    85,    88,
      89,    90,    91,    92,    93,    94,   113,   116,   117,   150,
     152,   641,   748,   750,   757,   760,   766,   870,  1110,   188,
    1144,   638,    84,  1153,   743,   743,    22,    37,    37,    83,
      59,    83,   689,   690,   755,   755,   755,   755,   755,   755,
      38,   728,   755,   728,    38,   728,   728,    83,   755,   755,
      19,    19,   754,   813,   816,    54,    21,    22,    24,   840,
     840,     6,     6,     6,     6,   667,    21,    22,    24,   646,
     647,   663,   667,     6,     6,    19,   768,   768,   768,   668,
       6,   668,     6,     6,     6,   705,   705,   717,   705,   718,
     721,   722,   723,   758,   760,   640,    57,    59,    83,    59,
      19,    85,    85,   233,   251,   811,   642,   642,   251,   254,
     255,    57,    28,   668,   798,   800,   811,    57,   640,   880,
     882,    44,   174,   300,    57,   904,   909,   159,    57,   919,
     920,   926,   920,   927,   643,   931,   341,   343,    57,   252,
     638,    83,    57,    57,    98,   230,   298,   433,   435,   437,
     440,   942,   943,    57,   394,   642,   638,    57,   252,   638,
      57,    57,    85,   198,   950,   955,    57,    57,   642,    57,
      57,    57,    85,   933,    57,    57,    57,    57,    57,    57,
      57,    57,    57,    57,    57,   192,    57,    57,    57,   642,
     290,   294,   641,    57,   240,   310,   393,   174,   174,   399,
     174,   192,   336,   240,    65,   638,   375,   174,   167,   386,
     642,   642,   411,   642,   642,   140,   316,    57,    23,   447,
     447,   447,   448,   786,    57,   711,    28,   789,   638,   667,
     140,    57,  1011,  1017,   322,   463,   488,   642,   994,   322,
     642,   993,   247,   661,   995,   996,   490,   642,    57,   492,
    1012,   190,   191,   192,   193,    24,   647,   660,  1048,  1053,
    1039,  1047,  1035,  1036,   660,   177,   536,    57,  1073,  1079,
     642,   638,    57,   638,   543,   543,   332,   194,  1086,    55,
    1086,   669,  1088,    72,   557,  1089,  1086,    57,   638,   665,
      83,    39,   719,   720,   746,   746,    58,   755,   755,   755,
     761,    58,    58,    31,    57,    31,   746,    42,    31,   638,
    1152,    39,    37,   755,   755,    51,    62,    63,    64,    65,
      67,    68,    69,    72,    74,    75,    80,    81,    85,   675,
     676,   677,   678,   679,   687,    85,   676,   677,   678,   679,
     688,    83,    83,    59,    59,    59,    59,    59,    83,    10,
      59,    83,    59,    83,    10,    59,    83,    83,    19,    58,
      22,     6,     6,   640,   105,   714,   640,    85,   722,    57,
      19,    57,   252,   252,   638,   639,   663,    74,    85,   293,
     879,    24,    58,   750,   870,   898,   899,   789,   895,   802,
     160,   167,   179,   180,   333,   918,   802,    84,   925,    40,
     335,   928,   642,   344,   638,    57,   638,   188,   443,   439,
     142,   436,   438,   441,   442,    83,    85,    57,    57,    57,
     638,    57,    84,    57,    57,    85,   197,   198,   199,   227,
     244,   250,   327,   330,   331,   337,   817,   818,   820,   821,
     822,   932,   642,    57,   291,   292,   641,    98,   172,   291,
     295,   885,   399,   194,   324,   332,   352,   328,   329,   642,
     642,   642,   244,   400,   789,   642,    65,   399,   310,   352,
     376,   377,   963,   789,   393,    65,    58,   156,   731,   975,
     975,   975,    23,   787,   353,   801,  1013,   638,   638,   642,
      84,   638,    84,   768,    84,   638,   638,    84,    84,  1052,
     802,    84,   643,  1054,  1059,    28,    84,  1060,  1065,   642,
      70,   802,   188,   638,   638,   643,   638,    74,   638,  1087,
    1090,  1095,   638,  1108,    19,    85,   718,    57,    57,   641,
     870,    57,   114,    84,    24,   705,   759,   765,   765,   755,
     755,    57,   764,   755,    85,   430,  1151,    19,    37,    59,
      59,    66,    70,    71,    73,    11,    12,    13,    31,    32,
      33,   119,   120,   638,   673,   680,   681,   682,    41,   683,
     684,   684,   686,    24,   646,   659,    57,   680,   683,   686,
     660,    57,   755,   755,    38,   728,    38,   728,    38,   728,
      10,    38,   728,    38,   728,    85,   747,    57,    59,    31,
      57,    59,   639,   639,   638,   638,    57,   755,    83,   714,
      84,   908,   642,   925,   924,   921,   640,   667,   336,   929,
     328,    57,    57,   434,   281,   943,    57,   953,   935,   642,
      84,   328,   329,   329,   639,   638,   171,   207,   338,   339,
     923,    28,    29,    58,   671,   672,   749,   756,    84,   825,
      57,    57,   400,   401,   402,   642,   961,   424,   643,   961,
     192,   252,   310,   400,   642,   642,   310,   731,   735,   642,
    1014,    84,  1016,  1004,  1004,   997,  1000,  1051,  1050,    84,
    1046,  1055,  1061,   638,    84,  1078,   638,   642,    84,  1091,
      84,    59,    59,   760,   740,   640,    86,   755,    24,   750,
     766,   870,    57,    57,   753,    57,   643,    57,    10,   638,
      14,    15,   674,    83,    15,    83,   674,   638,    76,    77,
      78,    79,   685,    83,   674,    82,    59,    59,    59,    59,
      59,    83,    10,    59,    59,    59,    83,    58,    59,    10,
      59,    59,    10,    59,    59,   755,    59,   899,   907,   905,
     921,    85,   199,   250,   327,   330,   331,   337,   817,   922,
     643,   333,   930,   642,    85,   160,   206,   320,   425,   428,
     429,   430,   951,   819,   820,   330,   330,   330,   209,   210,
     207,   755,    54,    92,   160,   200,   206,   225,   823,   252,
     642,   638,   154,   252,   642,    83,   157,  1012,  1015,    85,
     661,  1005,  1006,    85,    85,   278,   322,   479,   998,    85,
     245,   304,   337,   464,   465,   466,   817,  1001,    85,   135,
     430,   519,   522,   523,  1049,  1045,  1044,  1058,  1064,   537,
    1077,  1074,  1092,  1094,  1096,    57,    57,   115,     9,    85,
     725,   727,   729,   731,   732,   734,   737,   762,   765,   765,
      57,   638,   682,   673,   681,   684,   684,    39,   684,   684,
      19,    38,   728,    38,   728,   728,    10,   728,    57,    51,
      65,    70,    85,   188,   246,   303,   304,   305,   316,   318,
     320,   328,   329,   337,   817,   906,   642,   328,   329,   329,
     639,   638,   923,    57,   642,   954,   638,   207,   208,   214,
     215,   216,   217,   431,   824,   952,   160,   160,   671,    57,
      57,    85,    57,   639,   639,   639,   209,   210,    59,    28,
     666,    54,   200,   638,   666,   824,    54,   200,    85,   638,
     325,   426,   427,   962,   638,   731,    70,    85,   245,   246,
     247,   285,   304,   309,   322,   326,   328,   329,   337,   340,
     388,   461,   464,   465,   466,   472,   477,   487,   493,   817,
    1003,   479,   485,  1007,   642,   638,   642,    57,   638,   638,
     171,   338,   475,   638,   323,   220,   638,    57,   642,   521,
     521,   642,   642,    57,    55,    85,    98,   173,   241,   247,
     250,   508,   510,   511,   515,   516,   518,   524,   525,   535,
    1040,    85,   521,   526,  1056,    85,   289,   521,  1062,    29,
     670,   672,    51,    85,   199,   246,   302,   305,   326,   328,
     329,   332,   337,   388,   464,   487,   504,   541,   542,   543,
     544,   546,   549,   817,  1075,    85,   197,   337,  1093,    85,
     553,   554,   559,  1097,   760,   719,    10,    83,   155,   755,
      59,    83,   638,   638,   638,   638,   685,   685,    59,    59,
      59,    83,    59,    58,    59,   638,   310,   306,   307,   317,
     638,   247,   638,   330,   330,    65,    55,   250,   319,   322,
     321,   308,    74,    75,   236,   309,   805,   171,   314,    57,
     330,   330,   330,    57,   209,   210,   211,   212,   213,   209,
     210,   211,   212,   213,   432,    57,   638,   638,    57,   819,
      57,   666,   666,    57,    57,    57,   666,   666,   825,   467,
     468,   469,   470,   471,   472,   473,   474,   638,   247,   495,
      84,   638,   638,   638,   642,   308,    74,   309,   805,   171,
     338,   475,   469,   389,   642,   638,   323,   220,   638,   332,
     494,   638,   132,   467,    57,   638,    57,   638,   638,   638,
     638,   507,   513,  1053,   136,   521,   136,   513,   521,   514,
     323,   507,   507,   642,   512,   252,   517,   310,   336,  1041,
     336,  1042,   536,    57,  1057,   520,   638,  1066,  1054,    57,
    1063,  1060,  1066,    57,   638,   642,   247,   342,   638,   252,
     642,   308,    74,   309,   805,   643,   171,   209,   475,   548,
    1076,   389,   252,   132,   398,   467,   252,   252,   481,   638,
     545,   547,   550,    57,   667,   171,   209,    57,  1098,   556,
     555,   667,    57,   727,   734,   719,   763,    57,   755,    39,
      39,   728,   728,   179,   180,   324,   642,   639,   639,   310,
     639,   639,   638,   638,   642,   638,   638,   638,   638,   638,
     315,   639,   639,   639,    57,    57,   823,    57,    57,   823,
     823,   823,    57,    57,   642,   496,  1008,   482,   483,   638,
     638,   638,   642,   329,   642,   638,   638,   642,   642,   638,
     642,   528,  1067,  1067,   330,   252,   529,   530,   531,  1043,
     638,  1043,   252,   638,   638,   638,   330,   509,   642,   638,
     638,   188,   642,  1059,   642,  1065,    70,   336,   638,   642,
     642,   638,   638,   638,   638,   329,   642,   639,   638,   638,
     638,   642,   642,   642,   642,   198,   198,   118,    59,   638,
     638,    59,    83,   643,   643,   180,   325,   642,   823,   823,
     823,   823,   642,    85,   643,  1010,   481,   642,   638,   638,
    1067,   638,  1067,   638,   642,   638,   638,   642,   481,   667,
     667,   760,    57,   728,   476,  1009,   537,    83,    57,   670,
     728,    59
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   629,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   697,   697,   697,   697,   697,   697,   697,   697,
     697,   697,   698,   698,   698,   698,   698,   698,   698,   698,
     698,   698,   634,   634,   635,   635,   636,   636,   637,   638,
     638,   638,   639,   639,   639,   640,   640,   640,   641,   642,
     642,   642,   642,   642,   642,   643,   643,   643,   644,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   655,   656,   656,   657,   657,   658,   658,   658,   658,
     658,   658,   658,   659,   659,   660,   660,   661,   661,   662,
     662,   663,   663,   663,   663,   663,   664,   665,   665,   666,
     667,   667,   668,   668,   669,   669,   669,   669,   669,   670,
     670,   671,   671,   671,   672,   672,   672,   673,   673,   673,
     673,   673,   673,   673,   673,   674,   674,   675,   675,   675,
     675,   675,   675,   675,   675,   675,   675,   676,   677,   678,
     679,   679,   680,   680,   680,   680,   681,   681,   682,   682,
     683,   683,   683,   684,   684,   685,   685,   685,   685,   686,
     686,   686,   687,   687,   687,   687,   688,   688,   688,   688,
     688,   689,   689,   690,   690,   691,   692,   693,   694,   695,
     696,   696,   630,   631,   630,   632,   630,   633,   636,   700,
     699,   636,   701,   636,   702,   636,   703,   636,   704,   705,
     705,   705,   705,   705,   705,   705,   705,   705,   705,   705,
     705,   705,   705,   705,   705,   705,   705,   705,   706,   706,
     707,   707,   708,   708,   709,   709,   710,   711,   712,   711,
     713,   714,   636,   716,   717,   715,   718,   718,   720,   719,
     721,   721,   722,   723,   723,   724,   724,   725,   725,   725,
     725,   725,   726,   726,   727,   728,   729,   729,   729,   729,
     729,   729,   729,   729,   729,   729,   730,   730,   730,   730,
     731,   731,   731,   732,   732,   732,   732,   732,   732,   732,
     732,   733,   733,   733,   733,   733,   734,   734,   734,   734,
     734,   735,   735,   736,   736,   737,   737,   738,   738,   738,
     738,   739,   739,   740,   740,   740,   741,   741,   742,   743,
     743,   743,   743,   743,   743,   743,   743,   743,   744,   744,
     744,   744,   744,   744,   744,   744,   744,   744,   744,   744,
     745,   745,   745,   745,   746,   746,   746,   747,   748,   749,
     750,   750,   750,   750,   750,   750,   750,   750,   750,   750,
     750,   750,   750,   750,   752,   751,   753,   754,   753,   753,
     753,   755,   755,   755,   755,   755,   755,   755,   755,   755,
     755,   755,   755,   755,   755,   755,   755,   755,   755,   755,
     755,   755,   755,   755,   755,   755,   755,   755,   755,   755,
     755,   755,   755,   755,   755,   755,   755,   755,   756,   757,
     757,   757,   758,   758,   759,   759,   760,   760,   760,   761,
     762,   763,   760,   760,   760,   760,   760,   760,   760,   760,
     760,   760,   760,   760,   764,   760,   760,   760,   765,   766,
     766,   766,   636,   767,   767,   768,   768,   768,   768,   636,
     769,   636,   770,   771,   771,   771,   771,   771,   771,   771,
     771,   771,   771,   772,   772,   636,   773,   774,   775,   775,
     776,   776,   776,   776,   776,   776,   776,   777,   777,   778,
     778,   636,   779,   779,   780,   780,   780,   780,   781,   781,
     781,   781,   781,   781,   781,   781,   781,   782,   783,   783,
     783,   783,   783,   783,   783,   783,   783,   784,   784,   785,
     785,   786,   786,   787,   788,   789,   790,   790,   790,   790,
     791,   791,   791,   791,   791,   792,   792,   636,   793,   793,
     793,   793,   636,   794,   795,   795,   795,   795,   796,   796,
     796,   796,   796,   796,   796,   796,   797,   798,   798,   799,
     799,   800,   801,   801,   802,   803,   804,   805,   805,   806,
     807,   808,   808,   808,   808,   808,   809,   810,   811,   811,
     811,   812,   812,   813,   813,   813,   813,   813,   813,   814,
     814,   814,   815,   815,   816,   816,   817,   818,   818,   819,
     819,   820,   820,   821,   821,   822,   823,   823,   823,   823,
     823,   823,   823,   823,   823,   824,   824,   824,   824,   824,
     824,   824,   824,   824,   824,   824,   824,   824,   824,   825,
     826,   630,   827,   630,   828,   630,   829,   630,   830,   831,
     831,   630,   832,   630,   833,   630,   834,   835,   835,   835,
     835,   835,   835,   835,   835,   835,   835,   835,   835,   835,
     835,   835,   835,   835,   835,   836,   836,   836,   836,   836,
     836,   836,   836,   837,   837,   837,   837,   838,   838,   838,
     838,   839,   839,   839,   839,   839,   839,   839,   839,   839,
     839,   839,   839,   839,   839,   839,   839,   839,   839,   839,
     839,   839,   840,   630,   841,   842,   842,   842,   842,   842,
     842,   842,   630,   843,   630,   844,   630,   845,   630,   846,
     630,   847,   630,   848,   630,   849,   630,   850,   630,   851,
     630,   852,   630,   853,   630,   854,   855,   855,   855,   856,
     856,   630,   857,   630,   858,   630,   859,   630,   860,   630,
     861,   630,   862,   630,   863,   864,   864,   630,   865,   630,
     866,   630,   867,   868,   868,   868,   869,   869,   869,   870,
     870,   870,   870,   870,   636,   871,   872,   873,   874,   874,
     875,   875,   876,   877,   878,   879,   879,   880,   880,   881,
     881,   882,   883,   884,   885,   885,   885,   885,   886,   886,
     886,   886,   886,   886,   887,   887,   888,   888,   890,   889,
     891,   891,   891,   891,   630,   892,   806,   893,   894,   894,
     894,   894,   895,   894,   896,   896,   897,   898,   898,   899,
     899,   899,   899,   806,   914,   915,   915,   915,   915,   915,
     915,   915,   916,   916,   917,   918,   918,   918,   918,   919,
     919,   920,   921,   922,   922,   922,   922,   922,   922,   922,
     922,   923,   923,   923,   923,   923,   923,   924,   924,   925,
     925,   926,   927,   928,   928,   928,   929,   929,   930,   930,
     931,   932,   932,   932,   932,   932,   932,   932,   932,   932,
     933,   933,   934,   935,   826,   630,   936,   937,   937,   937,
     937,   937,   937,   937,   937,   937,   937,   806,   900,   901,
     901,   901,   901,   902,   902,   903,   904,   905,   906,   906,
     906,   906,   906,   906,   906,   906,   906,   906,   906,   906,
     906,   906,   906,   906,   906,   906,   906,   906,   906,   906,
     906,   906,   906,   906,   906,   906,   907,   907,   908,   908,
     909,   870,   630,   910,   630,   911,   630,   912,   630,   913,
     806,   938,   939,   939,   939,   940,   940,   940,   940,   940,
     941,   941,   942,   942,   943,   943,   943,   943,   943,   943,
     943,   943,   943,   944,   944,   944,   945,   945,   945,   945,
     945,   946,   946,   946,   946,   946,   946,   946,   946,   946,
     946,   946,   946,   946,   946,   946,   946,   946,   946,   946,
     946,   946,   946,   946,   946,   946,   946,   946,   946,   946,
     946,   946,   946,   946,   946,   946,   946,   946,   946,   946,
     946,   946,   946,   946,   946,   946,   946,   946,   946,   946,
     946,   946,   946,   946,   946,   946,   946,   946,   946,   946,
     946,   946,   946,   946,   946,   946,   946,   946,   946,   946,
     946,   946,   946,   946,   946,   946,   946,   946,   946,   946,
     946,   946,   947,   948,   946,   946,   946,   946,   946,   949,
     949,   949,   949,   949,   949,   949,   949,   949,   949,   949,
     949,   950,   951,   951,   951,   951,   951,   951,   951,   952,
     952,   953,   953,   954,   955,   956,   956,   958,   957,   959,
     960,   961,   961,   961,   962,   962,   962,   963,   963,   963,
     964,   964,   964,   964,   964,   964,   964,   964,   964,   964,
     964,   964,   964,   964,   964,   964,   964,   964,   964,   964,
     964,   964,   964,   964,   964,   964,   964,   964,   964,   964,
     965,   965,   966,   966,   967,   968,   870,   870,   870,   870,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     702,   755,   755,   806,   969,   970,   971,   972,   972,   972,
     972,   972,   972,   972,   972,   973,   973,   974,   975,   975,
     806,   976,   977,   977,   977,   977,   977,   977,   977,   977,
     978,   978,   979,   630,   980,   981,   981,   981,   981,   981,
     981,   806,   982,   982,   982,   983,   984,   984,   985,   985,
     986,   987,   988,   988,   988,   988,   988,   988,   988,   988,
     988,   988,   988,   988,   988,   988,   988,   989,   990,   991,
     991,   992,   992,   992,   992,   992,   992,   992,   992,   992,
     993,   992,   994,   992,   992,   992,   992,   995,   995,   996,
     997,   997,   998,   998,   998,   999,   999,  1000,  1000,  1001,
    1001,  1001,  1001,  1001,  1001,  1001,  1001,  1001,  1001,  1001,
    1002,  1003,  1003,  1003,  1003,  1003,  1003,  1003,  1003,  1003,
    1003,  1003,  1003,  1003,  1003,  1003,  1003,  1003,  1003,  1003,
    1003,  1003,  1003,  1003,  1003,  1003,  1003,  1003,  1003,  1003,
    1003,  1003,  1003,  1003,  1003,  1003,  1003,  1003,  1003,  1003,
    1004,  1004,  1005,  1006,  1007,  1007,  1007,  1008,  1008,  1009,
    1009,  1010,  1011,  1012,  1012,  1014,  1013,  1015,  1015,  1016,
    1016,  1017,   870,   870,   870,   870,   630,  1018,   630,  1019,
     630,  1020,   630,  1021,   630,  1022,   630,  1023,   630,  1024,
     630,  1025,  1026,  1026,  1026,  1026,  1026,  1026,  1026,  1026,
    1026,   806,  1027,  1028,  1028,  1028,  1029,  1029,  1029,  1029,
    1029,  1029,  1029,  1029,  1029,  1029,   806,  1031,  1030,  1032,
    1032,  1032,  1032,   806,  1033,  1034,  1034,  1034,  1034,  1035,
    1034,  1036,  1034,  1034,  1034,  1034,  1037,  1037,  1038,  1039,
    1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,
    1040,  1040,  1040,  1040,  1040,  1040,  1040,  1041,  1040,  1042,
    1040,  1040,  1040,  1040,  1040,  1043,  1043,  1043,  1044,  1045,
    1045,  1046,  1046,  1047,  1048,  1049,  1049,  1049,  1049,  1049,
    1050,  1051,  1051,  1052,  1052,  1053,  1054,  1055,  1056,  1056,
    1056,  1057,  1058,  1058,  1059,  1059,  1060,  1061,  1062,  1062,
    1062,  1063,  1064,  1064,  1065,  1065,  1066,  1066,  1067,  1067,
     870,   870,   806,  1068,  1068,  1069,  1070,  1070,  1070,  1070,
    1070,  1070,  1071,  1071,  1072,  1073,  1074,  1075,  1075,  1075,
    1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,
    1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,  1075,
    1075,  1075,  1075,  1075,  1076,  1076,  1076,  1076,  1077,  1077,
    1078,  1078,  1079,   870,   870,   630,  1080,   630,  1081,   806,
    1082,  1083,  1084,  1084,  1085,  1085,  1085,  1085,  1085,  1085,
    1085,  1085,  1085,  1085,  1085,  1085,  1085,  1086,  1086,  1087,
    1088,  1089,  1089,  1090,  1091,  1091,  1092,  1092,  1093,  1093,
    1093,  1094,  1095,  1096,  1096,  1097,  1097,  1097,  1098,   806,
    1099,  1100,  1100,  1100,  1100,  1100,  1100,  1100,  1101,  1101,
    1101,  1101,  1101,  1101,  1101,  1102,  1102,  1103,  1103,  1105,
    1104,  1106,  1106,  1106,  1106,  1106,  1106,  1106,  1106,  1106,
    1107,  1106,  1106,  1108,  1109,  1109,  1110,  1111,  1111,  1112,
    1112,   630,  1113,  1114,  1115,  1115,  1115,   870,   870,   870,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     870,   870,   870,   870,   870,   870,   870,   870,   870,   870,
     870,   870,   870,   870,   636,   636,  1116,  1117,  1118,  1118,
    1119,  1119,  1120,  1120,  1120,  1120,  1121,  1122,  1122,  1123,
    1123,  1124,  1124,  1125,  1125,  1125,  1125,  1125,  1125,  1125,
    1125,  1125,   636,  1126,  1126,   636,  1127,  1128,  1128,  1129,
    1130,  1130,   636,  1131,  1131,  1131,  1131,   630,  1132,   630,
    1133,   630,  1134,   630,  1135,   630,  1136,   630,  1137,   630,
    1138,   630,  1139,  1140,  1140,  1141,  1141,  1141,   806,  1142,
    1114,  1114,  1143,  1143,  1144,  1144,  1145,  1145,  1146,  1146,
    1146,  1146,  1146,  1146,  1146,   806,  1147,  1148,  1148,  1149,
    1149,  1149,  1150,  1151,  1152,  1152,  1153,  1153,  1154,   870,
     870
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     0,     2,     1,     1,     5,     1,
       3,     1,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     1,     1,     0,     2,
       2,     2,     3,     7,     2,     2,     5,     5,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     0,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     2,     2,     1,     1,     1,     1,     2,     1,
       1,     1,     2,     4,     1,     3,     1,     3,     1,     3,
       4,     6,     6,     0,     1,     1,     1,     1,     1,     2,
       4,     4,     2,     2,     2,     2,     2,     4,     2,     2,
       2,     0,     3,     0,     3,     0,     0,     0,     6,     6,
       1,     1,     1,     2,     1,     2,     1,     2,     1,     0,
       4,     1,     2,     1,     4,     1,     6,     1,     8,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     0,     4,
       2,     5,     0,     4,     0,     2,     1,     1,     0,     2,
       2,     4,     1,     0,     0,     7,     0,     1,     0,     2,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     1,     1,     5,     7,     5,     7,
       9,     7,     5,     7,     5,    11,     1,     1,     2,     1,
       7,     9,     7,     7,     9,     7,     9,     7,     9,     7,
      15,     1,     1,     1,     1,     3,     1,     1,     1,     1,
       3,     1,     3,     1,     3,     1,     3,     1,     2,     2,
       6,     1,     3,     0,     4,     3,     1,     3,     3,     2,
       4,     3,     4,     2,     2,     2,     2,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     3,     3,     1,
       5,     7,     7,     1,     0,     1,     3,     1,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     4,     1,     0,     5,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     4,     1,     1,
       1,     1,     1,     1,     3,     3,     5,     7,     6,     6,
       6,     6,     4,     8,     8,     4,     1,     1,     4,     1,
       1,     1,     5,     3,     2,     1,     3,     4,     6,     0,
       0,     0,     9,     4,     3,     4,     4,     5,     5,     3,
       3,     3,     2,     5,     0,     5,     7,     9,     0,     1,
       1,     1,     1,     4,     5,     1,     3,     1,     1,     1,
       3,     1,     5,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     0,     1,
       2,     2,     2,     4,     4,     3,     3,     0,     3,     0,
       3,     1,     1,     1,     0,     1,     2,     3,     0,     2,
       2,     2,     3,     2,     2,     2,     2,     1,     2,     2,
       2,     3,     3,     3,     2,     4,     3,     1,     2,     0,
       3,     0,     3,     0,     3,     1,     2,     1,     1,     1,
       0,     2,     2,     2,     2,     2,     1,     1,     3,     3,
       3,     3,     1,     4,     1,     1,     1,     1,     1,     3,
       2,     3,     3,     2,     3,     3,     0,     1,     2,     0,
       1,     3,     1,     3,     1,     0,     2,     2,     2,     2,
       2,     3,     3,     3,     3,     5,     0,     3,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     3,     1,     1,     1,     4,     1,     0,
       3,     5,     2,     1,     1,     2,     0,     5,     5,     5,
       5,     4,     4,     4,     4,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     1,     1,     1,     1,     0,
       3,     1,     3,     1,     3,     1,     4,     1,     5,     1,
       0,     1,     3,     1,     4,     1,     4,     0,     2,     3,
       3,     3,     3,     4,     4,     3,     2,     2,     2,     2,
       3,     3,     3,     2,     2,     1,     1,     1,     1,     2,
       2,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     4,     0,     2,     2,     2,     2,
       2,     2,     1,     4,     1,     4,     1,     5,     1,     4,
       1,     4,     1,     4,     1,     4,     1,     4,     1,     4,
       1,     5,     1,     3,     1,     4,     1,     1,     3,     0,
       1,     1,     4,     1,     4,     1,     4,     1,     3,     1,
       4,     1,     4,     1,     3,     2,     2,     1,     4,     1,
       2,     1,     3,     1,     1,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     1,     0,     3,
       0,     3,     0,     3,     3,     2,     2,     0,     3,     0,
       3,     0,     3,     1,     1,     1,     1,     1,     1,     2,
       3,     3,     3,     3,     0,     3,     0,     3,     0,     2,
       0,     2,     2,     2,     1,     5,     1,     2,     1,     1,
       3,     3,     0,     4,     0,     3,     5,     1,     3,     3,
       1,     1,     1,     1,     2,     1,     2,     2,     2,     2,
       3,     5,     0,     3,     5,     1,     1,     1,     1,     0,
       2,     0,     0,     2,     4,     4,     4,     2,     2,     2,
       1,     1,     1,     2,     2,     3,     3,     0,     3,     0,
       3,     4,     3,     0,     2,     2,     0,     2,     0,     2,
       4,     2,     4,     4,     4,     2,     2,     1,     2,     1,
       0,     3,     0,     0,     5,     1,     5,     0,     2,     3,
       3,     3,     2,     2,     2,     2,     2,     1,     2,     1,
       1,     2,     4,     0,     3,     5,     0,     0,     0,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     3,     2,
       3,     3,     4,     4,     4,     4,     4,     2,     2,     3,
       3,     3,     3,     3,     3,     1,     0,     3,     0,     3,
       4,     1,     1,     6,     1,     6,     1,     6,     1,     6,
       2,     2,     0,     3,     3,     0,     3,     3,     2,     2,
       1,     3,     1,     3,     1,     3,     2,     2,     2,     2,
       2,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     4,     6,     4,     6,     6,
       4,     6,     5,     5,     4,     5,     5,     6,     6,     3,
       3,     4,     5,     6,     5,     5,     5,     5,     5,     5,
       5,     5,     5,     5,     6,     6,     6,     5,     6,     6,
       6,     8,     6,     6,     6,     7,     5,     6,     5,     6,
       7,     5,     6,     5,     6,     8,     4,     4,     5,     4,
       4,     4,     5,     5,     6,     5,     5,     6,     5,     5,
       6,     7,     7,     7,     7,     7,     8,     8,     5,     5,
       4,     4,     0,     0,     6,     6,     5,     5,     5,     1,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     1,
       1,     1,     3,     4,     4,     3,     3,     2,     2,     1,
       2,     0,     2,     0,     5,     0,     3,     0,     4,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     4,     4,     4,     6,     2,     3,     2,     2,
       2,     2,     3,     5,     5,     6,     6,     4,     5,     3,
       3,     3,     4,     3,     3,     2,     2,     2,     3,     3,
       0,     3,     0,     3,     0,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       6,     4,     4,     1,     1,     3,     2,     1,     1,     1,
       2,     3,     3,     3,     3,     0,     3,     5,     1,     3,
       1,     2,     1,     2,     2,     2,     1,     2,     2,     4,
       0,     3,     5,     1,     4,     0,     3,     3,     3,     2,
       3,     2,     1,     2,     2,     2,     3,     3,     0,     1,
       2,     3,     1,     1,     2,     2,     3,     3,     3,     3,
       4,     2,     4,     3,     2,     3,     1,     2,     4,     0,
       3,     2,     1,     2,     3,     3,     3,     3,     2,     3,
       0,     5,     0,     5,     2,     2,     1,     4,     1,     1,
       0,     3,     2,     2,     2,     5,     2,     0,     3,     0,
       2,     2,     3,     2,     2,     3,     2,     2,     2,     1,
       3,     2,     2,     2,     2,     2,     2,     3,     2,     2,
       2,     2,     2,     2,     2,     2,     3,     3,     3,     3,
       2,     3,     2,     3,     3,     4,     4,     2,     2,     2,
       3,     3,     3,     2,     3,     3,     3,     4,     2,     1,
       0,     2,     3,     1,     0,     1,     2,     0,     2,     0,
       1,     3,     0,     0,     2,     0,     3,     0,     3,     0,
       3,     3,     1,     1,     1,     1,     1,     4,     1,     6,
       1,     6,     1,     6,     1,     7,     1,     6,     1,     7,
       1,     5,     0,     2,     3,     2,     3,     3,     2,     3,
       2,     2,     2,     3,     3,     3,     1,     3,     3,     2,
       3,     3,     2,     2,     2,     2,     2,     0,     4,     2,
       3,     3,     5,     1,     2,     1,     1,     2,     2,     0,
       3,     0,     3,     6,     2,     3,     0,     3,     5,     0,
       4,     4,     3,     4,     2,     3,     3,     3,     3,     4,
       4,     4,     3,     3,     4,     4,     2,     0,     3,     0,
       3,     6,     3,     3,     4,     1,     1,     1,     0,     0,
       3,     0,     3,     4,     1,     2,     2,     2,     4,     4,
       0,     0,     3,     0,     3,     3,     1,     0,     0,     2,
       2,     0,     0,     3,     1,     5,     1,     0,     0,     2,
       2,     0,     0,     3,     1,     5,     1,     2,     0,     2,
       1,     1,     1,     1,     2,     2,     1,     1,     2,     4,
       2,     2,     0,     3,     5,     0,     0,     2,     2,     2,
       2,     2,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     3,     3,     4,
       3,     2,     2,     1,     1,     1,     1,     1,     0,     3,
       0,     3,     4,     1,     1,     1,     6,     1,     6,     1,
       2,     5,     0,     3,     1,     1,     2,     3,     1,     3,
       2,     3,     3,     3,     4,     3,     3,     0,     1,     2,
       1,     4,     6,     0,     0,     3,     0,     3,     2,     2,
       2,     0,     0,     0,     3,     4,     4,     2,     0,     2,
       2,     3,     3,     3,     3,     5,     5,     4,     3,     2,
       3,     3,     3,     3,     3,     1,     2,     0,     2,     0,
       4,     2,     3,     5,     1,     2,     2,     2,     2,     2,
       0,     4,     2,     1,     1,     3,     1,     0,     2,     0,
       3,     1,     4,     3,     3,     2,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     0,     5,     2,     0,
       0,     2,     2,     2,     1,     3,     1,     0,     2,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     3,     1,     3,     5,     2,     0,
       0,     2,     1,     3,     4,     3,     3,     1,     4,     1,
       5,     1,     3,     1,     3,     1,     3,     1,     4,     1,
       2,     1,     3,     0,     1,     0,     1,     2,     2,     2,
       3,     3,     1,     1,     0,     2,     1,     1,     1,     1,
       2,     3,     2,     3,     4,     2,     2,     3,     3,     1,
       2,     3,     0,     2,     0,     3,     0,     3,     3,     1,
       1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        YY_LAC_DISCARD ("YYBACKUP");                              \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Given a state stack such that *YYBOTTOM is its bottom, such that
   *YYTOP is either its top or is YYTOP_EMPTY to indicate an empty
   stack, and such that *YYCAPACITY is the maximum number of elements it
   can hold without a reallocation, make sure there is enough room to
   store YYADD more elements.  If not, allocate a new stack using
   YYSTACK_ALLOC, copy the existing elements, and adjust *YYBOTTOM,
   *YYTOP, and *YYCAPACITY to reflect the new capacity and memory
   location.  If *YYBOTTOM != YYBOTTOM_NO_FREE, then free the old stack
   using YYSTACK_FREE.  Return 0 if successful or if no reallocation is
   required.  Return YYENOMEM if memory is exhausted.  */
static int
yy_lac_stack_realloc (YYPTRDIFF_T *yycapacity, YYPTRDIFF_T yyadd,
#if YYDEBUG
                      char const *yydebug_prefix,
                      char const *yydebug_suffix,
#endif
                      yy_state_t **yybottom,
                      yy_state_t *yybottom_no_free,
                      yy_state_t **yytop, yy_state_t *yytop_empty)
{
  YYPTRDIFF_T yysize_old =
    *yytop == yytop_empty ? 0 : *yytop - *yybottom + 1;
  YYPTRDIFF_T yysize_new = yysize_old + yyadd;
  if (*yycapacity < yysize_new)
    {
      YYPTRDIFF_T yyalloc = 2 * yysize_new;
      yy_state_t *yybottom_new;
      /* Use YYMAXDEPTH for maximum stack size given that the stack
         should never need to grow larger than the main state stack
         needs to grow without LAC.  */
      if (YYMAXDEPTH < yysize_new)
        {
          YYDPRINTF ((stderr, "%smax size exceeded%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (YYMAXDEPTH < yyalloc)
        yyalloc = YYMAXDEPTH;
      yybottom_new =
        YY_CAST (yy_state_t *,
                 YYSTACK_ALLOC (YY_CAST (YYSIZE_T,
                                         yyalloc * YYSIZEOF (*yybottom_new))));
      if (!yybottom_new)
        {
          YYDPRINTF ((stderr, "%srealloc failed%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (*yytop != yytop_empty)
        {
          YYCOPY (yybottom_new, *yybottom, yysize_old);
          *yytop = yybottom_new + (yysize_old - 1);
        }
      if (*yybottom != yybottom_no_free)
        YYSTACK_FREE (*yybottom);
      *yybottom = yybottom_new;
      *yycapacity = yyalloc;
    }
  return 0;
}

/* Establish the initial context for the current lookahead if no initial
   context is currently established.

   We define a context as a snapshot of the parser stacks.  We define
   the initial context for a lookahead as the context in which the
   parser initially examines that lookahead in order to select a
   syntactic action.  Thus, if the lookahead eventually proves
   syntactically unacceptable (possibly in a later context reached via a
   series of reductions), the initial context can be used to determine
   the exact set of tokens that would be syntactically acceptable in the
   lookahead's place.  Moreover, it is the context after which any
   further semantic actions would be erroneous because they would be
   determined by a syntactically unacceptable token.

   YY_LAC_ESTABLISH should be invoked when a reduction is about to be
   performed in an inconsistent state (which, for the purposes of LAC,
   includes consistent states that don't know they're consistent because
   their default reductions have been disabled).  Iff there is a
   lookahead token, it should also be invoked before reporting a syntax
   error.  This latter case is for the sake of the debugging output.

   For parse.lac=full, the implementation of YY_LAC_ESTABLISH is as
   follows.  If no initial context is currently established for the
   current lookahead, then check if that lookahead can eventually be
   shifted if syntactic actions continue from the current context.
   Report a syntax error if it cannot.  */
#define YY_LAC_ESTABLISH                                                \
do {                                                                    \
  if (!yy_lac_established)                                              \
    {                                                                   \
      YYDPRINTF ((stderr,                                               \
                  "LAC: initial context established for %s\n",          \
                  yysymbol_name (yytoken)));                            \
      yy_lac_established = 1;                                           \
      switch (yy_lac (yyesa, &yyes, &yyes_capacity, yyssp, yytoken))    \
        {                                                               \
        case YYENOMEM:                                                  \
          YYNOMEM;                                                      \
        case 1:                                                         \
          goto yyerrlab;                                                \
        }                                                               \
    }                                                                   \
} while (0)

/* Discard any previous initial lookahead context because of Event,
   which may be a lookahead change or an invalidation of the currently
   established initial context for the current lookahead.

   The most common example of a lookahead change is a shift.  An example
   of both cases is syntax error recovery.  That is, a syntax error
   occurs when the lookahead is syntactically erroneous for the
   currently established initial context, so error recovery manipulates
   the parser stacks to try to find a new initial context in which the
   current lookahead is syntactically acceptable.  If it fails to find
   such a context, it discards the lookahead.  */
#if YYDEBUG
# define YY_LAC_DISCARD(Event)                                           \
do {                                                                     \
  if (yy_lac_established)                                                \
    {                                                                    \
      YYDPRINTF ((stderr, "LAC: initial context discarded due to "       \
                  Event "\n"));                                          \
      yy_lac_established = 0;                                            \
    }                                                                    \
} while (0)
#else
# define YY_LAC_DISCARD(Event) yy_lac_established = 0
#endif

/* Given the stack whose top is *YYSSP, return 0 iff YYTOKEN can
   eventually (after perhaps some reductions) be shifted, return 1 if
   not, or return YYENOMEM if memory is exhausted.  As preconditions and
   postconditions: *YYES_CAPACITY is the allocated size of the array to
   which *YYES points, and either *YYES = YYESA or *YYES points to an
   array allocated with YYSTACK_ALLOC.  yy_lac may overwrite the
   contents of either array, alter *YYES and *YYES_CAPACITY, and free
   any old *YYES other than YYESA.  */
static int
yy_lac (yy_state_t *yyesa, yy_state_t **yyes,
        YYPTRDIFF_T *yyes_capacity, yy_state_t *yyssp, yysymbol_kind_t yytoken)
{
  yy_state_t *yyes_prev = yyssp;
  yy_state_t *yyesp = yyes_prev;
  /* Reduce until we encounter a shift and thereby accept the token.  */
  YYDPRINTF ((stderr, "LAC: checking lookahead %s:", yysymbol_name (yytoken)));
  if (yytoken == YYSYMBOL_YYUNDEF)
    {
      YYDPRINTF ((stderr, " Always Err\n"));
      return 1;
    }
  while (1)
    {
      int yyrule = yypact[+*yyesp];
      if (yypact_value_is_default (yyrule)
          || (yyrule += yytoken) < 0 || YYLAST < yyrule
          || yycheck[yyrule] != yytoken)
        {
          /* Use the default action.  */
          yyrule = yydefact[+*yyesp];
          if (yyrule == 0)
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
        }
      else
        {
          /* Use the action from yytable.  */
          yyrule = yytable[yyrule];
          if (yytable_value_is_error (yyrule))
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
          if (0 < yyrule)
            {
              YYDPRINTF ((stderr, " S%d\n", yyrule));
              return 0;
            }
          yyrule = -yyrule;
        }
      /* By now we know we have to simulate a reduce.  */
      YYDPRINTF ((stderr, " R%d", yyrule - 1));
      {
        /* Pop the corresponding number of values from the stack.  */
        YYPTRDIFF_T yylen = yyr2[yyrule];
        /* First pop from the LAC stack as many tokens as possible.  */
        if (yyesp != yyes_prev)
          {
            YYPTRDIFF_T yysize = yyesp - *yyes + 1;
            if (yylen < yysize)
              {
                yyesp -= yylen;
                yylen = 0;
              }
            else
              {
                yyesp = yyes_prev;
                yylen -= yysize;
              }
          }
        /* Only afterwards look at the main stack.  */
        if (yylen)
          yyesp = yyes_prev -= yylen;
      }
      /* Push the resulting state of the reduction.  */
      {
        yy_state_fast_t yystate;
        {
          const int yylhs = yyr1[yyrule] - YYNTOKENS;
          const int yyi = yypgoto[yylhs] + *yyesp;
          yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyesp
                     ? yytable[yyi]
                     : yydefgoto[yylhs]);
        }
        if (yyesp == yyes_prev)
          {
            yyesp = *yyes;
            YY_IGNORE_USELESS_CAST_BEGIN
            *yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        else
          {
            if (yy_lac_stack_realloc (yyes_capacity, 1,
#if YYDEBUG
                                      " (", ")",
#endif
                                      yyes, yyesa, &yyesp, yyes_prev))
              {
                YYDPRINTF ((stderr, "\n"));
                return YYENOMEM;
              }
            YY_IGNORE_USELESS_CAST_BEGIN
            *++yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        YYDPRINTF ((stderr, " G%d", yystate));
      }
    }
}

/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yy_state_t *yyesa;
  yy_state_t **yyes;
  YYPTRDIFF_T *yyes_capacity;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;

  int yyx;
  for (yyx = 0; yyx < YYNTOKENS; ++yyx)
    {
      yysymbol_kind_t yysym = YY_CAST (yysymbol_kind_t, yyx);
      if (yysym != YYSYMBOL_YYerror && yysym != YYSYMBOL_YYUNDEF)
        switch (yy_lac (yyctx->yyesa, yyctx->yyes, yyctx->yyes_capacity, yyctx->yyssp, yysym))
          {
          case YYENOMEM:
            return YYENOMEM;
          case 1:
            continue;
          default:
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = yysym;
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
       In the first two cases, it might appear that the current syntax
       error should have been detected in the previous state when yy_lac
       was invoked.  However, at that time, there might have been a
       different syntax error that discarded a different initial context
       during error recovery, leaving behind the current lookahead.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      YYDPRINTF ((stderr, "Constructing syntax error message\n"));
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else if (yyn == 0)
        YYDPRINTF ((stderr, "No expected tokens.\n"));
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.  In order to see if a particular token T is a
   valid looakhead, invoke yy_lac (YYESA, YYES, YYES_CAPACITY, YYSSP, T).

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store or if
   yy_lac returned YYENOMEM.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    yy_state_t yyesa[20];
    yy_state_t *yyes = yyesa;
    YYPTRDIFF_T yyes_capacity = 20 < YYMAXDEPTH ? 20 : YYMAXDEPTH;

  /* Whether LAC context is established.  A Boolean.  */
  int yy_lac_established = 0;
  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    {
      YY_LAC_ESTABLISH;
      goto yydefault;
    }
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      YY_LAC_ESTABLISH;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  YY_LAC_DISCARD ("shift");
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  {
    int yychar_backup = yychar;
    switch (yyn)
      {
  case 572: /* enum_type: NET_TYPE  */
#line 61 "conf/gen_parser.m4"
                    { (yyval.i) = T_ENUM_NET_TYPE; }
#line 8371 "obj/conf/cf-parse.tab.c"
    break;

  case 573: /* enum_type: RTS  */
#line 61 "conf/gen_parser.m4"
                                                    { (yyval.i) = T_ENUM_RTS; }
#line 8377 "obj/conf/cf-parse.tab.c"
    break;

  case 574: /* enum_type: SCOPE  */
#line 61 "conf/gen_parser.m4"
                                                                                 { (yyval.i) = T_ENUM_SCOPE; }
#line 8383 "obj/conf/cf-parse.tab.c"
    break;

  case 575: /* enum_type: RTD  */
#line 61 "conf/gen_parser.m4"
                                                                                                              { (yyval.i) = T_ENUM_RTD; }
#line 8389 "obj/conf/cf-parse.tab.c"
    break;

  case 576: /* enum_type: ROA  */
#line 61 "conf/gen_parser.m4"
                                                                                                                                         { (yyval.i) = T_ENUM_ROA; }
#line 8395 "obj/conf/cf-parse.tab.c"
    break;

  case 577: /* enum_type: ASPA  */
#line 61 "conf/gen_parser.m4"
                                                                                                                                                                     { (yyval.i) = T_ENUM_ASPA; }
#line 8401 "obj/conf/cf-parse.tab.c"
    break;

  case 578: /* enum_type: AF  */
#line 61 "conf/gen_parser.m4"
                                                                                                                                                                                                { (yyval.i) = T_ENUM_AF; }
#line 8407 "obj/conf/cf-parse.tab.c"
    break;

  case 579: /* enum_type: MPLS_POLICY  */
#line 61 "conf/gen_parser.m4"
                                                                                                                                                                                                                                  { (yyval.i) = T_ENUM_MPLS_POLICY; }
#line 8413 "obj/conf/cf-parse.tab.c"
    break;

  case 580: /* enum_type: BGP_ORIGIN  */
#line 61 "conf/gen_parser.m4"
                                                                                                                                                                                                                                                                            { (yyval.i) = T_ENUM_BGP_ORIGIN; }
#line 8419 "obj/conf/cf-parse.tab.c"
    break;

  case 581: /* enum_type: RA_PREFERENCE  */
#line 61 "conf/gen_parser.m4"
                                                                                                                                                                                                                                                                                                                        { (yyval.i) = T_ENUM_RA_PREFERENCE; }
#line 8425 "obj/conf/cf-parse.tab.c"
    break;

  case 582: /* config: conf_entries END  */
#line 149 "conf/confbase.Y"
                         { return 0; }
#line 8431 "obj/conf/cf-parse.tab.c"
    break;

  case 583: /* config: CLI_MARKER cli_cmd  */
#line 150 "conf/confbase.Y"
                      { return 0; }
#line 8437 "obj/conf/cf-parse.tab.c"
    break;

  case 588: /* definition: DEFINE symbol '=' term ';'  */
#line 166 "conf/confbase.Y"
                              {
     struct f_val *val = cfg_allocz(sizeof(struct f_val));
     *val = cf_eval((yyvsp[-1].x), T_VOID);
     cf_define_symbol(new_config, (yyvsp[-3].s), SYM_CONSTANT | val->type, val, val);
   }
#line 8447 "obj/conf/cf-parse.tab.c"
    break;

  case 590: /* expr: '(' term ')'  */
#line 175 "conf/confbase.Y"
                { (yyval.i) = cf_eval_int((yyvsp[-1].x)); }
#line 8453 "obj/conf/cf-parse.tab.c"
    break;

  case 591: /* expr: symbol_known  */
#line 176 "conf/confbase.Y"
                {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number constant expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 8461 "obj/conf/cf-parse.tab.c"
    break;

  case 592: /* expr_us: expr S  */
#line 182 "conf/confbase.Y"
           { (yyval.time) = (yyvsp[-1].i) S_; }
#line 8467 "obj/conf/cf-parse.tab.c"
    break;

  case 593: /* expr_us: expr MS  */
#line 183 "conf/confbase.Y"
           { (yyval.time) = (yyvsp[-1].i) MS_; }
#line 8473 "obj/conf/cf-parse.tab.c"
    break;

  case 594: /* expr_us: expr US  */
#line 184 "conf/confbase.Y"
           { (yyval.time) = (yyvsp[-1].i) US_; }
#line 8479 "obj/conf/cf-parse.tab.c"
    break;

  case 599: /* bool: expr  */
#line 193 "conf/confbase.Y"
        { (yyval.i) = !!(yyvsp[0].i); }
#line 8485 "obj/conf/cf-parse.tab.c"
    break;

  case 600: /* bool: ON  */
#line 194 "conf/confbase.Y"
      { (yyval.i) = 1; }
#line 8491 "obj/conf/cf-parse.tab.c"
    break;

  case 601: /* bool: YES  */
#line 195 "conf/confbase.Y"
       { (yyval.i) = 1; }
#line 8497 "obj/conf/cf-parse.tab.c"
    break;

  case 602: /* bool: OFF  */
#line 196 "conf/confbase.Y"
       { (yyval.i) = 0; }
#line 8503 "obj/conf/cf-parse.tab.c"
    break;

  case 603: /* bool: NO  */
#line 197 "conf/confbase.Y"
      { (yyval.i) = 0; }
#line 8509 "obj/conf/cf-parse.tab.c"
    break;

  case 604: /* bool: %empty  */
#line 198 "conf/confbase.Y"
                                 { (yyval.i) = 1; }
#line 8515 "obj/conf/cf-parse.tab.c"
    break;

  case 605: /* ipa: IP4  */
#line 205 "conf/confbase.Y"
       { (yyval.a) = ipa_from_ip4((yyvsp[0].ip4)); }
#line 8521 "obj/conf/cf-parse.tab.c"
    break;

  case 606: /* ipa: IP6  */
#line 206 "conf/confbase.Y"
       { (yyval.a) = ipa_from_ip6((yyvsp[0].ip6)); }
#line 8527 "obj/conf/cf-parse.tab.c"
    break;

  case 607: /* ipa: CF_SYM_KNOWN  */
#line 207 "conf/confbase.Y"
                {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address constant expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).ip;
   }
#line 8536 "obj/conf/cf-parse.tab.c"
    break;

  case 608: /* ipa_scope: %empty  */
#line 214 "conf/confbase.Y"
               { (yyval.iface) = NULL; }
#line 8542 "obj/conf/cf-parse.tab.c"
    break;

  case 609: /* ipa_scope: '%' symbol  */
#line 215 "conf/confbase.Y"
              { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 8548 "obj/conf/cf-parse.tab.c"
    break;

  case 610: /* pxlen4: '/' NUM  */
#line 222 "conf/confbase.Y"
           {
     if ((yyvsp[0].i) > IP4_MAX_PREFIX_LENGTH) cf_error("Invalid prefix length %u", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 8557 "obj/conf/cf-parse.tab.c"
    break;

  case 611: /* net_ip4_: IP4 pxlen4  */
#line 229 "conf/confbase.Y"
{
  net_fill_ip4(&((yyval.net)), (yyvsp[-1].ip4), (yyvsp[0].i));

  net_addr_ip4 *n = (void *) &((yyval.net));
  if (!net_validate_ip4(n))
    cf_error("Invalid IPv4 prefix %I4/%d, maybe you wanted %I4/%d",
	     n->prefix, n->pxlen, ip4_and(n->prefix, ip4_mkmask(n->pxlen)), n->pxlen);
}
#line 8570 "obj/conf/cf-parse.tab.c"
    break;

  case 612: /* net_ip6_: IP6 '/' NUM  */
#line 239 "conf/confbase.Y"
{
  if ((yyvsp[0].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[0].i));

  net_fill_ip6(&((yyval.net)), (yyvsp[-2].ip6), (yyvsp[0].i));

  net_addr_ip6 *n = (void *) &((yyval.net));
  if (!net_validate_ip6(n))
    cf_error("Invalid IPv6 prefix %I6/%d, maybe you wanted %I6/%d",
	     n->prefix, n->pxlen, ip6_and(n->prefix, ip6_mkmask(n->pxlen)), n->pxlen);
}
#line 8586 "obj/conf/cf-parse.tab.c"
    break;

  case 613: /* net_ip6_sadr_: IP6 '/' NUM FROM IP6 '/' NUM  */
#line 252 "conf/confbase.Y"
{
  if ((yyvsp[-4].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[-4].i));

  if ((yyvsp[0].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[0].i));

  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_ip6_sadr));
  net_fill_ip6_sadr((yyval.net_ptr), (yyvsp[-6].ip6), (yyvsp[-4].i), (yyvsp[-2].ip6), (yyvsp[0].i));

  net_addr_ip6_sadr *n = (void *) (yyval.net_ptr);
  if (!net_validate_ip6_sadr(n))
    cf_error("Invalid SADR IPv6 prefix %I6/%d from %I6/%d, maybe you wanted %I6/%d from %I6/%d",
	     n->dst_prefix, n->dst_pxlen, n->src_prefix, n->src_pxlen,
	     ip6_and(n->dst_prefix, ip6_mkmask(n->dst_pxlen)), n->dst_pxlen,
	     ip6_and(n->src_prefix, ip6_mkmask(n->src_pxlen)), n->src_pxlen);
}
#line 8608 "obj/conf/cf-parse.tab.c"
    break;

  case 614: /* net_vpn4_: VPN_RD net_ip4_  */
#line 271 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn4));
  net_fill_vpn4((yyval.net_ptr), net4_prefix(&(yyvsp[0].net)), net4_pxlen(&(yyvsp[0].net)), (yyvsp[-1].rd));
}
#line 8617 "obj/conf/cf-parse.tab.c"
    break;

  case 615: /* net_vpn6_: VPN_RD net_ip6_  */
#line 277 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn6));
  net_fill_vpn6((yyval.net_ptr), net6_prefix(&(yyvsp[0].net)), net6_pxlen(&(yyvsp[0].net)), (yyvsp[-1].rd));
}
#line 8626 "obj/conf/cf-parse.tab.c"
    break;

  case 616: /* net_roa4_: net_ip4_ MAX NUM AS NUM  */
#line 283 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_roa4));
  net_fill_roa4((yyval.net_ptr), net4_prefix(&(yyvsp[-4].net)), net4_pxlen(&(yyvsp[-4].net)), (yyvsp[-2].i), (yyvsp[0].i));
  if ((yyvsp[-2].i) < net4_pxlen(&(yyvsp[-4].net)) || (yyvsp[-2].i) > IP4_MAX_PREFIX_LENGTH)
    cf_error("Invalid max prefix length %u", (yyvsp[-2].i));
}
#line 8637 "obj/conf/cf-parse.tab.c"
    break;

  case 617: /* net_roa6_: net_ip6_ MAX NUM AS NUM  */
#line 291 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_roa6));
  net_fill_roa6((yyval.net_ptr), net6_prefix(&(yyvsp[-4].net)), net6_pxlen(&(yyvsp[-4].net)), (yyvsp[-2].i), (yyvsp[0].i));
  if ((yyvsp[-2].i) < net6_pxlen(&(yyvsp[-4].net)) || (yyvsp[-2].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid max prefix length %u", (yyvsp[-2].i));
}
#line 8648 "obj/conf/cf-parse.tab.c"
    break;

  case 618: /* net_mpls_: MPLS NUM  */
#line 299 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_mpls));
  net_fill_mpls((yyval.net_ptr), (yyvsp[0].i));
}
#line 8657 "obj/conf/cf-parse.tab.c"
    break;

  case 619: /* net_aspa_: ASPA NUM  */
#line 305 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_aspa));
  net_fill_aspa((yyval.net_ptr), (yyvsp[0].i));
}
#line 8666 "obj/conf/cf-parse.tab.c"
    break;

  case 626: /* net_: net_ip_  */
#line 315 "conf/confbase.Y"
           { (yyval.net_ptr) = cfg_alloc((yyvsp[0].net).length); net_copy((yyval.net_ptr), &((yyvsp[0].net))); }
#line 8672 "obj/conf/cf-parse.tab.c"
    break;

  case 634: /* net_ip4: CF_SYM_KNOWN  */
#line 329 "conf/confbase.Y"
                {
     if (((yyvsp[0].s)->class != (SYM_CONSTANT | T_NET)) || (SYM_VAL((yyvsp[0].s)).net->type != NET_IP4))
       cf_error("IPv4 network constant expected");
     (yyval.net) = * SYM_VAL((yyvsp[0].s)).net;
   }
#line 8682 "obj/conf/cf-parse.tab.c"
    break;

  case 636: /* net_ip6: CF_SYM_KNOWN  */
#line 338 "conf/confbase.Y"
                {
     if (((yyvsp[0].s)->class != (SYM_CONSTANT | T_NET)) || (SYM_VAL((yyvsp[0].s)).net->type != NET_IP6))
       cf_error("IPv6 network constant expected");
     (yyval.net) = * SYM_VAL((yyvsp[0].s)).net;
   }
#line 8692 "obj/conf/cf-parse.tab.c"
    break;

  case 638: /* net_ip: CF_SYM_KNOWN  */
#line 347 "conf/confbase.Y"
                {
     if (((yyvsp[0].s)->class != (SYM_CONSTANT | T_NET)) || !net_is_ip(SYM_VAL((yyvsp[0].s)).net))
       cf_error("IP network constant expected");
     (yyval.net) = * SYM_VAL((yyvsp[0].s)).net;
   }
#line 8702 "obj/conf/cf-parse.tab.c"
    break;

  case 640: /* net_any: CF_SYM_KNOWN  */
#line 356 "conf/confbase.Y"
                {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_NET))
       cf_error("Network constant expected");
     (yyval.net_ptr) = (net_addr *) SYM_VAL((yyvsp[0].s)).net; /* Avoid const warning */
   }
#line 8712 "obj/conf/cf-parse.tab.c"
    break;

  case 643: /* net_or_ipa: IP4  */
#line 366 "conf/confbase.Y"
       { net_fill_ip4(&((yyval.net)), (yyvsp[0].ip4), IP4_MAX_PREFIX_LENGTH); }
#line 8718 "obj/conf/cf-parse.tab.c"
    break;

  case 644: /* net_or_ipa: IP6  */
#line 367 "conf/confbase.Y"
       { net_fill_ip6(&((yyval.net)), (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH); }
#line 8724 "obj/conf/cf-parse.tab.c"
    break;

  case 645: /* net_or_ipa: CF_SYM_KNOWN  */
#line 368 "conf/confbase.Y"
                {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
       net_fill_ip_host(&((yyval.net)), SYM_VAL((yyvsp[0].s)).ip);
     else if (((yyvsp[0].s)->class == (SYM_CONSTANT | T_NET)) && net_is_ip(SYM_VAL((yyvsp[0].s)).net))
       (yyval.net) = * SYM_VAL((yyvsp[0].s)).net;
     else
       cf_error("IP address or network constant expected");
   }
#line 8737 "obj/conf/cf-parse.tab.c"
    break;

  case 646: /* label_stack_start: NUM  */
#line 379 "conf/confbase.Y"
{
  (yyval.mls) = cfg_allocz(sizeof(mpls_label_stack));
  (yyval.mls)->len = 1;
  (yyval.mls)->stack[0] = (yyvsp[0].i);
}
#line 8747 "obj/conf/cf-parse.tab.c"
    break;

  case 648: /* label_stack: label_stack '/' NUM  */
#line 387 "conf/confbase.Y"
                        {
    if ((yyvsp[-2].mls)->len >= MPLS_MAX_LABEL_STACK)
      cf_error("Too many labels in stack");
    (yyvsp[-2].mls)->stack[(yyvsp[-2].mls)->len++] = (yyvsp[0].i);
    (yyval.mls) = (yyvsp[-2].mls);
  }
#line 8758 "obj/conf/cf-parse.tab.c"
    break;

  case 649: /* time: TEXT  */
#line 396 "conf/confbase.Y"
        {
     (yyval.time) = tm_parse_time((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date/time");
   }
#line 8768 "obj/conf/cf-parse.tab.c"
    break;

  case 651: /* text: CF_SYM_KNOWN  */
#line 405 "conf/confbase.Y"
                {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String constant expected");
     (yyval.t) = SYM_VAL((yyvsp[0].s)).s;
   }
#line 8777 "obj/conf/cf-parse.tab.c"
    break;

  case 653: /* opttext: %empty  */
#line 413 "conf/confbase.Y"
               { (yyval.t) = NULL; }
#line 8783 "obj/conf/cf-parse.tab.c"
    break;

  case 654: /* text_or_ipa: TEXT  */
#line 417 "conf/confbase.Y"
        { (yyval.v).type = T_STRING; (yyval.v).val.s = (yyvsp[0].t); }
#line 8789 "obj/conf/cf-parse.tab.c"
    break;

  case 655: /* text_or_ipa: IP4  */
#line 418 "conf/confbase.Y"
       { (yyval.v).type = T_IP; (yyval.v).val.ip = ipa_from_ip4((yyvsp[0].ip4)); }
#line 8795 "obj/conf/cf-parse.tab.c"
    break;

  case 656: /* text_or_ipa: IP6  */
#line 419 "conf/confbase.Y"
       { (yyval.v).type = T_IP; (yyval.v).val.ip = ipa_from_ip6((yyvsp[0].ip6)); }
#line 8801 "obj/conf/cf-parse.tab.c"
    break;

  case 657: /* text_or_ipa: CF_SYM_KNOWN  */
#line 420 "conf/confbase.Y"
                {
     if (((yyvsp[0].s)->class == (SYM_CONSTANT | T_STRING)) ||
	 ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP)))
       (yyval.v) = *((yyvsp[0].s)->val);
     else
       cf_error("String or IP constant expected");
   }
#line 8813 "obj/conf/cf-parse.tab.c"
    break;

  case 658: /* text_or_ipa: '(' term ')'  */
#line 427 "conf/confbase.Y"
                {
     (yyval.v) = cf_eval((yyvsp[-1].x), T_VOID);
     if (((yyval.v).type != T_BYTESTRING) && ((yyval.v).type != T_STRING))
       cf_error("Bytestring or string value expected");
   }
#line 8823 "obj/conf/cf-parse.tab.c"
    break;

  case 660: /* bytestring: bytestring_expr  */
#line 436 "conf/confbase.Y"
                   { (yyval.bs) = cf_eval((yyvsp[0].x), T_BYTESTRING).val.bs; }
#line 8829 "obj/conf/cf-parse.tab.c"
    break;

  case 661: /* bytestring_text: BYTETEXT  */
#line 440 "conf/confbase.Y"
            { (yyval.v).type = T_BYTESTRING; (yyval.v).val.bs = (yyvsp[0].bs); }
#line 8835 "obj/conf/cf-parse.tab.c"
    break;

  case 662: /* bytestring_text: TEXT  */
#line 441 "conf/confbase.Y"
        { (yyval.v).type = T_STRING; (yyval.v).val.s = (yyvsp[0].t); }
#line 8841 "obj/conf/cf-parse.tab.c"
    break;

  case 663: /* bytestring_text: bytestring_expr  */
#line 442 "conf/confbase.Y"
                   {
     (yyval.v) = cf_eval((yyvsp[0].x), T_VOID);
     if (((yyval.v).type != T_BYTESTRING) && ((yyval.v).type != T_STRING))
       cf_error("Bytestring or string value expected");
   }
#line 8851 "obj/conf/cf-parse.tab.c"
    break;

  case 666: /* bytestring_expr: '(' term ')'  */
#line 452 "conf/confbase.Y"
                { (yyval.x) = (yyvsp[-1].x); }
#line 8857 "obj/conf/cf-parse.tab.c"
    break;

  case 667: /* flow_num_op: TRUE  */
#line 37 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_TRUE; }
#line 8863 "obj/conf/cf-parse.tab.c"
    break;

  case 668: /* flow_num_op: '='  */
#line 38 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_EQ;  }
#line 8869 "obj/conf/cf-parse.tab.c"
    break;

  case 669: /* flow_num_op: NEQ  */
#line 39 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_NEQ; }
#line 8875 "obj/conf/cf-parse.tab.c"
    break;

  case 670: /* flow_num_op: '<'  */
#line 40 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_LT;  }
#line 8881 "obj/conf/cf-parse.tab.c"
    break;

  case 671: /* flow_num_op: LEQ  */
#line 41 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_LEQ; }
#line 8887 "obj/conf/cf-parse.tab.c"
    break;

  case 672: /* flow_num_op: '>'  */
#line 42 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_GT;  }
#line 8893 "obj/conf/cf-parse.tab.c"
    break;

  case 673: /* flow_num_op: GEQ  */
#line 43 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_GEQ; }
#line 8899 "obj/conf/cf-parse.tab.c"
    break;

  case 674: /* flow_num_op: FALSE  */
#line 44 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_FALSE; }
#line 8905 "obj/conf/cf-parse.tab.c"
    break;

  case 675: /* flow_logic_op: OR  */
#line 48 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_OR; }
#line 8911 "obj/conf/cf-parse.tab.c"
    break;

  case 676: /* flow_logic_op: AND  */
#line 49 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_AND; }
#line 8917 "obj/conf/cf-parse.tab.c"
    break;

  case 677: /* flow_num_type_: PROTO  */
#line 53 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_IP_PROTOCOL; }
#line 8923 "obj/conf/cf-parse.tab.c"
    break;

  case 678: /* flow_num_type_: NEXT HEADER  */
#line 54 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_NEXT_HEADER; }
#line 8929 "obj/conf/cf-parse.tab.c"
    break;

  case 679: /* flow_num_type_: PORT  */
#line 55 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_PORT; }
#line 8935 "obj/conf/cf-parse.tab.c"
    break;

  case 680: /* flow_num_type_: DPORT  */
#line 56 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_DST_PORT; }
#line 8941 "obj/conf/cf-parse.tab.c"
    break;

  case 681: /* flow_num_type_: SPORT  */
#line 57 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_SRC_PORT; }
#line 8947 "obj/conf/cf-parse.tab.c"
    break;

  case 682: /* flow_num_type_: ICMP TYPE  */
#line 58 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_ICMP_TYPE; }
#line 8953 "obj/conf/cf-parse.tab.c"
    break;

  case 683: /* flow_num_type_: ICMP CODE  */
#line 59 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_ICMP_CODE; }
#line 8959 "obj/conf/cf-parse.tab.c"
    break;

  case 684: /* flow_num_type_: LENGTH  */
#line 60 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_PACKET_LENGTH; }
#line 8965 "obj/conf/cf-parse.tab.c"
    break;

  case 685: /* flow_num_type_: DSCP  */
#line 61 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_DSCP; }
#line 8971 "obj/conf/cf-parse.tab.c"
    break;

  case 686: /* flow_num_type_: LABEL  */
#line 62 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_LABEL; }
#line 8977 "obj/conf/cf-parse.tab.c"
    break;

  case 687: /* flow_num_type: flow_num_type_  */
#line 65 "conf/flowspec.Y"
                             { flow_builder_set_type(this_flow, (yyvsp[0].i32)); }
#line 8983 "obj/conf/cf-parse.tab.c"
    break;

  case 688: /* flow_flag_type: TCP FLAGS  */
#line 66 "conf/flowspec.Y"
                             { flow_builder_set_type(this_flow, FLOW_TYPE_TCP_FLAGS); }
#line 8989 "obj/conf/cf-parse.tab.c"
    break;

  case 689: /* flow_frag_type: FRAGMENT  */
#line 67 "conf/flowspec.Y"
                             { flow_builder_set_type(this_flow, FLOW_TYPE_FRAGMENT); }
#line 8995 "obj/conf/cf-parse.tab.c"
    break;

  case 690: /* flow_srcdst: DST  */
#line 70 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_DST_PREFIX; }
#line 9001 "obj/conf/cf-parse.tab.c"
    break;

  case 691: /* flow_srcdst: SRC  */
#line 71 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_SRC_PREFIX; }
#line 9007 "obj/conf/cf-parse.tab.c"
    break;

  case 692: /* flow_num_opts: flow_num_op expr  */
#line 75 "conf/flowspec.Y"
                    {
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, (yyvsp[-1].i32), (yyvsp[0].i));
   }
#line 9016 "obj/conf/cf-parse.tab.c"
    break;

  case 693: /* flow_num_opts: flow_num_opts flow_logic_op flow_num_op expr  */
#line 79 "conf/flowspec.Y"
                                                {
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, (yyvsp[-2].i32) | (yyvsp[-1].i32), (yyvsp[0].i));
   }
#line 9025 "obj/conf/cf-parse.tab.c"
    break;

  case 696: /* flow_num_opt_ext_expr: expr  */
#line 88 "conf/flowspec.Y"
        {
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_EQ, (yyvsp[0].i));
   }
#line 9034 "obj/conf/cf-parse.tab.c"
    break;

  case 697: /* flow_num_opt_ext_expr: expr DDOT expr  */
#line 92 "conf/flowspec.Y"
                  {
     flow_check_cf_value_length(this_flow, (yyvsp[-2].i));
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_GEQ, (yyvsp[-2].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_AND | FLOW_OP_LEQ, (yyvsp[0].i));
   }
#line 9045 "obj/conf/cf-parse.tab.c"
    break;

  case 700: /* flow_bmk_opts: flow_neg expr '/' expr  */
#line 106 "conf/flowspec.Y"
                          {
     flow_check_cf_bmk_values(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
     flow_builder_add_val_mask(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
   }
#line 9054 "obj/conf/cf-parse.tab.c"
    break;

  case 701: /* flow_bmk_opts: flow_bmk_opts flow_logic_op flow_neg expr '/' expr  */
#line 110 "conf/flowspec.Y"
                                                      {
     flow_check_cf_bmk_values(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
     flow_builder_add_val_mask(this_flow, (yyvsp[-4].i32) | (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
   }
#line 9063 "obj/conf/cf-parse.tab.c"
    break;

  case 702: /* flow_bmk_opts: flow_bmk_opts ',' flow_neg expr '/' expr  */
#line 114 "conf/flowspec.Y"
                                            {
     flow_check_cf_bmk_values(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
     flow_builder_add_val_mask(this_flow, 0x40 | (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i)); /* AND */
   }
#line 9072 "obj/conf/cf-parse.tab.c"
    break;

  case 703: /* flow_neg: %empty  */
#line 121 "conf/flowspec.Y"
                { (yyval.i32) = 0x00; }
#line 9078 "obj/conf/cf-parse.tab.c"
    break;

  case 704: /* flow_neg: '!'  */
#line 122 "conf/flowspec.Y"
                { (yyval.i32) = 0x02; }
#line 9084 "obj/conf/cf-parse.tab.c"
    break;

  case 705: /* flow_frag_val: DONT_FRAGMENT  */
#line 126 "conf/flowspec.Y"
                  { (yyval.i32) = 1; }
#line 9090 "obj/conf/cf-parse.tab.c"
    break;

  case 706: /* flow_frag_val: IS_FRAGMENT  */
#line 127 "conf/flowspec.Y"
                  { (yyval.i32) = 2; }
#line 9096 "obj/conf/cf-parse.tab.c"
    break;

  case 707: /* flow_frag_val: FIRST_FRAGMENT  */
#line 128 "conf/flowspec.Y"
                  { (yyval.i32) = 4; }
#line 9102 "obj/conf/cf-parse.tab.c"
    break;

  case 708: /* flow_frag_val: LAST_FRAGMENT  */
#line 129 "conf/flowspec.Y"
                  { (yyval.i32) = 8; }
#line 9108 "obj/conf/cf-parse.tab.c"
    break;

  case 709: /* flow_frag_opts: flow_neg flow_frag_val  */
#line 133 "conf/flowspec.Y"
                          {
     flow_builder_add_val_mask(this_flow, 0, ((yyvsp[-1].i32) ? 0 : (yyvsp[0].i32)), (yyvsp[0].i32));
   }
#line 9116 "obj/conf/cf-parse.tab.c"
    break;

  case 710: /* flow_frag_opts: flow_frag_opts flow_logic_op flow_neg flow_frag_val  */
#line 136 "conf/flowspec.Y"
                                                       {
     flow_builder_add_val_mask(this_flow, (yyvsp[-2].i32), ((yyvsp[-1].i32) ? 0 : (yyvsp[0].i32)), (yyvsp[0].i32));
   }
#line 9124 "obj/conf/cf-parse.tab.c"
    break;

  case 711: /* flow_frag_opts: flow_frag_opts ',' flow_neg flow_frag_val  */
#line 139 "conf/flowspec.Y"
                                             {
     flow_builder_add_val_mask(this_flow, 0x40, ((yyvsp[-1].i32) ? 0 : (yyvsp[0].i32)), (yyvsp[0].i32)); /* AND */
   }
#line 9132 "obj/conf/cf-parse.tab.c"
    break;

  case 712: /* flow4_item: flow_srcdst net_ip4  */
#line 145 "conf/flowspec.Y"
                       {
     flow_builder_set_type(this_flow, (yyvsp[-1].i32));
     flow_builder4_add_pfx(this_flow, (net_addr_ip4 *) &((yyvsp[0].net)));
   }
#line 9141 "obj/conf/cf-parse.tab.c"
    break;

  case 716: /* flow6_item: flow_srcdst net_ip6  */
#line 155 "conf/flowspec.Y"
                       {
     flow_builder_set_type(this_flow, (yyvsp[-1].i32));
     flow_builder6_add_pfx(this_flow, (net_addr_ip6 *) &((yyvsp[0].net)), 0);
   }
#line 9150 "obj/conf/cf-parse.tab.c"
    break;

  case 717: /* flow6_item: flow_srcdst net_ip6 OFFSET NUM  */
#line 159 "conf/flowspec.Y"
                                  {
     if ((yyvsp[0].i) > (yyvsp[-2].net).pxlen)
       cf_error("Prefix offset is higher than prefix length");
     flow_builder_set_type(this_flow, (yyvsp[-3].i32));
     flow_builder6_add_pfx(this_flow, (net_addr_ip6 *) &((yyvsp[-2].net)), (yyvsp[0].i));
   }
#line 9161 "obj/conf/cf-parse.tab.c"
    break;

  case 725: /* flow_builder_init: %empty  */
#line 181 "conf/flowspec.Y"
{
  if (this_flow == NULL)
    this_flow = flow_builder_init(config_pool);	  /* FIXME: This should be allocated from tmp in future */
  else
    flow_builder_clear(this_flow);
}
#line 9172 "obj/conf/cf-parse.tab.c"
    break;

  case 726: /* flow_builder_set_ipv4: %empty  */
#line 188 "conf/flowspec.Y"
                       { this_flow->ipv6 = 0; }
#line 9178 "obj/conf/cf-parse.tab.c"
    break;

  case 727: /* flow_builder_set_ipv6: %empty  */
#line 189 "conf/flowspec.Y"
                       { this_flow->ipv6 = 1; }
#line 9184 "obj/conf/cf-parse.tab.c"
    break;

  case 728: /* net_flow4_: FLOW4 '{' flow_builder_init flow_builder_set_ipv4 flow4_opts '}'  */
#line 192 "conf/flowspec.Y"
{
  (yyval.net_ptr) = (net_addr *) flow_builder4_finalize(this_flow, cfg_mem);
  flow4_validate_cf((net_addr_flow4 *) (yyval.net_ptr));
}
#line 9193 "obj/conf/cf-parse.tab.c"
    break;

  case 729: /* net_flow6_: FLOW6 '{' flow_builder_init flow_builder_set_ipv6 flow6_opts '}'  */
#line 198 "conf/flowspec.Y"
{
  (yyval.net_ptr) = (net_addr *) flow_builder6_finalize(this_flow, cfg_mem);
  flow6_validate_cf((net_addr_flow6 *) (yyval.net_ptr));
}
#line 9202 "obj/conf/cf-parse.tab.c"
    break;

  case 739: /* $@1: %empty  */
#line 402 "filter/config.Y"
                 {
     (yyvsp[0].s) = cf_define_symbol(new_config, (yyvsp[0].s), SYM_FILTER, filter, NULL);
     cf_push_scope( new_config, (yyvsp[0].s) );
     this_function = NULL;
   }
#line 9212 "obj/conf/cf-parse.tab.c"
    break;

  case 740: /* filter_def: FILTER symbol $@1 filter_body  */
#line 406 "filter/config.Y"
                 {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     *f = (struct filter) { .sym = (yyvsp[-2].s), .root = (yyvsp[0].fl) };
     (yyvsp[-2].s)->filter = f;

     cf_pop_scope(new_config);
   }
#line 9224 "obj/conf/cf-parse.tab.c"
    break;

  case 742: /* filter_eval: EVAL term  */
#line 417 "filter/config.Y"
             { cf_eval_int((yyvsp[0].x)); }
#line 9230 "obj/conf/cf-parse.tab.c"
    break;

  case 744: /* custom_attr: ATTRIBUTE type symbol ';'  */
#line 421 "filter/config.Y"
                                       {
  cf_define_symbol(new_config, (yyvsp[-1].s), SYM_ATTRIBUTE, attribute, ca_lookup(new_config->pool, (yyvsp[-1].s)->name, (yyvsp[-2].i))->fda);
}
#line 9238 "obj/conf/cf-parse.tab.c"
    break;

  case 746: /* bt_test_suite: BT_TEST_SUITE '(' symbol_known ',' text ')'  */
#line 427 "filter/config.Y"
                                             {
  cf_assert_symbol((yyvsp[-3].s), SYM_FUNCTION);
  struct f_bt_test_suite *t = cfg_allocz(sizeof(struct f_bt_test_suite));
  t->fn = (yyvsp[-3].s)->function;
  t->fn_name = (yyvsp[-3].s)->name;
  t->dsc = (yyvsp[-1].t);

  add_tail(&new_config->tests, &t->n);
 }
#line 9252 "obj/conf/cf-parse.tab.c"
    break;

  case 748: /* bt_test_same: BT_TEST_SAME '(' symbol_known ',' symbol_known ',' NUM ')'  */
#line 440 "filter/config.Y"
                                                            {
  cf_assert_symbol((yyvsp[-5].s), SYM_FUNCTION);
  cf_assert_symbol((yyvsp[-3].s), SYM_FUNCTION);
  struct f_bt_test_suite *t = cfg_allocz(sizeof(struct f_bt_test_suite));
  t->fn = (yyvsp[-5].s)->function;
  t->cmp = (yyvsp[-3].s)->function;
  t->result = (yyvsp[-1].i);
  t->fn_name = (yyvsp[-5].s)->name;
  t->dsc = (yyvsp[-3].s)->name;
  add_tail(&new_config->tests, &t->n);
 }
#line 9268 "obj/conf/cf-parse.tab.c"
    break;

  case 749: /* type: INT  */
#line 454 "filter/config.Y"
       { (yyval.i) = T_INT; }
#line 9274 "obj/conf/cf-parse.tab.c"
    break;

  case 750: /* type: BOOL  */
#line 455 "filter/config.Y"
        { (yyval.i) = T_BOOL; }
#line 9280 "obj/conf/cf-parse.tab.c"
    break;

  case 751: /* type: IP  */
#line 456 "filter/config.Y"
      { (yyval.i) = T_IP; }
#line 9286 "obj/conf/cf-parse.tab.c"
    break;

  case 752: /* type: RD  */
#line 457 "filter/config.Y"
      { (yyval.i) = T_RD; }
#line 9292 "obj/conf/cf-parse.tab.c"
    break;

  case 753: /* type: PREFIX  */
#line 458 "filter/config.Y"
          { (yyval.i) = T_NET; }
#line 9298 "obj/conf/cf-parse.tab.c"
    break;

  case 754: /* type: PAIR  */
#line 459 "filter/config.Y"
        { (yyval.i) = T_PAIR; }
#line 9304 "obj/conf/cf-parse.tab.c"
    break;

  case 755: /* type: QUAD  */
#line 460 "filter/config.Y"
        { (yyval.i) = T_QUAD; }
#line 9310 "obj/conf/cf-parse.tab.c"
    break;

  case 756: /* type: EC  */
#line 461 "filter/config.Y"
      { (yyval.i) = T_EC; }
#line 9316 "obj/conf/cf-parse.tab.c"
    break;

  case 757: /* type: LC  */
#line 462 "filter/config.Y"
      { (yyval.i) = T_LC; }
#line 9322 "obj/conf/cf-parse.tab.c"
    break;

  case 758: /* type: STRING  */
#line 463 "filter/config.Y"
          { (yyval.i) = T_STRING; }
#line 9328 "obj/conf/cf-parse.tab.c"
    break;

  case 759: /* type: BYTESTRING  */
#line 464 "filter/config.Y"
              { (yyval.i) = T_BYTESTRING; }
#line 9334 "obj/conf/cf-parse.tab.c"
    break;

  case 760: /* type: BGPMASK  */
#line 465 "filter/config.Y"
           { (yyval.i) = T_PATH_MASK; }
#line 9340 "obj/conf/cf-parse.tab.c"
    break;

  case 761: /* type: BGPPATH  */
#line 466 "filter/config.Y"
           { (yyval.i) = T_PATH; }
#line 9346 "obj/conf/cf-parse.tab.c"
    break;

  case 762: /* type: CLIST  */
#line 467 "filter/config.Y"
         { (yyval.i) = T_CLIST; }
#line 9352 "obj/conf/cf-parse.tab.c"
    break;

  case 763: /* type: ECLIST  */
#line 468 "filter/config.Y"
          { (yyval.i) = T_ECLIST; }
#line 9358 "obj/conf/cf-parse.tab.c"
    break;

  case 764: /* type: LCLIST  */
#line 469 "filter/config.Y"
          { (yyval.i) = T_LCLIST; }
#line 9364 "obj/conf/cf-parse.tab.c"
    break;

  case 765: /* type: ROUTE  */
#line 470 "filter/config.Y"
         { (yyval.i) = T_ROUTE; }
#line 9370 "obj/conf/cf-parse.tab.c"
    break;

  case 766: /* type: type SET  */
#line 471 "filter/config.Y"
            {
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_ENUM:
	  case T_EC:
	  case T_LC:
	  case T_RD:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_NET:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 9396 "obj/conf/cf-parse.tab.c"
    break;

  case 767: /* type: ENUM enum_type  */
#line 492 "filter/config.Y"
                  { (yyval.i) = (yyvsp[0].i); }
#line 9402 "obj/conf/cf-parse.tab.c"
    break;

  case 768: /* function_argsn: %empty  */
#line 496 "filter/config.Y"
               { (yyval.fa) = NULL; }
#line 9408 "obj/conf/cf-parse.tab.c"
    break;

  case 769: /* function_argsn: function_argsn type symbol ';'  */
#line 497 "filter/config.Y"
                                  {
     if ((yyvsp[-1].s)->scope->slots >= 0xfe) cf_error("Too many declarations, at most 255 allowed");
     (yyval.fa) = cfg_alloc(sizeof(struct f_arg));
     (yyval.fa)->arg = cf_define_symbol(new_config, (yyvsp[-1].s), SYM_VARIABLE | (yyvsp[-2].i), offset, sym_->scope->slots++);
     (yyval.fa)->next = (yyvsp[-3].fa);
   }
#line 9419 "obj/conf/cf-parse.tab.c"
    break;

  case 770: /* function_args: '(' ')'  */
#line 506 "filter/config.Y"
           { (yyval.fa) = NULL; }
#line 9425 "obj/conf/cf-parse.tab.c"
    break;

  case 771: /* function_args: '(' function_argsn type symbol ')'  */
#line 507 "filter/config.Y"
                                      {
     (yyval.fa) = cfg_alloc(sizeof(struct f_arg));
     (yyval.fa)->arg = cf_define_symbol(new_config, (yyvsp[-1].s), SYM_VARIABLE | (yyvsp[-2].i), offset, sym_->scope->slots++);
     (yyval.fa)->next = (yyvsp[-3].fa);
   }
#line 9435 "obj/conf/cf-parse.tab.c"
    break;

  case 772: /* function_vars: %empty  */
#line 515 "filter/config.Y"
               { (yyval.i) = 0; }
#line 9441 "obj/conf/cf-parse.tab.c"
    break;

  case 773: /* function_vars: function_vars type symbol ';'  */
#line 516 "filter/config.Y"
                                 {
     cf_define_symbol(new_config, (yyvsp[-1].s), SYM_VARIABLE | (yyvsp[-2].i), offset, f_new_var(sym_->scope));
     (yyval.i) = (yyvsp[-3].i) + 1;
   }
#line 9450 "obj/conf/cf-parse.tab.c"
    break;

  case 774: /* function_type: %empty  */
#line 523 "filter/config.Y"
               { (yyval.i) = T_VOID; }
#line 9456 "obj/conf/cf-parse.tab.c"
    break;

  case 775: /* function_type: IMP type  */
#line 524 "filter/config.Y"
            { (yyval.i) = (yyvsp[0].i); }
#line 9462 "obj/conf/cf-parse.tab.c"
    break;

  case 777: /* filter: symbol_known  */
#line 530 "filter/config.Y"
                {
     cf_assert_symbol((yyvsp[0].s), SYM_FILTER);
     (yyval.f) = (yyvsp[0].s)->filter;
   }
#line 9471 "obj/conf/cf-parse.tab.c"
    break;

  case 778: /* $@2: %empty  */
#line 534 "filter/config.Y"
   {
     cf_push_scope(new_config, NULL);
     this_function = NULL;
   }
#line 9480 "obj/conf/cf-parse.tab.c"
    break;

  case 779: /* filter: $@2 filter_body  */
#line 537 "filter/config.Y"
                 {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     *f = (struct filter) { .root = (yyvsp[0].fl) };
     (yyval.f) = f;

     cf_pop_scope(new_config);
   }
#line 9492 "obj/conf/cf-parse.tab.c"
    break;

  case 780: /* where_filter: WHERE term  */
#line 547 "filter/config.Y"
              {
     /* Construct 'IF term THEN { ACCEPT; } ELSE { REJECT; }' */
     (yyval.f) = f_new_where((yyvsp[0].x));
   }
#line 9501 "obj/conf/cf-parse.tab.c"
    break;

  case 781: /* function_body: function_vars '{' cmds '}'  */
#line 554 "filter/config.Y"
                              {
     (yyval.fl) = f_linearize((yyvsp[-1].x), 0);
     (yyval.fl)->vars = (yyvsp[-3].i);
   }
#line 9510 "obj/conf/cf-parse.tab.c"
    break;

  case 783: /* $@3: %empty  */
#line 563 "filter/config.Y"
                   {
     DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     this_function = cf_define_symbol(new_config, (yyvsp[0].s), SYM_FUNCTION, function, NULL);
     cf_push_scope(new_config, this_function);
   }
#line 9520 "obj/conf/cf-parse.tab.c"
    break;

  case 784: /* $@4: %empty  */
#line 567 "filter/config.Y"
                                 {
     /* Make dummy f_line for storing function prototype */
     struct f_line *dummy = cfg_allocz(sizeof(struct f_line));
     this_function->function = dummy;

     dummy->return_type = (yyvsp[0].i);

     /* Revert the args */
     while ((yyvsp[-1].fa)) {
       struct f_arg *tmp = (yyvsp[-1].fa);
       (yyvsp[-1].fa) = (yyvsp[-1].fa)->next;

       tmp->next = dummy->arg_list;
       dummy->arg_list = tmp;
       dummy->args++;
     }
   }
#line 9542 "obj/conf/cf-parse.tab.c"
    break;

  case 785: /* function_def: FUNCTION symbol $@3 function_args function_type $@4 function_body  */
#line 583 "filter/config.Y"
                   {
     (yyvsp[0].fl)->args = this_function->function->args;
     (yyvsp[0].fl)->arg_list = this_function->function->arg_list;
     (yyvsp[0].fl)->return_type = this_function->function->return_type;
     (yyvsp[-5].s)->function = (yyvsp[0].fl);
     cf_pop_scope(new_config);
   }
#line 9554 "obj/conf/cf-parse.tab.c"
    break;

  case 786: /* cmds: %empty  */
#line 594 "filter/config.Y"
                  { (yyval.x) = NULL; }
#line 9560 "obj/conf/cf-parse.tab.c"
    break;

  case 787: /* cmds: cmds_int  */
#line 595 "filter/config.Y"
            { (yyval.x) = (yyvsp[0].xp).begin; }
#line 9566 "obj/conf/cf-parse.tab.c"
    break;

  case 788: /* $@5: %empty  */
#line 598 "filter/config.Y"
             { cf_push_soft_scope(new_config); }
#line 9572 "obj/conf/cf-parse.tab.c"
    break;

  case 789: /* cmds_scoped: $@5 cmds  */
#line 598 "filter/config.Y"
                                                      { cf_pop_soft_scope(new_config); (yyval.x) = (yyvsp[0].x); }
#line 9578 "obj/conf/cf-parse.tab.c"
    break;

  case 792: /* cmd_prep: cmd_var  */
#line 602 "filter/config.Y"
                  {
  (yyval.xp).begin = (yyval.xp).end = (yyvsp[0].x);
  if ((yyvsp[0].x))
    while ((yyval.xp).end->next)
      (yyval.xp).end = (yyval.xp).end->next;
}
#line 9589 "obj/conf/cf-parse.tab.c"
    break;

  case 794: /* cmds_int: cmds_int cmd_prep  */
#line 611 "filter/config.Y"
                     {
  if (!(yyvsp[-1].xp).begin)
    (yyval.xp) = (yyvsp[0].xp);
  else if (!(yyvsp[0].xp).begin)
    (yyval.xp) = (yyvsp[-1].xp);
  else {
    (yyval.xp).begin = (yyvsp[-1].xp).begin;
    (yyval.xp).end = (yyvsp[0].xp).end;
    (yyvsp[-1].xp).end->next = (yyvsp[0].xp).begin;
  }
 }
#line 9605 "obj/conf/cf-parse.tab.c"
    break;

  case 795: /* fipa: IP4  */
#line 628 "filter/config.Y"
                          { (yyval.v).type = T_IP; (yyval.v).val.ip = ipa_from_ip4((yyvsp[0].ip4)); }
#line 9611 "obj/conf/cf-parse.tab.c"
    break;

  case 796: /* fipa: IP6  */
#line 629 "filter/config.Y"
                          { (yyval.v).type = T_IP; (yyval.v).val.ip = ipa_from_ip6((yyvsp[0].ip6)); }
#line 9617 "obj/conf/cf-parse.tab.c"
    break;

  case 797: /* set_atom0: NUM  */
#line 642 "filter/config.Y"
          { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 9623 "obj/conf/cf-parse.tab.c"
    break;

  case 798: /* set_atom0: fipa  */
#line 643 "filter/config.Y"
          { (yyval.v) = (yyvsp[0].v); }
#line 9629 "obj/conf/cf-parse.tab.c"
    break;

  case 799: /* set_atom0: VPN_RD  */
#line 644 "filter/config.Y"
          { (yyval.v).type = T_RD; (yyval.v).val.rd = (yyvsp[0].rd); }
#line 9635 "obj/conf/cf-parse.tab.c"
    break;

  case 800: /* set_atom0: ENUM_TOKEN  */
#line 645 "filter/config.Y"
              { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 9641 "obj/conf/cf-parse.tab.c"
    break;

  case 801: /* set_atom0: '(' term ')'  */
#line 646 "filter/config.Y"
                {
     (yyval.v) = cf_eval((yyvsp[-1].x), T_VOID);
     if (!f_valid_set_type((yyval.v).type))
       cf_error("Set-incompatible type (%s)", f_type_name((yyval.v).type));
   }
#line 9651 "obj/conf/cf-parse.tab.c"
    break;

  case 803: /* set_atom: symbol_known  */
#line 655 "filter/config.Y"
                {
     cf_assert_symbol((yyvsp[0].s), SYM_CONSTANT);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[0].s))))
       cf_error("%s: Set-incompatible type (%s)", (yyvsp[0].s)->name, f_type_name(SYM_TYPE((yyvsp[0].s))));
     (yyval.v) = *(yyvsp[0].s)->val;
   }
#line 9662 "obj/conf/cf-parse.tab.c"
    break;

  case 805: /* cnum: term  */
#line 668 "filter/config.Y"
        { (yyval.i32) = cf_eval_int((yyvsp[0].x)); }
#line 9668 "obj/conf/cf-parse.tab.c"
    break;

  case 806: /* pair_item: '(' cnum ',' cnum ')'  */
#line 671 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 9674 "obj/conf/cf-parse.tab.c"
    break;

  case 807: /* pair_item: '(' cnum ',' cnum DDOT cnum ')'  */
#line 672 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 9680 "obj/conf/cf-parse.tab.c"
    break;

  case 808: /* pair_item: '(' cnum ',' '*' ')'  */
#line 673 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 9686 "obj/conf/cf-parse.tab.c"
    break;

  case 809: /* pair_item: '(' cnum DDOT cnum ',' cnum ')'  */
#line 674 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_set((yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 9692 "obj/conf/cf-parse.tab.c"
    break;

  case 810: /* pair_item: '(' cnum DDOT cnum ',' cnum DDOT cnum ')'  */
#line 675 "filter/config.Y"
                                             { (yyval.e) = f_new_pair_set((yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 9698 "obj/conf/cf-parse.tab.c"
    break;

  case 811: /* pair_item: '(' cnum DDOT cnum ',' '*' ')'  */
#line 676 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 9704 "obj/conf/cf-parse.tab.c"
    break;

  case 812: /* pair_item: '(' '*' ',' cnum ')'  */
#line 677 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 9710 "obj/conf/cf-parse.tab.c"
    break;

  case 813: /* pair_item: '(' '*' ',' cnum DDOT cnum ')'  */
#line 678 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 9716 "obj/conf/cf-parse.tab.c"
    break;

  case 814: /* pair_item: '(' '*' ',' '*' ')'  */
#line 679 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_item(0, CC_ALL, 0, CC_ALL); }
#line 9722 "obj/conf/cf-parse.tab.c"
    break;

  case 815: /* pair_item: '(' cnum ',' cnum ')' DDOT '(' cnum ',' cnum ')'  */
#line 681 "filter/config.Y"
   { (yyval.e) = f_new_pair_item((yyvsp[-9].i32), (yyvsp[-3].i32), (yyvsp[-7].i32), (yyvsp[-1].i32)); }
#line 9728 "obj/conf/cf-parse.tab.c"
    break;

  case 816: /* ec_kind: RT  */
#line 685 "filter/config.Y"
      { (yyval.ecs) = EC_RT; }
#line 9734 "obj/conf/cf-parse.tab.c"
    break;

  case 817: /* ec_kind: RO  */
#line 686 "filter/config.Y"
      { (yyval.ecs) = EC_RO; }
#line 9740 "obj/conf/cf-parse.tab.c"
    break;

  case 818: /* ec_kind: UNKNOWN NUM  */
#line 687 "filter/config.Y"
               { (yyval.ecs) = (yyvsp[0].i); }
#line 9746 "obj/conf/cf-parse.tab.c"
    break;

  case 819: /* ec_kind: GENERIC  */
#line 688 "filter/config.Y"
           { (yyval.ecs) = EC_GENERIC; }
#line 9752 "obj/conf/cf-parse.tab.c"
    break;

  case 820: /* ec_item: '(' ec_kind ',' cnum ',' cnum ')'  */
#line 692 "filter/config.Y"
                                                { (yyval.e) = f_new_ec_item((yyvsp[-5].ecs), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 9758 "obj/conf/cf-parse.tab.c"
    break;

  case 821: /* ec_item: '(' ec_kind ',' cnum ',' cnum DDOT cnum ')'  */
#line 693 "filter/config.Y"
                                                { (yyval.e) = f_new_ec_item((yyvsp[-7].ecs), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 9764 "obj/conf/cf-parse.tab.c"
    break;

  case 822: /* ec_item: '(' ec_kind ',' cnum ',' '*' ')'  */
#line 694 "filter/config.Y"
                                                { (yyval.e) = f_new_ec_item((yyvsp[-5].ecs), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 9770 "obj/conf/cf-parse.tab.c"
    break;

  case 823: /* lc_item: '(' cnum ',' cnum ',' cnum ')'  */
#line 698 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 9776 "obj/conf/cf-parse.tab.c"
    break;

  case 824: /* lc_item: '(' cnum ',' cnum ',' cnum DDOT cnum ')'  */
#line 699 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 9782 "obj/conf/cf-parse.tab.c"
    break;

  case 825: /* lc_item: '(' cnum ',' cnum ',' '*' ')'  */
#line 700 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 9788 "obj/conf/cf-parse.tab.c"
    break;

  case 826: /* lc_item: '(' cnum ',' cnum DDOT cnum ',' '*' ')'  */
#line 701 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 9794 "obj/conf/cf-parse.tab.c"
    break;

  case 827: /* lc_item: '(' cnum ',' '*' ',' '*' ')'  */
#line 702 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 9800 "obj/conf/cf-parse.tab.c"
    break;

  case 828: /* lc_item: '(' cnum DDOT cnum ',' '*' ',' '*' ')'  */
#line 703 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 9806 "obj/conf/cf-parse.tab.c"
    break;

  case 829: /* lc_item: '(' '*' ',' '*' ',' '*' ')'  */
#line 704 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item(0, LC_ALL, 0, LC_ALL, 0, LC_ALL); }
#line 9812 "obj/conf/cf-parse.tab.c"
    break;

  case 830: /* lc_item: '(' cnum ',' cnum ',' cnum ')' DDOT '(' cnum ',' cnum ',' cnum ')'  */
#line 706 "filter/config.Y"
   { (yyval.e) = f_new_lc_item((yyvsp[-13].i32), (yyvsp[-5].i32), (yyvsp[-11].i32), (yyvsp[-3].i32), (yyvsp[-9].i32), (yyvsp[-1].i32)); }
#line 9818 "obj/conf/cf-parse.tab.c"
    break;

  case 834: /* set_item: set_atom  */
#line 713 "filter/config.Y"
            { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 9824 "obj/conf/cf-parse.tab.c"
    break;

  case 835: /* set_item: set_atom DDOT set_atom  */
#line 714 "filter/config.Y"
                          { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 9830 "obj/conf/cf-parse.tab.c"
    break;

  case 839: /* switch_item: switch_atom  */
#line 721 "filter/config.Y"
               { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 9836 "obj/conf/cf-parse.tab.c"
    break;

  case 840: /* switch_item: switch_atom DDOT switch_atom  */
#line 722 "filter/config.Y"
                                { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 9842 "obj/conf/cf-parse.tab.c"
    break;

  case 842: /* ec_items: ec_items ',' ec_item  */
#line 727 "filter/config.Y"
                        { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 9848 "obj/conf/cf-parse.tab.c"
    break;

  case 844: /* set_items: set_items ',' set_item  */
#line 732 "filter/config.Y"
                          { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 9854 "obj/conf/cf-parse.tab.c"
    break;

  case 846: /* switch_items: switch_items ',' switch_item  */
#line 737 "filter/config.Y"
                                { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 9860 "obj/conf/cf-parse.tab.c"
    break;

  case 847: /* fprefix: net_ip_  */
#line 741 "filter/config.Y"
                { (yyval.px).net = (yyvsp[0].net); (yyval.px).lo = (yyvsp[0].net).pxlen; (yyval.px).hi = (yyvsp[0].net).pxlen; }
#line 9866 "obj/conf/cf-parse.tab.c"
    break;

  case 848: /* fprefix: net_ip_ '+'  */
#line 742 "filter/config.Y"
                { (yyval.px).net = (yyvsp[-1].net); (yyval.px).lo = (yyvsp[-1].net).pxlen; (yyval.px).hi = net_max_prefix_length[(yyvsp[-1].net).type]; }
#line 9872 "obj/conf/cf-parse.tab.c"
    break;

  case 849: /* fprefix: net_ip_ '-'  */
#line 743 "filter/config.Y"
                { (yyval.px).net = (yyvsp[-1].net); (yyval.px).lo = 0; (yyval.px).hi = (yyvsp[-1].net).pxlen; }
#line 9878 "obj/conf/cf-parse.tab.c"
    break;

  case 850: /* fprefix: net_ip_ '{' NUM ',' NUM '}'  */
#line 744 "filter/config.Y"
                               {
     (yyval.px).net = (yyvsp[-5].net); (yyval.px).lo = (yyvsp[-3].i); (yyval.px).hi = (yyvsp[-1].i);
     if (((yyvsp[-3].i) > (yyvsp[-1].i)) || ((yyvsp[-1].i) > net_max_prefix_length[(yyvsp[-5].net).type]))
       cf_error("Invalid prefix pattern range: {%u, %u}", (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 9888 "obj/conf/cf-parse.tab.c"
    break;

  case 851: /* fprefix_set: fprefix  */
#line 752 "filter/config.Y"
           { (yyval.trie) = f_new_trie(cfg_mem, 0); trie_add_prefix((yyval.trie), &((yyvsp[0].px).net), (yyvsp[0].px).lo, (yyvsp[0].px).hi); }
#line 9894 "obj/conf/cf-parse.tab.c"
    break;

  case 852: /* fprefix_set: fprefix_set ',' fprefix  */
#line 753 "filter/config.Y"
                           { (yyval.trie) = (yyvsp[-2].trie); if (!trie_add_prefix((yyval.trie), &((yyvsp[0].px).net), (yyvsp[0].px).lo, (yyvsp[0].px).hi)) cf_error("Mixed IPv4/IPv6 prefixes in prefix set"); }
#line 9900 "obj/conf/cf-parse.tab.c"
    break;

  case 853: /* switch_body: %empty  */
#line 756 "filter/config.Y"
                         { (yyval.e) = NULL; }
#line 9906 "obj/conf/cf-parse.tab.c"
    break;

  case 854: /* switch_body: switch_body switch_items ':' cmds_scoped  */
#line 757 "filter/config.Y"
                                            {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 9918 "obj/conf/cf-parse.tab.c"
    break;

  case 855: /* switch_body: switch_body ELSECOL cmds_scoped  */
#line 764 "filter/config.Y"
                                   {
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 9930 "obj/conf/cf-parse.tab.c"
    break;

  case 856: /* bgp_path_expr: symbol_value  */
#line 774 "filter/config.Y"
                { (yyval.x) = (yyvsp[0].x); }
#line 9936 "obj/conf/cf-parse.tab.c"
    break;

  case 857: /* bgp_path_expr: '(' term ')'  */
#line 775 "filter/config.Y"
                { (yyval.x) = (yyvsp[-1].x); }
#line 9942 "obj/conf/cf-parse.tab.c"
    break;

  case 858: /* bgp_path: PO bgp_path_tail PC  */
#line 779 "filter/config.Y"
                         { (yyval.x) = (yyvsp[-1].x); }
#line 9948 "obj/conf/cf-parse.tab.c"
    break;

  case 859: /* bgp_path_tail: NUM bgp_path_tail  */
#line 783 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .asn = (yyvsp[-1].i), .kind = PM_ASN, }, }); (yyval.x)->next = (yyvsp[0].x);  }
#line 9954 "obj/conf/cf-parse.tab.c"
    break;

  case 860: /* bgp_path_tail: NUM DDOT NUM bgp_path_tail  */
#line 784 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .from = (yyvsp[-3].i), .to = (yyvsp[-1].i), .kind = PM_ASN_RANGE }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 9960 "obj/conf/cf-parse.tab.c"
    break;

  case 861: /* bgp_path_tail: '[' ']' bgp_path_tail  */
#line 785 "filter/config.Y"
                         { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .set = NULL, .kind = PM_ASN_SET }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 9966 "obj/conf/cf-parse.tab.c"
    break;

  case 862: /* bgp_path_tail: '[' set_items ']' bgp_path_tail  */
#line 786 "filter/config.Y"
                                   {
   if ((yyvsp[-2].e)->from.type != T_INT) cf_error("Only integer sets allowed in path mask");
   (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .set = build_tree((yyvsp[-2].e)), .kind = PM_ASN_SET }, }); (yyval.x)->next = (yyvsp[0].x);
 }
#line 9975 "obj/conf/cf-parse.tab.c"
    break;

  case 863: /* bgp_path_tail: '*' bgp_path_tail  */
#line 790 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .kind = PM_ASTERISK }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 9981 "obj/conf/cf-parse.tab.c"
    break;

  case 864: /* bgp_path_tail: '?' bgp_path_tail  */
#line 791 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .kind = PM_QUESTION }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 9987 "obj/conf/cf-parse.tab.c"
    break;

  case 865: /* bgp_path_tail: '+' bgp_path_tail  */
#line 792 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .kind = PM_LOOP }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 9993 "obj/conf/cf-parse.tab.c"
    break;

  case 866: /* bgp_path_tail: bgp_path_expr bgp_path_tail  */
#line 793 "filter/config.Y"
                                { (yyval.x) = (yyvsp[-1].x); (yyval.x)->next = (yyvsp[0].x); }
#line 9999 "obj/conf/cf-parse.tab.c"
    break;

  case 867: /* bgp_path_tail: %empty  */
#line 794 "filter/config.Y"
                                { (yyval.x) = NULL; }
#line 10005 "obj/conf/cf-parse.tab.c"
    break;

  case 868: /* constant: NUM  */
#line 798 "filter/config.Y"
            { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_INT, .val.i = (yyvsp[0].i), }); }
#line 10011 "obj/conf/cf-parse.tab.c"
    break;

  case 869: /* constant: TRUE  */
#line 799 "filter/config.Y"
            { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_BOOL, .val.i = 1, }); }
#line 10017 "obj/conf/cf-parse.tab.c"
    break;

  case 870: /* constant: FALSE  */
#line 800 "filter/config.Y"
            { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_BOOL, .val.i = 0, }); }
#line 10023 "obj/conf/cf-parse.tab.c"
    break;

  case 871: /* constant: TEXT  */
#line 801 "filter/config.Y"
            { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_STRING, .val.s = (yyvsp[0].t), }); }
#line 10029 "obj/conf/cf-parse.tab.c"
    break;

  case 872: /* constant: BYTETEXT  */
#line 802 "filter/config.Y"
            { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_BYTESTRING, .val.bs = (yyvsp[0].bs), }); }
#line 10035 "obj/conf/cf-parse.tab.c"
    break;

  case 873: /* constant: fipa  */
#line 803 "filter/config.Y"
            { (yyval.x) = f_new_inst(FI_CONSTANT, (yyvsp[0].v)); }
#line 10041 "obj/conf/cf-parse.tab.c"
    break;

  case 874: /* constant: VPN_RD  */
#line 804 "filter/config.Y"
            { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_RD, .val.rd = (yyvsp[0].rd), }); }
#line 10047 "obj/conf/cf-parse.tab.c"
    break;

  case 875: /* constant: net_  */
#line 805 "filter/config.Y"
            { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_NET, .val.net = (yyvsp[0].net_ptr), }); }
#line 10053 "obj/conf/cf-parse.tab.c"
    break;

  case 876: /* constant: '[' ']'  */
#line 806 "filter/config.Y"
           { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_SET, .val.t = NULL, }); }
#line 10059 "obj/conf/cf-parse.tab.c"
    break;

  case 877: /* constant: '[' set_items ']'  */
#line 807 "filter/config.Y"
                     {
     DBG( "We've got a set here..." );
     (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_SET, .val.t = build_tree((yyvsp[-1].e)), });
     DBG( "ook\n" );
 }
#line 10069 "obj/conf/cf-parse.tab.c"
    break;

  case 878: /* constant: '[' fprefix_set ']'  */
#line 812 "filter/config.Y"
                       { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PREFIX_SET, .val.ti = (yyvsp[-1].trie), }); }
#line 10075 "obj/conf/cf-parse.tab.c"
    break;

  case 879: /* constant: ENUM_TOKEN  */
#line 813 "filter/config.Y"
              { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = (yyvsp[0].i) >> 16, .val.i = (yyvsp[0].i) & 0xffff, }); }
#line 10081 "obj/conf/cf-parse.tab.c"
    break;

  case 880: /* constructor: '(' term ',' term ')'  */
#line 817 "filter/config.Y"
                         { (yyval.x) = f_new_inst(FI_PAIR_CONSTRUCT, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 10087 "obj/conf/cf-parse.tab.c"
    break;

  case 881: /* constructor: '(' ec_kind ',' term ',' term ')'  */
#line 818 "filter/config.Y"
                                     { (yyval.x) = f_new_inst(FI_EC_CONSTRUCT, (yyvsp[-3].x), (yyvsp[-1].x), (yyvsp[-5].ecs)); }
#line 10093 "obj/conf/cf-parse.tab.c"
    break;

  case 882: /* constructor: '(' term ',' term ',' term ')'  */
#line 819 "filter/config.Y"
                                  { (yyval.x) = f_new_inst(FI_LC_CONSTRUCT, (yyvsp[-5].x), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 10099 "obj/conf/cf-parse.tab.c"
    break;

  case 883: /* constructor: bgp_path  */
#line 820 "filter/config.Y"
            { (yyval.x) = f_new_inst(FI_PATHMASK_CONSTRUCT, (yyvsp[0].x)); }
#line 10105 "obj/conf/cf-parse.tab.c"
    break;

  case 884: /* var_list_r: %empty  */
#line 826 "filter/config.Y"
               { (yyval.x) = NULL; }
#line 10111 "obj/conf/cf-parse.tab.c"
    break;

  case 885: /* var_list_r: term  */
#line 827 "filter/config.Y"
        { (yyval.x) = (yyvsp[0].x); }
#line 10117 "obj/conf/cf-parse.tab.c"
    break;

  case 886: /* var_list_r: var_list_r ',' term  */
#line 828 "filter/config.Y"
                       { (yyval.x) = (yyvsp[0].x); (yyval.x)->next = (yyvsp[-2].x); }
#line 10123 "obj/conf/cf-parse.tab.c"
    break;

  case 887: /* var_list: var_list_r  */
#line 832 "filter/config.Y"
   {
     (yyval.x) = NULL;

     /* Revert the var_list_r */
     while ((yyvsp[0].x)) {
       struct f_inst *tmp = (yyvsp[0].x);
       (yyvsp[0].x) = (yyvsp[0].x)->next;

       tmp->next = (yyval.x);
       (yyval.x) = tmp;
     }
   }
#line 10140 "obj/conf/cf-parse.tab.c"
    break;

  case 888: /* function_call: symbol_known '(' var_list ')'  */
#line 848 "filter/config.Y"
   {
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");

     (yyval.x) = f_new_inst(FI_CALL, (yyvsp[-1].x), (yyvsp[-3].s));
   }
#line 10151 "obj/conf/cf-parse.tab.c"
    break;

  case 889: /* symbol_value: symbol_known  */
#line 857 "filter/config.Y"
  {
    switch ((yyvsp[0].s)->class) {
      case SYM_CONSTANT_RANGE:
	(yyval.x) = f_new_inst(FI_CONSTANT, *((yyvsp[0].s)->val));
	break;
      case SYM_VARIABLE_RANGE:
	(yyval.x) = f_new_inst(FI_VAR_GET, (yyvsp[0].s));
	break;
      case SYM_ATTRIBUTE:
	(yyval.x) = f_new_inst(FI_EA_GET, f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_ROUTE, .val.rte = NULL }), *(yyvsp[0].s)->attribute);
	break;
      default:
	cf_error("Can't get value of symbol %s", (yyvsp[0].s)->name);
    }
  }
#line 10171 "obj/conf/cf-parse.tab.c"
    break;

  case 890: /* static_attr: FROM  */
#line 875 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_IP,         SA_FROM,	0); }
#line 10177 "obj/conf/cf-parse.tab.c"
    break;

  case 891: /* static_attr: GW  */
#line 876 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_IP,         SA_GW,	0); }
#line 10183 "obj/conf/cf-parse.tab.c"
    break;

  case 892: /* static_attr: NET  */
#line 877 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_NET,	  SA_NET,	1); }
#line 10189 "obj/conf/cf-parse.tab.c"
    break;

  case 893: /* static_attr: PROTO  */
#line 878 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_PROTO,	1); }
#line 10195 "obj/conf/cf-parse.tab.c"
    break;

  case 894: /* static_attr: SOURCE  */
#line 879 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_ENUM_RTS,   SA_SOURCE,	1); }
#line 10201 "obj/conf/cf-parse.tab.c"
    break;

  case 895: /* static_attr: SCOPE  */
#line 880 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_ENUM_SCOPE, SA_SCOPE,	0); }
#line 10207 "obj/conf/cf-parse.tab.c"
    break;

  case 896: /* static_attr: DEST  */
#line 881 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_ENUM_RTD,   SA_DEST,	0); }
#line 10213 "obj/conf/cf-parse.tab.c"
    break;

  case 897: /* static_attr: IFNAME  */
#line 882 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_IFNAME,	0); }
#line 10219 "obj/conf/cf-parse.tab.c"
    break;

  case 898: /* static_attr: IFINDEX  */
#line 883 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_INT,        SA_IFINDEX,	1); }
#line 10225 "obj/conf/cf-parse.tab.c"
    break;

  case 899: /* static_attr: WEIGHT  */
#line 884 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_INT,        SA_WEIGHT,	0); }
#line 10231 "obj/conf/cf-parse.tab.c"
    break;

  case 900: /* static_attr: PREFERENCE  */
#line 885 "filter/config.Y"
              { (yyval.fsa) = f_new_static_attr(T_INT,	  SA_PREF,	0); }
#line 10237 "obj/conf/cf-parse.tab.c"
    break;

  case 901: /* static_attr: GW_MPLS  */
#line 886 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_INT,        SA_GW_MPLS,	0); }
#line 10243 "obj/conf/cf-parse.tab.c"
    break;

  case 902: /* static_attr: GW_MPLS_STACK  */
#line 887 "filter/config.Y"
                 { (yyval.fsa) = f_new_static_attr(T_CLIST, SA_GW_MPLS_STACK,	0); }
#line 10249 "obj/conf/cf-parse.tab.c"
    break;

  case 903: /* static_attr: ONLINK  */
#line 888 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_BOOL,       SA_ONLINK,	0); }
#line 10255 "obj/conf/cf-parse.tab.c"
    break;

  case 904: /* $@6: %empty  */
#line 891 "filter/config.Y"
                          { f_method_call_start((yyvsp[-1].x)); }
#line 10261 "obj/conf/cf-parse.tab.c"
    break;

  case 905: /* term_dot_method: term '.' $@6 method_name_cont  */
#line 891 "filter/config.Y"
                                                                        { f_method_call_end(); (yyval.x) = (yyvsp[0].x); }
#line 10267 "obj/conf/cf-parse.tab.c"
    break;

  case 906: /* method_name_cont: CF_SYM_METHOD_BARE  */
#line 893 "filter/config.Y"
                      {
     (yyval.x) = f_dispatch_method((yyvsp[0].s), FM.object, NULL, 1);
   }
#line 10275 "obj/conf/cf-parse.tab.c"
    break;

  case 907: /* $@7: %empty  */
#line 896 "filter/config.Y"
                      {
     f_method_call_args();
   }
#line 10283 "obj/conf/cf-parse.tab.c"
    break;

  case 908: /* method_name_cont: CF_SYM_METHOD_ARGS $@7 '(' var_list ')'  */
#line 898 "filter/config.Y"
                      {
     (yyval.x) = f_dispatch_method((yyvsp[-4].s), FM.object, (yyvsp[-1].x), 1);
   }
#line 10291 "obj/conf/cf-parse.tab.c"
    break;

  case 909: /* method_name_cont: static_attr  */
#line 901 "filter/config.Y"
               {
     if (FM.object->type != T_ROUTE)
       cf_error("Getting a route attribute from %s, need a route", f_type_name(FM.object->type));
     (yyval.x) = f_new_inst(FI_RTA_GET, FM.object, (yyvsp[0].fsa));
   }
#line 10301 "obj/conf/cf-parse.tab.c"
    break;

  case 910: /* method_name_cont: dynamic_attr  */
#line 906 "filter/config.Y"
                {
     if (FM.object->type != T_ROUTE)
       cf_error("Getting a route attribute from %s, need a route", f_type_name(FM.object->type));
     (yyval.x) = f_new_inst(FI_EA_GET, FM.object, (yyvsp[0].fda));
   }
#line 10311 "obj/conf/cf-parse.tab.c"
    break;

  case 911: /* term: '(' term ')'  */
#line 914 "filter/config.Y"
                        { (yyval.x) = (yyvsp[-1].x); }
#line 10317 "obj/conf/cf-parse.tab.c"
    break;

  case 912: /* term: term '+' term  */
#line 915 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_ADD, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 10323 "obj/conf/cf-parse.tab.c"
    break;

  case 913: /* term: term '-' term  */
#line 916 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_SUBTRACT, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 10329 "obj/conf/cf-parse.tab.c"
    break;

  case 914: /* term: term '*' term  */
#line 917 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_MULTIPLY, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 10335 "obj/conf/cf-parse.tab.c"
    break;

  case 915: /* term: term '/' term  */
#line 918 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_DIVIDE, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 10341 "obj/conf/cf-parse.tab.c"
    break;

  case 916: /* term: term AND term  */
#line 919 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_AND, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 10347 "obj/conf/cf-parse.tab.c"
    break;

  case 917: /* term: term OR term  */
#line 920 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_OR, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 10353 "obj/conf/cf-parse.tab.c"
    break;

  case 918: /* term: term '=' term  */
#line 921 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_EQ, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 10359 "obj/conf/cf-parse.tab.c"
    break;

  case 919: /* term: term NEQ term  */
#line 922 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_NEQ, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 10365 "obj/conf/cf-parse.tab.c"
    break;

  case 920: /* term: term '<' term  */
#line 923 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_LT, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 10371 "obj/conf/cf-parse.tab.c"
    break;

  case 921: /* term: term LEQ term  */
#line 924 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_LTE, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 10377 "obj/conf/cf-parse.tab.c"
    break;

  case 922: /* term: term '>' term  */
#line 925 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_LT, (yyvsp[0].x), (yyvsp[-2].x)); }
#line 10383 "obj/conf/cf-parse.tab.c"
    break;

  case 923: /* term: term GEQ term  */
#line 926 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_LTE, (yyvsp[0].x), (yyvsp[-2].x)); }
#line 10389 "obj/conf/cf-parse.tab.c"
    break;

  case 924: /* term: term '~' term  */
#line 927 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_MATCH, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 10395 "obj/conf/cf-parse.tab.c"
    break;

  case 925: /* term: term NMA term  */
#line 928 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_NOT_MATCH, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 10401 "obj/conf/cf-parse.tab.c"
    break;

  case 926: /* term: '!' term  */
#line 929 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_NOT, (yyvsp[0].x)); }
#line 10407 "obj/conf/cf-parse.tab.c"
    break;

  case 927: /* term: DEFINED '(' term ')'  */
#line 930 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_DEFINED, (yyvsp[-1].x)); }
#line 10413 "obj/conf/cf-parse.tab.c"
    break;

  case 928: /* term: symbol_value  */
#line 932 "filter/config.Y"
                  { (yyval.x) = (yyvsp[0].x); }
#line 10419 "obj/conf/cf-parse.tab.c"
    break;

  case 929: /* term: constant  */
#line 933 "filter/config.Y"
            { (yyval.x) = (yyvsp[0].x); }
#line 10425 "obj/conf/cf-parse.tab.c"
    break;

  case 930: /* term: constructor  */
#line 934 "filter/config.Y"
               { (yyval.x) = (yyvsp[0].x); }
#line 10431 "obj/conf/cf-parse.tab.c"
    break;

  case 931: /* term: static_attr  */
#line 936 "filter/config.Y"
               { (yyval.x) = f_new_inst(FI_RTA_GET, f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_ROUTE, .val.rte = NULL }), (yyvsp[0].fsa)); }
#line 10437 "obj/conf/cf-parse.tab.c"
    break;

  case 932: /* term: dynamic_attr  */
#line 938 "filter/config.Y"
                { (yyval.x) = f_new_inst(FI_EA_GET, f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_ROUTE, .val.rte = NULL }), (yyvsp[0].fda)); }
#line 10443 "obj/conf/cf-parse.tab.c"
    break;

  case 934: /* term: '+' EMPTY '+'  */
#line 942 "filter/config.Y"
                 { (yyval.x) = f_new_inst(FI_CONSTANT, val_empty(T_PATH)); }
#line 10449 "obj/conf/cf-parse.tab.c"
    break;

  case 935: /* term: '-' EMPTY '-'  */
#line 943 "filter/config.Y"
                 { (yyval.x) = f_new_inst(FI_CONSTANT, val_empty(T_CLIST)); }
#line 10455 "obj/conf/cf-parse.tab.c"
    break;

  case 936: /* term: '-' '-' EMPTY '-' '-'  */
#line 944 "filter/config.Y"
                         { (yyval.x) = f_new_inst(FI_CONSTANT, val_empty(T_ECLIST)); }
#line 10461 "obj/conf/cf-parse.tab.c"
    break;

  case 937: /* term: '-' '-' '-' EMPTY '-' '-' '-'  */
#line 945 "filter/config.Y"
                                 { (yyval.x) = f_new_inst(FI_CONSTANT, val_empty(T_LCLIST)); }
#line 10467 "obj/conf/cf-parse.tab.c"
    break;

  case 938: /* term: PREPEND '(' term ',' term ')'  */
#line 947 "filter/config.Y"
                                 { (yyval.x) = f_dispatch_method_x("prepend", (yyvsp[-3].x)->type, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 10473 "obj/conf/cf-parse.tab.c"
    break;

  case 939: /* term: ADD '(' term ',' term ')'  */
#line 948 "filter/config.Y"
                             { (yyval.x) = f_dispatch_method_x("add", (yyvsp[-3].x)->type, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 10479 "obj/conf/cf-parse.tab.c"
    break;

  case 940: /* term: DELETE '(' term ',' term ')'  */
#line 949 "filter/config.Y"
                                { (yyval.x) = f_dispatch_method_x("delete", (yyvsp[-3].x)->type, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 10485 "obj/conf/cf-parse.tab.c"
    break;

  case 941: /* term: FILTER '(' term ',' term ')'  */
#line 950 "filter/config.Y"
                                { (yyval.x) = f_dispatch_method_x("filter", (yyvsp[-3].x)->type, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 10491 "obj/conf/cf-parse.tab.c"
    break;

  case 942: /* term: ROA_CHECK '(' rtable ')'  */
#line 952 "filter/config.Y"
                            { (yyval.x) = f_new_inst(FI_ROA_CHECK_IMPLICIT, (yyvsp[-1].r)); }
#line 10497 "obj/conf/cf-parse.tab.c"
    break;

  case 943: /* term: ROA_CHECK '(' rtable ',' term ',' term ')'  */
#line 953 "filter/config.Y"
                                              { (yyval.x) = f_new_inst(FI_ROA_CHECK_EXPLICIT, (yyvsp[-3].x), (yyvsp[-1].x), (yyvsp[-5].r)); }
#line 10503 "obj/conf/cf-parse.tab.c"
    break;

  case 944: /* term: ASPA_CHECK '(' rtable ',' term ',' term ')'  */
#line 954 "filter/config.Y"
                                               { (yyval.x) = f_new_inst(FI_ASPA_CHECK_EXPLICIT, (yyvsp[-3].x), (yyvsp[-1].x), (yyvsp[-5].r)); }
#line 10509 "obj/conf/cf-parse.tab.c"
    break;

  case 945: /* term: FORMAT '(' term ')'  */
#line 956 "filter/config.Y"
                       {  (yyval.x) = f_new_inst(FI_FORMAT, (yyvsp[-1].x)); }
#line 10515 "obj/conf/cf-parse.tab.c"
    break;

  case 948: /* term_bs: FROM_HEX '(' term ')'  */
#line 963 "filter/config.Y"
                         { (yyval.x) = f_new_inst(FI_FROM_HEX, (yyvsp[-1].x)); }
#line 10521 "obj/conf/cf-parse.tab.c"
    break;

  case 949: /* break_command: ACCEPT  */
#line 967 "filter/config.Y"
          { (yyval.fret) = F_ACCEPT; }
#line 10527 "obj/conf/cf-parse.tab.c"
    break;

  case 950: /* break_command: REJECT  */
#line 968 "filter/config.Y"
          { (yyval.fret) = F_REJECT; }
#line 10533 "obj/conf/cf-parse.tab.c"
    break;

  case 951: /* break_command: ERROR  */
#line 969 "filter/config.Y"
         { (yyval.fret) = F_ERROR; }
#line 10539 "obj/conf/cf-parse.tab.c"
    break;

  case 952: /* var: type symbol '=' term ';'  */
#line 973 "filter/config.Y"
                            {
     struct symbol *sym = cf_define_symbol(new_config, (yyvsp[-3].s), SYM_VARIABLE | (yyvsp[-4].i), offset, f_new_var(sym_->scope));
     (yyval.x) = f_new_inst(FI_VAR_INIT, (yyvsp[-1].x), sym);
   }
#line 10548 "obj/conf/cf-parse.tab.c"
    break;

  case 953: /* var: type symbol ';'  */
#line 977 "filter/config.Y"
                   {
     struct symbol *sym = cf_define_symbol(new_config, (yyvsp[-1].s), SYM_VARIABLE | (yyvsp[-2].i), offset, f_new_var(sym_->scope));
     (yyval.x) = f_new_inst(FI_VAR_INIT0, sym);
   }
#line 10557 "obj/conf/cf-parse.tab.c"
    break;

  case 954: /* for_var: type symbol  */
#line 984 "filter/config.Y"
               { (yyval.s) = cf_define_symbol(new_config, (yyvsp[0].s), SYM_VARIABLE | (yyvsp[-1].i), offset, f_new_var(sym_->scope)); }
#line 10563 "obj/conf/cf-parse.tab.c"
    break;

  case 955: /* for_var: CF_SYM_KNOWN  */
#line 985 "filter/config.Y"
                { cf_error("Use of a pre-defined variable in for loop is not allowed"); }
#line 10569 "obj/conf/cf-parse.tab.c"
    break;

  case 956: /* cmd: '{' cmds_scoped '}'  */
#line 989 "filter/config.Y"
                       {
     (yyval.x) = (yyvsp[-1].x);
   }
#line 10577 "obj/conf/cf-parse.tab.c"
    break;

  case 957: /* cmd: IF term THEN cmd  */
#line 992 "filter/config.Y"
                    {
     (yyval.x) = f_new_inst(FI_CONDITION, (yyvsp[-2].x), (yyvsp[0].x), NULL);
   }
#line 10585 "obj/conf/cf-parse.tab.c"
    break;

  case 958: /* cmd: IF term THEN cmd ELSE cmd  */
#line 995 "filter/config.Y"
                             {
     (yyval.x) = f_new_inst(FI_CONDITION, (yyvsp[-4].x), (yyvsp[-2].x), (yyvsp[0].x));
   }
#line 10593 "obj/conf/cf-parse.tab.c"
    break;

  case 959: /* $@8: %empty  */
#line 998 "filter/config.Y"
       {
     /* Reserve space for walk data on stack */
     cf_push_block_scope(new_config);
     new_config->current_scope->slots += 2;
   }
#line 10603 "obj/conf/cf-parse.tab.c"
    break;

  case 960: /* $@9: %empty  */
#line 1004 "filter/config.Y"
   { this_for_scope = new_config->current_scope; new_config->current_scope = this_for_scope->next; }
#line 10609 "obj/conf/cf-parse.tab.c"
    break;

  case 961: /* $@10: %empty  */
#line 1006 "filter/config.Y"
   { new_config->current_scope = this_for_scope; this_for_scope = NULL; }
#line 10615 "obj/conf/cf-parse.tab.c"
    break;

  case 962: /* cmd: FOR $@8 for_var IN $@9 term $@10 DO cmd  */
#line 1007 "filter/config.Y"
          {
     cf_pop_block_scope(new_config);
     (yyval.x) = f_for_cycle((yyvsp[-6].s), (yyvsp[-3].x), (yyvsp[0].x));
   }
#line 10624 "obj/conf/cf-parse.tab.c"
    break;

  case 963: /* cmd: symbol_known '=' term ';'  */
#line 1011 "filter/config.Y"
                             {
     switch ((yyvsp[-3].s)->class) {
       case SYM_VARIABLE_RANGE:
	 (yyval.x) = f_new_inst(FI_VAR_SET, (yyvsp[-1].x), (yyvsp[-3].s));
	 break;
       case SYM_ATTRIBUTE:
	 (yyval.x) = f_new_inst(FI_EA_SET, (yyvsp[-1].x), *(yyvsp[-3].s)->attribute);
	 break;
       default:
	 cf_error("Can't assign to symbol %s", (yyvsp[-3].s)->name);
     }
   }
#line 10641 "obj/conf/cf-parse.tab.c"
    break;

  case 964: /* cmd: RETURN term ';'  */
#line 1023 "filter/config.Y"
                   {
     DBG( "Ook, we'll return the value\n" );
     if (!this_function)
       cf_error("Can't return from a non-function, use accept or reject instead.");
     if (this_function->function->return_type == T_VOID)
     {
       if ((yyvsp[-1].x)->type != T_VOID)
	 cf_warn("Inferring function %s return type from its return value: %s", this_function->name, f_type_name((yyvsp[-1].x)->type));
       ((struct f_line *) this_function->function)->return_type = (yyvsp[-1].x)->type;
     }
     else if (this_function->function->return_type != (yyvsp[-1].x)->type)
       cf_error("Can't return type %s from function %s, expected %s",
		f_type_name((yyvsp[-1].x)->type), this_function->name, f_type_name(this_function->function->return_type));

     (yyval.x) = f_new_inst(FI_RETURN, (yyvsp[-1].x));
   }
#line 10662 "obj/conf/cf-parse.tab.c"
    break;

  case 965: /* cmd: dynamic_attr '=' term ';'  */
#line 1039 "filter/config.Y"
                             {
     (yyval.x) = f_new_inst(FI_EA_SET, (yyvsp[-1].x), (yyvsp[-3].fda));
   }
#line 10670 "obj/conf/cf-parse.tab.c"
    break;

  case 966: /* cmd: static_attr '=' term ';'  */
#line 1042 "filter/config.Y"
                            {
     if ((yyvsp[-3].fsa).readonly)
       cf_error( "This static attribute is read-only.");
     (yyval.x) = f_new_inst(FI_RTA_SET, (yyvsp[-1].x), (yyvsp[-3].fsa));
   }
#line 10680 "obj/conf/cf-parse.tab.c"
    break;

  case 967: /* cmd: UNSET '(' dynamic_attr ')' ';'  */
#line 1047 "filter/config.Y"
                                  {
     (yyval.x) = f_new_inst(FI_EA_UNSET, (yyvsp[-2].fda));
   }
#line 10688 "obj/conf/cf-parse.tab.c"
    break;

  case 968: /* cmd: UNSET '(' symbol_known ')' ';'  */
#line 1050 "filter/config.Y"
                                  {
     switch ((yyvsp[-2].s)->class) {
       case SYM_ATTRIBUTE:
	 (yyval.x) = f_new_inst(FI_EA_UNSET, *(yyvsp[-2].s)->attribute);
	 break;
       default:
	 cf_error("Can't unset symbol %s", (yyvsp[-2].s)->name);
     }
 }
#line 10702 "obj/conf/cf-parse.tab.c"
    break;

  case 969: /* cmd: break_command var_list_r ';'  */
#line 1059 "filter/config.Y"
                                {
    (yyval.x) = f_print((yyvsp[-1].x), !!(yyvsp[-1].x), (yyvsp[-2].fret));
   }
#line 10710 "obj/conf/cf-parse.tab.c"
    break;

  case 970: /* cmd: PRINT var_list_r ';'  */
#line 1062 "filter/config.Y"
                        {
    (yyval.x) = f_print((yyvsp[-1].x), 1, F_NOP);
   }
#line 10718 "obj/conf/cf-parse.tab.c"
    break;

  case 971: /* cmd: PRINTN var_list_r ';'  */
#line 1065 "filter/config.Y"
                         {
    (yyval.x) = f_print((yyvsp[-1].x), 0, F_NOP);
   }
#line 10726 "obj/conf/cf-parse.tab.c"
    break;

  case 972: /* cmd: function_call ';'  */
#line 1068 "filter/config.Y"
                     { (yyval.x) = f_new_inst(FI_DROP_RESULT, (yyvsp[-1].x)); }
#line 10732 "obj/conf/cf-parse.tab.c"
    break;

  case 973: /* cmd: CASE term '{' switch_body '}'  */
#line 1069 "filter/config.Y"
                                 {
      (yyval.x) = f_new_inst(FI_SWITCH, (yyvsp[-3].x), (yyvsp[-1].e));
   }
#line 10740 "obj/conf/cf-parse.tab.c"
    break;

  case 974: /* $@11: %empty  */
#line 1072 "filter/config.Y"
              {
     f_method_call_start(f_lval_getter(&(yyvsp[-1].flv)));
   }
#line 10748 "obj/conf/cf-parse.tab.c"
    break;

  case 975: /* cmd: lvalue '.' $@11 method_name_cont ';'  */
#line 1074 "filter/config.Y"
                          {
     f_method_call_end();
     (yyval.x) = f_lval_setter(&(yyvsp[-4].flv), (yyvsp[-1].x));
   }
#line 10757 "obj/conf/cf-parse.tab.c"
    break;

  case 976: /* cmd: BT_ASSERT '(' get_cf_position term get_cf_position ')' ';'  */
#line 1078 "filter/config.Y"
                                                              { (yyval.x) = assert_done((yyvsp[-3].x), (yyvsp[-4].t) + 1, (yyvsp[-2].t) - 1); }
#line 10763 "obj/conf/cf-parse.tab.c"
    break;

  case 977: /* cmd: BT_CHECK_ASSIGN '(' get_cf_position lvalue get_cf_position ',' term ')' ';'  */
#line 1079 "filter/config.Y"
                                                                               { (yyval.x) = assert_assign(&(yyvsp[-5].flv), (yyvsp[-2].x), (yyvsp[-6].t) + 1, (yyvsp[-4].t) - 1); }
#line 10769 "obj/conf/cf-parse.tab.c"
    break;

  case 978: /* get_cf_position: %empty  */
#line 1083 "filter/config.Y"
{
  (yyval.t) = cf_text;
}
#line 10777 "obj/conf/cf-parse.tab.c"
    break;

  case 979: /* lvalue: CF_SYM_KNOWN  */
#line 1088 "filter/config.Y"
                {
     switch ((yyvsp[0].s)->class)
     {
       case SYM_VARIABLE_RANGE:
	 (yyval.flv) = (struct f_lval) { .type = F_LVAL_VARIABLE, .sym = (yyvsp[0].s), .rte = f_const_empty(T_ROUTE) };
         break;
       case SYM_ATTRIBUTE:
         (yyval.flv) = (struct f_lval) { .type = F_LVAL_EA, .da = *((yyvsp[0].s)->attribute), .rte = f_const_empty(T_ROUTE) };
	 break;
       default:
	 cf_error("Variable name or custom attribute name required");
     }
   }
#line 10795 "obj/conf/cf-parse.tab.c"
    break;

  case 980: /* lvalue: static_attr  */
#line 1101 "filter/config.Y"
               { (yyval.flv) = (struct f_lval) { .type = F_LVAL_SA, .sa = (yyvsp[0].fsa), .rte = f_const_empty(T_ROUTE) }; }
#line 10801 "obj/conf/cf-parse.tab.c"
    break;

  case 981: /* lvalue: dynamic_attr  */
#line 1102 "filter/config.Y"
                { (yyval.flv) = (struct f_lval) { .type = F_LVAL_EA, .da = (yyvsp[0].fda), .rte = f_const_empty(T_ROUTE) }; }
#line 10807 "obj/conf/cf-parse.tab.c"
    break;

  case 983: /* rtrid: ROUTER ID idval ';'  */
#line 170 "nest/config.Y"
                       { new_config->router_id = (yyvsp[-1].i32); }
#line 10813 "obj/conf/cf-parse.tab.c"
    break;

  case 984: /* rtrid: ROUTER ID FROM iface_patt ';'  */
#line 171 "nest/config.Y"
                                 { new_config->router_id_from = this_ipatt; }
#line 10819 "obj/conf/cf-parse.tab.c"
    break;

  case 985: /* idval: NUM  */
#line 175 "nest/config.Y"
       { (yyval.i32) = (yyvsp[0].i); }
#line 10825 "obj/conf/cf-parse.tab.c"
    break;

  case 986: /* idval: '(' term ')'  */
#line 176 "nest/config.Y"
                { (yyval.i32) = cf_eval_int((yyvsp[-1].x)); }
#line 10831 "obj/conf/cf-parse.tab.c"
    break;

  case 987: /* idval: IP4  */
#line 177 "nest/config.Y"
       { (yyval.i32) = ip4_to_u32((yyvsp[0].ip4)); }
#line 10837 "obj/conf/cf-parse.tab.c"
    break;

  case 988: /* idval: CF_SYM_KNOWN  */
#line 178 "nest/config.Y"
                {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[0].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[0].s)).i;
     else if (((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP)) && ipa_is_ip4(SYM_VAL((yyvsp[0].s)).ip))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[0].s)).ip);
     else
       cf_error("Number or IPv4 address constant expected");
   }
#line 10850 "obj/conf/cf-parse.tab.c"
    break;

  case 990: /* hostname_override: HOSTNAME text ';'  */
#line 190 "nest/config.Y"
                                     { new_config->hostname = (yyvsp[-1].t); }
#line 10856 "obj/conf/cf-parse.tab.c"
    break;

  case 992: /* gr_opts: GRACEFUL RESTART WAIT expr ';'  */
#line 194 "nest/config.Y"
                                        { new_config->gr_wait = (yyvsp[-1].i); }
#line 10862 "obj/conf/cf-parse.tab.c"
    break;

  case 993: /* net_type_base: IPV4  */
#line 200 "nest/config.Y"
        { (yyval.i) = NET_IP4; }
#line 10868 "obj/conf/cf-parse.tab.c"
    break;

  case 994: /* net_type_base: IPV6  */
#line 201 "nest/config.Y"
        { (yyval.i) = NET_IP6; }
#line 10874 "obj/conf/cf-parse.tab.c"
    break;

  case 995: /* net_type_base: IPV6 SADR  */
#line 202 "nest/config.Y"
             { (yyval.i) = NET_IP6_SADR; }
#line 10880 "obj/conf/cf-parse.tab.c"
    break;

  case 996: /* net_type_base: VPN4  */
#line 203 "nest/config.Y"
        { (yyval.i) = NET_VPN4; }
#line 10886 "obj/conf/cf-parse.tab.c"
    break;

  case 997: /* net_type_base: VPN6  */
#line 204 "nest/config.Y"
        { (yyval.i) = NET_VPN6; }
#line 10892 "obj/conf/cf-parse.tab.c"
    break;

  case 998: /* net_type_base: ROA4  */
#line 205 "nest/config.Y"
        { (yyval.i) = NET_ROA4; }
#line 10898 "obj/conf/cf-parse.tab.c"
    break;

  case 999: /* net_type_base: ROA6  */
#line 206 "nest/config.Y"
        { (yyval.i) = NET_ROA6; }
#line 10904 "obj/conf/cf-parse.tab.c"
    break;

  case 1000: /* net_type_base: FLOW4  */
#line 207 "nest/config.Y"
        { (yyval.i) = NET_FLOW4; }
#line 10910 "obj/conf/cf-parse.tab.c"
    break;

  case 1001: /* net_type_base: FLOW6  */
#line 208 "nest/config.Y"
        { (yyval.i) = NET_FLOW6; }
#line 10916 "obj/conf/cf-parse.tab.c"
    break;

  case 1002: /* net_type_base: ASPA  */
#line 209 "nest/config.Y"
        { (yyval.i) = NET_ASPA; }
#line 10922 "obj/conf/cf-parse.tab.c"
    break;

  case 1004: /* net_type: MPLS  */
#line 214 "nest/config.Y"
        { (yyval.i) = NET_MPLS; }
#line 10928 "obj/conf/cf-parse.tab.c"
    break;

  case 1007: /* table_start: net_type TABLE symbol  */
#line 224 "nest/config.Y"
                                   {
   this_table = rt_new_table((yyvsp[0].s), (yyvsp[-2].i));
   }
#line 10936 "obj/conf/cf-parse.tab.c"
    break;

  case 1009: /* table_sorted: SORTED  */
#line 231 "nest/config.Y"
          { this_table->sorted = 1; }
#line 10942 "obj/conf/cf-parse.tab.c"
    break;

  case 1010: /* table_opt: SORTED bool  */
#line 235 "nest/config.Y"
               { this_table->sorted = (yyvsp[0].i); }
#line 10948 "obj/conf/cf-parse.tab.c"
    break;

  case 1011: /* table_opt: DEBUG debug_mask  */
#line 236 "nest/config.Y"
                    { this_table->debug = (yyvsp[0].i); }
#line 10954 "obj/conf/cf-parse.tab.c"
    break;

  case 1012: /* table_opt: TRIE bool  */
#line 237 "nest/config.Y"
             {
     if (!net_val_match(this_table->addr_type, NB_IP | NB_VPN | NB_ROA | NB_IP6_SADR))
       cf_error("Trie option not supported for %s table", net_label[this_table->addr_type]);
     this_table->trie_used = (yyvsp[0].i);
   }
#line 10964 "obj/conf/cf-parse.tab.c"
    break;

  case 1013: /* table_opt: MIN SETTLE TIME expr_us  */
#line 242 "nest/config.Y"
                           { this_table->min_settle_time = (yyvsp[0].time); }
#line 10970 "obj/conf/cf-parse.tab.c"
    break;

  case 1014: /* table_opt: MAX SETTLE TIME expr_us  */
#line 243 "nest/config.Y"
                           { this_table->max_settle_time = (yyvsp[0].time); }
#line 10976 "obj/conf/cf-parse.tab.c"
    break;

  case 1015: /* table_opt: GC THRESHOLD expr  */
#line 244 "nest/config.Y"
                     { this_table->gc_threshold = (yyvsp[0].i); }
#line 10982 "obj/conf/cf-parse.tab.c"
    break;

  case 1016: /* table_opt: GC PERIOD expr_us  */
#line 245 "nest/config.Y"
                     { this_table->gc_period = (uint) (yyvsp[0].time); if ((yyvsp[0].time) > 3600 S_) cf_error("GC period must be at most 3600 s"); }
#line 10988 "obj/conf/cf-parse.tab.c"
    break;

  case 1021: /* conf: proto  */
#line 261 "nest/config.Y"
            { proto_postconfig(); }
#line 10994 "obj/conf/cf-parse.tab.c"
    break;

  case 1022: /* proto_start: PROTOCOL  */
#line 264 "nest/config.Y"
            { (yyval.i) = SYM_PROTO; }
#line 11000 "obj/conf/cf-parse.tab.c"
    break;

  case 1023: /* proto_start: TEMPLATE  */
#line 265 "nest/config.Y"
            { (yyval.i) = SYM_TEMPLATE; }
#line 11006 "obj/conf/cf-parse.tab.c"
    break;

  case 1024: /* proto_name: %empty  */
#line 269 "nest/config.Y"
               {
     struct symbol *s = cf_default_name(new_config, this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->proto = this_proto;
     this_proto->name = s->name;
     }
#line 11017 "obj/conf/cf-parse.tab.c"
    break;

  case 1025: /* proto_name: symbol  */
#line 275 "nest/config.Y"
          {
     cf_define_symbol(new_config, (yyvsp[0].s), this_proto->class, proto, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 11026 "obj/conf/cf-parse.tab.c"
    break;

  case 1026: /* proto_name: FROM CF_SYM_KNOWN  */
#line 279 "nest/config.Y"
                     {
     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     struct symbol *s = cf_default_name(new_config, this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->proto = this_proto;
     this_proto->name = s->name;

     proto_copy_config(this_proto, (yyvsp[0].s)->proto);
   }
#line 11041 "obj/conf/cf-parse.tab.c"
    break;

  case 1027: /* proto_name: symbol FROM CF_SYM_KNOWN  */
#line 289 "nest/config.Y"
                            {
     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol(new_config, (yyvsp[-2].s), this_proto->class, proto, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     proto_copy_config(this_proto, (yyvsp[0].s)->proto);
   }
#line 11054 "obj/conf/cf-parse.tab.c"
    break;

  case 1029: /* proto_item: DISABLED bool  */
#line 301 "nest/config.Y"
                 { this_proto->disabled = (yyvsp[0].i); }
#line 11060 "obj/conf/cf-parse.tab.c"
    break;

  case 1030: /* proto_item: DEBUG debug_mask  */
#line 302 "nest/config.Y"
                    { this_proto->debug = (yyvsp[0].i); }
#line 11066 "obj/conf/cf-parse.tab.c"
    break;

  case 1031: /* proto_item: MRTDUMP mrtdump_mask  */
#line 303 "nest/config.Y"
                        { this_proto->mrtdump = (yyvsp[0].i); }
#line 11072 "obj/conf/cf-parse.tab.c"
    break;

  case 1032: /* proto_item: ROUTER ID idval  */
#line 304 "nest/config.Y"
                   { this_proto->router_id = (yyvsp[0].i32); }
#line 11078 "obj/conf/cf-parse.tab.c"
    break;

  case 1033: /* proto_item: HOSTNAME text  */
#line 305 "nest/config.Y"
                 { this_proto->hostname = (yyvsp[0].t); }
#line 11084 "obj/conf/cf-parse.tab.c"
    break;

  case 1034: /* proto_item: DESCRIPTION text  */
#line 306 "nest/config.Y"
                    { this_proto->dsc = (yyvsp[0].t); }
#line 11090 "obj/conf/cf-parse.tab.c"
    break;

  case 1035: /* proto_item: VRF text  */
#line 307 "nest/config.Y"
            { this_proto->vrf = if_get_by_name((yyvsp[0].t)); this_proto->vrf_set = 1; }
#line 11096 "obj/conf/cf-parse.tab.c"
    break;

  case 1036: /* proto_item: VRF DEFAULT  */
#line 308 "nest/config.Y"
               { this_proto->vrf = NULL; this_proto->vrf_set = 1; }
#line 11102 "obj/conf/cf-parse.tab.c"
    break;

  case 1037: /* channel_start: net_type_base  */
#line 313 "nest/config.Y"
{
  (yyval.cc) = this_channel = channel_config_get(NULL, net_label[(yyvsp[0].i)], (yyvsp[0].i), this_proto);
}
#line 11110 "obj/conf/cf-parse.tab.c"
    break;

  case 1038: /* channel_item_: TABLE rtable  */
#line 318 "nest/config.Y"
                {
     if (this_channel->net_type && ((yyvsp[0].r)->addr_type != this_channel->net_type))
       cf_error("Incompatible table type");
     this_channel->table = (yyvsp[0].r);
   }
#line 11120 "obj/conf/cf-parse.tab.c"
    break;

  case 1039: /* channel_item_: IMPORT imexport  */
#line 323 "nest/config.Y"
                   { this_channel->in_filter = (yyvsp[0].f); }
#line 11126 "obj/conf/cf-parse.tab.c"
    break;

  case 1040: /* channel_item_: EXPORT imexport  */
#line 324 "nest/config.Y"
                   { this_channel->out_filter = (yyvsp[0].f); }
#line 11132 "obj/conf/cf-parse.tab.c"
    break;

  case 1041: /* channel_item_: RECEIVE LIMIT limit_spec  */
#line 325 "nest/config.Y"
                            { this_channel->rx_limit = (yyvsp[0].cl); }
#line 11138 "obj/conf/cf-parse.tab.c"
    break;

  case 1042: /* channel_item_: IMPORT LIMIT limit_spec  */
#line 326 "nest/config.Y"
                           { this_channel->in_limit = (yyvsp[0].cl); }
#line 11144 "obj/conf/cf-parse.tab.c"
    break;

  case 1043: /* channel_item_: EXPORT LIMIT limit_spec  */
#line 327 "nest/config.Y"
                           { this_channel->out_limit = (yyvsp[0].cl); }
#line 11150 "obj/conf/cf-parse.tab.c"
    break;

  case 1044: /* channel_item_: PREFERENCE expr  */
#line 328 "nest/config.Y"
                   { this_channel->preference = (yyvsp[0].i); check_u16((yyvsp[0].i)); }
#line 11156 "obj/conf/cf-parse.tab.c"
    break;

  case 1045: /* channel_item_: IMPORT KEEP FILTERED bool  */
#line 329 "nest/config.Y"
                             { this_channel->in_keep_filtered = (yyvsp[0].i); }
#line 11162 "obj/conf/cf-parse.tab.c"
    break;

  case 1046: /* channel_item_: RPKI RELOAD bool  */
#line 330 "nest/config.Y"
                    { this_channel->rpki_reload = (yyvsp[0].i); }
#line 11168 "obj/conf/cf-parse.tab.c"
    break;

  case 1048: /* channel_item: DEBUG debug_mask  */
#line 336 "nest/config.Y"
                    { this_channel->debug = (yyvsp[0].i); }
#line 11174 "obj/conf/cf-parse.tab.c"
    break;

  case 1053: /* channel_end: %empty  */
#line 350 "nest/config.Y"
{
  if (!this_channel->table)
    cf_error("Routing table not specified");

  this_channel = NULL;
}
#line 11185 "obj/conf/cf-parse.tab.c"
    break;

  case 1055: /* rtable: CF_SYM_KNOWN  */
#line 360 "nest/config.Y"
                     { cf_assert_symbol((yyvsp[0].s), SYM_TABLE); (yyval.r) = (yyvsp[0].s)->table; }
#line 11191 "obj/conf/cf-parse.tab.c"
    break;

  case 1056: /* imexport: FILTER filter  */
#line 363 "nest/config.Y"
                 { (yyval.f) = (yyvsp[0].f); }
#line 11197 "obj/conf/cf-parse.tab.c"
    break;

  case 1058: /* imexport: ALL  */
#line 365 "nest/config.Y"
       { (yyval.f) = FILTER_ACCEPT; }
#line 11203 "obj/conf/cf-parse.tab.c"
    break;

  case 1059: /* imexport: NONE  */
#line 366 "nest/config.Y"
        { (yyval.f) = FILTER_REJECT; }
#line 11209 "obj/conf/cf-parse.tab.c"
    break;

  case 1060: /* limit_action: %empty  */
#line 370 "nest/config.Y"
                 { (yyval.i) = PLA_DISABLE; }
#line 11215 "obj/conf/cf-parse.tab.c"
    break;

  case 1061: /* limit_action: ACTION WARN  */
#line 371 "nest/config.Y"
               { (yyval.i) = PLA_WARN; }
#line 11221 "obj/conf/cf-parse.tab.c"
    break;

  case 1062: /* limit_action: ACTION BLOCK  */
#line 372 "nest/config.Y"
                { (yyval.i) = PLA_BLOCK; }
#line 11227 "obj/conf/cf-parse.tab.c"
    break;

  case 1063: /* limit_action: ACTION RESTART  */
#line 373 "nest/config.Y"
                  { (yyval.i) = PLA_RESTART; }
#line 11233 "obj/conf/cf-parse.tab.c"
    break;

  case 1064: /* limit_action: ACTION DISABLE  */
#line 374 "nest/config.Y"
                  { (yyval.i) = PLA_DISABLE; }
#line 11239 "obj/conf/cf-parse.tab.c"
    break;

  case 1065: /* limit_spec: expr limit_action  */
#line 378 "nest/config.Y"
                     { (yyval.cl) = (struct channel_limit){ .limit = (yyvsp[-1].i), (yyval.cl).action = (yyvsp[0].i) }; }
#line 11245 "obj/conf/cf-parse.tab.c"
    break;

  case 1066: /* limit_spec: OFF  */
#line 379 "nest/config.Y"
       { (yyval.cl) = (struct channel_limit){}; }
#line 11251 "obj/conf/cf-parse.tab.c"
    break;

  case 1068: /* debug_default: DEBUG PROTOCOLS debug_mask  */
#line 386 "nest/config.Y"
                              { new_config->proto_default_debug = (yyvsp[0].i); }
#line 11257 "obj/conf/cf-parse.tab.c"
    break;

  case 1069: /* debug_default: DEBUG CHANNELS debug_mask  */
#line 387 "nest/config.Y"
                             { new_config->channel_default_debug = (yyvsp[0].i); }
#line 11263 "obj/conf/cf-parse.tab.c"
    break;

  case 1070: /* debug_default: DEBUG TABLES debug_mask  */
#line 388 "nest/config.Y"
                           { new_config->table_default_debug = (yyvsp[0].i); }
#line 11269 "obj/conf/cf-parse.tab.c"
    break;

  case 1071: /* debug_default: DEBUG COMMANDS expr  */
#line 389 "nest/config.Y"
                       { new_config->cli_debug = (yyvsp[0].i); }
#line 11275 "obj/conf/cf-parse.tab.c"
    break;

  case 1073: /* timeformat_base: TIMEFORMAT timeformat_which timeformat_spec ';'  */
#line 397 "nest/config.Y"
                                                   { *(yyvsp[-2].tfp) = (yyvsp[-1].tf); }
#line 11281 "obj/conf/cf-parse.tab.c"
    break;

  case 1074: /* timeformat_which: ROUTE  */
#line 401 "nest/config.Y"
         { (yyval.tfp) = &new_config->tf_route; }
#line 11287 "obj/conf/cf-parse.tab.c"
    break;

  case 1075: /* timeformat_which: PROTOCOL  */
#line 402 "nest/config.Y"
            { (yyval.tfp) = &new_config->tf_proto; }
#line 11293 "obj/conf/cf-parse.tab.c"
    break;

  case 1076: /* timeformat_which: BASE  */
#line 403 "nest/config.Y"
        { (yyval.tfp) = &new_config->tf_base; }
#line 11299 "obj/conf/cf-parse.tab.c"
    break;

  case 1077: /* timeformat_which: LOG  */
#line 404 "nest/config.Y"
       { (yyval.tfp) = &new_config->tf_log; }
#line 11305 "obj/conf/cf-parse.tab.c"
    break;

  case 1078: /* timeformat_spec: TEXT  */
#line 408 "nest/config.Y"
        { (yyval.tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 11311 "obj/conf/cf-parse.tab.c"
    break;

  case 1079: /* timeformat_spec: TEXT expr TEXT  */
#line 409 "nest/config.Y"
                  { (yyval.tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (s64) (yyvsp[-1].i) S_}; }
#line 11317 "obj/conf/cf-parse.tab.c"
    break;

  case 1080: /* timeformat_spec: ISO SHORT  */
#line 410 "nest/config.Y"
                { (yyval.tf) = TM_ISO_SHORT_S; }
#line 11323 "obj/conf/cf-parse.tab.c"
    break;

  case 1081: /* timeformat_spec: ISO SHORT MS  */
#line 411 "nest/config.Y"
                { (yyval.tf) = TM_ISO_SHORT_MS; }
#line 11329 "obj/conf/cf-parse.tab.c"
    break;

  case 1082: /* timeformat_spec: ISO SHORT US  */
#line 412 "nest/config.Y"
                { (yyval.tf) = TM_ISO_SHORT_US; }
#line 11335 "obj/conf/cf-parse.tab.c"
    break;

  case 1083: /* timeformat_spec: ISO LONG  */
#line 413 "nest/config.Y"
                { (yyval.tf) = TM_ISO_LONG_S; }
#line 11341 "obj/conf/cf-parse.tab.c"
    break;

  case 1084: /* timeformat_spec: ISO LONG MS  */
#line 414 "nest/config.Y"
                { (yyval.tf) = TM_ISO_LONG_MS; }
#line 11347 "obj/conf/cf-parse.tab.c"
    break;

  case 1085: /* timeformat_spec: ISO LONG US  */
#line 415 "nest/config.Y"
                { (yyval.tf) = TM_ISO_LONG_US; }
#line 11353 "obj/conf/cf-parse.tab.c"
    break;

  case 1086: /* iface_patt_node_init: %empty  */
#line 422 "nest/config.Y"
               {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 11363 "obj/conf/cf-parse.tab.c"
    break;

  case 1087: /* iface_patt_node_body: TEXT  */
#line 430 "nest/config.Y"
        { this_ipn->pattern = (yyvsp[0].t); /* this_ipn->prefix stays zero */ }
#line 11369 "obj/conf/cf-parse.tab.c"
    break;

  case 1088: /* iface_patt_node_body: opttext net_or_ipa  */
#line 431 "nest/config.Y"
                      { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].net); }
#line 11375 "obj/conf/cf-parse.tab.c"
    break;

  case 1089: /* iface_negate: %empty  */
#line 435 "nest/config.Y"
       { this_ipn->positive = 1; }
#line 11381 "obj/conf/cf-parse.tab.c"
    break;

  case 1090: /* iface_negate: '-'  */
#line 436 "nest/config.Y"
       { this_ipn->positive = 0; }
#line 11387 "obj/conf/cf-parse.tab.c"
    break;

  case 1094: /* iface_patt_list_nopx: iface_patt_list  */
#line 450 "nest/config.Y"
                                      { iface_patt_check(); }
#line 11393 "obj/conf/cf-parse.tab.c"
    break;

  case 1095: /* iface_patt_init: %empty  */
#line 452 "nest/config.Y"
                 {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 11403 "obj/conf/cf-parse.tab.c"
    break;

  case 1097: /* tos: CLASS expr  */
#line 464 "nest/config.Y"
              { (yyval.i) = (yyvsp[0].i) & 0xfc;        if ((yyvsp[0].i) > 255) cf_error("TX class must be in range 0-255"); }
#line 11409 "obj/conf/cf-parse.tab.c"
    break;

  case 1098: /* tos: DSCP expr  */
#line 465 "nest/config.Y"
              { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if ((yyvsp[0].i) > 63)  cf_error("TX DSCP must be in range 0-63"); }
#line 11415 "obj/conf/cf-parse.tab.c"
    break;

  case 1100: /* dev_proto_start: proto_start DIRECT  */
#line 472 "nest/config.Y"
                                    {
     this_proto = proto_config_new(&proto_device, (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 11424 "obj/conf/cf-parse.tab.c"
    break;

  case 1105: /* dev_proto: dev_proto CHECK LINK bool ';'  */
#line 483 "nest/config.Y"
                                 { DIRECT_CFG->check_link = (yyvsp[-1].i); }
#line 11430 "obj/conf/cf-parse.tab.c"
    break;

  case 1106: /* dev_iface_init: %empty  */
#line 487 "nest/config.Y"
               {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 11440 "obj/conf/cf-parse.tab.c"
    break;

  case 1108: /* debug_mask: ALL  */
#line 501 "nest/config.Y"
       { (yyval.i) = ~0; }
#line 11446 "obj/conf/cf-parse.tab.c"
    break;

  case 1109: /* debug_mask: OFF  */
#line 502 "nest/config.Y"
       { (yyval.i) = 0; }
#line 11452 "obj/conf/cf-parse.tab.c"
    break;

  case 1110: /* debug_mask: '{' debug_list '}'  */
#line 503 "nest/config.Y"
                      { (yyval.i) = (yyvsp[-1].i); }
#line 11458 "obj/conf/cf-parse.tab.c"
    break;

  case 1112: /* debug_list: debug_list ',' debug_flag  */
#line 508 "nest/config.Y"
                             { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 11464 "obj/conf/cf-parse.tab.c"
    break;

  case 1113: /* debug_flag: STATES  */
#line 512 "nest/config.Y"
                { (yyval.i) = D_STATES; }
#line 11470 "obj/conf/cf-parse.tab.c"
    break;

  case 1114: /* debug_flag: ROUTES  */
#line 513 "nest/config.Y"
                { (yyval.i) = D_ROUTES; }
#line 11476 "obj/conf/cf-parse.tab.c"
    break;

  case 1115: /* debug_flag: FILTERS  */
#line 514 "nest/config.Y"
                { (yyval.i) = D_FILTERS; }
#line 11482 "obj/conf/cf-parse.tab.c"
    break;

  case 1116: /* debug_flag: INTERFACES  */
#line 515 "nest/config.Y"
                { (yyval.i) = D_IFACES; }
#line 11488 "obj/conf/cf-parse.tab.c"
    break;

  case 1117: /* debug_flag: EVENTS  */
#line 516 "nest/config.Y"
                { (yyval.i) = D_EVENTS; }
#line 11494 "obj/conf/cf-parse.tab.c"
    break;

  case 1118: /* debug_flag: PACKETS  */
#line 517 "nest/config.Y"
                { (yyval.i) = D_PACKETS; }
#line 11500 "obj/conf/cf-parse.tab.c"
    break;

  case 1119: /* mrtdump_mask: ALL  */
#line 523 "nest/config.Y"
       { (yyval.i) = ~0; }
#line 11506 "obj/conf/cf-parse.tab.c"
    break;

  case 1120: /* mrtdump_mask: OFF  */
#line 524 "nest/config.Y"
       { (yyval.i) = 0; }
#line 11512 "obj/conf/cf-parse.tab.c"
    break;

  case 1121: /* mrtdump_mask: '{' mrtdump_list '}'  */
#line 525 "nest/config.Y"
                        { (yyval.i) = (yyvsp[-1].i); }
#line 11518 "obj/conf/cf-parse.tab.c"
    break;

  case 1123: /* mrtdump_list: mrtdump_list ',' mrtdump_flag  */
#line 530 "nest/config.Y"
                                 { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 11524 "obj/conf/cf-parse.tab.c"
    break;

  case 1124: /* mrtdump_flag: STATES  */
#line 534 "nest/config.Y"
                { (yyval.i) = MD_STATES; }
#line 11530 "obj/conf/cf-parse.tab.c"
    break;

  case 1125: /* mrtdump_flag: MESSAGES  */
#line 535 "nest/config.Y"
                { (yyval.i) = MD_MESSAGES; }
#line 11536 "obj/conf/cf-parse.tab.c"
    break;

  case 1135: /* password_item_begin: pass_key bytestring_text  */
#line 562 "nest/config.Y"
{
  init_password_list();
  if ((yyvsp[0].v).type == T_BYTESTRING)
    init_password((yyvsp[0].v).val.bs->data, (yyvsp[0].v).val.bs->length, password_id++);
  else if ((yyvsp[0].v).type == T_STRING)
    init_password((yyvsp[0].v).val.s, strlen((yyvsp[0].v).val.s), password_id++);
  else bug("Bad bytestring_text");
}
#line 11549 "obj/conf/cf-parse.tab.c"
    break;

  case 1136: /* password_item_params: %empty  */
#line 572 "nest/config.Y"
               { }
#line 11555 "obj/conf/cf-parse.tab.c"
    break;

  case 1137: /* password_item_params: GENERATE FROM time ';' password_item_params  */
#line 573 "nest/config.Y"
                                               { this_p_item->genfrom = (yyvsp[-2].time); }
#line 11561 "obj/conf/cf-parse.tab.c"
    break;

  case 1138: /* password_item_params: GENERATE TO time ';' password_item_params  */
#line 574 "nest/config.Y"
                                             { this_p_item->gento = (yyvsp[-2].time); }
#line 11567 "obj/conf/cf-parse.tab.c"
    break;

  case 1139: /* password_item_params: ACCEPT FROM time ';' password_item_params  */
#line 575 "nest/config.Y"
                                             { this_p_item->accfrom = (yyvsp[-2].time); }
#line 11573 "obj/conf/cf-parse.tab.c"
    break;

  case 1140: /* password_item_params: ACCEPT TO time ';' password_item_params  */
#line 576 "nest/config.Y"
                                           { this_p_item->accto = (yyvsp[-2].time); }
#line 11579 "obj/conf/cf-parse.tab.c"
    break;

  case 1141: /* password_item_params: FROM time ';' password_item_params  */
#line 577 "nest/config.Y"
                                      { this_p_item->genfrom = this_p_item->accfrom = (yyvsp[-2].time); }
#line 11585 "obj/conf/cf-parse.tab.c"
    break;

  case 1142: /* password_item_params: TO time ';' password_item_params  */
#line 578 "nest/config.Y"
                                    { this_p_item->gento = this_p_item->accto = (yyvsp[-2].time); }
#line 11591 "obj/conf/cf-parse.tab.c"
    break;

  case 1143: /* password_item_params: ID expr ';' password_item_params  */
#line 579 "nest/config.Y"
                                    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) > 255) cf_error("Password ID must be in range 0-255"); }
#line 11597 "obj/conf/cf-parse.tab.c"
    break;

  case 1144: /* password_item_params: ALGORITHM password_algorithm ';' password_item_params  */
#line 580 "nest/config.Y"
                                                         { this_p_item->alg = (yyvsp[-2].i); }
#line 11603 "obj/conf/cf-parse.tab.c"
    break;

  case 1145: /* password_algorithm: KEYED MD5  */
#line 584 "nest/config.Y"
                { (yyval.i) = ALG_MD5; }
#line 11609 "obj/conf/cf-parse.tab.c"
    break;

  case 1146: /* password_algorithm: KEYED SHA1  */
#line 585 "nest/config.Y"
                { (yyval.i) = ALG_SHA1; }
#line 11615 "obj/conf/cf-parse.tab.c"
    break;

  case 1147: /* password_algorithm: KEYED SHA256  */
#line 586 "nest/config.Y"
                { (yyval.i) = ALG_SHA256; }
#line 11621 "obj/conf/cf-parse.tab.c"
    break;

  case 1148: /* password_algorithm: KEYED SHA384  */
#line 587 "nest/config.Y"
                { (yyval.i) = ALG_SHA384; }
#line 11627 "obj/conf/cf-parse.tab.c"
    break;

  case 1149: /* password_algorithm: KEYED SHA512  */
#line 588 "nest/config.Y"
                { (yyval.i) = ALG_SHA512; }
#line 11633 "obj/conf/cf-parse.tab.c"
    break;

  case 1150: /* password_algorithm: HMAC MD5  */
#line 589 "nest/config.Y"
                { (yyval.i) = ALG_HMAC_MD5; }
#line 11639 "obj/conf/cf-parse.tab.c"
    break;

  case 1151: /* password_algorithm: HMAC SHA1  */
#line 590 "nest/config.Y"
                { (yyval.i) = ALG_HMAC_SHA1; }
#line 11645 "obj/conf/cf-parse.tab.c"
    break;

  case 1152: /* password_algorithm: HMAC SHA256  */
#line 591 "nest/config.Y"
                { (yyval.i) = ALG_HMAC_SHA256; }
#line 11651 "obj/conf/cf-parse.tab.c"
    break;

  case 1153: /* password_algorithm: HMAC SHA384  */
#line 592 "nest/config.Y"
                { (yyval.i) = ALG_HMAC_SHA384; }
#line 11657 "obj/conf/cf-parse.tab.c"
    break;

  case 1154: /* password_algorithm: HMAC SHA512  */
#line 593 "nest/config.Y"
                { (yyval.i) = ALG_HMAC_SHA512; }
#line 11663 "obj/conf/cf-parse.tab.c"
    break;

  case 1155: /* password_algorithm: BLAKE2S128  */
#line 594 "nest/config.Y"
                { (yyval.i) = ALG_BLAKE2S_128; }
#line 11669 "obj/conf/cf-parse.tab.c"
    break;

  case 1156: /* password_algorithm: BLAKE2S256  */
#line 595 "nest/config.Y"
                { (yyval.i) = ALG_BLAKE2S_256; }
#line 11675 "obj/conf/cf-parse.tab.c"
    break;

  case 1157: /* password_algorithm: BLAKE2B256  */
#line 596 "nest/config.Y"
                { (yyval.i) = ALG_BLAKE2B_256; }
#line 11681 "obj/conf/cf-parse.tab.c"
    break;

  case 1158: /* password_algorithm: BLAKE2B512  */
#line 597 "nest/config.Y"
                { (yyval.i) = ALG_BLAKE2B_512; }
#line 11687 "obj/conf/cf-parse.tab.c"
    break;

  case 1159: /* password_item_end: %empty  */
#line 601 "nest/config.Y"
{
  password_validate_length(this_p_item);
}
#line 11695 "obj/conf/cf-parse.tab.c"
    break;

  case 1162: /* cmd_SHOW_STATUS: SHOW STATUS END  */
#line 614 "nest/config.Y"
{ cmd_show_status(); }
#line 11701 "obj/conf/cf-parse.tab.c"
    break;

  case 1164: /* cmd_SHOW_MEMORY: SHOW MEMORY END  */
#line 617 "nest/config.Y"
{ cmd_show_memory(); }
#line 11707 "obj/conf/cf-parse.tab.c"
    break;

  case 1166: /* cmd_SHOW_PROTOCOLS: SHOW PROTOCOLS proto_patt2 END  */
#line 620 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 11713 "obj/conf/cf-parse.tab.c"
    break;

  case 1168: /* cmd_SHOW_PROTOCOLS_ALL: SHOW PROTOCOLS ALL proto_patt2 END  */
#line 623 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 11719 "obj/conf/cf-parse.tab.c"
    break;

  case 1169: /* optproto: CF_SYM_KNOWN  */
#line 626 "nest/config.Y"
                { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.s) = (yyvsp[0].s); }
#line 11725 "obj/conf/cf-parse.tab.c"
    break;

  case 1170: /* optproto: %empty  */
#line 627 "nest/config.Y"
               { (yyval.s) = NULL; }
#line 11731 "obj/conf/cf-parse.tab.c"
    break;

  case 1172: /* cmd_SHOW_INTERFACES: SHOW INTERFACES END  */
#line 631 "nest/config.Y"
{ if_show(); }
#line 11737 "obj/conf/cf-parse.tab.c"
    break;

  case 1174: /* cmd_SHOW_INTERFACES_SUMMARY: SHOW INTERFACES SUMMARY END  */
#line 634 "nest/config.Y"
{ if_show_summary(); }
#line 11743 "obj/conf/cf-parse.tab.c"
    break;

  case 1176: /* cmd_SHOW_ROUTE: SHOW ROUTE r_args END  */
#line 638 "nest/config.Y"
{ rt_show((yyvsp[-1].ra)); }
#line 11749 "obj/conf/cf-parse.tab.c"
    break;

  case 1177: /* r_args: %empty  */
#line 658 "nest/config.Y"
               {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     init_list(&((yyval.ra)->tables));
     (yyval.ra)->filter = FILTER_ACCEPT;
     (yyval.ra)->running_on_config = config;
   }
#line 11760 "obj/conf/cf-parse.tab.c"
    break;

  case 1178: /* r_args: r_args net_any  */
#line 664 "nest/config.Y"
                  {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->addr) cf_error("Only one prefix expected");
     (yyval.ra)->addr = (yyvsp[0].net_ptr);
     (yyval.ra)->addr_mode = RSD_ADDR_EQUAL;
   }
#line 11771 "obj/conf/cf-parse.tab.c"
    break;

  case 1179: /* r_args: r_args FOR r_args_for  */
#line 670 "nest/config.Y"
                         {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->addr) cf_error("Only one prefix expected");
     (yyval.ra)->addr = (yyvsp[0].net_ptr);
     (yyval.ra)->addr_mode = RSD_ADDR_FOR;
   }
#line 11782 "obj/conf/cf-parse.tab.c"
    break;

  case 1180: /* r_args: r_args IN net_any  */
#line 676 "nest/config.Y"
                     {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->addr) cf_error("Only one prefix expected");
     if (!net_type_match((yyvsp[0].net_ptr), NB_IP)) cf_error("Only IP networks accepted for 'in' argument");
     (yyval.ra)->addr = (yyvsp[0].net_ptr);
     (yyval.ra)->addr_mode = RSD_ADDR_IN;
   }
#line 11794 "obj/conf/cf-parse.tab.c"
    break;

  case 1181: /* r_args: r_args TABLE symbol_known  */
#line 683 "nest/config.Y"
                            {
     cf_assert_symbol((yyvsp[0].s), SYM_TABLE);
     (yyval.ra) = (yyvsp[-2].ra);
     rt_show_add_table((yyval.ra), (yyvsp[0].s)->table->table);
     (yyval.ra)->tables_defined_by = RSD_TDB_DIRECT;
   }
#line 11805 "obj/conf/cf-parse.tab.c"
    break;

  case 1182: /* r_args: r_args TABLE ALL  */
#line 689 "nest/config.Y"
                    {
     struct rtable_config *t;
     (yyval.ra) = (yyvsp[-2].ra);
     WALK_LIST(t, config->tables)
       rt_show_add_table((yyval.ra), t->table);
     (yyval.ra)->tables_defined_by = RSD_TDB_ALL;
   }
#line 11817 "obj/conf/cf-parse.tab.c"
    break;

  case 1183: /* r_args: r_args IMPORT TABLE channel_arg  */
#line 696 "nest/config.Y"
                                   {
     if (!(yyvsp[0].c)->in_table) cf_error("No import table in channel %s.%s", (yyvsp[0].c)->proto->name, (yyvsp[0].c)->name);
     rt_show_add_table((yyval.ra), (yyvsp[0].c)->in_table);
     (yyval.ra)->tables_defined_by = RSD_TDB_DIRECT;
   }
#line 11827 "obj/conf/cf-parse.tab.c"
    break;

  case 1184: /* r_args: r_args EXPORT TABLE channel_arg  */
#line 701 "nest/config.Y"
                                   {
     if (!(yyvsp[0].c)->out_table) cf_error("No export table in channel %s.%s", (yyvsp[0].c)->proto->name, (yyvsp[0].c)->name);
     rt_show_add_table((yyval.ra), (yyvsp[0].c)->out_table);
     (yyval.ra)->tables_defined_by = RSD_TDB_DIRECT;
   }
#line 11837 "obj/conf/cf-parse.tab.c"
    break;

  case 1185: /* r_args: r_args FILTER filter  */
#line 706 "nest/config.Y"
                        {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 11847 "obj/conf/cf-parse.tab.c"
    break;

  case 1186: /* r_args: r_args where_filter  */
#line 711 "nest/config.Y"
                       {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 11857 "obj/conf/cf-parse.tab.c"
    break;

  case 1187: /* r_args: r_args ALL  */
#line 716 "nest/config.Y"
              {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 11866 "obj/conf/cf-parse.tab.c"
    break;

  case 1188: /* r_args: r_args PRIMARY  */
#line 720 "nest/config.Y"
                  {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 11875 "obj/conf/cf-parse.tab.c"
    break;

  case 1189: /* r_args: r_args FILTERED  */
#line 724 "nest/config.Y"
                   {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 11884 "obj/conf/cf-parse.tab.c"
    break;

  case 1190: /* r_args: r_args export_mode symbol_known  */
#line 728 "nest/config.Y"
                                   {
     cf_assert_symbol((yyvsp[0].s), SYM_PROTO);
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->proto;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Export specified twice");
     if (!c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   }
#line 11899 "obj/conf/cf-parse.tab.c"
    break;

  case 1191: /* r_args: r_args export_mode channel_arg  */
#line 738 "nest/config.Y"
                                  {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Export specified twice");
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_channel = (yyvsp[0].c);
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   }
#line 11911 "obj/conf/cf-parse.tab.c"
    break;

  case 1192: /* r_args: r_args PROTOCOL symbol_known  */
#line 745 "nest/config.Y"
                                {
     cf_assert_symbol((yyvsp[0].s), SYM_PROTO);
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->proto;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if (!c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   }
#line 11925 "obj/conf/cf-parse.tab.c"
    break;

  case 1193: /* r_args: r_args STATS  */
#line 754 "nest/config.Y"
                {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 11934 "obj/conf/cf-parse.tab.c"
    break;

  case 1194: /* r_args: r_args COUNT  */
#line 758 "nest/config.Y"
                {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 11943 "obj/conf/cf-parse.tab.c"
    break;

  case 1195: /* r_args_for: r_args_for_val  */
#line 765 "nest/config.Y"
                 {
    (yyval.net_ptr) = cfg_alloc((yyvsp[0].net).length);
    net_copy((yyval.net_ptr), &(yyvsp[0].net));
  }
#line 11952 "obj/conf/cf-parse.tab.c"
    break;

  case 1199: /* r_args_for: VPN_RD IP4  */
#line 772 "nest/config.Y"
              {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn4));
    net_fill_vpn4((yyval.net_ptr), (yyvsp[0].ip4), IP4_MAX_PREFIX_LENGTH, (yyvsp[-1].rd));
  }
#line 11961 "obj/conf/cf-parse.tab.c"
    break;

  case 1200: /* r_args_for: VPN_RD IP6  */
#line 776 "nest/config.Y"
              {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn6));
    net_fill_vpn6((yyval.net_ptr), (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH, (yyvsp[-1].rd));
  }
#line 11970 "obj/conf/cf-parse.tab.c"
    break;

  case 1201: /* r_args_for: IP6 FROM IP6  */
#line 780 "nest/config.Y"
                {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_ip6_sadr));
    net_fill_ip6_sadr((yyval.net_ptr), (yyvsp[-2].ip6), IP6_MAX_PREFIX_LENGTH, (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH);
  }
#line 11979 "obj/conf/cf-parse.tab.c"
    break;

  case 1202: /* r_args_for: CF_SYM_KNOWN  */
#line 784 "nest/config.Y"
                {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
     {
       (yyval.net_ptr) = cfg_alloc(ipa_is_ip4(SYM_VAL((yyvsp[0].s)).ip) ? sizeof(net_addr_ip4) : sizeof(net_addr_ip6));
       net_fill_ip_host((yyval.net_ptr), SYM_VAL((yyvsp[0].s)).ip);
     }
     else if (((yyvsp[0].s)->class == (SYM_CONSTANT | T_NET)) && net_type_match(SYM_VAL((yyvsp[0].s)).net, NB_IP | NB_VPN))
       (yyval.net_ptr) = (net_addr *) SYM_VAL((yyvsp[0].s)).net; /* Avoid const warning */
     else
       cf_error("IP address or network constant expected");
   }
#line 11995 "obj/conf/cf-parse.tab.c"
    break;

  case 1205: /* r_args_for_val: IP4  */
#line 800 "nest/config.Y"
       { net_fill_ip4(&((yyval.net)), (yyvsp[0].ip4), IP4_MAX_PREFIX_LENGTH); }
#line 12001 "obj/conf/cf-parse.tab.c"
    break;

  case 1206: /* r_args_for_val: IP6  */
#line 801 "nest/config.Y"
       { net_fill_ip6(&((yyval.net)), (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH); }
#line 12007 "obj/conf/cf-parse.tab.c"
    break;

  case 1207: /* export_mode: PREEXPORT  */
#line 804 "nest/config.Y"
                { (yyval.i) = RSEM_PREEXPORT; }
#line 12013 "obj/conf/cf-parse.tab.c"
    break;

  case 1208: /* export_mode: EXPORT  */
#line 805 "nest/config.Y"
                { (yyval.i) = RSEM_EXPORT; }
#line 12019 "obj/conf/cf-parse.tab.c"
    break;

  case 1209: /* export_mode: NOEXPORT  */
#line 806 "nest/config.Y"
                { (yyval.i) = RSEM_NOEXPORT; }
#line 12025 "obj/conf/cf-parse.tab.c"
    break;

  case 1210: /* export_mode: EXPORTED  */
#line 807 "nest/config.Y"
                { (yyval.i) = RSEM_EXPORTED; }
#line 12031 "obj/conf/cf-parse.tab.c"
    break;

  case 1211: /* channel_sym: IPV4  */
#line 812 "nest/config.Y"
                { (yyval.t) = "ipv4"; }
#line 12037 "obj/conf/cf-parse.tab.c"
    break;

  case 1212: /* channel_sym: IPV4_MC  */
#line 813 "nest/config.Y"
                { (yyval.t) = "ipv4-mc"; }
#line 12043 "obj/conf/cf-parse.tab.c"
    break;

  case 1213: /* channel_sym: IPV4_MPLS  */
#line 814 "nest/config.Y"
                { (yyval.t) = "ipv4-mpls"; }
#line 12049 "obj/conf/cf-parse.tab.c"
    break;

  case 1214: /* channel_sym: IPV6  */
#line 815 "nest/config.Y"
                { (yyval.t) = "ipv6"; }
#line 12055 "obj/conf/cf-parse.tab.c"
    break;

  case 1215: /* channel_sym: IPV6_MC  */
#line 816 "nest/config.Y"
                { (yyval.t) = "ipv6-mc"; }
#line 12061 "obj/conf/cf-parse.tab.c"
    break;

  case 1216: /* channel_sym: IPV6_MPLS  */
#line 817 "nest/config.Y"
                { (yyval.t) = "ipv6-mpls"; }
#line 12067 "obj/conf/cf-parse.tab.c"
    break;

  case 1217: /* channel_sym: IPV6_SADR  */
#line 818 "nest/config.Y"
                { (yyval.t) = "ipv6-sadr"; }
#line 12073 "obj/conf/cf-parse.tab.c"
    break;

  case 1218: /* channel_sym: VPN4  */
#line 819 "nest/config.Y"
                { (yyval.t) = "vpn4"; }
#line 12079 "obj/conf/cf-parse.tab.c"
    break;

  case 1219: /* channel_sym: VPN4_MC  */
#line 820 "nest/config.Y"
                { (yyval.t) = "vpn4-mc"; }
#line 12085 "obj/conf/cf-parse.tab.c"
    break;

  case 1220: /* channel_sym: VPN4_MPLS  */
#line 821 "nest/config.Y"
                { (yyval.t) = "vpn4-mpls"; }
#line 12091 "obj/conf/cf-parse.tab.c"
    break;

  case 1221: /* channel_sym: VPN6  */
#line 822 "nest/config.Y"
                { (yyval.t) = "vpn6"; }
#line 12097 "obj/conf/cf-parse.tab.c"
    break;

  case 1222: /* channel_sym: VPN6_MC  */
#line 823 "nest/config.Y"
                { (yyval.t) = "vpn6-mc"; }
#line 12103 "obj/conf/cf-parse.tab.c"
    break;

  case 1223: /* channel_sym: VPN6_MPLS  */
#line 824 "nest/config.Y"
                { (yyval.t) = "vpn6-mpls"; }
#line 12109 "obj/conf/cf-parse.tab.c"
    break;

  case 1224: /* channel_sym: ROA4  */
#line 825 "nest/config.Y"
                { (yyval.t) = "roa4"; }
#line 12115 "obj/conf/cf-parse.tab.c"
    break;

  case 1225: /* channel_sym: ROA6  */
#line 826 "nest/config.Y"
                { (yyval.t) = "roa6"; }
#line 12121 "obj/conf/cf-parse.tab.c"
    break;

  case 1226: /* channel_sym: FLOW4  */
#line 827 "nest/config.Y"
                { (yyval.t) = "flow4"; }
#line 12127 "obj/conf/cf-parse.tab.c"
    break;

  case 1227: /* channel_sym: FLOW6  */
#line 828 "nest/config.Y"
                { (yyval.t) = "flow6"; }
#line 12133 "obj/conf/cf-parse.tab.c"
    break;

  case 1228: /* channel_sym: MPLS  */
#line 829 "nest/config.Y"
                { (yyval.t) = "mpls"; }
#line 12139 "obj/conf/cf-parse.tab.c"
    break;

  case 1229: /* channel_sym: ASPA  */
#line 830 "nest/config.Y"
                { (yyval.t) = "aspa"; }
#line 12145 "obj/conf/cf-parse.tab.c"
    break;

  case 1230: /* channel_sym: PRI  */
#line 831 "nest/config.Y"
                { (yyval.t) = "pri"; }
#line 12151 "obj/conf/cf-parse.tab.c"
    break;

  case 1231: /* channel_sym: SEC  */
#line 832 "nest/config.Y"
                { (yyval.t) = "sec"; }
#line 12157 "obj/conf/cf-parse.tab.c"
    break;

  case 1232: /* channel_arg: CF_SYM_KNOWN '.' channel_sym  */
#line 836 "nest/config.Y"
                                {
     cf_assert_symbol((yyvsp[-2].s), SYM_PROTO);
     struct proto *p =  (yyvsp[-2].s)->proto->proto;
     if (!p) cf_error("%s is not a protocol", (yyvsp[-2].s)->name);
     (yyval.c) = proto_find_channel_by_name(p, (yyvsp[0].t));
     if (!(yyval.c)) cf_error("Channel %s.%s not found", (yyvsp[-2].s)->name, (yyvsp[0].t));
   }
#line 12169 "obj/conf/cf-parse.tab.c"
    break;

  case 1234: /* cmd_SHOW_SYMBOLS: SHOW SYMBOLS sym_args END  */
#line 847 "nest/config.Y"
{ cmd_show_symbols((yyvsp[-1].sd)); }
#line 12175 "obj/conf/cf-parse.tab.c"
    break;

  case 1235: /* sym_args: %empty  */
#line 856 "nest/config.Y"
               {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 12183 "obj/conf/cf-parse.tab.c"
    break;

  case 1236: /* sym_args: sym_args TABLE  */
#line 859 "nest/config.Y"
                  { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 12189 "obj/conf/cf-parse.tab.c"
    break;

  case 1237: /* sym_args: sym_args FILTER  */
#line 860 "nest/config.Y"
                   { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 12195 "obj/conf/cf-parse.tab.c"
    break;

  case 1238: /* sym_args: sym_args FUNCTION  */
#line 861 "nest/config.Y"
                     { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 12201 "obj/conf/cf-parse.tab.c"
    break;

  case 1239: /* sym_args: sym_args PROTOCOL  */
#line 862 "nest/config.Y"
                     { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 12207 "obj/conf/cf-parse.tab.c"
    break;

  case 1240: /* sym_args: sym_args TEMPLATE  */
#line 863 "nest/config.Y"
                     { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 12213 "obj/conf/cf-parse.tab.c"
    break;

  case 1241: /* sym_args: sym_args CF_SYM_KNOWN  */
#line 864 "nest/config.Y"
                         { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 12219 "obj/conf/cf-parse.tab.c"
    break;

  case 1243: /* cmd_DUMP_RESOURCES: DUMP RESOURCES text END  */
#line 869 "nest/config.Y"
{ cmd_dump_file(this_cli, (yyvsp[-1].t), "resources", resource_dump); }
#line 12225 "obj/conf/cf-parse.tab.c"
    break;

  case 1245: /* cmd_DUMP_SOCKETS: DUMP SOCKETS text END  */
#line 871 "nest/config.Y"
{ cmd_dump_file(this_cli, (yyvsp[-1].t), "sockets", sk_dump_all); }
#line 12231 "obj/conf/cf-parse.tab.c"
    break;

  case 1247: /* cmd_DUMP_AO_KEYS: DUMP AO KEYS text END  */
#line 873 "nest/config.Y"
{ cmd_dump_file(this_cli, (yyvsp[-1].t), "AO keys", sk_dump_ao_all); }
#line 12237 "obj/conf/cf-parse.tab.c"
    break;

  case 1249: /* cmd_DUMP_EVENTS: DUMP EVENTS text END  */
#line 875 "nest/config.Y"
{ cmd_dump_file(this_cli, (yyvsp[-1].t), "event log", io_log_dump); }
#line 12243 "obj/conf/cf-parse.tab.c"
    break;

  case 1251: /* cmd_DUMP_INTERFACES: DUMP INTERFACES text END  */
#line 877 "nest/config.Y"
{ cmd_dump_file(this_cli, (yyvsp[-1].t), "interfaces", if_dump_all); }
#line 12249 "obj/conf/cf-parse.tab.c"
    break;

  case 1253: /* cmd_DUMP_NEIGHBORS: DUMP NEIGHBORS text END  */
#line 879 "nest/config.Y"
{ cmd_dump_file(this_cli, (yyvsp[-1].t), "neighbor cache", neigh_dump_all); }
#line 12255 "obj/conf/cf-parse.tab.c"
    break;

  case 1255: /* cmd_DUMP_ATTRIBUTES: DUMP ATTRIBUTES text END  */
#line 881 "nest/config.Y"
{ cmd_dump_file(this_cli, (yyvsp[-1].t), "attribute cache", rta_dump_all); }
#line 12261 "obj/conf/cf-parse.tab.c"
    break;

  case 1257: /* cmd_DUMP_ROUTES: DUMP ROUTES text END  */
#line 883 "nest/config.Y"
{ cmd_dump_file(this_cli, (yyvsp[-1].t), "routing tables", rt_dump_all); }
#line 12267 "obj/conf/cf-parse.tab.c"
    break;

  case 1259: /* cmd_DUMP_PROTOCOLS: DUMP PROTOCOLS text END  */
#line 885 "nest/config.Y"
{ cmd_dump_file(this_cli, (yyvsp[-1].t), "protocols", protos_dump_all); }
#line 12273 "obj/conf/cf-parse.tab.c"
    break;

  case 1261: /* cmd_DUMP_FILTER_ALL: DUMP FILTER ALL text END  */
#line 887 "nest/config.Y"
{ cmd_dump_file(this_cli, (yyvsp[-1].t), "filter bytecode", filters_dump_all); }
#line 12279 "obj/conf/cf-parse.tab.c"
    break;

  case 1263: /* cmd_EVAL: EVAL term END  */
#line 890 "nest/config.Y"
{ cmd_eval(f_linearize((yyvsp[-1].x), 1)); }
#line 12285 "obj/conf/cf-parse.tab.c"
    break;

  case 1265: /* cmd_ECHO: ECHO echo_mask echo_size END  */
#line 893 "nest/config.Y"
                                       {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 12294 "obj/conf/cf-parse.tab.c"
    break;

  case 1266: /* echo_mask: ALL  */
#line 899 "nest/config.Y"
       { (yyval.i) = ~0; }
#line 12300 "obj/conf/cf-parse.tab.c"
    break;

  case 1267: /* echo_mask: OFF  */
#line 900 "nest/config.Y"
       { (yyval.i) = 0; }
#line 12306 "obj/conf/cf-parse.tab.c"
    break;

  case 1268: /* echo_mask: '{' log_mask_list '}'  */
#line 901 "nest/config.Y"
                         { (yyval.i) = (yyvsp[-1].i); }
#line 12312 "obj/conf/cf-parse.tab.c"
    break;

  case 1269: /* echo_size: %empty  */
#line 905 "nest/config.Y"
               { (yyval.i) = 4096; }
#line 12318 "obj/conf/cf-parse.tab.c"
    break;

  case 1270: /* echo_size: NUM  */
#line 906 "nest/config.Y"
       {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 12327 "obj/conf/cf-parse.tab.c"
    break;

  case 1272: /* cmd_DISABLE: DISABLE proto_patt opttext END  */
#line 913 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-2].ps), proto_cmd_disable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 12333 "obj/conf/cf-parse.tab.c"
    break;

  case 1274: /* cmd_ENABLE: ENABLE proto_patt opttext END  */
#line 915 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-2].ps), proto_cmd_enable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 12339 "obj/conf/cf-parse.tab.c"
    break;

  case 1276: /* cmd_RESTART: RESTART proto_patt opttext END  */
#line 917 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-2].ps), proto_cmd_restart, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 12345 "obj/conf/cf-parse.tab.c"
    break;

  case 1278: /* cmd_RELOAD: RELOAD proto_patt END  */
#line 919 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 12351 "obj/conf/cf-parse.tab.c"
    break;

  case 1280: /* cmd_RELOAD_IN: RELOAD IN proto_patt END  */
#line 921 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 12357 "obj/conf/cf-parse.tab.c"
    break;

  case 1282: /* cmd_RELOAD_OUT: RELOAD OUT proto_patt END  */
#line 923 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 12363 "obj/conf/cf-parse.tab.c"
    break;

  case 1284: /* cmd_DEBUG: DEBUG debug_args END  */
#line 927 "nest/config.Y"
{ /* Done in debug_args */  }
#line 12369 "obj/conf/cf-parse.tab.c"
    break;

  case 1285: /* debug_args: proto_patt debug_mask  */
#line 939 "nest/config.Y"
                         { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_debug, 1, (yyvsp[0].i));  }
#line 12375 "obj/conf/cf-parse.tab.c"
    break;

  case 1286: /* debug_args: channel_arg debug_mask  */
#line 940 "nest/config.Y"
                          { channel_cmd_debug((yyvsp[-1].c), (yyvsp[0].i)); }
#line 12381 "obj/conf/cf-parse.tab.c"
    break;

  case 1288: /* cmd_MRTDUMP: MRTDUMP proto_patt mrtdump_mask END  */
#line 945 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 12387 "obj/conf/cf-parse.tab.c"
    break;

  case 1290: /* cmd_RESTRICT: RESTRICT END  */
#line 948 "nest/config.Y"
{ this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 12393 "obj/conf/cf-parse.tab.c"
    break;

  case 1292: /* cmd_TIMEFORMAT: TIMEFORMAT timeformat_spec END  */
#line 952 "nest/config.Y"
{ cli_set_timeformat(this_cli, (yyvsp[-1].tf)); }
#line 12399 "obj/conf/cf-parse.tab.c"
    break;

  case 1293: /* proto_patt: CF_SYM_KNOWN  */
#line 961 "nest/config.Y"
                { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 12405 "obj/conf/cf-parse.tab.c"
    break;

  case 1294: /* proto_patt: ALL  */
#line 962 "nest/config.Y"
        { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 12411 "obj/conf/cf-parse.tab.c"
    break;

  case 1295: /* proto_patt: TEXT  */
#line 963 "nest/config.Y"
        { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 12417 "obj/conf/cf-parse.tab.c"
    break;

  case 1296: /* proto_patt2: CF_SYM_KNOWN  */
#line 967 "nest/config.Y"
                { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 12423 "obj/conf/cf-parse.tab.c"
    break;

  case 1297: /* proto_patt2: %empty  */
#line 968 "nest/config.Y"
        { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 12429 "obj/conf/cf-parse.tab.c"
    break;

  case 1298: /* proto_patt2: TEXT  */
#line 969 "nest/config.Y"
        { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 12435 "obj/conf/cf-parse.tab.c"
    break;

  case 1299: /* dynamic_attr: IGP_METRIC  */
#line 972 "nest/config.Y"
                         { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 12441 "obj/conf/cf-parse.tab.c"
    break;

  case 1300: /* dynamic_attr: ASPA_PROVIDERS  */
#line 974 "nest/config.Y"
                             { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_ASPA_PROVIDERS); }
#line 12447 "obj/conf/cf-parse.tab.c"
    break;

  case 1301: /* dynamic_attr: MPLS_LABEL  */
#line 976 "nest/config.Y"
                          { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_MPLS_LABEL); }
#line 12453 "obj/conf/cf-parse.tab.c"
    break;

  case 1302: /* dynamic_attr: MPLS_POLICY  */
#line 977 "nest/config.Y"
                          { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_MPLS_POLICY, EA_MPLS_POLICY); }
#line 12459 "obj/conf/cf-parse.tab.c"
    break;

  case 1303: /* dynamic_attr: MPLS_CLASS  */
#line 978 "nest/config.Y"
                          { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_MPLS_CLASS); }
#line 12465 "obj/conf/cf-parse.tab.c"
    break;

  case 1306: /* mpls_domain_start: MPLS DOMAIN symbol  */
#line 35 "nest/mpls.Y"
                                      { this_mpls_domain = mpls_domain_config_new((yyvsp[0].s)); }
#line 12471 "obj/conf/cf-parse.tab.c"
    break;

  case 1312: /* mpls_domain_end: %empty  */
#line 51 "nest/mpls.Y"
                 { mpls_domain_postconfig(this_mpls_domain); this_mpls_domain = NULL; }
#line 12477 "obj/conf/cf-parse.tab.c"
    break;

  case 1314: /* mpls_range_start: LABEL RANGE symbol  */
#line 57 "nest/mpls.Y"
{
  if (((yyvsp[0].s)->class == SYM_KEYWORD) && ((yyvsp[0].s)->keyword->value == STATIC))
    this_mpls_range = this_mpls_domain->static_range;
  else if (((yyvsp[0].s)->class == SYM_KEYWORD) && ((yyvsp[0].s)->keyword->value == DYNAMIC))
    this_mpls_range = this_mpls_domain->dynamic_range;
  else
    this_mpls_range = mpls_range_config_new(this_mpls_domain, (yyvsp[0].s));
}
#line 12490 "obj/conf/cf-parse.tab.c"
    break;

  case 1315: /* mpls_range_opt: START expr  */
#line 67 "nest/mpls.Y"
              { this_mpls_range->start = (yyvsp[0].i); if ((yyvsp[0].i) >= MPLS_MAX_LABEL) cf_error("MPLS label range start must be less than 2^20"); }
#line 12496 "obj/conf/cf-parse.tab.c"
    break;

  case 1316: /* mpls_range_opt: LENGTH expr  */
#line 68 "nest/mpls.Y"
               { this_mpls_range->length = (yyvsp[0].i); if ((yyvsp[0].i) >= MPLS_MAX_LABEL) cf_error("MPLS label range length must be less than 2^20"); if (!(yyvsp[0].i)) cf_error("MPLS label range length must be nonzero"); }
#line 12502 "obj/conf/cf-parse.tab.c"
    break;

  case 1321: /* mpls_range_end: %empty  */
#line 82 "nest/mpls.Y"
{
  struct mpls_range_config *r = this_mpls_range;

  if ((r->start == (uint) -1) || (r->length == (uint) -1))
    cf_error("MPLS label range start and length must be specified");

  if (r->start + r->length > MPLS_MAX_LABEL)
    cf_error("MPLS label range end must be less than 2^20");

  this_mpls_range = NULL;
}
#line 12518 "obj/conf/cf-parse.tab.c"
    break;

  case 1323: /* mpls_channel_start: MPLS  */
#line 98 "nest/mpls.Y"
{
  (yyval.cc) = this_channel = channel_config_get(&channel_mpls, net_label[NET_MPLS], NET_MPLS, this_proto);

  if (EMPTY_LIST(new_config->mpls_domains))
  {
    int counter = 0;
    mpls_domain_config_new(cf_default_name(new_config, "mpls%d", &counter));
    cf_warn("No MPLS domain defined");
  }

  /* Default values for new channel */
  if (!MPLS_CC->domain)
  {
    MPLS_CC->domain = cf_default_mpls_domain(new_config);
    MPLS_CC->label_policy = MPLS_POLICY_PREFIX;
  }
}
#line 12540 "obj/conf/cf-parse.tab.c"
    break;

  case 1324: /* mpls_label_policy: STATIC  */
#line 117 "nest/mpls.Y"
          { (yyval.i) = MPLS_POLICY_STATIC; }
#line 12546 "obj/conf/cf-parse.tab.c"
    break;

  case 1325: /* mpls_label_policy: PREFIX  */
#line 118 "nest/mpls.Y"
          { (yyval.i) = MPLS_POLICY_PREFIX; }
#line 12552 "obj/conf/cf-parse.tab.c"
    break;

  case 1326: /* mpls_label_policy: AGGREGATE  */
#line 119 "nest/mpls.Y"
             { (yyval.i) = MPLS_POLICY_AGGREGATE; }
#line 12558 "obj/conf/cf-parse.tab.c"
    break;

  case 1327: /* mpls_label_policy: VRF  */
#line 120 "nest/mpls.Y"
       { (yyval.i) = MPLS_POLICY_VRF; }
#line 12564 "obj/conf/cf-parse.tab.c"
    break;

  case 1329: /* mpls_channel_opt: DOMAIN symbol_known  */
#line 125 "nest/mpls.Y"
                       { cf_assert_symbol((yyvsp[0].s), SYM_MPLS_DOMAIN); MPLS_CC->domain = (yyvsp[0].s)->mpls_domain; }
#line 12570 "obj/conf/cf-parse.tab.c"
    break;

  case 1330: /* mpls_channel_opt: LABEL RANGE symbol_known  */
#line 126 "nest/mpls.Y"
                            { cf_assert_symbol((yyvsp[0].s), SYM_MPLS_RANGE); MPLS_CC->range = (yyvsp[0].s)->mpls_range; }
#line 12576 "obj/conf/cf-parse.tab.c"
    break;

  case 1331: /* mpls_channel_opt: LABEL RANGE STATIC  */
#line 127 "nest/mpls.Y"
                       { MPLS_CC->range = MPLS_CC->domain->static_range; }
#line 12582 "obj/conf/cf-parse.tab.c"
    break;

  case 1332: /* mpls_channel_opt: LABEL RANGE DYNAMIC  */
#line 128 "nest/mpls.Y"
                       { MPLS_CC->range = MPLS_CC->domain->dynamic_range; }
#line 12588 "obj/conf/cf-parse.tab.c"
    break;

  case 1333: /* mpls_channel_opt: LABEL POLICY mpls_label_policy  */
#line 129 "nest/mpls.Y"
                                  { MPLS_CC->label_policy = (yyvsp[0].i); }
#line 12594 "obj/conf/cf-parse.tab.c"
    break;

  case 1338: /* $@12: %empty  */
#line 142 "nest/mpls.Y"
                  { mpls_channel_postconfig(this_channel); }
#line 12600 "obj/conf/cf-parse.tab.c"
    break;

  case 1340: /* show_mpls_ranges_args: %empty  */
#line 147 "nest/mpls.Y"
   {
     if (EMPTY_LIST(config->mpls_domains))
       cf_error("No MPLS domain defined");

     (yyval.msrc) = cfg_allocz(sizeof(struct mpls_show_ranges_cmd));
   }
#line 12611 "obj/conf/cf-parse.tab.c"
    break;

  case 1341: /* show_mpls_ranges_args: show_mpls_ranges_args symbol_known  */
#line 154 "nest/mpls.Y"
   {
     if ((yyvsp[0].s)->class == SYM_MPLS_DOMAIN)
     {
       if ((yyval.msrc)->domain)
	cf_error("Only one MPLS domain expected");

       (yyval.msrc)->domain = (yyvsp[0].s)->mpls_domain;
     }
     else if ((yyvsp[0].s)->class == SYM_MPLS_RANGE)
     {
       if ((yyval.msrc)->range)
	cf_error("Only one MPLS label range expected");

       if ((yyval.msrc)->domain != (yyvsp[0].s)->mpls_range->domain)
	cf_error("MPLS label range from different MPLS domain");

       (yyval.msrc)->domain = (yyvsp[0].s)->mpls_range->domain;
       (yyval.msrc)->range = (yyvsp[0].s)->mpls_range;
     }
     else
       cf_error("MPLS domain or label range expected");
   }
#line 12638 "obj/conf/cf-parse.tab.c"
    break;

  case 1342: /* show_mpls_ranges_args: show_mpls_ranges_args STATIC  */
#line 177 "nest/mpls.Y"
   {
     if ((yyval.msrc)->range)
       cf_error("Only one MPLS label range expected");

     (yyval.msrc)->domain = (yyval.msrc)->domain ?: cf_default_mpls_domain(config);
     (yyval.msrc)->range = (yyval.msrc)->domain->static_range;
   }
#line 12650 "obj/conf/cf-parse.tab.c"
    break;

  case 1343: /* show_mpls_ranges_args: show_mpls_ranges_args DYNAMIC  */
#line 185 "nest/mpls.Y"
   {
     if ((yyval.msrc)->range)
       cf_error("Only one MPLS label range expected");

     (yyval.msrc)->domain = (yyval.msrc)->domain ?: cf_default_mpls_domain(config);
     (yyval.msrc)->range = (yyval.msrc)->domain->dynamic_range;
   }
#line 12662 "obj/conf/cf-parse.tab.c"
    break;

  case 1345: /* cmd_SHOW_MPLS_RANGES: SHOW MPLS RANGES show_mpls_ranges_args END  */
#line 195 "nest/mpls.Y"
{ mpls_show_ranges((yyvsp[-1].msrc)); }
#line 12668 "obj/conf/cf-parse.tab.c"
    break;

  case 1347: /* aggregator_proto_start: proto_start AGGREGATOR  */
#line 32 "proto/aggregator/config.Y"
{
  this_proto = proto_config_new(&proto_aggregator, (yyvsp[-1].i));
  this_channel = AGGREGATOR_CFG->src = channel_config_new(NULL, "source", 0, this_proto);
  AGGREGATOR_CFG->dst = channel_config_new(NULL, "destination", 0, this_proto);

  AGGREGATOR_CFG->src->ra_mode = AGGREGATOR_CFG->dst->ra_mode = RA_ANY;
}
#line 12680 "obj/conf/cf-parse.tab.c"
    break;

  case 1350: /* aggregator_proto_item: PEER TABLE rtable  */
#line 43 "proto/aggregator/config.Y"
                     { AGGREGATOR_CFG->dst->table = (yyvsp[0].r); }
#line 12686 "obj/conf/cf-parse.tab.c"
    break;

  case 1351: /* aggregator_proto_item: AGGREGATE ON aggr_list  */
#line 44 "proto/aggregator/config.Y"
                          {
    if (AGGREGATOR_CFG->aggr_on)
      cf_error("Only one aggregate on clause allowed");

    bool net_present = 0;
    int count = 0;

    for (const struct aggr_item_node *item = (yyvsp[0].ai); item; item = item->next) {
//      log(L_WARN "type %d sacode %d", item->i.type, item->i.sa.sa_code);
      if (item->i.type == AGGR_ITEM_STATIC_ATTR && item->i.sa.sa_code == SA_NET)
	net_present = 1;

      count++;
    }

   if (!net_present)
     cf_error("'NET' must be present");

   AGGREGATOR_CFG->aggr_on = cfg_alloc(sizeof(struct aggr_item) * count);

   int pos = 0;
   for (const struct aggr_item_node *item = (yyvsp[0].ai); item; item = item->next) {
     if (item->i.type == AGGR_ITEM_DYNAMIC_ATTR)
       AGGREGATOR_CFG->aggr_on_da_count++;

     AGGREGATOR_CFG->aggr_on[pos++] = item->i;
   }

   AGGREGATOR_CFG->aggr_on_count = pos;
 }
#line 12721 "obj/conf/cf-parse.tab.c"
    break;

  case 1352: /* $@13: %empty  */
#line 74 "proto/aggregator/config.Y"
            {
   cf_push_block_scope(new_config);
   cf_create_symbol(new_config, "routes", SYM_VARIABLE | T_ROUTES_BLOCK, offset, f_new_var(sym_->scope));
 }
#line 12730 "obj/conf/cf-parse.tab.c"
    break;

  case 1353: /* aggregator_proto_item: MERGE BY $@13 function_body  */
#line 77 "proto/aggregator/config.Y"
                 {
   cf_pop_block_scope(new_config);
   (yyvsp[0].fl)->args++;
   AGGREGATOR_CFG->merge_by = (yyvsp[0].fl);
 }
#line 12740 "obj/conf/cf-parse.tab.c"
    break;

  case 1358: /* aggr_list: aggr_list ',' aggr_item  */
#line 90 "proto/aggregator/config.Y"
                           {
       if ((yyvsp[0].ai) == NULL) {
         (yyval.ai) = (yyvsp[-2].ai);
       } else {
         (yyval.ai) = (yyvsp[0].ai);
         (yyval.ai)->next = (yyvsp[-2].ai);
       }
   }
#line 12753 "obj/conf/cf-parse.tab.c"
    break;

  case 1359: /* aggr_item: '(' term ')'  */
#line 101 "proto/aggregator/config.Y"
                {
       (yyval.ai) = AGGR_ITEM_ALLOC;
       (yyval.ai)->i.type = AGGR_ITEM_TERM;
       (yyval.ai)->i.line = f_linearize((yyvsp[-1].x), 1);
    }
#line 12763 "obj/conf/cf-parse.tab.c"
    break;

  case 1360: /* aggr_item: CF_SYM_KNOWN  */
#line 106 "proto/aggregator/config.Y"
                 {
      switch ((yyvsp[0].s)->class) {
        case SYM_ATTRIBUTE:
          (yyval.ai) = AGGR_ITEM_ALLOC;
          (yyval.ai)->i.type = AGGR_ITEM_DYNAMIC_ATTR;
          (yyval.ai)->i.da = *(yyvsp[0].s)->attribute;
          break;
        case SYM_CONSTANT_RANGE:
          (yyval.ai) = NULL;
          break;
        default:
          cf_error("Can't aggregate on symbol type %s.", cf_symbol_class_name((yyvsp[0].s)));
      }
    }
#line 12782 "obj/conf/cf-parse.tab.c"
    break;

  case 1361: /* aggr_item: dynamic_attr  */
#line 120 "proto/aggregator/config.Y"
                 {
      (yyval.ai) = AGGR_ITEM_ALLOC;
      (yyval.ai)->i.type = AGGR_ITEM_DYNAMIC_ATTR;
      (yyval.ai)->i.da = (yyvsp[0].fda);
    }
#line 12792 "obj/conf/cf-parse.tab.c"
    break;

  case 1362: /* aggr_item: static_attr  */
#line 125 "proto/aggregator/config.Y"
                {
      (yyval.ai) = AGGR_ITEM_ALLOC;
      (yyval.ai)->i.type = AGGR_ITEM_STATIC_ATTR;
      (yyval.ai)->i.sa = (yyvsp[0].fsa);
    }
#line 12802 "obj/conf/cf-parse.tab.c"
    break;

  case 1364: /* bfd_proto_start: proto_start BFD  */
#line 39 "proto/bfd/config.Y"
{
  this_proto = proto_config_new(&proto_bfd, (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);
  BFD_CFG->accept_ipv4 = BFD_CFG->accept_ipv6 = 1;
  BFD_CFG->accept_direct = BFD_CFG->accept_multihop = 1;
}
#line 12814 "obj/conf/cf-parse.tab.c"
    break;

  case 1370: /* bfd_proto_item: STRICT BIND bool  */
#line 53 "proto/bfd/config.Y"
                    { BFD_CFG->strict_bind = (yyvsp[0].i); }
#line 12820 "obj/conf/cf-parse.tab.c"
    break;

  case 1371: /* bfd_proto_item: ZERO UDP6 CHECKSUM RX bool  */
#line 54 "proto/bfd/config.Y"
                              { BFD_CFG->zero_udp6_checksum_rx = (yyvsp[0].i); }
#line 12826 "obj/conf/cf-parse.tab.c"
    break;

  case 1375: /* bfd_accept_item: IPV4  */
#line 67 "proto/bfd/config.Y"
                        { BFD_CFG->accept_ipv4 = 1;  BFD_CFG->accept_ipv6 = 0; }
#line 12832 "obj/conf/cf-parse.tab.c"
    break;

  case 1376: /* bfd_accept_item: IPV6  */
#line 68 "proto/bfd/config.Y"
                        { BFD_CFG->accept_ipv4 = 0;  BFD_CFG->accept_ipv6 = 1; }
#line 12838 "obj/conf/cf-parse.tab.c"
    break;

  case 1377: /* bfd_accept_item: DIRECT  */
#line 69 "proto/bfd/config.Y"
                        { BFD_CFG->accept_direct = 1;  BFD_CFG->accept_multihop = 0; }
#line 12844 "obj/conf/cf-parse.tab.c"
    break;

  case 1378: /* bfd_accept_item: MULTIHOP  */
#line 70 "proto/bfd/config.Y"
                        { BFD_CFG->accept_direct = 0;  BFD_CFG->accept_multihop = 1; }
#line 12850 "obj/conf/cf-parse.tab.c"
    break;

  case 1379: /* bfd_accept: %empty  */
#line 74 "proto/bfd/config.Y"
   {
     BFD_CFG->accept_ipv4 = BFD_CFG->accept_ipv6 = 1;
     BFD_CFG->accept_direct = BFD_CFG->accept_multihop = 1;
   }
#line 12859 "obj/conf/cf-parse.tab.c"
    break;

  case 1381: /* bfd_iface_start: %empty  */
#line 82 "proto/bfd/config.Y"
{
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  add_tail(&BFD_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;

  reset_passwords();
}
#line 12876 "obj/conf/cf-parse.tab.c"
    break;

  case 1382: /* bfd_iface_finish: %empty  */
#line 96 "proto/bfd/config.Y"
{
  BFD_IFACE->passwords = get_passwords();

  if (!BFD_IFACE->auth_type != !BFD_IFACE->passwords)
    cf_warn("Authentication and password options should be used together");

  if (BFD_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *BFD_IFACE->passwords)
    {
      if (pass->alg)
        cf_error("Password algorithm option not available in BFD protocol");

      pass->alg = bfd_auth_type_to_hash_alg[BFD_IFACE->auth_type];
    }
  }
}
#line 12899 "obj/conf/cf-parse.tab.c"
    break;

  case 1383: /* bfd_iface_item: INTERVAL expr_us  */
#line 116 "proto/bfd/config.Y"
                    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].time); }
#line 12905 "obj/conf/cf-parse.tab.c"
    break;

  case 1384: /* bfd_iface_item: MIN RX INTERVAL expr_us  */
#line 117 "proto/bfd/config.Y"
                           { BFD_IFACE->min_rx_int = (yyvsp[0].time); }
#line 12911 "obj/conf/cf-parse.tab.c"
    break;

  case 1385: /* bfd_iface_item: MIN TX INTERVAL expr_us  */
#line 118 "proto/bfd/config.Y"
                           { BFD_IFACE->min_tx_int = (yyvsp[0].time); }
#line 12917 "obj/conf/cf-parse.tab.c"
    break;

  case 1386: /* bfd_iface_item: IDLE TX INTERVAL expr_us  */
#line 119 "proto/bfd/config.Y"
                            { BFD_IFACE->idle_tx_int = (yyvsp[0].time); }
#line 12923 "obj/conf/cf-parse.tab.c"
    break;

  case 1387: /* bfd_iface_item: MULTIPLIER expr  */
#line 120 "proto/bfd/config.Y"
                   { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 12929 "obj/conf/cf-parse.tab.c"
    break;

  case 1388: /* bfd_iface_item: PASSIVE bool  */
#line 121 "proto/bfd/config.Y"
                { BFD_IFACE->passive = (yyvsp[0].i); }
#line 12935 "obj/conf/cf-parse.tab.c"
    break;

  case 1389: /* bfd_iface_item: AUTHENTICATION bfd_auth_type  */
#line 122 "proto/bfd/config.Y"
                                { BFD_IFACE->auth_type = (yyvsp[0].i); }
#line 12941 "obj/conf/cf-parse.tab.c"
    break;

  case 1390: /* bfd_iface_item: password_list  */
#line 123 "proto/bfd/config.Y"
                 {}
#line 12947 "obj/conf/cf-parse.tab.c"
    break;

  case 1391: /* bfd_auth_type: NONE  */
#line 127 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_NONE; }
#line 12953 "obj/conf/cf-parse.tab.c"
    break;

  case 1392: /* bfd_auth_type: SIMPLE  */
#line 128 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_SIMPLE; }
#line 12959 "obj/conf/cf-parse.tab.c"
    break;

  case 1393: /* bfd_auth_type: KEYED MD5  */
#line 129 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_KEYED_MD5; }
#line 12965 "obj/conf/cf-parse.tab.c"
    break;

  case 1394: /* bfd_auth_type: KEYED SHA1  */
#line 130 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_KEYED_SHA1; }
#line 12971 "obj/conf/cf-parse.tab.c"
    break;

  case 1395: /* bfd_auth_type: METICULOUS KEYED MD5  */
#line 131 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_MD5; }
#line 12977 "obj/conf/cf-parse.tab.c"
    break;

  case 1396: /* bfd_auth_type: METICULOUS KEYED SHA1  */
#line 132 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_SHA1; }
#line 12983 "obj/conf/cf-parse.tab.c"
    break;

  case 1402: /* bfd_multihop: bfd_iface_start bfd_iface_opt_list bfd_iface_finish  */
#line 150 "proto/bfd/config.Y"
{ BFD_CFG->multihop = BFD_IFACE; }
#line 12989 "obj/conf/cf-parse.tab.c"
    break;

  case 1403: /* bfd_neigh_iface: %empty  */
#line 154 "proto/bfd/config.Y"
               { (yyval.iface) = NULL; }
#line 12995 "obj/conf/cf-parse.tab.c"
    break;

  case 1404: /* bfd_neigh_iface: '%' symbol  */
#line 155 "proto/bfd/config.Y"
              { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 13001 "obj/conf/cf-parse.tab.c"
    break;

  case 1405: /* bfd_neigh_iface: DEV text  */
#line 156 "proto/bfd/config.Y"
            { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 13007 "obj/conf/cf-parse.tab.c"
    break;

  case 1406: /* bfd_neigh_local: %empty  */
#line 160 "proto/bfd/config.Y"
               { (yyval.a) = IPA_NONE; }
#line 13013 "obj/conf/cf-parse.tab.c"
    break;

  case 1407: /* bfd_neigh_local: LOCAL ipa  */
#line 161 "proto/bfd/config.Y"
             { (yyval.a) = (yyvsp[0].a); }
#line 13019 "obj/conf/cf-parse.tab.c"
    break;

  case 1408: /* bfd_neigh_multihop: %empty  */
#line 165 "proto/bfd/config.Y"
               { (yyval.i) = 0; }
#line 13025 "obj/conf/cf-parse.tab.c"
    break;

  case 1409: /* bfd_neigh_multihop: MULTIHOP bool  */
#line 166 "proto/bfd/config.Y"
                 { (yyval.i) = (yyvsp[0].i); }
#line 13031 "obj/conf/cf-parse.tab.c"
    break;

  case 1410: /* bfd_neighbor: ipa bfd_neigh_iface bfd_neigh_local bfd_neigh_multihop  */
#line 170 "proto/bfd/config.Y"
{
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 13051 "obj/conf/cf-parse.tab.c"
    break;

  case 1411: /* bfd_item: INTERVAL expr_us  */
#line 190 "proto/bfd/config.Y"
                    { this_bfd_opts->min_rx_int = this_bfd_opts->min_tx_int = (yyvsp[0].time); }
#line 13057 "obj/conf/cf-parse.tab.c"
    break;

  case 1412: /* bfd_item: MIN RX INTERVAL expr_us  */
#line 191 "proto/bfd/config.Y"
                           { this_bfd_opts->min_rx_int = (yyvsp[0].time); }
#line 13063 "obj/conf/cf-parse.tab.c"
    break;

  case 1413: /* bfd_item: MIN TX INTERVAL expr_us  */
#line 192 "proto/bfd/config.Y"
                           { this_bfd_opts->min_tx_int = (yyvsp[0].time); }
#line 13069 "obj/conf/cf-parse.tab.c"
    break;

  case 1414: /* bfd_item: IDLE TX INTERVAL expr_us  */
#line 193 "proto/bfd/config.Y"
                            { this_bfd_opts->idle_tx_int = (yyvsp[0].time); }
#line 13075 "obj/conf/cf-parse.tab.c"
    break;

  case 1415: /* bfd_item: MULTIPLIER expr  */
#line 194 "proto/bfd/config.Y"
                   { this_bfd_opts->multiplier = (yyvsp[0].i); }
#line 13081 "obj/conf/cf-parse.tab.c"
    break;

  case 1416: /* bfd_item: PASSIVE bool  */
#line 195 "proto/bfd/config.Y"
                { this_bfd_opts->passive = (yyvsp[0].i); this_bfd_opts->passive_set = 1; }
#line 13087 "obj/conf/cf-parse.tab.c"
    break;

  case 1417: /* bfd_item: GRACEFUL  */
#line 196 "proto/bfd/config.Y"
            { this_bfd_opts->mode = BGP_BFD_GRACEFUL; }
#line 13093 "obj/conf/cf-parse.tab.c"
    break;

  case 1418: /* bfd_item: AUTHENTICATION bfd_auth_type  */
#line 197 "proto/bfd/config.Y"
                                { this_bfd_opts->auth_type = (yyvsp[0].i); }
#line 13099 "obj/conf/cf-parse.tab.c"
    break;

  case 1419: /* bfd_item: password_list  */
#line 198 "proto/bfd/config.Y"
                 {}
#line 13105 "obj/conf/cf-parse.tab.c"
    break;

  case 1422: /* bfd_opts_start: %empty  */
#line 207 "proto/bfd/config.Y"
{ reset_passwords(); }
#line 13111 "obj/conf/cf-parse.tab.c"
    break;

  case 1423: /* bfd_opts_end: %empty  */
#line 210 "proto/bfd/config.Y"
{
  this_bfd_opts->passwords = get_passwords();

  if (!this_bfd_opts->auth_type != !this_bfd_opts->passwords)
    cf_warn("Authentication and password options should be used together");

  if (this_bfd_opts->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *this_bfd_opts->passwords)
    {
      if (pass->alg)
        cf_error("Password algorithm option not available in BFD protocol");

      pass->alg = bfd_auth_type_to_hash_alg[this_bfd_opts->auth_type];
    }
  }
}
#line 13134 "obj/conf/cf-parse.tab.c"
    break;

  case 1426: /* cmd_SHOW_BFD_SESSIONS: SHOW BFD SESSIONS bfd_show_sessions_args END  */
#line 237 "proto/bfd/config.Y"
{ PROTO_WALK_CMD((yyvsp[-1].bssc)->name, &proto_bfd, p) bfd_show_sessions(p, (yyvsp[-1].bssc)); }
#line 13140 "obj/conf/cf-parse.tab.c"
    break;

  case 1427: /* bfd_show_sessions_args: %empty  */
#line 249 "proto/bfd/config.Y"
               { (yyval.bssc) = cfg_allocz(sizeof(struct bfd_show_sessions_cmd)); }
#line 13146 "obj/conf/cf-parse.tab.c"
    break;

  case 1428: /* bfd_show_sessions_args: bfd_show_sessions_args CF_SYM_KNOWN  */
#line 250 "proto/bfd/config.Y"
                                       { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.bssc)->name = (yyvsp[0].s); }
#line 13152 "obj/conf/cf-parse.tab.c"
    break;

  case 1429: /* bfd_show_sessions_args: bfd_show_sessions_args ADDRESS net_or_ipa  */
#line 251 "proto/bfd/config.Y"
                                             { net_copy(&((yyval.bssc)->address), &((yyvsp[0].net))); }
#line 13158 "obj/conf/cf-parse.tab.c"
    break;

  case 1430: /* bfd_show_sessions_args: bfd_show_sessions_args INTERFACE text  */
#line 252 "proto/bfd/config.Y"
                                         { (yyval.bssc)->iface = if_get_by_name((yyvsp[0].t)); }
#line 13164 "obj/conf/cf-parse.tab.c"
    break;

  case 1431: /* bfd_show_sessions_args: bfd_show_sessions_args DEV text  */
#line 253 "proto/bfd/config.Y"
                                   { (yyval.bssc)->iface = if_get_by_name((yyvsp[0].t)); }
#line 13170 "obj/conf/cf-parse.tab.c"
    break;

  case 1432: /* bfd_show_sessions_args: bfd_show_sessions_args ALL  */
#line 254 "proto/bfd/config.Y"
                              { (yyval.bssc)->verbose = 1; }
#line 13176 "obj/conf/cf-parse.tab.c"
    break;

  case 1433: /* bfd_show_sessions_args: bfd_show_sessions_args IPV4  */
#line 255 "proto/bfd/config.Y"
                               { (yyval.bssc)->ipv4 = 1; if ((yyval.bssc)->ipv6) cf_error("Options 'ipv4' and 'ipv6' are mutually exclusive"); }
#line 13182 "obj/conf/cf-parse.tab.c"
    break;

  case 1434: /* bfd_show_sessions_args: bfd_show_sessions_args IPV6  */
#line 256 "proto/bfd/config.Y"
                               { (yyval.bssc)->ipv6 = 1; if ((yyval.bssc)->ipv4) cf_error("Options 'ipv4' and 'ipv6' are mutually exclusive"); }
#line 13188 "obj/conf/cf-parse.tab.c"
    break;

  case 1435: /* bfd_show_sessions_args: bfd_show_sessions_args DIRECT  */
#line 257 "proto/bfd/config.Y"
                                 { (yyval.bssc)->direct = 1; if ((yyval.bssc)->multihop) cf_error("Options 'direct' and 'multihop' are mutually exclusive"); }
#line 13194 "obj/conf/cf-parse.tab.c"
    break;

  case 1436: /* bfd_show_sessions_args: bfd_show_sessions_args MULTIHOP  */
#line 258 "proto/bfd/config.Y"
                                   { (yyval.bssc)->multihop = 1; if ((yyval.bssc)->direct) cf_error("Options 'direct' and 'multihop' are mutually exclusive"); }
#line 13200 "obj/conf/cf-parse.tab.c"
    break;

  case 1438: /* babel_proto_start: proto_start BABEL  */
#line 37 "proto/babel/config.Y"
{
  this_proto = proto_config_new(&proto_babel, (yyvsp[-1].i));
  init_list(&BABEL_CFG->iface_list);
  BABEL_CFG->hold_time = 1 S_;
}
#line 13210 "obj/conf/cf-parse.tab.c"
    break;

  case 1442: /* babel_proto_item: RANDOMIZE ROUTER ID bool  */
#line 47 "proto/babel/config.Y"
                            { BABEL_CFG->randomize_router_id = (yyvsp[0].i); }
#line 13216 "obj/conf/cf-parse.tab.c"
    break;

  case 1446: /* babel_iface_start: %empty  */
#line 60 "proto/babel/config.Y"
{
  this_ipatt = cfg_allocz(sizeof(struct babel_iface_config));
  add_tail(&BABEL_CFG->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  BABEL_IFACE->port = BABEL_PORT;
  BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED;
  BABEL_IFACE->limit = BABEL_HELLO_LIMIT;
  BABEL_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  BABEL_IFACE->tx_priority = sk_priority_control;
  BABEL_IFACE->rtt_min = BABEL_RTT_MIN;
  BABEL_IFACE->rtt_max = BABEL_RTT_MAX;
  BABEL_IFACE->rtt_decay = BABEL_RTT_DECAY;
  BABEL_IFACE->rtt_send = 1;
  BABEL_IFACE->check_link = 1;
  BABEL_IFACE->ext_next_hop = 1;
}
#line 13239 "obj/conf/cf-parse.tab.c"
    break;

  case 1447: /* babel_iface_finish: %empty  */
#line 81 "proto/babel/config.Y"
{
  if (BABEL_IFACE->type == BABEL_IFACE_TYPE_WIRELESS)
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRELESS;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRELESS;
  }
  else
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRED;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRED;
    if (BABEL_IFACE->type == BABEL_IFACE_TYPE_TUNNEL && !BABEL_IFACE->rtt_cost)
      BABEL_IFACE->rtt_cost = BABEL_RXCOST_RTT;
  }

  if (BABEL_IFACE->rtt_cost && !BABEL_IFACE->rtt_send)
    cf_error("Can't set RTT cost when sending timestamps is disabled");

  if (BABEL_IFACE->rtt_min >= BABEL_IFACE->rtt_max)
    cf_error("Min RTT must be smaller than max RTT");

  /* Make sure we do not overflow the 16-bit centisec fields */
  if (!BABEL_IFACE->update_interval)
    BABEL_IFACE->update_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_UPDATE_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);
  BABEL_IFACE->ihu_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_IHU_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);

  BABEL_CFG->hold_time = MAX_(BABEL_CFG->hold_time, BABEL_IFACE->update_interval*BABEL_HOLD_TIME_FACTOR);

  BABEL_IFACE->passwords = get_passwords();

  if (!BABEL_IFACE->auth_type != !BABEL_IFACE->passwords)
    cf_error("Authentication and password options should be used together");

  if (BABEL_IFACE->passwords)
  {
    struct password_item *pass;
    uint len = 0, i = 0;

    WALK_LIST(pass, *BABEL_IFACE->passwords)
    {
      /* Set default crypto algorithm (HMAC-SHA256) */
      if (!pass->alg)
	pass->alg = ALG_HMAC_SHA256;

      if (!((pass->alg & ALG_HMAC) ||
	    (pass->alg == ALG_BLAKE2S_128) ||
	    (pass->alg == ALG_BLAKE2S_256) ||
	    (pass->alg == ALG_BLAKE2B_256) ||
	    (pass->alg == ALG_BLAKE2B_512)))
	cf_error("Only HMAC and Blake2 algorithms are supported");

      len += mac_type_length(pass->alg);
      i++;
    }

    BABEL_IFACE->mac_num_keys = i;
    BABEL_IFACE->mac_total_len = len;
  }

}
#line 13307 "obj/conf/cf-parse.tab.c"
    break;

  case 1449: /* babel_iface_item: PORT expr  */
#line 147 "proto/babel/config.Y"
             { BABEL_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 13313 "obj/conf/cf-parse.tab.c"
    break;

  case 1450: /* babel_iface_item: RXCOST expr  */
#line 148 "proto/babel/config.Y"
               { BABEL_IFACE->rxcost = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid rxcost"); }
#line 13319 "obj/conf/cf-parse.tab.c"
    break;

  case 1451: /* babel_iface_item: LIMIT expr  */
#line 149 "proto/babel/config.Y"
              { BABEL_IFACE->limit = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>16)) cf_error("Limit must be in range 1-16"); }
#line 13325 "obj/conf/cf-parse.tab.c"
    break;

  case 1452: /* babel_iface_item: TYPE WIRED  */
#line 150 "proto/babel/config.Y"
              { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED; }
#line 13331 "obj/conf/cf-parse.tab.c"
    break;

  case 1453: /* babel_iface_item: TYPE WIRELESS  */
#line 151 "proto/babel/config.Y"
                 { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRELESS; }
#line 13337 "obj/conf/cf-parse.tab.c"
    break;

  case 1454: /* babel_iface_item: TYPE TUNNEL  */
#line 152 "proto/babel/config.Y"
               { BABEL_IFACE->type = BABEL_IFACE_TYPE_TUNNEL; }
#line 13343 "obj/conf/cf-parse.tab.c"
    break;

  case 1455: /* babel_iface_item: HELLO INTERVAL expr_us  */
#line 153 "proto/babel/config.Y"
                          { BABEL_IFACE->hello_interval = (yyvsp[0].time); if (((yyvsp[0].time)<BABEL_MIN_INTERVAL) || ((yyvsp[0].time)>BABEL_MAX_INTERVAL)) cf_error("Hello interval must be in range 10 ms - 655 s"); }
#line 13349 "obj/conf/cf-parse.tab.c"
    break;

  case 1456: /* babel_iface_item: UPDATE INTERVAL expr_us  */
#line 154 "proto/babel/config.Y"
                           { BABEL_IFACE->update_interval = (yyvsp[0].time); if (((yyvsp[0].time)<BABEL_MIN_INTERVAL) || ((yyvsp[0].time)>BABEL_MAX_INTERVAL)) cf_error("Update interval must be in range 10 ms - 655 s"); }
#line 13355 "obj/conf/cf-parse.tab.c"
    break;

  case 1457: /* babel_iface_item: RX BUFFER expr  */
#line 155 "proto/babel/config.Y"
                  { BABEL_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX buffer must be in range 256-65535"); }
#line 13361 "obj/conf/cf-parse.tab.c"
    break;

  case 1458: /* babel_iface_item: TX LENGTH expr  */
#line 156 "proto/babel/config.Y"
                  { BABEL_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 13367 "obj/conf/cf-parse.tab.c"
    break;

  case 1459: /* babel_iface_item: TX tos  */
#line 157 "proto/babel/config.Y"
          { BABEL_IFACE->tx_tos = (yyvsp[0].i); }
#line 13373 "obj/conf/cf-parse.tab.c"
    break;

  case 1460: /* babel_iface_item: TX PRIORITY expr  */
#line 158 "proto/babel/config.Y"
                    { BABEL_IFACE->tx_priority = (yyvsp[0].i); }
#line 13379 "obj/conf/cf-parse.tab.c"
    break;

  case 1461: /* babel_iface_item: CHECK LINK bool  */
#line 159 "proto/babel/config.Y"
                   { BABEL_IFACE->check_link = (yyvsp[0].i); }
#line 13385 "obj/conf/cf-parse.tab.c"
    break;

  case 1462: /* babel_iface_item: NEXT HOP IPV4 ipa  */
#line 160 "proto/babel/config.Y"
                     { BABEL_IFACE->next_hop_ip4 = (yyvsp[0].a); if (!ipa_is_ip4((yyvsp[0].a))) cf_error("Must be an IPv4 address"); }
#line 13391 "obj/conf/cf-parse.tab.c"
    break;

  case 1463: /* babel_iface_item: NEXT HOP IPV6 ipa  */
#line 161 "proto/babel/config.Y"
                     { BABEL_IFACE->next_hop_ip6 = (yyvsp[0].a); if (!ipa_is_ip6((yyvsp[0].a))) cf_error("Must be an IPv6 address"); }
#line 13397 "obj/conf/cf-parse.tab.c"
    break;

  case 1464: /* babel_iface_item: NEXT HOP PREFER NATIVE  */
#line 162 "proto/babel/config.Y"
                          { BABEL_IFACE->next_hop_prefer = BABEL_NHP_NATIVE; }
#line 13403 "obj/conf/cf-parse.tab.c"
    break;

  case 1465: /* babel_iface_item: NEXT HOP PREFER IPV6  */
#line 163 "proto/babel/config.Y"
                        { BABEL_IFACE->next_hop_prefer = BABEL_NHP_IP6; }
#line 13409 "obj/conf/cf-parse.tab.c"
    break;

  case 1466: /* babel_iface_item: EXTENDED NEXT HOP bool  */
#line 164 "proto/babel/config.Y"
                          { BABEL_IFACE->ext_next_hop = (yyvsp[0].i); }
#line 13415 "obj/conf/cf-parse.tab.c"
    break;

  case 1467: /* babel_iface_item: AUTHENTICATION NONE  */
#line 165 "proto/babel/config.Y"
                       { BABEL_IFACE->auth_type = BABEL_AUTH_NONE; }
#line 13421 "obj/conf/cf-parse.tab.c"
    break;

  case 1468: /* babel_iface_item: AUTHENTICATION MAC  */
#line 166 "proto/babel/config.Y"
                      { BABEL_IFACE->auth_type = BABEL_AUTH_MAC; BABEL_IFACE->auth_permissive = 0; }
#line 13427 "obj/conf/cf-parse.tab.c"
    break;

  case 1469: /* babel_iface_item: AUTHENTICATION MAC PERMISSIVE  */
#line 167 "proto/babel/config.Y"
                                 { BABEL_IFACE->auth_type = BABEL_AUTH_MAC; BABEL_IFACE->auth_permissive = 1; }
#line 13433 "obj/conf/cf-parse.tab.c"
    break;

  case 1470: /* babel_iface_item: RTT MIN expr_us  */
#line 168 "proto/babel/config.Y"
                   { BABEL_IFACE->rtt_min = (yyvsp[0].time); }
#line 13439 "obj/conf/cf-parse.tab.c"
    break;

  case 1471: /* babel_iface_item: RTT MAX expr_us  */
#line 169 "proto/babel/config.Y"
                   { BABEL_IFACE->rtt_max = (yyvsp[0].time); }
#line 13445 "obj/conf/cf-parse.tab.c"
    break;

  case 1472: /* babel_iface_item: RTT COST expr  */
#line 170 "proto/babel/config.Y"
                 { BABEL_IFACE->rtt_cost = (yyvsp[0].i); if ((yyvsp[0].i) >= BABEL_INFINITY) cf_error("RTT cost must be < 65535"); }
#line 13451 "obj/conf/cf-parse.tab.c"
    break;

  case 1473: /* babel_iface_item: RTT DECAY expr  */
#line 171 "proto/babel/config.Y"
                  { BABEL_IFACE->rtt_decay = (yyvsp[0].i); if (((yyvsp[0].i) < 1) || ((yyvsp[0].i) > 256)) cf_error("RTT decay must be between 1-256"); }
#line 13457 "obj/conf/cf-parse.tab.c"
    break;

  case 1474: /* babel_iface_item: SEND TIMESTAMPS bool  */
#line 172 "proto/babel/config.Y"
                        { BABEL_IFACE->rtt_send = (yyvsp[0].i); }
#line 13463 "obj/conf/cf-parse.tab.c"
    break;

  case 1481: /* dynamic_attr: BABEL_METRIC  */
#line 190 "proto/babel/config.Y"
                           { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_BABEL_METRIC); }
#line 13469 "obj/conf/cf-parse.tab.c"
    break;

  case 1483: /* cmd_SHOW_BABEL_INTERFACES: SHOW BABEL INTERFACES optproto opttext END  */
#line 195 "proto/babel/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_babel, p) babel_show_interfaces(p, (yyvsp[-1].t)); }
#line 13475 "obj/conf/cf-parse.tab.c"
    break;

  case 1485: /* cmd_SHOW_BABEL_NEIGHBORS: SHOW BABEL NEIGHBORS optproto opttext END  */
#line 198 "proto/babel/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_babel, p) babel_show_neighbors(p, (yyvsp[-1].t)); }
#line 13481 "obj/conf/cf-parse.tab.c"
    break;

  case 1487: /* cmd_SHOW_BABEL_ENTRIES: SHOW BABEL ENTRIES optproto opttext END  */
#line 201 "proto/babel/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_babel, p) babel_show_entries(p); }
#line 13487 "obj/conf/cf-parse.tab.c"
    break;

  case 1489: /* cmd_SHOW_BABEL_ROUTES: SHOW BABEL ROUTES optproto opttext END  */
#line 204 "proto/babel/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_babel, p)  babel_show_routes(p); }
#line 13493 "obj/conf/cf-parse.tab.c"
    break;

  case 1491: /* bgp_proto_start: proto_start BGP  */
#line 56 "proto/bgp/config.Y"
                                 {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[-1].i));
     BGP_CFG->local_port = BGP_PORT;
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_enhanced_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->enable_hostname = 0;
     BGP_CFG->capabilities = 2;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->allow_as_sets = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->min_gr_time = 0;
     BGP_CFG->max_gr_time = ~0U;
     BGP_CFG->llgr_mode = -1;
     BGP_CFG->llgr_time = 3600;
     BGP_CFG->min_llgr_time = 0;
     BGP_CFG->max_llgr_time = ~0U;
     BGP_CFG->setkey = 1;
     BGP_CFG->local_role = BGP_ROLE_UNDEFINED;
     BGP_CFG->dynamic_name = "dynbgp";
     BGP_CFG->check_link = -1;
     BGP_CFG->send_hold_time = -1;
   }
#line 13534 "obj/conf/cf-parse.tab.c"
    break;

  case 1493: /* bgp_loc_opts: bgp_loc_opts PORT expr  */
#line 96 "proto/bgp/config.Y"
                          { BGP_CFG->local_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 13540 "obj/conf/cf-parse.tab.c"
    break;

  case 1494: /* bgp_loc_opts: bgp_loc_opts AS expr  */
#line 97 "proto/bgp/config.Y"
                        { BGP_CFG->local_as = (yyvsp[0].i); }
#line 13546 "obj/conf/cf-parse.tab.c"
    break;

  case 1496: /* bgp_nbr_opts: bgp_nbr_opts PORT expr  */
#line 102 "proto/bgp/config.Y"
                          { BGP_CFG->remote_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 13552 "obj/conf/cf-parse.tab.c"
    break;

  case 1497: /* bgp_nbr_opts: bgp_nbr_opts AS expr  */
#line 103 "proto/bgp/config.Y"
                        { BGP_CFG->remote_as = (yyvsp[0].i); }
#line 13558 "obj/conf/cf-parse.tab.c"
    break;

  case 1498: /* bgp_nbr_opts: bgp_nbr_opts INTERNAL  */
#line 104 "proto/bgp/config.Y"
                         { BGP_CFG->peer_type = BGP_PT_INTERNAL; }
#line 13564 "obj/conf/cf-parse.tab.c"
    break;

  case 1499: /* bgp_nbr_opts: bgp_nbr_opts EXTERNAL  */
#line 105 "proto/bgp/config.Y"
                         { BGP_CFG->peer_type = BGP_PT_EXTERNAL; }
#line 13570 "obj/conf/cf-parse.tab.c"
    break;

  case 1500: /* bgp_cease_mask: bool  */
#line 110 "proto/bgp/config.Y"
        { (yyval.i) = (yyvsp[0].i) ? ~(1 << 7) : 0; }
#line 13576 "obj/conf/cf-parse.tab.c"
    break;

  case 1501: /* bgp_cease_mask: '{' bgp_cease_list '}'  */
#line 111 "proto/bgp/config.Y"
                          { (yyval.i) = (yyvsp[-1].i); }
#line 13582 "obj/conf/cf-parse.tab.c"
    break;

  case 1503: /* bgp_cease_list: bgp_cease_list ',' bgp_cease_flag  */
#line 116 "proto/bgp/config.Y"
                                     { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 13588 "obj/conf/cf-parse.tab.c"
    break;

  case 1504: /* bgp_cease_flag: CEASE  */
#line 120 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 0; }
#line 13594 "obj/conf/cf-parse.tab.c"
    break;

  case 1505: /* bgp_cease_flag: PREFIX LIMIT HIT  */
#line 121 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 1; }
#line 13600 "obj/conf/cf-parse.tab.c"
    break;

  case 1506: /* bgp_cease_flag: ADMINISTRATIVE SHUTDOWN  */
#line 122 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 2; }
#line 13606 "obj/conf/cf-parse.tab.c"
    break;

  case 1507: /* bgp_cease_flag: PEER DECONFIGURED  */
#line 123 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 3; }
#line 13612 "obj/conf/cf-parse.tab.c"
    break;

  case 1508: /* bgp_cease_flag: ADMINISTRATIVE RESET  */
#line 124 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 4; }
#line 13618 "obj/conf/cf-parse.tab.c"
    break;

  case 1509: /* bgp_cease_flag: CONNECTION REJECTED  */
#line 125 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 5; }
#line 13624 "obj/conf/cf-parse.tab.c"
    break;

  case 1510: /* bgp_cease_flag: CONFIGURATION CHANGE  */
#line 126 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 6; }
#line 13630 "obj/conf/cf-parse.tab.c"
    break;

  case 1511: /* bgp_cease_flag: CONNECTION COLLISION  */
#line 127 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 7; }
#line 13636 "obj/conf/cf-parse.tab.c"
    break;

  case 1512: /* bgp_cease_flag: OUT OF RESOURCES  */
#line 128 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 8; }
#line 13642 "obj/conf/cf-parse.tab.c"
    break;

  case 1513: /* bgp_auth_type: NONE  */
#line 132 "proto/bgp/config.Y"
                { (yyval.i) = BGP_AUTH_NONE; }
#line 13648 "obj/conf/cf-parse.tab.c"
    break;

  case 1514: /* bgp_auth_type: MD5  */
#line 133 "proto/bgp/config.Y"
                { (yyval.i) = BGP_AUTH_MD5; }
#line 13654 "obj/conf/cf-parse.tab.c"
    break;

  case 1515: /* bgp_auth_type: AO  */
#line 134 "proto/bgp/config.Y"
                { (yyval.i) = BGP_AUTH_AO; }
#line 13660 "obj/conf/cf-parse.tab.c"
    break;

  case 1516: /* bgp_role_name: PEER  */
#line 138 "proto/bgp/config.Y"
             { (yyval.i) = BGP_ROLE_PEER; }
#line 13666 "obj/conf/cf-parse.tab.c"
    break;

  case 1517: /* bgp_role_name: PROVIDER  */
#line 139 "proto/bgp/config.Y"
             { (yyval.i) = BGP_ROLE_PROVIDER; }
#line 13672 "obj/conf/cf-parse.tab.c"
    break;

  case 1518: /* bgp_role_name: CUSTOMER  */
#line 140 "proto/bgp/config.Y"
             { (yyval.i) = BGP_ROLE_CUSTOMER; }
#line 13678 "obj/conf/cf-parse.tab.c"
    break;

  case 1519: /* bgp_role_name: RS_SERVER  */
#line 141 "proto/bgp/config.Y"
             { (yyval.i) = BGP_ROLE_RS_SERVER; }
#line 13684 "obj/conf/cf-parse.tab.c"
    break;

  case 1520: /* bgp_role_name: RS_CLIENT  */
#line 142 "proto/bgp/config.Y"
             { (yyval.i) = BGP_ROLE_RS_CLIENT; }
#line 13690 "obj/conf/cf-parse.tab.c"
    break;

  case 1526: /* bgp_proto: bgp_proto LOCAL ipa ipa_scope bgp_loc_opts ';'  */
#line 151 "proto/bgp/config.Y"
                                                  {
     BGP_CFG->local_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 13699 "obj/conf/cf-parse.tab.c"
    break;

  case 1528: /* bgp_proto: bgp_proto NEIGHBOR ipa ipa_scope bgp_nbr_opts ';'  */
#line 156 "proto/bgp/config.Y"
                                                     {
     if (ipa_nonzero(BGP_CFG->remote_ip) || BGP_CFG->remote_range)
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 13710 "obj/conf/cf-parse.tab.c"
    break;

  case 1529: /* bgp_proto: bgp_proto NEIGHBOR RANGE net_ip bgp_nbr_opts ';'  */
#line 162 "proto/bgp/config.Y"
                                                    {
     if (ipa_nonzero(BGP_CFG->remote_ip) || BGP_CFG->remote_range)
       cf_error("Only one neighbor per BGP instance is allowed");
     net_addr *n = cfg_alloc((yyvsp[-2].net).length);
     net_copy(n, &((yyvsp[-2].net)));
     BGP_CFG->remote_range = n;
   }
#line 13722 "obj/conf/cf-parse.tab.c"
    break;

  case 1530: /* bgp_proto: bgp_proto INTERFACE TEXT ';'  */
#line 169 "proto/bgp/config.Y"
                                { BGP_CFG->iface = if_get_by_name((yyvsp[-1].t)); }
#line 13728 "obj/conf/cf-parse.tab.c"
    break;

  case 1531: /* bgp_proto: bgp_proto RR CLUSTER ID idval ';'  */
#line 170 "proto/bgp/config.Y"
                                     { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 13734 "obj/conf/cf-parse.tab.c"
    break;

  case 1532: /* bgp_proto: bgp_proto RR CLIENT bool ';'  */
#line 171 "proto/bgp/config.Y"
                                { BGP_CFG->rr_client = (yyvsp[-1].i); }
#line 13740 "obj/conf/cf-parse.tab.c"
    break;

  case 1533: /* bgp_proto: bgp_proto RS CLIENT bool ';'  */
#line 172 "proto/bgp/config.Y"
                                { BGP_CFG->rs_client = (yyvsp[-1].i); }
#line 13746 "obj/conf/cf-parse.tab.c"
    break;

  case 1534: /* bgp_proto: bgp_proto CONFEDERATION expr ';'  */
#line 173 "proto/bgp/config.Y"
                                    { BGP_CFG->confederation = (yyvsp[-1].i); }
#line 13752 "obj/conf/cf-parse.tab.c"
    break;

  case 1535: /* bgp_proto: bgp_proto CONFEDERATION MEMBER bool ';'  */
#line 174 "proto/bgp/config.Y"
                                           { BGP_CFG->confederation_member = (yyvsp[-1].i); }
#line 13758 "obj/conf/cf-parse.tab.c"
    break;

  case 1536: /* bgp_proto: bgp_proto HOLD TIME expr ';'  */
#line 175 "proto/bgp/config.Y"
                                { BGP_CFG->hold_time = (yyvsp[-1].i); if (((yyvsp[-1].i) && (yyvsp[-1].i)<3) || ((yyvsp[-1].i)>65535)) cf_error("Hold time must be in range 3-65535 or zero"); }
#line 13764 "obj/conf/cf-parse.tab.c"
    break;

  case 1537: /* bgp_proto: bgp_proto MIN HOLD TIME expr ';'  */
#line 176 "proto/bgp/config.Y"
                                    { BGP_CFG->min_hold_time = (yyvsp[-1].i); }
#line 13770 "obj/conf/cf-parse.tab.c"
    break;

  case 1538: /* bgp_proto: bgp_proto STARTUP HOLD TIME expr ';'  */
#line 177 "proto/bgp/config.Y"
                                        { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 13776 "obj/conf/cf-parse.tab.c"
    break;

  case 1539: /* bgp_proto: bgp_proto DIRECT ';'  */
#line 178 "proto/bgp/config.Y"
                        { BGP_CFG->multihop = 0; }
#line 13782 "obj/conf/cf-parse.tab.c"
    break;

  case 1540: /* bgp_proto: bgp_proto MULTIHOP ';'  */
#line 179 "proto/bgp/config.Y"
                          { BGP_CFG->multihop = 64; }
#line 13788 "obj/conf/cf-parse.tab.c"
    break;

  case 1541: /* bgp_proto: bgp_proto MULTIHOP expr ';'  */
#line 180 "proto/bgp/config.Y"
                               { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 13794 "obj/conf/cf-parse.tab.c"
    break;

  case 1542: /* bgp_proto: bgp_proto DYNAMIC NAME text ';'  */
#line 181 "proto/bgp/config.Y"
                                   {
     if (strchr((yyvsp[-1].t), '%')) cf_error("Forbidden character '%%' in dynamic name");
     if (strlen((yyvsp[-1].t)) > (SYM_MAX_LEN - 16)) cf_error("Dynamic name too long");
     BGP_CFG->dynamic_name = (yyvsp[-1].t);
   }
#line 13804 "obj/conf/cf-parse.tab.c"
    break;

  case 1543: /* bgp_proto: bgp_proto DYNAMIC NAME DIGITS expr ';'  */
#line 186 "proto/bgp/config.Y"
                                          { BGP_CFG->dynamic_name_digits = (yyvsp[-1].i); if ((yyvsp[-1].i)>10) cf_error("Dynamic name digits must be at most 10"); }
#line 13810 "obj/conf/cf-parse.tab.c"
    break;

  case 1544: /* bgp_proto: bgp_proto STRICT BIND bool ';'  */
#line 187 "proto/bgp/config.Y"
                                  { BGP_CFG->strict_bind = (yyvsp[-1].i); }
#line 13816 "obj/conf/cf-parse.tab.c"
    break;

  case 1545: /* bgp_proto: bgp_proto FREE BIND bool ';'  */
#line 188 "proto/bgp/config.Y"
                                { BGP_CFG->free_bind = (yyvsp[-1].i); }
#line 13822 "obj/conf/cf-parse.tab.c"
    break;

  case 1546: /* bgp_proto: bgp_proto PATH METRIC bool ';'  */
#line 189 "proto/bgp/config.Y"
                                  { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 13828 "obj/conf/cf-parse.tab.c"
    break;

  case 1547: /* bgp_proto: bgp_proto MED METRIC bool ';'  */
#line 190 "proto/bgp/config.Y"
                                 { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 13834 "obj/conf/cf-parse.tab.c"
    break;

  case 1548: /* bgp_proto: bgp_proto IGP METRIC bool ';'  */
#line 191 "proto/bgp/config.Y"
                                 { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 13840 "obj/conf/cf-parse.tab.c"
    break;

  case 1549: /* bgp_proto: bgp_proto PREFER OLDER bool ';'  */
#line 192 "proto/bgp/config.Y"
                                   { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 13846 "obj/conf/cf-parse.tab.c"
    break;

  case 1550: /* bgp_proto: bgp_proto DETERMINISTIC MED bool ';'  */
#line 193 "proto/bgp/config.Y"
                                        { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 13852 "obj/conf/cf-parse.tab.c"
    break;

  case 1551: /* bgp_proto: bgp_proto DEFAULT BGP_MED expr ';'  */
#line 194 "proto/bgp/config.Y"
                                      { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 13858 "obj/conf/cf-parse.tab.c"
    break;

  case 1552: /* bgp_proto: bgp_proto DEFAULT BGP_LOCAL_PREF expr ';'  */
#line 195 "proto/bgp/config.Y"
                                             { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 13864 "obj/conf/cf-parse.tab.c"
    break;

  case 1553: /* bgp_proto: bgp_proto SOURCE ADDRESS ipa ';'  */
#line 196 "proto/bgp/config.Y"
                                    { BGP_CFG->local_ip = (yyvsp[-1].a); }
#line 13870 "obj/conf/cf-parse.tab.c"
    break;

  case 1554: /* bgp_proto: bgp_proto START DELAY TIME expr ';'  */
#line 197 "proto/bgp/config.Y"
                                       { BGP_CFG->connect_delay_time = (yyvsp[-1].i); cf_warn("%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
#line 13876 "obj/conf/cf-parse.tab.c"
    break;

  case 1555: /* bgp_proto: bgp_proto CONNECT DELAY TIME expr ';'  */
#line 198 "proto/bgp/config.Y"
                                         { BGP_CFG->connect_delay_time = (yyvsp[-1].i); }
#line 13882 "obj/conf/cf-parse.tab.c"
    break;

  case 1556: /* bgp_proto: bgp_proto CONNECT RETRY TIME expr ';'  */
#line 199 "proto/bgp/config.Y"
                                         { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 13888 "obj/conf/cf-parse.tab.c"
    break;

  case 1557: /* bgp_proto: bgp_proto KEEPALIVE TIME expr ';'  */
#line 200 "proto/bgp/config.Y"
                                     { BGP_CFG->keepalive_time = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>65535)) cf_error("Keepalive time must be in range 1-65535"); }
#line 13894 "obj/conf/cf-parse.tab.c"
    break;

  case 1558: /* bgp_proto: bgp_proto MIN KEEPALIVE TIME expr ';'  */
#line 201 "proto/bgp/config.Y"
                                         { BGP_CFG->min_keepalive_time = (yyvsp[-1].i); }
#line 13900 "obj/conf/cf-parse.tab.c"
    break;

  case 1559: /* bgp_proto: bgp_proto SEND HOLD TIME expr ';'  */
#line 202 "proto/bgp/config.Y"
                                    { BGP_CFG->send_hold_time = (yyvsp[-1].i); }
#line 13906 "obj/conf/cf-parse.tab.c"
    break;

  case 1560: /* bgp_proto: bgp_proto ERROR FORGET TIME expr ';'  */
#line 203 "proto/bgp/config.Y"
                                        { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 13912 "obj/conf/cf-parse.tab.c"
    break;

  case 1561: /* bgp_proto: bgp_proto ERROR WAIT TIME expr ',' expr ';'  */
#line 204 "proto/bgp/config.Y"
                                               { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 13918 "obj/conf/cf-parse.tab.c"
    break;

  case 1562: /* bgp_proto: bgp_proto DISABLE AFTER ERROR bool ';'  */
#line 205 "proto/bgp/config.Y"
                                          { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 13924 "obj/conf/cf-parse.tab.c"
    break;

  case 1563: /* bgp_proto: bgp_proto DISABLE AFTER CEASE bgp_cease_mask ';'  */
#line 206 "proto/bgp/config.Y"
                                                    { BGP_CFG->disable_after_cease = (yyvsp[-1].i); }
#line 13930 "obj/conf/cf-parse.tab.c"
    break;

  case 1564: /* bgp_proto: bgp_proto ENABLE ROUTE REFRESH bool ';'  */
#line 207 "proto/bgp/config.Y"
                                           { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 13936 "obj/conf/cf-parse.tab.c"
    break;

  case 1565: /* bgp_proto: bgp_proto ENABLE ENHANCED ROUTE REFRESH bool ';'  */
#line 208 "proto/bgp/config.Y"
                                                    { BGP_CFG->enable_enhanced_refresh = (yyvsp[-1].i); }
#line 13942 "obj/conf/cf-parse.tab.c"
    break;

  case 1566: /* bgp_proto: bgp_proto ENABLE AS4 bool ';'  */
#line 209 "proto/bgp/config.Y"
                                 { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 13948 "obj/conf/cf-parse.tab.c"
    break;

  case 1567: /* bgp_proto: bgp_proto ENABLE EXTENDED MESSAGES bool ';'  */
#line 210 "proto/bgp/config.Y"
                                               { BGP_CFG->enable_extended_messages = (yyvsp[-1].i); }
#line 13954 "obj/conf/cf-parse.tab.c"
    break;

  case 1568: /* bgp_proto: bgp_proto ADVERTISE HOSTNAME bool ';'  */
#line 211 "proto/bgp/config.Y"
                                         { BGP_CFG->enable_hostname = (yyvsp[-1].i); }
#line 13960 "obj/conf/cf-parse.tab.c"
    break;

  case 1569: /* bgp_proto: bgp_proto REQUIRE ROUTE REFRESH bool ';'  */
#line 212 "proto/bgp/config.Y"
                                            { BGP_CFG->require_refresh = (yyvsp[-1].i); }
#line 13966 "obj/conf/cf-parse.tab.c"
    break;

  case 1570: /* bgp_proto: bgp_proto REQUIRE ENHANCED ROUTE REFRESH bool ';'  */
#line 213 "proto/bgp/config.Y"
                                                     { BGP_CFG->require_enhanced_refresh = (yyvsp[-1].i); }
#line 13972 "obj/conf/cf-parse.tab.c"
    break;

  case 1571: /* bgp_proto: bgp_proto REQUIRE AS4 bool ';'  */
#line 214 "proto/bgp/config.Y"
                                  { BGP_CFG->require_as4 = (yyvsp[-1].i); }
#line 13978 "obj/conf/cf-parse.tab.c"
    break;

  case 1572: /* bgp_proto: bgp_proto REQUIRE EXTENDED MESSAGES bool ';'  */
#line 215 "proto/bgp/config.Y"
                                                { BGP_CFG->require_extended_messages = (yyvsp[-1].i); }
#line 13984 "obj/conf/cf-parse.tab.c"
    break;

  case 1573: /* bgp_proto: bgp_proto REQUIRE HOSTNAME bool ';'  */
#line 216 "proto/bgp/config.Y"
                                       { BGP_CFG->require_hostname = (yyvsp[-1].i); }
#line 13990 "obj/conf/cf-parse.tab.c"
    break;

  case 1574: /* bgp_proto: bgp_proto REQUIRE GRACEFUL RESTART bool ';'  */
#line 217 "proto/bgp/config.Y"
                                               { BGP_CFG->require_gr = (yyvsp[-1].i); }
#line 13996 "obj/conf/cf-parse.tab.c"
    break;

  case 1575: /* bgp_proto: bgp_proto REQUIRE LONG LIVED GRACEFUL RESTART bool ';'  */
#line 218 "proto/bgp/config.Y"
                                                          { BGP_CFG->require_llgr = (yyvsp[-1].i); }
#line 14002 "obj/conf/cf-parse.tab.c"
    break;

  case 1576: /* bgp_proto: bgp_proto CAPABILITIES bool ';'  */
#line 219 "proto/bgp/config.Y"
                                   { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 14008 "obj/conf/cf-parse.tab.c"
    break;

  case 1577: /* bgp_proto: bgp_proto AUTHENTICATION bgp_auth_type ';'  */
#line 220 "proto/bgp/config.Y"
                                              { BGP_CFG->auth_type = (yyvsp[-1].i); }
#line 14014 "obj/conf/cf-parse.tab.c"
    break;

  case 1579: /* bgp_proto: bgp_proto PASSWORD text ';'  */
#line 222 "proto/bgp/config.Y"
                               { BGP_CFG->password = (yyvsp[-1].t); }
#line 14020 "obj/conf/cf-parse.tab.c"
    break;

  case 1580: /* bgp_proto: bgp_proto SETKEY bool ';'  */
#line 223 "proto/bgp/config.Y"
                             { BGP_CFG->setkey = (yyvsp[-1].i); }
#line 14026 "obj/conf/cf-parse.tab.c"
    break;

  case 1581: /* bgp_proto: bgp_proto PASSIVE bool ';'  */
#line 224 "proto/bgp/config.Y"
                              { BGP_CFG->passive = (yyvsp[-1].i); }
#line 14032 "obj/conf/cf-parse.tab.c"
    break;

  case 1582: /* bgp_proto: bgp_proto INTERPRET COMMUNITIES bool ';'  */
#line 225 "proto/bgp/config.Y"
                                            { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 14038 "obj/conf/cf-parse.tab.c"
    break;

  case 1583: /* bgp_proto: bgp_proto ALLOW LOCAL AS ';'  */
#line 226 "proto/bgp/config.Y"
                                { BGP_CFG->allow_local_as = -1; }
#line 14044 "obj/conf/cf-parse.tab.c"
    break;

  case 1584: /* bgp_proto: bgp_proto ALLOW LOCAL AS expr ';'  */
#line 227 "proto/bgp/config.Y"
                                     { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 14050 "obj/conf/cf-parse.tab.c"
    break;

  case 1585: /* bgp_proto: bgp_proto ALLOW BGP_LOCAL_PREF bool ';'  */
#line 228 "proto/bgp/config.Y"
                                           { BGP_CFG->allow_local_pref = (yyvsp[-1].i); }
#line 14056 "obj/conf/cf-parse.tab.c"
    break;

  case 1586: /* bgp_proto: bgp_proto ALLOW BGP_MED bool ';'  */
#line 229 "proto/bgp/config.Y"
                                    { BGP_CFG->allow_med = (yyvsp[-1].i); }
#line 14062 "obj/conf/cf-parse.tab.c"
    break;

  case 1587: /* bgp_proto: bgp_proto ALLOW AS SETS bool ';'  */
#line 230 "proto/bgp/config.Y"
                                    { BGP_CFG->allow_as_sets = (yyvsp[-1].i); }
#line 14068 "obj/conf/cf-parse.tab.c"
    break;

  case 1588: /* bgp_proto: bgp_proto GRACEFUL RESTART bool ';'  */
#line 231 "proto/bgp/config.Y"
                                       { BGP_CFG->gr_mode = (yyvsp[-1].i); }
#line 14074 "obj/conf/cf-parse.tab.c"
    break;

  case 1589: /* bgp_proto: bgp_proto GRACEFUL RESTART AWARE ';'  */
#line 232 "proto/bgp/config.Y"
                                        { BGP_CFG->gr_mode = BGP_GR_AWARE; }
#line 14080 "obj/conf/cf-parse.tab.c"
    break;

  case 1590: /* bgp_proto: bgp_proto GRACEFUL RESTART TIME expr ';'  */
#line 233 "proto/bgp/config.Y"
                                            { BGP_CFG->gr_time = (yyvsp[-1].i); if ((yyvsp[-1].i) >= (1 << 12)) cf_error("Graceful restart time must be less than 4096"); }
#line 14086 "obj/conf/cf-parse.tab.c"
    break;

  case 1591: /* bgp_proto: bgp_proto MIN GRACEFUL RESTART TIME expr ';'  */
#line 234 "proto/bgp/config.Y"
                                                { BGP_CFG->min_gr_time = (yyvsp[-1].i); if ((yyvsp[-1].i) >= (1 << 12)) cf_error("Min graceful restart time must be less than 4096"); }
#line 14092 "obj/conf/cf-parse.tab.c"
    break;

  case 1592: /* bgp_proto: bgp_proto MAX GRACEFUL RESTART TIME expr ';'  */
#line 235 "proto/bgp/config.Y"
                                                { BGP_CFG->max_gr_time = (yyvsp[-1].i); if ((yyvsp[-1].i) >= (1 << 12)) cf_error("Max graceful restart time must be less than 4096"); }
#line 14098 "obj/conf/cf-parse.tab.c"
    break;

  case 1593: /* bgp_proto: bgp_proto LONG LIVED GRACEFUL RESTART bool ';'  */
#line 236 "proto/bgp/config.Y"
                                                  { BGP_CFG->llgr_mode = (yyvsp[-1].i); }
#line 14104 "obj/conf/cf-parse.tab.c"
    break;

  case 1594: /* bgp_proto: bgp_proto LONG LIVED GRACEFUL RESTART AWARE ';'  */
#line 237 "proto/bgp/config.Y"
                                                   { BGP_CFG->llgr_mode = BGP_LLGR_AWARE; }
#line 14110 "obj/conf/cf-parse.tab.c"
    break;

  case 1595: /* bgp_proto: bgp_proto LONG LIVED STALE TIME expr ';'  */
#line 238 "proto/bgp/config.Y"
                                            { BGP_CFG->llgr_time = (yyvsp[-1].i); if ((yyvsp[-1].i) >= (1 << 24)) cf_error("Long-lived stale time must be less than 2^24"); }
#line 14116 "obj/conf/cf-parse.tab.c"
    break;

  case 1596: /* bgp_proto: bgp_proto MIN LONG LIVED STALE TIME expr ';'  */
#line 239 "proto/bgp/config.Y"
                                                { BGP_CFG->min_llgr_time = (yyvsp[-1].i); if ((yyvsp[-1].i) >= (1 << 24)) cf_error("Min long-lived stale time must be less than 2^24"); }
#line 14122 "obj/conf/cf-parse.tab.c"
    break;

  case 1597: /* bgp_proto: bgp_proto MAX LONG LIVED STALE TIME expr ';'  */
#line 240 "proto/bgp/config.Y"
                                                { BGP_CFG->max_llgr_time = (yyvsp[-1].i); if ((yyvsp[-1].i) >= (1 << 24)) cf_error("Max long-lived stale time must be less than 2^24"); }
#line 14128 "obj/conf/cf-parse.tab.c"
    break;

  case 1598: /* bgp_proto: bgp_proto TTL SECURITY bool ';'  */
#line 241 "proto/bgp/config.Y"
                                   { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 14134 "obj/conf/cf-parse.tab.c"
    break;

  case 1599: /* bgp_proto: bgp_proto CHECK LINK bool ';'  */
#line 242 "proto/bgp/config.Y"
                                 { BGP_CFG->check_link = (yyvsp[-1].i); }
#line 14140 "obj/conf/cf-parse.tab.c"
    break;

  case 1600: /* bgp_proto: bgp_proto BFD bool ';'  */
#line 243 "proto/bgp/config.Y"
                          { if ((yyvsp[-1].i)) init_bfd_opts(&BGP_CFG->bfd); else BGP_CFG->bfd = NULL; }
#line 14146 "obj/conf/cf-parse.tab.c"
    break;

  case 1601: /* bgp_proto: bgp_proto BFD GRACEFUL ';'  */
#line 244 "proto/bgp/config.Y"
                              { init_bfd_opts(&BGP_CFG->bfd); BGP_CFG->bfd->mode = BGP_BFD_GRACEFUL; }
#line 14152 "obj/conf/cf-parse.tab.c"
    break;

  case 1602: /* $@14: %empty  */
#line 245 "proto/bgp/config.Y"
                 { open_bfd_opts(&BGP_CFG->bfd); }
#line 14158 "obj/conf/cf-parse.tab.c"
    break;

  case 1603: /* $@15: %empty  */
#line 245 "proto/bgp/config.Y"
                                                            { close_bfd_opts(); }
#line 14164 "obj/conf/cf-parse.tab.c"
    break;

  case 1605: /* bgp_proto: bgp_proto ENFORCE FIRST AS bool ';'  */
#line 246 "proto/bgp/config.Y"
                                       { BGP_CFG->enforce_first_as = (yyvsp[-1].i); }
#line 14170 "obj/conf/cf-parse.tab.c"
    break;

  case 1606: /* bgp_proto: bgp_proto LOCAL ROLE bgp_role_name ';'  */
#line 247 "proto/bgp/config.Y"
                                          { BGP_CFG->local_role = (yyvsp[-1].i); }
#line 14176 "obj/conf/cf-parse.tab.c"
    break;

  case 1607: /* bgp_proto: bgp_proto REQUIRE ROLES bool ';'  */
#line 248 "proto/bgp/config.Y"
                                    { BGP_CFG->require_roles = (yyvsp[-1].i); }
#line 14182 "obj/conf/cf-parse.tab.c"
    break;

  case 1608: /* bgp_proto: bgp_proto DISABLE RX bool ';'  */
#line 249 "proto/bgp/config.Y"
                                 { BGP_CFG->disable_rx = (yyvsp[-1].i); }
#line 14188 "obj/conf/cf-parse.tab.c"
    break;

  case 1609: /* bgp_afi: IPV4  */
#line 253 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV4; }
#line 14194 "obj/conf/cf-parse.tab.c"
    break;

  case 1610: /* bgp_afi: IPV6  */
#line 254 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV6; }
#line 14200 "obj/conf/cf-parse.tab.c"
    break;

  case 1611: /* bgp_afi: IPV4 MULTICAST  */
#line 255 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV4_MC; }
#line 14206 "obj/conf/cf-parse.tab.c"
    break;

  case 1612: /* bgp_afi: IPV6 MULTICAST  */
#line 256 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV6_MC; }
#line 14212 "obj/conf/cf-parse.tab.c"
    break;

  case 1613: /* bgp_afi: IPV4 MPLS  */
#line 257 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV4_MPLS; }
#line 14218 "obj/conf/cf-parse.tab.c"
    break;

  case 1614: /* bgp_afi: IPV6 MPLS  */
#line 258 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV6_MPLS; }
#line 14224 "obj/conf/cf-parse.tab.c"
    break;

  case 1615: /* bgp_afi: VPN4 MPLS  */
#line 259 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_VPN4_MPLS; }
#line 14230 "obj/conf/cf-parse.tab.c"
    break;

  case 1616: /* bgp_afi: VPN6 MPLS  */
#line 260 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_VPN6_MPLS; }
#line 14236 "obj/conf/cf-parse.tab.c"
    break;

  case 1617: /* bgp_afi: VPN4 MULTICAST  */
#line 261 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_VPN4_MC; }
#line 14242 "obj/conf/cf-parse.tab.c"
    break;

  case 1618: /* bgp_afi: VPN6 MULTICAST  */
#line 262 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_VPN6_MC; }
#line 14248 "obj/conf/cf-parse.tab.c"
    break;

  case 1619: /* bgp_afi: FLOW4  */
#line 263 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_FLOW4; }
#line 14254 "obj/conf/cf-parse.tab.c"
    break;

  case 1620: /* bgp_afi: FLOW6  */
#line 264 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_FLOW6; }
#line 14260 "obj/conf/cf-parse.tab.c"
    break;

  case 1621: /* tcp_ao_key_start: KEY  */
#line 267 "proto/bgp/config.Y"
                      {
  this_ao_key = cfg_allocz(sizeof(struct ao_config));
  *next_ao_key = this_ao_key;
  next_ao_key = &(this_ao_key->next);

  this_ao_key->key.send_id = -1;
  this_ao_key->key.recv_id = -1;
  this_ao_key->key.algorithm = ALG_HMAC_SHA1;
}
#line 14274 "obj/conf/cf-parse.tab.c"
    break;

  case 1622: /* tcp_ao_key_opt: ID expr ';'  */
#line 278 "proto/bgp/config.Y"
               {
     if ((yyvsp[-1].i) > 255)
       cf_error("Key ID must be in range 0-255");
     this_ao_key->key.send_id = (yyvsp[-1].i);
     this_ao_key->key.recv_id = (yyvsp[-1].i);
   }
#line 14285 "obj/conf/cf-parse.tab.c"
    break;

  case 1623: /* tcp_ao_key_opt: SEND ID expr ';'  */
#line 284 "proto/bgp/config.Y"
                    {
     if ((yyvsp[-1].i) > 255)
       cf_error("Send ID must be in range 0-255");
     this_ao_key->key.send_id = (yyvsp[-1].i);
   }
#line 14295 "obj/conf/cf-parse.tab.c"
    break;

  case 1624: /* tcp_ao_key_opt: RECV ID expr ';'  */
#line 289 "proto/bgp/config.Y"
                    {
     if ((yyvsp[-1].i) > 255)
       cf_error("Recv ID must be in range 0-255");
     this_ao_key->key.recv_id = (yyvsp[-1].i);
   }
#line 14305 "obj/conf/cf-parse.tab.c"
    break;

  case 1625: /* tcp_ao_key_opt: ALGORITHM tcp_ao_algorithm ';'  */
#line 294 "proto/bgp/config.Y"
                                  {
     if (!tcp_ao_alg_known((yyvsp[-1].i)))
       cf_error("Unknown algorithm for TCP-AO");
     this_ao_key->key.algorithm = (yyvsp[-1].i);
   }
#line 14315 "obj/conf/cf-parse.tab.c"
    break;

  case 1626: /* tcp_ao_key_opt: SECRET bytestring_text ';'  */
#line 299 "proto/bgp/config.Y"
                              {
     if ((yyvsp[-1].v).type == T_BYTESTRING)
     {
       this_ao_key->key.key = (yyvsp[-1].v).val.bs->data;
       this_ao_key->key.keylen = (yyvsp[-1].v).val.bs->length;
     }
     else if ((yyvsp[-1].v).type == T_STRING)
     {
       this_ao_key->key.key = (yyvsp[-1].v).val.s;
       this_ao_key->key.keylen = strlen((yyvsp[-1].v).val.s);
     }
     else bug("Bad bytestring_text");

     if (this_ao_key->key.keylen > AO_MAX_KEY_LENGTH)
       cf_error("TCP-AO secret too long");
   }
#line 14336 "obj/conf/cf-parse.tab.c"
    break;

  case 1627: /* tcp_ao_key_opt: DEPRECATED ';'  */
#line 315 "proto/bgp/config.Y"
                  {
     if (this_ao_key->key.preference > 0)
       cf_error("Key cannot be both preferred and deprecated");
     this_ao_key->key.preference = -1;
   }
#line 14346 "obj/conf/cf-parse.tab.c"
    break;

  case 1628: /* tcp_ao_key_opt: PREFERRED ';'  */
#line 320 "proto/bgp/config.Y"
                 {
     if (this_ao_key->key.preference < 0)
       cf_error("Key cannot be both preferred and deprecated");
     this_ao_key->key.preference = 1;
   }
#line 14356 "obj/conf/cf-parse.tab.c"
    break;

  case 1629: /* tcp_ao_algorithm: password_algorithm  */
#line 328 "proto/bgp/config.Y"
                      { (yyval.i) = (yyvsp[0].i); }
#line 14362 "obj/conf/cf-parse.tab.c"
    break;

  case 1630: /* tcp_ao_algorithm: CMAC AES128  */
#line 329 "proto/bgp/config.Y"
               { (yyval.i) = ALG_CMAC_AES128_AO; }
#line 14368 "obj/conf/cf-parse.tab.c"
    break;

  case 1633: /* tcp_ao_key_end: %empty  */
#line 337 "proto/bgp/config.Y"
                {
  struct ao_config *key = this_ao_key;
  this_ao_key = NULL;

  if (key->key.send_id == -1)
    cf_error("No key Send ID");
  if (key->key.recv_id == -1)
    cf_error("No key Recv ID");
  if (!key->key.key || !key->key.keylen)
    cf_error("No secret defined for key %i/%i", key->key.send_id, key->key.recv_id);
}
#line 14384 "obj/conf/cf-parse.tab.c"
    break;

  case 1636: /* tcp_ao_keys: tcp_ao_keys tcp_ao_key ';'  */
#line 353 "proto/bgp/config.Y"
                              { }
#line 14390 "obj/conf/cf-parse.tab.c"
    break;

  case 1637: /* $@16: %empty  */
#line 357 "proto/bgp/config.Y"
       { next_ao_key = &(BGP_CFG->ao_keys); }
#line 14396 "obj/conf/cf-parse.tab.c"
    break;

  case 1638: /* tcp_ao_key_list: '{' $@16 tcp_ao_keys '}'  */
#line 357 "proto/bgp/config.Y"
                                                              { next_ao_key = NULL; }
#line 14402 "obj/conf/cf-parse.tab.c"
    break;

  case 1639: /* tcp_ao_end: %empty  */
#line 361 "proto/bgp/config.Y"
{
  char used_aos_id_send[256];
  char used_aos_id_recv[256];
  memset(used_aos_id_send, 0, sizeof(char)*256);
  memset(used_aos_id_recv, 0, sizeof(char)*256);

  for (struct ao_config *key = BGP_CFG->ao_keys; key; key = key->next)
  {
    if (used_aos_id_send[key->key.send_id])
      cf_error("Multiple keys with Send ID %i", key->key.send_id);
    used_aos_id_send[key->key.send_id] = 1;

    if (used_aos_id_recv[key->key.recv_id])
      cf_error("Multiple keys with Recv ID %i", key->key.recv_id);
    used_aos_id_recv[key->key.recv_id] = 1;
  }
}
#line 14424 "obj/conf/cf-parse.tab.c"
    break;

  case 1640: /* bgp_channel_start: bgp_afi  */
#line 380 "proto/bgp/config.Y"
{
  const struct bgp_af_desc *desc = bgp_get_af_desc((yyvsp[0].i32));

  if (!desc)
    cf_error("Unknown AFI/SAFI");

  this_channel = channel_config_get(&channel_bgp, desc->name, desc->net, this_proto);

  /* New channel */
  if (!BGP_CC->desc)
  {
    BGP_CC->c.in_filter = FILTER_UNDEF;
    BGP_CC->c.out_filter = FILTER_UNDEF;
    BGP_CC->c.ra_mode = RA_UNDEF;
    BGP_CC->afi = (yyvsp[0].i32);
    BGP_CC->desc = desc;
    BGP_CC->next_hop_keep = 0xff; /* undefined */
    BGP_CC->gr_able = 0xff;	/* undefined */
    BGP_CC->llgr_able = 0xff;	/* undefined */
    BGP_CC->llgr_time = ~0U;	/* undefined */
    BGP_CC->min_llgr_time = ~0U; /* undefined */
    BGP_CC->max_llgr_time = ~0U; /* undefined */
    BGP_CC->aigp = 0xff;	/* undefined */
  }
}
#line 14454 "obj/conf/cf-parse.tab.c"
    break;

  case 1641: /* bgp_nh: bool  */
#line 407 "proto/bgp/config.Y"
        { (yyval.i) = (yyvsp[0].i); }
#line 14460 "obj/conf/cf-parse.tab.c"
    break;

  case 1642: /* bgp_nh: IBGP  */
#line 408 "proto/bgp/config.Y"
        { (yyval.i) = NH_IBGP; }
#line 14466 "obj/conf/cf-parse.tab.c"
    break;

  case 1643: /* bgp_nh: EBGP  */
#line 409 "proto/bgp/config.Y"
        { (yyval.i) = NH_EBGP; }
#line 14472 "obj/conf/cf-parse.tab.c"
    break;

  case 1644: /* bgp_llnh: NATIVE  */
#line 413 "proto/bgp/config.Y"
          { (yyval.i) = LLNH_NATIVE; }
#line 14478 "obj/conf/cf-parse.tab.c"
    break;

  case 1645: /* bgp_llnh: SINGLE  */
#line 414 "proto/bgp/config.Y"
          { (yyval.i) = LLNH_SINGLE; }
#line 14484 "obj/conf/cf-parse.tab.c"
    break;

  case 1646: /* bgp_llnh: DOUBLE  */
#line 415 "proto/bgp/config.Y"
          { (yyval.i) = LLNH_DOUBLE; }
#line 14490 "obj/conf/cf-parse.tab.c"
    break;

  case 1651: /* bgp_channel_item: NEXT HOP ADDRESS ipa  */
#line 422 "proto/bgp/config.Y"
                        { BGP_CC->next_hop_addr = (yyvsp[0].a); }
#line 14496 "obj/conf/cf-parse.tab.c"
    break;

  case 1652: /* bgp_channel_item: NEXT HOP SELF bgp_nh  */
#line 423 "proto/bgp/config.Y"
                        { BGP_CC->next_hop_self = (yyvsp[0].i); }
#line 14502 "obj/conf/cf-parse.tab.c"
    break;

  case 1653: /* bgp_channel_item: NEXT HOP KEEP bgp_nh  */
#line 424 "proto/bgp/config.Y"
                        { BGP_CC->next_hop_keep = (yyvsp[0].i); }
#line 14508 "obj/conf/cf-parse.tab.c"
    break;

  case 1654: /* bgp_channel_item: NEXT HOP PREFER GLOBAL  */
#line 425 "proto/bgp/config.Y"
                          { BGP_CC->next_hop_prefer = NHP_GLOBAL; }
#line 14514 "obj/conf/cf-parse.tab.c"
    break;

  case 1655: /* bgp_channel_item: LINK LOCAL NEXT HOP FORMAT bgp_llnh  */
#line 426 "proto/bgp/config.Y"
                                       { BGP_CC->llnh_format = (yyvsp[0].i); }
#line 14520 "obj/conf/cf-parse.tab.c"
    break;

  case 1656: /* bgp_channel_item: MANDATORY bool  */
#line 427 "proto/bgp/config.Y"
                  { BGP_CC->mandatory = (yyvsp[0].i); }
#line 14526 "obj/conf/cf-parse.tab.c"
    break;

  case 1657: /* bgp_channel_item: MISSING LLADDR bgp_lladdr  */
#line 428 "proto/bgp/config.Y"
                             { cf_warn("%s.%s: Missing lladdr option is deprecated and ignored, remove it", this_proto->name, this_channel->name); }
#line 14532 "obj/conf/cf-parse.tab.c"
    break;

  case 1658: /* bgp_channel_item: GATEWAY DIRECT  */
#line 429 "proto/bgp/config.Y"
                  { BGP_CC->gw_mode = GW_DIRECT; }
#line 14538 "obj/conf/cf-parse.tab.c"
    break;

  case 1659: /* bgp_channel_item: GATEWAY RECURSIVE  */
#line 430 "proto/bgp/config.Y"
                     { BGP_CC->gw_mode = GW_RECURSIVE; }
#line 14544 "obj/conf/cf-parse.tab.c"
    break;

  case 1660: /* bgp_channel_item: SECONDARY bool  */
#line 431 "proto/bgp/config.Y"
                  { BGP_CC->secondary = (yyvsp[0].i); }
#line 14550 "obj/conf/cf-parse.tab.c"
    break;

  case 1661: /* bgp_channel_item: VALIDATE bool  */
#line 432 "proto/bgp/config.Y"
                 {
    BGP_CC->validate = (yyvsp[0].i);
    if (BGP_SAFI(BGP_CC->afi) != BGP_SAFI_FLOW)
      cf_error("Validate option limited to flowspec channels");
   }
#line 14560 "obj/conf/cf-parse.tab.c"
    break;

  case 1662: /* bgp_channel_item: GRACEFUL RESTART bool  */
#line 437 "proto/bgp/config.Y"
                         { BGP_CC->gr_able = (yyvsp[0].i); }
#line 14566 "obj/conf/cf-parse.tab.c"
    break;

  case 1663: /* bgp_channel_item: LONG LIVED GRACEFUL RESTART bool  */
#line 438 "proto/bgp/config.Y"
                                    { BGP_CC->llgr_able = (yyvsp[0].i); }
#line 14572 "obj/conf/cf-parse.tab.c"
    break;

  case 1664: /* bgp_channel_item: LONG LIVED STALE TIME expr  */
#line 439 "proto/bgp/config.Y"
                              { BGP_CC->llgr_time = (yyvsp[0].i); if ((yyvsp[0].i) >= (1 << 24)) cf_error("Long-lived stale time must be less than 2^24"); }
#line 14578 "obj/conf/cf-parse.tab.c"
    break;

  case 1665: /* bgp_channel_item: MIN LONG LIVED STALE TIME expr  */
#line 440 "proto/bgp/config.Y"
                                  { BGP_CC->min_llgr_time = (yyvsp[0].i); if ((yyvsp[0].i) >= (1 << 24)) cf_error("Min long-lived stale time must be less than 2^24"); }
#line 14584 "obj/conf/cf-parse.tab.c"
    break;

  case 1666: /* bgp_channel_item: MAX LONG LIVED STALE TIME expr  */
#line 441 "proto/bgp/config.Y"
                                  { BGP_CC->max_llgr_time = (yyvsp[0].i); if ((yyvsp[0].i) >= (1 << 24)) cf_error("Max long-lived stale time must be less than 2^24"); }
#line 14590 "obj/conf/cf-parse.tab.c"
    break;

  case 1667: /* bgp_channel_item: EXTENDED NEXT HOP bool  */
#line 442 "proto/bgp/config.Y"
                          { BGP_CC->ext_next_hop = (yyvsp[0].i); }
#line 14596 "obj/conf/cf-parse.tab.c"
    break;

  case 1668: /* bgp_channel_item: REQUIRE EXTENDED NEXT HOP bool  */
#line 443 "proto/bgp/config.Y"
                                  { BGP_CC->require_ext_next_hop = (yyvsp[0].i);  if (BGP_AFI(BGP_CC->afi) != BGP_AFI_IPV4) cf_warn("Require extended next hop option ignored for non-IPv4 channels"); }
#line 14602 "obj/conf/cf-parse.tab.c"
    break;

  case 1669: /* bgp_channel_item: ADD PATHS RX  */
#line 444 "proto/bgp/config.Y"
                { BGP_CC->add_path = BGP_ADD_PATH_RX; }
#line 14608 "obj/conf/cf-parse.tab.c"
    break;

  case 1670: /* bgp_channel_item: ADD PATHS TX  */
#line 445 "proto/bgp/config.Y"
                { BGP_CC->add_path = BGP_ADD_PATH_TX; }
#line 14614 "obj/conf/cf-parse.tab.c"
    break;

  case 1671: /* bgp_channel_item: ADD PATHS bool  */
#line 446 "proto/bgp/config.Y"
                  { BGP_CC->add_path = (yyvsp[0].i) ? BGP_ADD_PATH_FULL : 0; }
#line 14620 "obj/conf/cf-parse.tab.c"
    break;

  case 1672: /* bgp_channel_item: REQUIRE ADD PATHS bool  */
#line 447 "proto/bgp/config.Y"
                          { BGP_CC->require_add_path = (yyvsp[0].i); }
#line 14626 "obj/conf/cf-parse.tab.c"
    break;

  case 1673: /* bgp_channel_item: IMPORT TABLE bool  */
#line 448 "proto/bgp/config.Y"
                     { BGP_CC->import_table = (yyvsp[0].i); }
#line 14632 "obj/conf/cf-parse.tab.c"
    break;

  case 1674: /* bgp_channel_item: EXPORT TABLE bool  */
#line 449 "proto/bgp/config.Y"
                     { BGP_CC->export_table = (yyvsp[0].i); }
#line 14638 "obj/conf/cf-parse.tab.c"
    break;

  case 1675: /* bgp_channel_item: AIGP bool  */
#line 450 "proto/bgp/config.Y"
             { BGP_CC->aigp = (yyvsp[0].i); BGP_CC->aigp_originate = 0; }
#line 14644 "obj/conf/cf-parse.tab.c"
    break;

  case 1676: /* bgp_channel_item: AIGP ORIGINATE  */
#line 451 "proto/bgp/config.Y"
                  { BGP_CC->aigp = 1; BGP_CC->aigp_originate = 1; }
#line 14650 "obj/conf/cf-parse.tab.c"
    break;

  case 1677: /* bgp_channel_item: COST expr  */
#line 452 "proto/bgp/config.Y"
             { BGP_CC->cost = (yyvsp[0].i); if ((yyvsp[0].i) < 1) cf_error("Cost must be positive"); }
#line 14656 "obj/conf/cf-parse.tab.c"
    break;

  case 1678: /* bgp_channel_item: IGP TABLE rtable  */
#line 453 "proto/bgp/config.Y"
                    {
    if (BGP_CC->desc->no_igp)
      cf_error("IGP table not allowed here");

    if ((yyvsp[0].r)->addr_type == NET_IP4)
      BGP_CC->igp_table_ip4 = (yyvsp[0].r);
    else if ((yyvsp[0].r)->addr_type == NET_IP6)
      BGP_CC->igp_table_ip6 = (yyvsp[0].r);
    else
      cf_error("Mismatched IGP table type");
   }
#line 14672 "obj/conf/cf-parse.tab.c"
    break;

  case 1679: /* bgp_channel_item: BASE TABLE rtable  */
#line 464 "proto/bgp/config.Y"
                     {
    if (BGP_SAFI(BGP_CC->afi) != BGP_SAFI_FLOW)
      cf_error("Base table option limited to flowspec channels");

    if (((BGP_CC->afi == BGP_AF_FLOW4) && ((yyvsp[0].r)->addr_type == NET_IP4)) ||
        ((BGP_CC->afi == BGP_AF_FLOW6) && ((yyvsp[0].r)->addr_type == NET_IP6)))
      BGP_CC->base_table = (yyvsp[0].r);
    else
      cf_error("Mismatched base table type");
   }
#line 14687 "obj/conf/cf-parse.tab.c"
    break;

  case 1684: /* bgp_channel_end: %empty  */
#line 487 "proto/bgp/config.Y"
{
  if (!this_channel->table)
    cf_error("Routing table not specified");

  this_channel = NULL;
}
#line 14698 "obj/conf/cf-parse.tab.c"
    break;

  case 1686: /* dynamic_attr: BGP_ORIGIN  */
#line 498 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(PROTOCOL_BGP, BA_ORIGIN));	(yyval.fda).flags = BAF_TRANSITIVE; }
#line 14704 "obj/conf/cf-parse.tab.c"
    break;

  case 1687: /* dynamic_attr: BGP_PATH  */
#line 500 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(PROTOCOL_BGP, BA_AS_PATH));		(yyval.fda).flags = BAF_TRANSITIVE; }
#line 14710 "obj/conf/cf-parse.tab.c"
    break;

  case 1688: /* dynamic_attr: BGP_NEXT_HOP  */
#line 502 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(PROTOCOL_BGP, BA_NEXT_HOP));	(yyval.fda).flags = BAF_TRANSITIVE; }
#line 14716 "obj/conf/cf-parse.tab.c"
    break;

  case 1689: /* dynamic_attr: BGP_MED  */
#line 504 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(PROTOCOL_BGP, BA_MULTI_EXIT_DISC));	(yyval.fda).flags = BAF_OPTIONAL; }
#line 14722 "obj/conf/cf-parse.tab.c"
    break;

  case 1690: /* dynamic_attr: BGP_LOCAL_PREF  */
#line 506 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(PROTOCOL_BGP, BA_LOCAL_PREF));		(yyval.fda).flags = BAF_TRANSITIVE; }
#line 14728 "obj/conf/cf-parse.tab.c"
    break;

  case 1691: /* dynamic_attr: BGP_ATOMIC_AGGR  */
#line 508 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(PROTOCOL_BGP, BA_ATOMIC_AGGR)); (yyval.fda).flags = BAF_TRANSITIVE; }
#line 14734 "obj/conf/cf-parse.tab.c"
    break;

  case 1692: /* dynamic_attr: BGP_AGGREGATOR  */
#line 510 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(PROTOCOL_BGP, BA_AGGREGATOR));	(yyval.fda).flags = BAF_OPTIONAL | BAF_TRANSITIVE; }
#line 14740 "obj/conf/cf-parse.tab.c"
    break;

  case 1693: /* dynamic_attr: BGP_COMMUNITY  */
#line 512 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(PROTOCOL_BGP, BA_COMMUNITY));	(yyval.fda).flags = BAF_OPTIONAL | BAF_TRANSITIVE; }
#line 14746 "obj/conf/cf-parse.tab.c"
    break;

  case 1694: /* dynamic_attr: BGP_ORIGINATOR_ID  */
#line 514 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(PROTOCOL_BGP, BA_ORIGINATOR_ID));	(yyval.fda).flags = BAF_OPTIONAL; }
#line 14752 "obj/conf/cf-parse.tab.c"
    break;

  case 1695: /* dynamic_attr: BGP_CLUSTER_LIST  */
#line 516 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(PROTOCOL_BGP, BA_CLUSTER_LIST));	(yyval.fda).flags = BAF_OPTIONAL; }
#line 14758 "obj/conf/cf-parse.tab.c"
    break;

  case 1696: /* dynamic_attr: BGP_EXT_COMMUNITY  */
#line 518 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(PROTOCOL_BGP, BA_EXT_COMMUNITY));	(yyval.fda).flags = BAF_OPTIONAL | BAF_TRANSITIVE; }
#line 14764 "obj/conf/cf-parse.tab.c"
    break;

  case 1697: /* dynamic_attr: BGP_AIGP  */
#line 520 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(PROTOCOL_BGP, BA_AIGP));	(yyval.fda).flags = BAF_OPTIONAL; }
#line 14770 "obj/conf/cf-parse.tab.c"
    break;

  case 1698: /* dynamic_attr: BGP_LARGE_COMMUNITY  */
#line 522 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_LC_SET, T_LCLIST, EA_CODE(PROTOCOL_BGP, BA_LARGE_COMMUNITY)); (yyval.fda).flags = BAF_OPTIONAL | BAF_TRANSITIVE; }
#line 14776 "obj/conf/cf-parse.tab.c"
    break;

  case 1699: /* dynamic_attr: BGP_OTC  */
#line 524 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(PROTOCOL_BGP, BA_ONLY_TO_CUSTOMER));	(yyval.fda).flags = BAF_OPTIONAL | BAF_TRANSITIVE; }
#line 14782 "obj/conf/cf-parse.tab.c"
    break;

  case 1700: /* custom_attr: ATTRIBUTE BGP expr type symbol ';'  */
#line 526 "proto/bgp/config.Y"
                                                {
  if ((yyvsp[-3].i) > 255 || (yyvsp[-3].i) < 1)
    cf_error("Invalid attribute number (Given %i, must be 1-255)", (yyvsp[-3].i));
  if ((yyvsp[-2].i) != T_BYTESTRING)
    cf_error("Attribute type must be bytestring, not %s", f_type_name((yyvsp[-2].i)));
  if (bgp_attr_name((yyvsp[-3].i)))
    cf_error("Attribute BGP.%d already known as %s", (yyvsp[-3].i), bgp_attr_name((yyvsp[-3].i)));

  struct f_dynamic_attr *a = cfg_alloc(sizeof(struct f_dynamic_attr));
  *a = f_new_dynamic_attr(f_type_attr((yyvsp[-2].i)), T_BYTESTRING, EA_CODE(PROTOCOL_BGP, (yyvsp[-3].i)));
  a->flags = BAF_TRANSITIVE | BAF_OPTIONAL;
  cf_define_symbol(new_config, (yyvsp[-1].s), SYM_ATTRIBUTE, attribute, a);
}
#line 14800 "obj/conf/cf-parse.tab.c"
    break;

  case 1701: /* term: ASPA_CHECK_DOWNSTREAM '(' rtable ')'  */
#line 543 "proto/bgp/config.Y"
                                           { (yyval.x) =
  f_new_inst(FI_ASPA_CHECK_EXPLICIT,
      f_new_inst(FI_EA_GET,
	f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_ROUTE, .val.rte = NULL, }),
	f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(PROTOCOL_BGP, BA_AS_PATH))
      ),
      f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_BOOL, .val.i = 0, }),
      (yyvsp[-1].r)
  );
}
#line 14815 "obj/conf/cf-parse.tab.c"
    break;

  case 1702: /* term: ASPA_CHECK_UPSTREAM '(' rtable ')'  */
#line 554 "proto/bgp/config.Y"
                                         { (yyval.x) =
  f_new_inst(FI_ASPA_CHECK_EXPLICIT,
      f_new_inst(FI_EA_GET,
	f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_ROUTE, .val.rte = NULL, }),
	f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(PROTOCOL_BGP, BA_AS_PATH))
      ),
      f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_BOOL, .val.i = 1, }),
      (yyvsp[-1].r)
  );
}
#line 14830 "obj/conf/cf-parse.tab.c"
    break;

  case 1704: /* l3vpn_channel_start: net_type_base  */
#line 53 "proto/l3vpn/config.Y"
{
  /* Redefining proto_channel to change default values */
  (yyval.cc) = this_channel = channel_config_get(NULL, net_label[(yyvsp[0].i)], (yyvsp[0].i), this_proto);
  if (!this_channel->copy)
  {
    this_channel->out_filter = FILTER_ACCEPT;
    this_channel->preference = net_val_match((yyvsp[0].i), NB_IP) ?
      DEF_PREF_L3VPN_IMPORT :
      DEF_PREF_L3VPN_EXPORT;
  }
}
#line 14846 "obj/conf/cf-parse.tab.c"
    break;

  case 1706: /* l3vpn_proto_start: proto_start L3VPN  */
#line 68 "proto/l3vpn/config.Y"
{
  this_proto = proto_config_new(&proto_l3vpn, (yyvsp[-1].i));
}
#line 14854 "obj/conf/cf-parse.tab.c"
    break;

  case 1710: /* l3vpn_proto_item: RD VPN_RD  */
#line 77 "proto/l3vpn/config.Y"
             { L3VPN_CFG->rd = (yyvsp[0].rd); }
#line 14860 "obj/conf/cf-parse.tab.c"
    break;

  case 1711: /* l3vpn_proto_item: ROUTE DISTINGUISHER VPN_RD  */
#line 78 "proto/l3vpn/config.Y"
                              { L3VPN_CFG->rd = (yyvsp[0].rd); }
#line 14866 "obj/conf/cf-parse.tab.c"
    break;

  case 1712: /* l3vpn_proto_item: IMPORT TARGET l3vpn_targets  */
#line 79 "proto/l3vpn/config.Y"
                               { L3VPN_CFG->import_target = (yyvsp[0].e); }
#line 14872 "obj/conf/cf-parse.tab.c"
    break;

  case 1713: /* l3vpn_proto_item: EXPORT TARGET l3vpn_targets  */
#line 80 "proto/l3vpn/config.Y"
                               { L3VPN_CFG->export_target = (yyvsp[0].e); }
#line 14878 "obj/conf/cf-parse.tab.c"
    break;

  case 1714: /* l3vpn_proto_item: ROUTE TARGET l3vpn_targets  */
#line 81 "proto/l3vpn/config.Y"
                              { L3VPN_CFG->import_target = L3VPN_CFG->export_target = (yyvsp[0].e); }
#line 14884 "obj/conf/cf-parse.tab.c"
    break;

  case 1718: /* l3vpn_targets: ec_item  */
#line 94 "proto/l3vpn/config.Y"
           { f_tree_only_rt((yyvsp[0].e)); (yyval.e) = (yyvsp[0].e); }
#line 14890 "obj/conf/cf-parse.tab.c"
    break;

  case 1719: /* l3vpn_targets: '[' ec_items ']'  */
#line 95 "proto/l3vpn/config.Y"
                    { f_tree_only_rt((yyvsp[-1].e)); (yyval.e) = build_tree((yyvsp[-1].e)); }
#line 14896 "obj/conf/cf-parse.tab.c"
    break;

  case 1721: /* mrt_proto_start: proto_start MRT  */
#line 29 "proto/mrt/config.Y"
{
  this_proto = proto_config_new(&proto_mrt, (yyvsp[-1].i));
}
#line 14904 "obj/conf/cf-parse.tab.c"
    break;

  case 1723: /* mrt_proto_item: TABLE rtable  */
#line 35 "proto/mrt/config.Y"
                        { MRT_CFG->table_cf = (yyvsp[0].r); }
#line 14910 "obj/conf/cf-parse.tab.c"
    break;

  case 1724: /* mrt_proto_item: TABLE TEXT  */
#line 36 "proto/mrt/config.Y"
                        { MRT_CFG->table_expr = (yyvsp[0].t); }
#line 14916 "obj/conf/cf-parse.tab.c"
    break;

  case 1725: /* mrt_proto_item: FILTER filter  */
#line 37 "proto/mrt/config.Y"
                        { MRT_CFG->filter = (yyvsp[0].f); }
#line 14922 "obj/conf/cf-parse.tab.c"
    break;

  case 1726: /* mrt_proto_item: where_filter  */
#line 38 "proto/mrt/config.Y"
                        { MRT_CFG->filter = (yyvsp[0].f); }
#line 14928 "obj/conf/cf-parse.tab.c"
    break;

  case 1727: /* mrt_proto_item: FILENAME text  */
#line 39 "proto/mrt/config.Y"
                        { MRT_CFG->filename = (yyvsp[0].t); }
#line 14934 "obj/conf/cf-parse.tab.c"
    break;

  case 1728: /* mrt_proto_item: PERIOD expr  */
#line 40 "proto/mrt/config.Y"
                        { MRT_CFG->period = (yyvsp[0].i); }
#line 14940 "obj/conf/cf-parse.tab.c"
    break;

  case 1729: /* mrt_proto_item: ALWAYS ADD PATH bool  */
#line 41 "proto/mrt/config.Y"
                        { MRT_CFG->always_add_path = (yyvsp[0].i); }
#line 14946 "obj/conf/cf-parse.tab.c"
    break;

  case 1732: /* mrt_proto: mrt_proto_start proto_name '{' mrt_proto_opts '}'  */
#line 50 "proto/mrt/config.Y"
                                                     { mrt_check_config(this_proto); }
#line 14952 "obj/conf/cf-parse.tab.c"
    break;

  case 1734: /* cmd_MRT_DUMP: MRT DUMP mrt_dump_args END  */
#line 54 "proto/mrt/config.Y"
{ mrt_dump_cmd((yyvsp[-1].md)); }
#line 14958 "obj/conf/cf-parse.tab.c"
    break;

  case 1735: /* mrt_dump_args: %empty  */
#line 62 "proto/mrt/config.Y"
               { (yyval.md) = cfg_allocz(sizeof(struct mrt_dump_data)); }
#line 14964 "obj/conf/cf-parse.tab.c"
    break;

  case 1736: /* mrt_dump_args: mrt_dump_args TABLE rtable  */
#line 63 "proto/mrt/config.Y"
                                { (yyval.md) = (yyvsp[-2].md); (yyval.md)->table_ptr = (yyvsp[0].r)->table; }
#line 14970 "obj/conf/cf-parse.tab.c"
    break;

  case 1737: /* mrt_dump_args: mrt_dump_args TABLE TEXT  */
#line 64 "proto/mrt/config.Y"
                                { (yyval.md) = (yyvsp[-2].md); (yyval.md)->table_expr = (yyvsp[0].t); }
#line 14976 "obj/conf/cf-parse.tab.c"
    break;

  case 1738: /* mrt_dump_args: mrt_dump_args FILTER filter  */
#line 65 "proto/mrt/config.Y"
                                { (yyval.md) = (yyvsp[-2].md); (yyval.md)->filter = (yyvsp[0].f); }
#line 14982 "obj/conf/cf-parse.tab.c"
    break;

  case 1739: /* mrt_dump_args: mrt_dump_args where_filter  */
#line 66 "proto/mrt/config.Y"
                                { (yyval.md) = (yyvsp[-1].md); (yyval.md)->filter = (yyvsp[0].f); }
#line 14988 "obj/conf/cf-parse.tab.c"
    break;

  case 1740: /* mrt_dump_args: mrt_dump_args TO text  */
#line 67 "proto/mrt/config.Y"
                                { (yyval.md) = (yyvsp[-2].md); (yyval.md)->filename = (yyvsp[0].t); }
#line 14994 "obj/conf/cf-parse.tab.c"
    break;

  case 1741: /* proto: ospf_proto '}'  */
#line 212 "proto/ospf/config.Y"
                      { ospf_proto_finish(); }
#line 15000 "obj/conf/cf-parse.tab.c"
    break;

  case 1742: /* ospf_variant: OSPF  */
#line 215 "proto/ospf/config.Y"
           { (yyval.i) = 1; }
#line 15006 "obj/conf/cf-parse.tab.c"
    break;

  case 1743: /* ospf_variant: OSPF V2  */
#line 216 "proto/ospf/config.Y"
           { (yyval.i) = 1; }
#line 15012 "obj/conf/cf-parse.tab.c"
    break;

  case 1744: /* ospf_variant: OSPF V3  */
#line 217 "proto/ospf/config.Y"
           { (yyval.i) = 0; }
#line 15018 "obj/conf/cf-parse.tab.c"
    break;

  case 1745: /* ospf_proto_start: proto_start ospf_variant  */
#line 221 "proto/ospf/config.Y"
{
  this_proto = proto_config_new(&proto_ospf, (yyvsp[-1].i));
  this_proto->net_type = (yyvsp[0].i) ? NET_IP4 : 0;

  init_list(&OSPF_CFG->area_list);
  init_list(&OSPF_CFG->vlink_list);
  OSPF_CFG->ecmp = rt_default_ecmp;
  OSPF_CFG->tick = OSPF_DEFAULT_TICK;
  OSPF_CFG->ospf2 = (yyvsp[0].i);
  OSPF_CFG->af_ext = !(yyvsp[0].i);
  OSPF_CFG->gr_mode = OSPF_GR_AWARE;
  OSPF_CFG->gr_time = OSPF_DEFAULT_GR_TIME;
}
#line 15036 "obj/conf/cf-parse.tab.c"
    break;

  case 1748: /* ospf_af_mc: %empty  */
#line 241 "proto/ospf/config.Y"
             { (yyval.i) = 0; }
#line 15042 "obj/conf/cf-parse.tab.c"
    break;

  case 1749: /* ospf_af_mc: MULTICAST  */
#line 242 "proto/ospf/config.Y"
             { (yyval.i) = 1; }
#line 15048 "obj/conf/cf-parse.tab.c"
    break;

  case 1750: /* ospf_channel_start: net_type ospf_af_mc  */
#line 247 "proto/ospf/config.Y"
{
  /* TODO: change name for multicast channels */
  (yyval.cc) = this_channel = channel_config_get(NULL, net_label[(yyvsp[-1].i)], (yyvsp[-1].i), this_proto);

  /* Save the multicast flag */
  OSPF_CFG->af_mc = (yyvsp[0].i);
}
#line 15060 "obj/conf/cf-parse.tab.c"
    break;

  case 1753: /* ospf_proto_item: ospf_channel  */
#line 259 "proto/ospf/config.Y"
                { this_proto->net_type = (yyvsp[0].cc)->net_type; }
#line 15066 "obj/conf/cf-parse.tab.c"
    break;

  case 1754: /* ospf_proto_item: RFC1583COMPAT bool  */
#line 260 "proto/ospf/config.Y"
                      { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 15072 "obj/conf/cf-parse.tab.c"
    break;

  case 1755: /* ospf_proto_item: RFC5838 bool  */
#line 261 "proto/ospf/config.Y"
                { OSPF_CFG->af_ext = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("RFC5838 option requires OSPFv3"); }
#line 15078 "obj/conf/cf-parse.tab.c"
    break;

  case 1756: /* ospf_proto_item: VPN PE bool  */
#line 262 "proto/ospf/config.Y"
               { OSPF_CFG->vpn_pe = (yyvsp[0].i); }
#line 15084 "obj/conf/cf-parse.tab.c"
    break;

  case 1757: /* ospf_proto_item: STUB ROUTER bool  */
#line 263 "proto/ospf/config.Y"
                    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 15090 "obj/conf/cf-parse.tab.c"
    break;

  case 1758: /* ospf_proto_item: GRACEFUL RESTART bool  */
#line 264 "proto/ospf/config.Y"
                         { OSPF_CFG->gr_mode = (yyvsp[0].i); }
#line 15096 "obj/conf/cf-parse.tab.c"
    break;

  case 1759: /* ospf_proto_item: GRACEFUL RESTART AWARE  */
#line 265 "proto/ospf/config.Y"
                          { OSPF_CFG->gr_mode = OSPF_GR_AWARE; }
#line 15102 "obj/conf/cf-parse.tab.c"
    break;

  case 1760: /* ospf_proto_item: GRACEFUL RESTART TIME expr  */
#line 266 "proto/ospf/config.Y"
                              { OSPF_CFG->gr_time = (yyvsp[0].i); if (((yyvsp[0].i) < 1) || ((yyvsp[0].i) > 1800)) cf_error("Graceful restart time must be in range 1-1800"); }
#line 15108 "obj/conf/cf-parse.tab.c"
    break;

  case 1761: /* ospf_proto_item: ECMP bool  */
#line 267 "proto/ospf/config.Y"
             { OSPF_CFG->ecmp = (yyvsp[0].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
#line 15114 "obj/conf/cf-parse.tab.c"
    break;

  case 1762: /* ospf_proto_item: ECMP bool LIMIT expr  */
#line 268 "proto/ospf/config.Y"
                        { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; }
#line 15120 "obj/conf/cf-parse.tab.c"
    break;

  case 1763: /* ospf_proto_item: MERGE EXTERNAL bool  */
#line 269 "proto/ospf/config.Y"
                       { OSPF_CFG->merge_external = (yyvsp[0].i); }
#line 15126 "obj/conf/cf-parse.tab.c"
    break;

  case 1764: /* ospf_proto_item: TICK expr  */
#line 270 "proto/ospf/config.Y"
             { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i) <= 0) cf_error("Tick must be greater than zero"); }
#line 15132 "obj/conf/cf-parse.tab.c"
    break;

  case 1765: /* ospf_proto_item: INSTANCE ID expr  */
#line 271 "proto/ospf/config.Y"
                    { OSPF_CFG->instance_id = (yyvsp[0].i); OSPF_CFG->instance_id_set = 1; if ((yyvsp[0].i) > 255) cf_error("Instance ID must be in range 0-255"); }
#line 15138 "obj/conf/cf-parse.tab.c"
    break;

  case 1767: /* ospf_area_start: AREA idval  */
#line 275 "proto/ospf/config.Y"
                            {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 15156 "obj/conf/cf-parse.tab.c"
    break;

  case 1768: /* ospf_area: ospf_area_start '{' ospf_area_opts '}'  */
#line 290 "proto/ospf/config.Y"
                                                  { ospf_area_finish(); }
#line 15162 "obj/conf/cf-parse.tab.c"
    break;

  case 1771: /* ospf_area_item: STUB bool  */
#line 299 "proto/ospf/config.Y"
             { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 15168 "obj/conf/cf-parse.tab.c"
    break;

  case 1772: /* ospf_area_item: NSSA  */
#line 300 "proto/ospf/config.Y"
        { this_area->type = OPT_N; }
#line 15174 "obj/conf/cf-parse.tab.c"
    break;

  case 1773: /* ospf_area_item: SUMMARY bool  */
#line 301 "proto/ospf/config.Y"
                { this_area->summary = (yyvsp[0].i); }
#line 15180 "obj/conf/cf-parse.tab.c"
    break;

  case 1774: /* ospf_area_item: DEFAULT NSSA bool  */
#line 302 "proto/ospf/config.Y"
                     { this_area->default_nssa = (yyvsp[0].i); }
#line 15186 "obj/conf/cf-parse.tab.c"
    break;

  case 1775: /* ospf_area_item: DEFAULT COST expr  */
#line 303 "proto/ospf/config.Y"
                     { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 15192 "obj/conf/cf-parse.tab.c"
    break;

  case 1776: /* ospf_area_item: DEFAULT COST2 expr  */
#line 304 "proto/ospf/config.Y"
                      { this_area->default_cost = (yyvsp[0].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[0].i)); }
#line 15198 "obj/conf/cf-parse.tab.c"
    break;

  case 1777: /* ospf_area_item: STUB COST expr  */
#line 305 "proto/ospf/config.Y"
                  { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 15204 "obj/conf/cf-parse.tab.c"
    break;

  case 1778: /* ospf_area_item: TRANSLATOR bool  */
#line 306 "proto/ospf/config.Y"
                   { this_area->translator = (yyvsp[0].i); }
#line 15210 "obj/conf/cf-parse.tab.c"
    break;

  case 1779: /* ospf_area_item: TRANSLATOR STABILITY expr  */
#line 307 "proto/ospf/config.Y"
                             { this_area->transint = (yyvsp[0].i); }
#line 15216 "obj/conf/cf-parse.tab.c"
    break;

  case 1780: /* $@17: %empty  */
#line 308 "proto/ospf/config.Y"
            { this_nets = &this_area->net_list; }
#line 15222 "obj/conf/cf-parse.tab.c"
    break;

  case 1782: /* $@18: %empty  */
#line 309 "proto/ospf/config.Y"
            { this_nets = &this_area->enet_list; }
#line 15228 "obj/conf/cf-parse.tab.c"
    break;

  case 1789: /* ospf_stubnet_start: net_ip  */
#line 321 "proto/ospf/config.Y"
          {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->prefix = (yyvsp[0].net);
     this_stubnet->cost = COST_D;
   }
#line 15239 "obj/conf/cf-parse.tab.c"
    break;

  case 1792: /* ospf_stubnet_item: HIDDEN bool  */
#line 335 "proto/ospf/config.Y"
               { this_stubnet->hidden = (yyvsp[0].i); }
#line 15245 "obj/conf/cf-parse.tab.c"
    break;

  case 1793: /* ospf_stubnet_item: SUMMARY bool  */
#line 336 "proto/ospf/config.Y"
                { this_stubnet->summary = (yyvsp[0].i); }
#line 15251 "obj/conf/cf-parse.tab.c"
    break;

  case 1794: /* ospf_stubnet_item: COST expr  */
#line 337 "proto/ospf/config.Y"
             { this_stubnet->cost = (yyvsp[0].i); }
#line 15257 "obj/conf/cf-parse.tab.c"
    break;

  case 1795: /* ospf_vlink: ospf_vlink_start ospf_instance_id '{' ospf_vlink_opts '}'  */
#line 341 "proto/ospf/config.Y"
                                                             { ospf_iface_finish(); }
#line 15263 "obj/conf/cf-parse.tab.c"
    break;

  case 1796: /* ospf_vlink: ospf_vlink_start ospf_instance_id  */
#line 342 "proto/ospf/config.Y"
                                     { ospf_iface_finish(); }
#line 15269 "obj/conf/cf-parse.tab.c"
    break;

  case 1800: /* ospf_vlink_item: HELLO expr  */
#line 351 "proto/ospf/config.Y"
              { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 15275 "obj/conf/cf-parse.tab.c"
    break;

  case 1801: /* ospf_vlink_item: RETRANSMIT expr  */
#line 352 "proto/ospf/config.Y"
                   { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 15281 "obj/conf/cf-parse.tab.c"
    break;

  case 1802: /* ospf_vlink_item: TRANSMIT DELAY expr  */
#line 353 "proto/ospf/config.Y"
                       { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 15287 "obj/conf/cf-parse.tab.c"
    break;

  case 1803: /* ospf_vlink_item: WAIT expr  */
#line 354 "proto/ospf/config.Y"
             { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 15293 "obj/conf/cf-parse.tab.c"
    break;

  case 1804: /* ospf_vlink_item: DEAD expr  */
#line 355 "proto/ospf/config.Y"
             { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 15299 "obj/conf/cf-parse.tab.c"
    break;

  case 1805: /* ospf_vlink_item: DEAD COUNT expr  */
#line 356 "proto/ospf/config.Y"
                   { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 15305 "obj/conf/cf-parse.tab.c"
    break;

  case 1806: /* ospf_vlink_item: AUTHENTICATION NONE  */
#line 357 "proto/ospf/config.Y"
                       { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
#line 15311 "obj/conf/cf-parse.tab.c"
    break;

  case 1807: /* ospf_vlink_item: AUTHENTICATION SIMPLE  */
#line 358 "proto/ospf/config.Y"
                         { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 15317 "obj/conf/cf-parse.tab.c"
    break;

  case 1808: /* ospf_vlink_item: AUTHENTICATION CRYPTOGRAPHIC  */
#line 359 "proto/ospf/config.Y"
                                { OSPF_PATT->autype = OSPF_AUTH_CRYPT; }
#line 15323 "obj/conf/cf-parse.tab.c"
    break;

  case 1810: /* ospf_vlink_start: VIRTUAL LINK idval  */
#line 364 "proto/ospf/config.Y"
 {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
#line 15343 "obj/conf/cf-parse.tab.c"
    break;

  case 1811: /* ospf_iface_item: COST expr  */
#line 382 "proto/ospf/config.Y"
             { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 15349 "obj/conf/cf-parse.tab.c"
    break;

  case 1812: /* ospf_iface_item: HELLO expr  */
#line 383 "proto/ospf/config.Y"
              { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 15355 "obj/conf/cf-parse.tab.c"
    break;

  case 1813: /* ospf_iface_item: POLL expr  */
#line 384 "proto/ospf/config.Y"
             { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 15361 "obj/conf/cf-parse.tab.c"
    break;

  case 1814: /* ospf_iface_item: RETRANSMIT expr  */
#line 385 "proto/ospf/config.Y"
                   { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 15367 "obj/conf/cf-parse.tab.c"
    break;

  case 1815: /* ospf_iface_item: WAIT expr  */
#line 386 "proto/ospf/config.Y"
             { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 15373 "obj/conf/cf-parse.tab.c"
    break;

  case 1816: /* ospf_iface_item: DEAD expr  */
#line 387 "proto/ospf/config.Y"
             { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 15379 "obj/conf/cf-parse.tab.c"
    break;

  case 1817: /* ospf_iface_item: DEAD COUNT expr  */
#line 388 "proto/ospf/config.Y"
                   { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 15385 "obj/conf/cf-parse.tab.c"
    break;

  case 1818: /* ospf_iface_item: TYPE BROADCAST  */
#line 389 "proto/ospf/config.Y"
                  { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 15391 "obj/conf/cf-parse.tab.c"
    break;

  case 1819: /* ospf_iface_item: TYPE BCAST  */
#line 390 "proto/ospf/config.Y"
              { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 15397 "obj/conf/cf-parse.tab.c"
    break;

  case 1820: /* ospf_iface_item: TYPE NONBROADCAST  */
#line 391 "proto/ospf/config.Y"
                     { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 15403 "obj/conf/cf-parse.tab.c"
    break;

  case 1821: /* ospf_iface_item: TYPE NBMA  */
#line 392 "proto/ospf/config.Y"
             { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 15409 "obj/conf/cf-parse.tab.c"
    break;

  case 1822: /* ospf_iface_item: TYPE POINTOPOINT  */
#line 393 "proto/ospf/config.Y"
                    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 15415 "obj/conf/cf-parse.tab.c"
    break;

  case 1823: /* ospf_iface_item: TYPE PTP  */
#line 394 "proto/ospf/config.Y"
            { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 15421 "obj/conf/cf-parse.tab.c"
    break;

  case 1824: /* ospf_iface_item: TYPE POINTOMULTIPOINT  */
#line 395 "proto/ospf/config.Y"
                         { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 15427 "obj/conf/cf-parse.tab.c"
    break;

  case 1825: /* ospf_iface_item: TYPE PTMP  */
#line 396 "proto/ospf/config.Y"
             { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 15433 "obj/conf/cf-parse.tab.c"
    break;

  case 1826: /* ospf_iface_item: REAL BROADCAST bool  */
#line 397 "proto/ospf/config.Y"
                       { OSPF_PATT->real_bcast = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
#line 15439 "obj/conf/cf-parse.tab.c"
    break;

  case 1827: /* ospf_iface_item: PTP NETMASK bool  */
#line 398 "proto/ospf/config.Y"
                    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
#line 15445 "obj/conf/cf-parse.tab.c"
    break;

  case 1828: /* ospf_iface_item: PTP ADDRESS bool  */
#line 399 "proto/ospf/config.Y"
                    { OSPF_PATT->ptp_address = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP address option requires OSPFv2"); }
#line 15451 "obj/conf/cf-parse.tab.c"
    break;

  case 1829: /* ospf_iface_item: TRANSMIT DELAY expr  */
#line 400 "proto/ospf/config.Y"
                       { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 15457 "obj/conf/cf-parse.tab.c"
    break;

  case 1830: /* ospf_iface_item: PRIORITY expr  */
#line 401 "proto/ospf/config.Y"
                 { OSPF_PATT->priority = (yyvsp[0].i) ; if ((yyvsp[0].i)>255) cf_error("Priority must be in range 0-255"); }
#line 15463 "obj/conf/cf-parse.tab.c"
    break;

  case 1831: /* ospf_iface_item: STRICT NONBROADCAST bool  */
#line 402 "proto/ospf/config.Y"
                            { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 15469 "obj/conf/cf-parse.tab.c"
    break;

  case 1832: /* ospf_iface_item: STUB bool  */
#line 403 "proto/ospf/config.Y"
             { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 15475 "obj/conf/cf-parse.tab.c"
    break;

  case 1833: /* ospf_iface_item: CHECK LINK bool  */
#line 404 "proto/ospf/config.Y"
                   { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 15481 "obj/conf/cf-parse.tab.c"
    break;

  case 1834: /* ospf_iface_item: ECMP WEIGHT expr  */
#line 405 "proto/ospf/config.Y"
                    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 15487 "obj/conf/cf-parse.tab.c"
    break;

  case 1835: /* ospf_iface_item: LINK LSA SUPPRESSION bool  */
#line 406 "proto/ospf/config.Y"
                             { OSPF_PATT->link_lsa_suppression = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
#line 15493 "obj/conf/cf-parse.tab.c"
    break;

  case 1837: /* ospf_iface_item: AUTHENTICATION NONE  */
#line 408 "proto/ospf/config.Y"
                       { OSPF_PATT->autype = OSPF_AUTH_NONE; }
#line 15499 "obj/conf/cf-parse.tab.c"
    break;

  case 1838: /* ospf_iface_item: AUTHENTICATION SIMPLE  */
#line 409 "proto/ospf/config.Y"
                         { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 15505 "obj/conf/cf-parse.tab.c"
    break;

  case 1839: /* ospf_iface_item: AUTHENTICATION CRYPTOGRAPHIC  */
#line 410 "proto/ospf/config.Y"
                                { OSPF_PATT->autype = OSPF_AUTH_CRYPT; }
#line 15511 "obj/conf/cf-parse.tab.c"
    break;

  case 1840: /* ospf_iface_item: RX BUFFER NORMAL  */
#line 411 "proto/ospf/config.Y"
                    { OSPF_PATT->rx_buffer = 0; }
#line 15517 "obj/conf/cf-parse.tab.c"
    break;

  case 1841: /* ospf_iface_item: RX BUFFER LARGE  */
#line 412 "proto/ospf/config.Y"
                   { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
#line 15523 "obj/conf/cf-parse.tab.c"
    break;

  case 1842: /* ospf_iface_item: RX BUFFER expr  */
#line 413 "proto/ospf/config.Y"
                  { OSPF_PATT->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 15529 "obj/conf/cf-parse.tab.c"
    break;

  case 1843: /* ospf_iface_item: TX tos  */
#line 414 "proto/ospf/config.Y"
          { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 15535 "obj/conf/cf-parse.tab.c"
    break;

  case 1844: /* ospf_iface_item: TX PRIORITY expr  */
#line 415 "proto/ospf/config.Y"
                    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 15541 "obj/conf/cf-parse.tab.c"
    break;

  case 1845: /* ospf_iface_item: TX LENGTH expr  */
#line 416 "proto/ospf/config.Y"
                  { OSPF_PATT->tx_length = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
#line 15547 "obj/conf/cf-parse.tab.c"
    break;

  case 1846: /* ospf_iface_item: TTL SECURITY bool  */
#line 417 "proto/ospf/config.Y"
                     { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 15553 "obj/conf/cf-parse.tab.c"
    break;

  case 1847: /* ospf_iface_item: TTL SECURITY TX ONLY  */
#line 418 "proto/ospf/config.Y"
                        { OSPF_PATT->ttl_security = 2; }
#line 15559 "obj/conf/cf-parse.tab.c"
    break;

  case 1848: /* ospf_iface_item: BFD bool  */
#line 419 "proto/ospf/config.Y"
            { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 15565 "obj/conf/cf-parse.tab.c"
    break;

  case 1853: /* pref_base: net_ip  */
#line 431 "proto/ospf/config.Y"
 {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->prefix = (yyvsp[0].net);
 }
#line 15575 "obj/conf/cf-parse.tab.c"
    break;

  case 1855: /* pref_opt: HIDDEN  */
#line 440 "proto/ospf/config.Y"
          { this_pref->hidden = 1; }
#line 15581 "obj/conf/cf-parse.tab.c"
    break;

  case 1856: /* pref_opt: TAG expr  */
#line 441 "proto/ospf/config.Y"
            { this_pref->tag = (yyvsp[0].i); }
#line 15587 "obj/conf/cf-parse.tab.c"
    break;

  case 1859: /* nbma_eligible: %empty  */
#line 450 "proto/ospf/config.Y"
             { (yyval.i) = 0; }
#line 15593 "obj/conf/cf-parse.tab.c"
    break;

  case 1860: /* nbma_eligible: ELIGIBLE  */
#line 451 "proto/ospf/config.Y"
            { (yyval.i) = 1; }
#line 15599 "obj/conf/cf-parse.tab.c"
    break;

  case 1861: /* nbma_item: ipa nbma_eligible ';'  */
#line 455 "proto/ospf/config.Y"
 {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 15610 "obj/conf/cf-parse.tab.c"
    break;

  case 1862: /* ospf_iface_start: %empty  */
#line 464 "proto/ospf/config.Y"
 {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->check_link = 1;
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->ptp_address = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 15635 "obj/conf/cf-parse.tab.c"
    break;

  case 1864: /* ospf_instance_id: INSTANCE expr  */
#line 488 "proto/ospf/config.Y"
                 { OSPF_PATT->instance_id = (yyvsp[0].i); OSPF_PATT->instance_id_set = 1; if ((yyvsp[0].i) > 255) cf_error("Instance ID must be in range 0-255"); }
#line 15641 "obj/conf/cf-parse.tab.c"
    break;

  case 1865: /* $@19: %empty  */
#line 492 "proto/ospf/config.Y"
                   { if (ospf_cfg_is_v3()) iface_patt_check(); }
#line 15647 "obj/conf/cf-parse.tab.c"
    break;

  case 1871: /* ospf_iface: ospf_iface_start ospf_iface_patt_list ospf_iface_opt_list  */
#line 506 "proto/ospf/config.Y"
                                                            { ospf_iface_finish(); }
#line 15653 "obj/conf/cf-parse.tab.c"
    break;

  case 1872: /* dynamic_attr: OSPF_METRIC1  */
#line 509 "proto/ospf/config.Y"
                           { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_OSPF_METRIC1); }
#line 15659 "obj/conf/cf-parse.tab.c"
    break;

  case 1873: /* dynamic_attr: OSPF_METRIC2  */
#line 510 "proto/ospf/config.Y"
                           { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_OSPF_METRIC2); }
#line 15665 "obj/conf/cf-parse.tab.c"
    break;

  case 1874: /* dynamic_attr: OSPF_TAG  */
#line 511 "proto/ospf/config.Y"
                       { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_OSPF_TAG); }
#line 15671 "obj/conf/cf-parse.tab.c"
    break;

  case 1875: /* dynamic_attr: OSPF_ROUTER_ID  */
#line 512 "proto/ospf/config.Y"
                             { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 15677 "obj/conf/cf-parse.tab.c"
    break;

  case 1877: /* cmd_SHOW_OSPF: SHOW OSPF optproto END  */
#line 516 "proto/ospf/config.Y"
{ PROTO_WALK_CMD((yyvsp[-1].s), &proto_ospf, p) ospf_sh(p); }
#line 15683 "obj/conf/cf-parse.tab.c"
    break;

  case 1879: /* cmd_SHOW_OSPF_NEIGHBORS: SHOW OSPF NEIGHBORS optproto opttext END  */
#line 519 "proto/ospf/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_ospf, p) ospf_sh_neigh(p, (yyvsp[-1].t)); }
#line 15689 "obj/conf/cf-parse.tab.c"
    break;

  case 1881: /* cmd_SHOW_OSPF_INTERFACE: SHOW OSPF INTERFACE optproto opttext END  */
#line 522 "proto/ospf/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_ospf, p) ospf_sh_iface(p, (yyvsp[-1].t)); }
#line 15695 "obj/conf/cf-parse.tab.c"
    break;

  case 1883: /* cmd_SHOW_OSPF_TOPOLOGY: SHOW OSPF TOPOLOGY optproto opttext END  */
#line 527 "proto/ospf/config.Y"
{ ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 15701 "obj/conf/cf-parse.tab.c"
    break;

  case 1885: /* cmd_SHOW_OSPF_TOPOLOGY_ALL: SHOW OSPF TOPOLOGY ALL optproto opttext END  */
#line 530 "proto/ospf/config.Y"
{ ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 15707 "obj/conf/cf-parse.tab.c"
    break;

  case 1887: /* cmd_SHOW_OSPF_STATE: SHOW OSPF STATE optproto opttext END  */
#line 535 "proto/ospf/config.Y"
{ ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 15713 "obj/conf/cf-parse.tab.c"
    break;

  case 1889: /* cmd_SHOW_OSPF_STATE_ALL: SHOW OSPF STATE ALL optproto opttext END  */
#line 538 "proto/ospf/config.Y"
{ ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 15719 "obj/conf/cf-parse.tab.c"
    break;

  case 1891: /* cmd_SHOW_OSPF_LSADB: SHOW OSPF LSADB lsadb_args END  */
#line 542 "proto/ospf/config.Y"
{
  if (!(yyvsp[-1].ld)->proto)
    (yyvsp[-1].ld)->proto = (struct ospf_proto *) proto_get_named(NULL, &proto_ospf);

  ospf_sh_lsadb((yyvsp[-1].ld));
}
#line 15730 "obj/conf/cf-parse.tab.c"
    break;

  case 1892: /* lsadb_args: %empty  */
#line 558 "proto/ospf/config.Y"
               {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 15738 "obj/conf/cf-parse.tab.c"
    break;

  case 1893: /* lsadb_args: lsadb_args GLOBAL  */
#line 561 "proto/ospf/config.Y"
                     { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 15744 "obj/conf/cf-parse.tab.c"
    break;

  case 1894: /* lsadb_args: lsadb_args AREA idval  */
#line 562 "proto/ospf/config.Y"
                         { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 15750 "obj/conf/cf-parse.tab.c"
    break;

  case 1895: /* lsadb_args: lsadb_args LINK  */
#line 563 "proto/ospf/config.Y"
                   { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 15756 "obj/conf/cf-parse.tab.c"
    break;

  case 1896: /* lsadb_args: lsadb_args TYPE NUM  */
#line 564 "proto/ospf/config.Y"
                       { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 15762 "obj/conf/cf-parse.tab.c"
    break;

  case 1897: /* lsadb_args: lsadb_args LSID idval  */
#line 565 "proto/ospf/config.Y"
                         { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 15768 "obj/conf/cf-parse.tab.c"
    break;

  case 1898: /* lsadb_args: lsadb_args SELF  */
#line 566 "proto/ospf/config.Y"
                   { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 15774 "obj/conf/cf-parse.tab.c"
    break;

  case 1899: /* lsadb_args: lsadb_args ROUTER idval  */
#line 567 "proto/ospf/config.Y"
                           { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 15780 "obj/conf/cf-parse.tab.c"
    break;

  case 1900: /* lsadb_args: lsadb_args CF_SYM_KNOWN  */
#line 568 "proto/ospf/config.Y"
                           { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->proto = (struct ospf_proto *) proto_get_named((yyvsp[0].s), &proto_ospf); }
#line 15786 "obj/conf/cf-parse.tab.c"
    break;

  case 1902: /* perf_proto_start: proto_start PERF  */
#line 27 "proto/perf/config.Y"
{
  this_proto = proto_config_new(&proto_perf, (yyvsp[-1].i));
  PERF_CFG->from = 10;
  PERF_CFG->to = 20;
  PERF_CFG->repeat = 4;
  PERF_CFG->threshold_max = 500 MS_;
  PERF_CFG->threshold_min = 1 MS_;
  PERF_CFG->attrs_per_rte = 0;
  PERF_CFG->keep = 0;
  PERF_CFG->mode = PERF_MODE_IMPORT;
}
#line 15802 "obj/conf/cf-parse.tab.c"
    break;

  case 1906: /* perf_proto_item: proto_channel  */
#line 46 "proto/perf/config.Y"
                 { this_proto->net_type = (yyvsp[0].cc)->net_type; }
#line 15808 "obj/conf/cf-parse.tab.c"
    break;

  case 1907: /* perf_proto_item: EXP FROM NUM  */
#line 47 "proto/perf/config.Y"
                { PERF_CFG->from = (yyvsp[0].i); }
#line 15814 "obj/conf/cf-parse.tab.c"
    break;

  case 1908: /* perf_proto_item: EXP TO NUM  */
#line 48 "proto/perf/config.Y"
              { PERF_CFG->to = (yyvsp[0].i); }
#line 15820 "obj/conf/cf-parse.tab.c"
    break;

  case 1909: /* perf_proto_item: REPEAT NUM  */
#line 49 "proto/perf/config.Y"
              { PERF_CFG->repeat = (yyvsp[0].i); }
#line 15826 "obj/conf/cf-parse.tab.c"
    break;

  case 1910: /* perf_proto_item: THRESHOLD MIN expr_us  */
#line 50 "proto/perf/config.Y"
                         { PERF_CFG->threshold_min = (yyvsp[0].time); }
#line 15832 "obj/conf/cf-parse.tab.c"
    break;

  case 1911: /* perf_proto_item: THRESHOLD MAX expr_us  */
#line 51 "proto/perf/config.Y"
                         { PERF_CFG->threshold_max = (yyvsp[0].time); }
#line 15838 "obj/conf/cf-parse.tab.c"
    break;

  case 1912: /* perf_proto_item: ATTRIBUTES NUM  */
#line 52 "proto/perf/config.Y"
                  { PERF_CFG->attrs_per_rte = (yyvsp[0].i); }
#line 15844 "obj/conf/cf-parse.tab.c"
    break;

  case 1913: /* perf_proto_item: KEEP bool  */
#line 53 "proto/perf/config.Y"
             { PERF_CFG->keep = (yyvsp[0].i); }
#line 15850 "obj/conf/cf-parse.tab.c"
    break;

  case 1914: /* perf_proto_item: MODE IMPORT  */
#line 54 "proto/perf/config.Y"
               { PERF_CFG->mode = PERF_MODE_IMPORT; }
#line 15856 "obj/conf/cf-parse.tab.c"
    break;

  case 1915: /* perf_proto_item: MODE EXPORT  */
#line 55 "proto/perf/config.Y"
               { PERF_CFG->mode = PERF_MODE_EXPORT; }
#line 15862 "obj/conf/cf-parse.tab.c"
    break;

  case 1916: /* proto: pipe_proto '}'  */
#line 23 "proto/pipe/config.Y"
                      { this_channel = NULL; }
#line 15868 "obj/conf/cf-parse.tab.c"
    break;

  case 1917: /* $@20: %empty  */
#line 26 "proto/pipe/config.Y"
{
  this_proto = proto_config_new(&proto_pipe, (yyvsp[-1].i));
}
#line 15876 "obj/conf/cf-parse.tab.c"
    break;

  case 1918: /* pipe_proto_start: proto_start PIPE $@20 proto_name  */
#line 30 "proto/pipe/config.Y"
{
  this_channel = proto_cf_main_channel(this_proto);
  if (!this_channel) {
    this_channel = channel_config_new(NULL, NULL, 0, this_proto);
    this_channel->in_filter = FILTER_ACCEPT;
    this_channel->out_filter = FILTER_ACCEPT;
  }
}
#line 15889 "obj/conf/cf-parse.tab.c"
    break;

  case 1922: /* pipe_proto: pipe_proto PEER TABLE rtable ';'  */
#line 43 "proto/pipe/config.Y"
                                    { PIPE_CFG->peer = (yyvsp[-1].r); }
#line 15895 "obj/conf/cf-parse.tab.c"
    break;

  case 1924: /* radv_proto_start: proto_start RADV  */
#line 56 "proto/radv/config.Y"
{
  this_proto = proto_config_new(&proto_radv, (yyvsp[-1].i));
  this_proto->net_type = NET_IP6;

  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
  init_list(&RADV_CFG->custom_list);
}
#line 15910 "obj/conf/cf-parse.tab.c"
    break;

  case 1928: /* radv_proto_item: PREFIX radv_prefix  */
#line 71 "proto/radv/config.Y"
                      { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
#line 15916 "obj/conf/cf-parse.tab.c"
    break;

  case 1929: /* $@21: %empty  */
#line 72 "proto/radv/config.Y"
         { init_list(&radv_dns_list); }
#line 15922 "obj/conf/cf-parse.tab.c"
    break;

  case 1930: /* radv_proto_item: RDNSS $@21 radv_rdnss  */
#line 72 "proto/radv/config.Y"
                                                   { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); }
#line 15928 "obj/conf/cf-parse.tab.c"
    break;

  case 1931: /* $@22: %empty  */
#line 73 "proto/radv/config.Y"
         { init_list(&radv_dns_list); }
#line 15934 "obj/conf/cf-parse.tab.c"
    break;

  case 1932: /* radv_proto_item: DNSSL $@22 radv_dnssl  */
#line 73 "proto/radv/config.Y"
                                                   { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); }
#line 15940 "obj/conf/cf-parse.tab.c"
    break;

  case 1933: /* radv_proto_item: CUSTOM OPTION TYPE expr VALUE bytestring  */
#line 74 "proto/radv/config.Y"
                                            { radv_add_to_custom_list(&RADV_CFG->custom_list, (yyvsp[-2].i), (yyvsp[0].bs)); }
#line 15946 "obj/conf/cf-parse.tab.c"
    break;

  case 1934: /* radv_proto_item: TRIGGER net_ip6  */
#line 75 "proto/radv/config.Y"
                   { RADV_CFG->trigger = (yyvsp[0].net); }
#line 15952 "obj/conf/cf-parse.tab.c"
    break;

  case 1935: /* radv_proto_item: PROPAGATE ROUTES bool  */
#line 76 "proto/radv/config.Y"
                         { RADV_CFG->propagate_routes = (yyvsp[0].i); }
#line 15958 "obj/conf/cf-parse.tab.c"
    break;

  case 1939: /* radv_iface_start: %empty  */
#line 89 "proto/radv/config.Y"
{
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);
  init_list(&RADV_IFACE->custom_list);

  RADV_IFACE->min_ra_int = (u32) -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->prefix_linger_time = (u32) -1;
  RADV_IFACE->route_linger_time = (u32) -1;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = (u32) -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
  RADV_IFACE->default_preference = RA_PREF_MEDIUM;
  RADV_IFACE->route_lifetime = (u32) -1;
  RADV_IFACE->route_lifetime_sensitive = 0;
  RADV_IFACE->route_preference = RA_PREF_MEDIUM;
}
#line 15985 "obj/conf/cf-parse.tab.c"
    break;

  case 1940: /* radv_iface_item: MIN RA INTERVAL expr  */
#line 113 "proto/radv/config.Y"
                        { RADV_IFACE->min_ra_int = (yyvsp[0].i); if ((yyvsp[0].i) < 3) cf_error("Min RA interval must be at least 3"); }
#line 15991 "obj/conf/cf-parse.tab.c"
    break;

  case 1941: /* radv_iface_item: MAX RA INTERVAL expr  */
#line 114 "proto/radv/config.Y"
                        { RADV_IFACE->max_ra_int = (yyvsp[0].i); if (((yyvsp[0].i) < 4) || ((yyvsp[0].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
#line 15997 "obj/conf/cf-parse.tab.c"
    break;

  case 1942: /* radv_iface_item: MIN DELAY expr  */
#line 115 "proto/radv/config.Y"
                  { RADV_IFACE->min_delay = (yyvsp[0].i); if ((yyvsp[0].i) <= 0) cf_error("Min delay must be positive"); }
#line 16003 "obj/conf/cf-parse.tab.c"
    break;

  case 1943: /* radv_iface_item: SOLICITED RA UNICAST bool  */
#line 116 "proto/radv/config.Y"
                             { RADV_IFACE->solicited_ra_unicast = (yyvsp[0].i); }
#line 16009 "obj/conf/cf-parse.tab.c"
    break;

  case 1944: /* radv_iface_item: MANAGED bool  */
#line 117 "proto/radv/config.Y"
                { RADV_IFACE->managed = (yyvsp[0].i); }
#line 16015 "obj/conf/cf-parse.tab.c"
    break;

  case 1945: /* radv_iface_item: OTHER CONFIG bool  */
#line 118 "proto/radv/config.Y"
                     { RADV_IFACE->other_config = (yyvsp[0].i); }
#line 16021 "obj/conf/cf-parse.tab.c"
    break;

  case 1946: /* radv_iface_item: LINK MTU expr  */
#line 119 "proto/radv/config.Y"
                 { RADV_IFACE->link_mtu = (yyvsp[0].i); }
#line 16027 "obj/conf/cf-parse.tab.c"
    break;

  case 1947: /* radv_iface_item: REACHABLE TIME expr  */
#line 120 "proto/radv/config.Y"
                       { RADV_IFACE->reachable_time = (yyvsp[0].i); if ((yyvsp[0].i) > 3600000) cf_error("Reachable time must be in range 0-3600000"); }
#line 16033 "obj/conf/cf-parse.tab.c"
    break;

  case 1948: /* radv_iface_item: RETRANS TIMER expr  */
#line 121 "proto/radv/config.Y"
                      { RADV_IFACE->retrans_timer = (yyvsp[0].i); }
#line 16039 "obj/conf/cf-parse.tab.c"
    break;

  case 1949: /* radv_iface_item: CURRENT HOP LIMIT expr  */
#line 122 "proto/radv/config.Y"
                          { RADV_IFACE->current_hop_limit = (yyvsp[0].i); if ((yyvsp[0].i) > 255) cf_error("Current hop limit must be in range 0-255"); }
#line 16045 "obj/conf/cf-parse.tab.c"
    break;

  case 1950: /* radv_iface_item: DEFAULT LIFETIME expr radv_sensitive  */
#line 123 "proto/radv/config.Y"
                                        {
     RADV_IFACE->default_lifetime = (yyvsp[-1].i);
     if ((yyvsp[-1].i) > 9000)  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[0].i) != (uint) -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[0].i);
   }
#line 16055 "obj/conf/cf-parse.tab.c"
    break;

  case 1951: /* radv_iface_item: ROUTE LIFETIME expr radv_sensitive  */
#line 128 "proto/radv/config.Y"
                                      {
     RADV_IFACE->route_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != (uint) -1) RADV_IFACE->route_lifetime_sensitive = (yyvsp[0].i);
   }
#line 16064 "obj/conf/cf-parse.tab.c"
    break;

  case 1952: /* radv_iface_item: DEFAULT PREFERENCE radv_preference  */
#line 132 "proto/radv/config.Y"
                                      { RADV_IFACE->default_preference = (yyvsp[0].i); }
#line 16070 "obj/conf/cf-parse.tab.c"
    break;

  case 1953: /* radv_iface_item: ROUTE PREFERENCE radv_preference  */
#line 133 "proto/radv/config.Y"
                                    { RADV_IFACE->route_preference = (yyvsp[0].i); }
#line 16076 "obj/conf/cf-parse.tab.c"
    break;

  case 1954: /* radv_iface_item: PREFIX LINGER TIME expr  */
#line 134 "proto/radv/config.Y"
                           { RADV_IFACE->prefix_linger_time = (yyvsp[0].i); }
#line 16082 "obj/conf/cf-parse.tab.c"
    break;

  case 1955: /* radv_iface_item: ROUTE LINGER TIME expr  */
#line 135 "proto/radv/config.Y"
                          { RADV_IFACE->route_linger_time = (yyvsp[0].i); }
#line 16088 "obj/conf/cf-parse.tab.c"
    break;

  case 1956: /* radv_iface_item: PREFIX radv_prefix  */
#line 136 "proto/radv/config.Y"
                      { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
#line 16094 "obj/conf/cf-parse.tab.c"
    break;

  case 1957: /* $@23: %empty  */
#line 137 "proto/radv/config.Y"
         { init_list(&radv_dns_list); }
#line 16100 "obj/conf/cf-parse.tab.c"
    break;

  case 1958: /* radv_iface_item: RDNSS $@23 radv_rdnss  */
#line 137 "proto/radv/config.Y"
                                                   { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); }
#line 16106 "obj/conf/cf-parse.tab.c"
    break;

  case 1959: /* $@24: %empty  */
#line 138 "proto/radv/config.Y"
         { init_list(&radv_dns_list); }
#line 16112 "obj/conf/cf-parse.tab.c"
    break;

  case 1960: /* radv_iface_item: DNSSL $@24 radv_dnssl  */
#line 138 "proto/radv/config.Y"
                                                   { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); }
#line 16118 "obj/conf/cf-parse.tab.c"
    break;

  case 1961: /* radv_iface_item: CUSTOM OPTION TYPE expr VALUE bytestring  */
#line 139 "proto/radv/config.Y"
                                            { radv_add_to_custom_list(&RADV_IFACE->custom_list, (yyvsp[-2].i), (yyvsp[0].bs)); }
#line 16124 "obj/conf/cf-parse.tab.c"
    break;

  case 1962: /* radv_iface_item: RDNSS LOCAL bool  */
#line 140 "proto/radv/config.Y"
                    { RADV_IFACE->rdnss_local = (yyvsp[0].i); }
#line 16130 "obj/conf/cf-parse.tab.c"
    break;

  case 1963: /* radv_iface_item: DNSSL LOCAL bool  */
#line 141 "proto/radv/config.Y"
                    { RADV_IFACE->dnssl_local = (yyvsp[0].i); }
#line 16136 "obj/conf/cf-parse.tab.c"
    break;

  case 1964: /* radv_iface_item: CUSTOM OPTION LOCAL bool  */
#line 142 "proto/radv/config.Y"
                            { RADV_IFACE->custom_local = (yyvsp[0].i); }
#line 16142 "obj/conf/cf-parse.tab.c"
    break;

  case 1965: /* radv_preference: LOW  */
#line 146 "proto/radv/config.Y"
       { (yyval.i) = RA_PREF_LOW; }
#line 16148 "obj/conf/cf-parse.tab.c"
    break;

  case 1966: /* radv_preference: MEDIUM  */
#line 147 "proto/radv/config.Y"
          { (yyval.i) = RA_PREF_MEDIUM; }
#line 16154 "obj/conf/cf-parse.tab.c"
    break;

  case 1967: /* radv_preference: HIGH  */
#line 148 "proto/radv/config.Y"
        { (yyval.i) = RA_PREF_HIGH; }
#line 16160 "obj/conf/cf-parse.tab.c"
    break;

  case 1968: /* radv_iface_finish: %empty  */
#line 151 "proto/radv/config.Y"
{
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = MAX_(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if (ic->route_lifetime == (u32) -1)
    ic->route_lifetime = 3 * ic->max_ra_int;

  if (ic->prefix_linger_time == (u32) -1)
    ic->prefix_linger_time = 3 * ic->max_ra_int;

  if (ic->route_linger_time == (u32) -1)
    ic->route_linger_time = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval");

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");

  if ((ic->route_lifetime > 0) && (ic->route_lifetime < ic->max_ra_int))
    cf_error("Route lifetime must be either 0 or at least Max RA interval");

  if ((ic->prefix_linger_time > 0) && (ic->prefix_linger_time < ic->max_ra_int))
    cf_error("Prefix linger time must be either 0 or at least Max RA interval");

  if ((ic->route_linger_time > 0) && (ic->route_linger_time < ic->max_ra_int))
    cf_error("Route linger time must be either 0 or at least Max RA interval");

  RADV_CFG->max_linger_time = MAX_(RADV_CFG->max_linger_time, ic->route_linger_time);
}
#line 16201 "obj/conf/cf-parse.tab.c"
    break;

  case 1974: /* radv_prefix_start: net_ip6  */
#line 204 "proto/radv/config.Y"
{
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = *(net_addr_ip6 *) &((yyvsp[0].net));

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
#line 16215 "obj/conf/cf-parse.tab.c"
    break;

  case 1975: /* radv_prefix_item: SKIP bool  */
#line 215 "proto/radv/config.Y"
             { RADV_PREFIX->skip = (yyvsp[0].i); }
#line 16221 "obj/conf/cf-parse.tab.c"
    break;

  case 1976: /* radv_prefix_item: ONLINK bool  */
#line 216 "proto/radv/config.Y"
               { RADV_PREFIX->onlink = (yyvsp[0].i); }
#line 16227 "obj/conf/cf-parse.tab.c"
    break;

  case 1977: /* radv_prefix_item: AUTONOMOUS bool  */
#line 217 "proto/radv/config.Y"
                   { RADV_PREFIX->autonomous = (yyvsp[0].i); }
#line 16233 "obj/conf/cf-parse.tab.c"
    break;

  case 1978: /* radv_prefix_item: VALID LIFETIME expr radv_sensitive  */
#line 218 "proto/radv/config.Y"
                                      {
     RADV_PREFIX->valid_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != (uint) -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[0].i);
   }
#line 16242 "obj/conf/cf-parse.tab.c"
    break;

  case 1979: /* radv_prefix_item: PREFERRED LIFETIME expr radv_sensitive  */
#line 222 "proto/radv/config.Y"
                                          {
     RADV_PREFIX->preferred_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != (uint) -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[0].i);
   }
#line 16251 "obj/conf/cf-parse.tab.c"
    break;

  case 1980: /* radv_prefix_finish: %empty  */
#line 229 "proto/radv/config.Y"
{
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
}
#line 16263 "obj/conf/cf-parse.tab.c"
    break;

  case 1986: /* radv_rdnss_node: ipa  */
#line 253 "proto/radv/config.Y"
{
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[0].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 16275 "obj/conf/cf-parse.tab.c"
    break;

  case 1987: /* radv_rdnss_start: %empty  */
#line 262 "proto/radv/config.Y"
{
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 16284 "obj/conf/cf-parse.tab.c"
    break;

  case 1990: /* radv_rdnss_item: LIFETIME radv_mult  */
#line 269 "proto/radv/config.Y"
                      { RADV_RDNSS->lifetime = (yyvsp[0].i); RADV_RDNSS->lifetime_mult = radv_mult_val; }
#line 16290 "obj/conf/cf-parse.tab.c"
    break;

  case 1991: /* radv_rdnss_finish: %empty  */
#line 273 "proto/radv/config.Y"
{
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
}
#line 16306 "obj/conf/cf-parse.tab.c"
    break;

  case 1996: /* radv_dnssl_node: TEXT  */
#line 297 "proto/radv/config.Y"
{
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[0].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
}
#line 16321 "obj/conf/cf-parse.tab.c"
    break;

  case 1997: /* radv_dnssl_start: %empty  */
#line 309 "proto/radv/config.Y"
{
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 16330 "obj/conf/cf-parse.tab.c"
    break;

  case 2000: /* radv_dnssl_item: LIFETIME radv_mult  */
#line 316 "proto/radv/config.Y"
                      { RADV_DNSSL->lifetime = (yyvsp[0].i); RADV_DNSSL->lifetime_mult = radv_mult_val; }
#line 16336 "obj/conf/cf-parse.tab.c"
    break;

  case 2001: /* radv_dnssl_finish: %empty  */
#line 320 "proto/radv/config.Y"
{
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
}
#line 16352 "obj/conf/cf-parse.tab.c"
    break;

  case 2006: /* radv_mult: expr  */
#line 344 "proto/radv/config.Y"
        { (yyval.i) = (yyvsp[0].i); radv_mult_val = 0; }
#line 16358 "obj/conf/cf-parse.tab.c"
    break;

  case 2007: /* radv_mult: MULT expr  */
#line 345 "proto/radv/config.Y"
             { (yyval.i) = 0; radv_mult_val = (yyvsp[0].i); if (((yyvsp[0].i) < 1) || ((yyvsp[0].i) > 254)) cf_error("Multiplier must be in range 1-254"); }
#line 16364 "obj/conf/cf-parse.tab.c"
    break;

  case 2008: /* radv_sensitive: %empty  */
#line 349 "proto/radv/config.Y"
               { (yyval.i) = (uint) -1; }
#line 16370 "obj/conf/cf-parse.tab.c"
    break;

  case 2009: /* radv_sensitive: SENSITIVE bool  */
#line 350 "proto/radv/config.Y"
                  { (yyval.i) = (yyvsp[0].i); }
#line 16376 "obj/conf/cf-parse.tab.c"
    break;

  case 2010: /* dynamic_attr: RA_PREFERENCE  */
#line 353 "proto/radv/config.Y"
                            { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_RA_PREFERENCE, EA_RA_PREFERENCE); }
#line 16382 "obj/conf/cf-parse.tab.c"
    break;

  case 2011: /* dynamic_attr: RA_LIFETIME  */
#line 354 "proto/radv/config.Y"
                          { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RA_LIFETIME); }
#line 16388 "obj/conf/cf-parse.tab.c"
    break;

  case 2013: /* rip_variant: RIP  */
#line 50 "proto/rip/config.Y"
          { (yyval.i) = 1; }
#line 16394 "obj/conf/cf-parse.tab.c"
    break;

  case 2014: /* rip_variant: RIP NG  */
#line 51 "proto/rip/config.Y"
          { (yyval.i) = 0; }
#line 16400 "obj/conf/cf-parse.tab.c"
    break;

  case 2015: /* rip_proto_start: proto_start rip_variant  */
#line 55 "proto/rip/config.Y"
{
  this_proto = proto_config_new(&proto_rip, (yyvsp[-1].i));
  this_proto->net_type = (yyvsp[0].i) ? NET_IP4 : NET_IP6;

  init_list(&RIP_CFG->patt_list);
  RIP_CFG->rip2 = (yyvsp[0].i);
  RIP_CFG->ecmp = rt_default_ecmp;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;
  RIP_CFG->min_timeout_time = 60 S_;
  RIP_CFG->max_garbage_time = 60 S_;
}
#line 16416 "obj/conf/cf-parse.tab.c"
    break;

  case 2018: /* rip_proto_item: ECMP bool  */
#line 70 "proto/rip/config.Y"
                        { RIP_CFG->ecmp = (yyvsp[0].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; }
#line 16422 "obj/conf/cf-parse.tab.c"
    break;

  case 2019: /* rip_proto_item: ECMP bool LIMIT expr  */
#line 71 "proto/rip/config.Y"
                        { RIP_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; }
#line 16428 "obj/conf/cf-parse.tab.c"
    break;

  case 2020: /* rip_proto_item: INFINITY expr  */
#line 72 "proto/rip/config.Y"
                        { RIP_CFG->infinity = (yyvsp[0].i); }
#line 16434 "obj/conf/cf-parse.tab.c"
    break;

  case 2025: /* rip_iface_start: %empty  */
#line 86 "proto/rip/config.Y"
{
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->check_link = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
  RIP_IFACE->rxmt_time = RIP_DEFAULT_RXMT_TIME;
}
#line 16462 "obj/conf/cf-parse.tab.c"
    break;

  case 2026: /* rip_iface_finish: %empty  */
#line 111 "proto/rip/config.Y"
{
  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    cf_warn("Authentication and password options should be used together");

  if (RIP_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *RIP_IFACE->passwords)
    {
      if (pass->alg && (RIP_IFACE->auth_type != RIP_AUTH_CRYPTO))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default crypto algorithm (MD5) */
      if (!pass->alg && (RIP_IFACE->auth_type == RIP_AUTH_CRYPTO))
	pass->alg = ALG_MD5;
    }
  }

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
}
#line 16495 "obj/conf/cf-parse.tab.c"
    break;

  case 2027: /* rip_iface_item: METRIC expr  */
#line 141 "proto/rip/config.Y"
                        { RIP_IFACE->metric = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>255)) cf_error("Metric must be in range 1-255"); }
#line 16501 "obj/conf/cf-parse.tab.c"
    break;

  case 2028: /* rip_iface_item: MODE MULTICAST  */
#line 142 "proto/rip/config.Y"
                        { RIP_IFACE->mode = RIP_IM_MULTICAST; }
#line 16507 "obj/conf/cf-parse.tab.c"
    break;

  case 2029: /* rip_iface_item: MODE BROADCAST  */
#line 143 "proto/rip/config.Y"
                        { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); }
#line 16513 "obj/conf/cf-parse.tab.c"
    break;

  case 2030: /* rip_iface_item: PASSIVE bool  */
#line 144 "proto/rip/config.Y"
                        { RIP_IFACE->passive = (yyvsp[0].i); }
#line 16519 "obj/conf/cf-parse.tab.c"
    break;

  case 2031: /* rip_iface_item: ADDRESS ipa  */
#line 145 "proto/rip/config.Y"
                        { RIP_IFACE->address = (yyvsp[0].a); if (ipa_is_ip4((yyvsp[0].a)) != rip_cfg_is_v2()) cf_error("IP address version mismatch"); }
#line 16525 "obj/conf/cf-parse.tab.c"
    break;

  case 2032: /* rip_iface_item: PORT expr  */
#line 146 "proto/rip/config.Y"
                        { RIP_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 16531 "obj/conf/cf-parse.tab.c"
    break;

  case 2033: /* rip_iface_item: VERSION expr  */
#line 147 "proto/rip/config.Y"
                        { RIP_IFACE->version = (yyvsp[0].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[0].i) != RIP_V1) && ((yyvsp[0].i) != RIP_V2)) cf_error("Unsupported version");
			}
#line 16540 "obj/conf/cf-parse.tab.c"
    break;

  case 2034: /* rip_iface_item: VERSION ONLY bool  */
#line 151 "proto/rip/config.Y"
                        { RIP_IFACE->version_only = (yyvsp[0].i); }
#line 16546 "obj/conf/cf-parse.tab.c"
    break;

  case 2035: /* rip_iface_item: SPLIT HORIZON bool  */
#line 152 "proto/rip/config.Y"
                        { RIP_IFACE->split_horizon = (yyvsp[0].i); }
#line 16552 "obj/conf/cf-parse.tab.c"
    break;

  case 2036: /* rip_iface_item: POISON REVERSE bool  */
#line 153 "proto/rip/config.Y"
                        { RIP_IFACE->poison_reverse = (yyvsp[0].i); }
#line 16558 "obj/conf/cf-parse.tab.c"
    break;

  case 2037: /* rip_iface_item: CHECK ZERO bool  */
#line 154 "proto/rip/config.Y"
                        { RIP_IFACE->check_zero = (yyvsp[0].i); }
#line 16564 "obj/conf/cf-parse.tab.c"
    break;

  case 2038: /* rip_iface_item: DEMAND CIRCUIT bool  */
#line 155 "proto/rip/config.Y"
                        { RIP_IFACE->demand_circuit = (yyvsp[0].i); }
#line 16570 "obj/conf/cf-parse.tab.c"
    break;

  case 2039: /* rip_iface_item: UPDATE TIME expr  */
#line 156 "proto/rip/config.Y"
                        { RIP_IFACE->update_time = (yyvsp[0].i) S_; if ((yyvsp[0].i)<=0) cf_error("Update time must be positive"); }
#line 16576 "obj/conf/cf-parse.tab.c"
    break;

  case 2040: /* rip_iface_item: TIMEOUT TIME expr  */
#line 157 "proto/rip/config.Y"
                        { RIP_IFACE->timeout_time = (yyvsp[0].i) S_; if ((yyvsp[0].i)<=0) cf_error("Timeout time must be positive"); }
#line 16582 "obj/conf/cf-parse.tab.c"
    break;

  case 2041: /* rip_iface_item: GARBAGE TIME expr  */
#line 158 "proto/rip/config.Y"
                        { RIP_IFACE->garbage_time = (yyvsp[0].i) S_; if ((yyvsp[0].i)<=0) cf_error("Garbage time must be positive"); }
#line 16588 "obj/conf/cf-parse.tab.c"
    break;

  case 2042: /* rip_iface_item: RETRANSMIT TIME expr_us  */
#line 159 "proto/rip/config.Y"
                           { RIP_IFACE->rxmt_time = (yyvsp[0].time); if ((yyvsp[0].time)<=0) cf_error("Retransmit time must be positive"); }
#line 16594 "obj/conf/cf-parse.tab.c"
    break;

  case 2043: /* rip_iface_item: ECMP WEIGHT expr  */
#line 160 "proto/rip/config.Y"
                        { RIP_IFACE->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 16600 "obj/conf/cf-parse.tab.c"
    break;

  case 2044: /* rip_iface_item: RX BUFFER expr  */
#line 161 "proto/rip/config.Y"
                        { RIP_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX length must be in range 256-65535"); }
#line 16606 "obj/conf/cf-parse.tab.c"
    break;

  case 2045: /* rip_iface_item: TX LENGTH expr  */
#line 162 "proto/rip/config.Y"
                        { RIP_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 16612 "obj/conf/cf-parse.tab.c"
    break;

  case 2046: /* rip_iface_item: TX tos  */
#line 163 "proto/rip/config.Y"
                        { RIP_IFACE->tx_tos = (yyvsp[0].i); }
#line 16618 "obj/conf/cf-parse.tab.c"
    break;

  case 2047: /* rip_iface_item: TX PRIORITY expr  */
#line 164 "proto/rip/config.Y"
                        { RIP_IFACE->tx_priority = (yyvsp[0].i); }
#line 16624 "obj/conf/cf-parse.tab.c"
    break;

  case 2048: /* rip_iface_item: TTL SECURITY bool  */
#line 165 "proto/rip/config.Y"
                        { RIP_IFACE->ttl_security = (yyvsp[0].i); }
#line 16630 "obj/conf/cf-parse.tab.c"
    break;

  case 2049: /* rip_iface_item: TTL SECURITY TX ONLY  */
#line 166 "proto/rip/config.Y"
                        { RIP_IFACE->ttl_security = 2; }
#line 16636 "obj/conf/cf-parse.tab.c"
    break;

  case 2050: /* rip_iface_item: CHECK LINK bool  */
#line 167 "proto/rip/config.Y"
                        { RIP_IFACE->check_link = (yyvsp[0].i); }
#line 16642 "obj/conf/cf-parse.tab.c"
    break;

  case 2051: /* rip_iface_item: BFD bool  */
#line 168 "proto/rip/config.Y"
                        { RIP_IFACE->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 16648 "obj/conf/cf-parse.tab.c"
    break;

  case 2052: /* rip_iface_item: AUTHENTICATION rip_auth  */
#line 169 "proto/rip/config.Y"
                           { RIP_IFACE->auth_type = (yyvsp[0].i); if ((yyvsp[0].i)) rip_check_auth(); }
#line 16654 "obj/conf/cf-parse.tab.c"
    break;

  case 2053: /* rip_iface_item: password_list  */
#line 170 "proto/rip/config.Y"
                        { rip_check_auth(); }
#line 16660 "obj/conf/cf-parse.tab.c"
    break;

  case 2054: /* rip_auth: NONE  */
#line 174 "proto/rip/config.Y"
                        { (yyval.i) = RIP_AUTH_NONE; }
#line 16666 "obj/conf/cf-parse.tab.c"
    break;

  case 2055: /* rip_auth: PLAINTEXT  */
#line 175 "proto/rip/config.Y"
                        { (yyval.i) = RIP_AUTH_PLAIN; }
#line 16672 "obj/conf/cf-parse.tab.c"
    break;

  case 2056: /* rip_auth: CRYPTOGRAPHIC  */
#line 176 "proto/rip/config.Y"
                        { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 16678 "obj/conf/cf-parse.tab.c"
    break;

  case 2057: /* rip_auth: MD5  */
#line 177 "proto/rip/config.Y"
                        { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 16684 "obj/conf/cf-parse.tab.c"
    break;

  case 2063: /* dynamic_attr: RIP_METRIC  */
#line 194 "proto/rip/config.Y"
                         { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RIP_METRIC); }
#line 16690 "obj/conf/cf-parse.tab.c"
    break;

  case 2064: /* dynamic_attr: RIP_TAG  */
#line 195 "proto/rip/config.Y"
                      { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RIP_TAG); }
#line 16696 "obj/conf/cf-parse.tab.c"
    break;

  case 2066: /* cmd_SHOW_RIP_INTERFACES: SHOW RIP INTERFACES optproto opttext END  */
#line 200 "proto/rip/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_rip, p) rip_show_interfaces(p, (yyvsp[-1].t)); }
#line 16702 "obj/conf/cf-parse.tab.c"
    break;

  case 2068: /* cmd_SHOW_RIP_NEIGHBORS: SHOW RIP NEIGHBORS optproto opttext END  */
#line 203 "proto/rip/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_rip, p) rip_show_neighbors(p, (yyvsp[-1].t)); }
#line 16708 "obj/conf/cf-parse.tab.c"
    break;

  case 2070: /* rpki_proto_start: proto_start RPKI  */
#line 45 "proto/rpki/config.Y"
                                   {
  this_proto = proto_config_new(&proto_rpki, (yyvsp[-1].i));
  RPKI_CFG->retry_interval = RPKI_RETRY_INTERVAL;
  RPKI_CFG->refresh_interval = RPKI_REFRESH_INTERVAL;
  RPKI_CFG->expire_interval = RPKI_EXPIRE_INTERVAL;
  RPKI_CFG->min_version = 0;
  RPKI_CFG->max_version = RPKI_MAX_VERSION;
}
#line 16721 "obj/conf/cf-parse.tab.c"
    break;

  case 2071: /* rpki_proto: rpki_proto_start proto_name '{' rpki_proto_opts '}'  */
#line 54 "proto/rpki/config.Y"
                                                                { rpki_check_config(RPKI_CFG); }
#line 16727 "obj/conf/cf-parse.tab.c"
    break;

  case 2079: /* rpki_proto_item: LOCAL ADDRESS ipa  */
#line 67 "proto/rpki/config.Y"
                     { RPKI_CFG->local_ip = (yyvsp[0].a); }
#line 16733 "obj/conf/cf-parse.tab.c"
    break;

  case 2081: /* rpki_proto_item: REFRESH rpki_keep_interval expr  */
#line 69 "proto/rpki/config.Y"
                                   {
     if (rpki_check_refresh_interval((yyvsp[0].i)))
       cf_error(rpki_check_refresh_interval((yyvsp[0].i)));
     RPKI_CFG->refresh_interval = (yyvsp[0].i);
     RPKI_CFG->keep_refresh_interval = (yyvsp[-1].i);
   }
#line 16744 "obj/conf/cf-parse.tab.c"
    break;

  case 2082: /* rpki_proto_item: RETRY rpki_keep_interval expr  */
#line 75 "proto/rpki/config.Y"
                                 {
     if (rpki_check_retry_interval((yyvsp[0].i)))
       cf_error(rpki_check_retry_interval((yyvsp[0].i)));
     RPKI_CFG->retry_interval = (yyvsp[0].i);
     RPKI_CFG->keep_retry_interval = (yyvsp[-1].i);
   }
#line 16755 "obj/conf/cf-parse.tab.c"
    break;

  case 2083: /* rpki_proto_item: EXPIRE rpki_keep_interval expr  */
#line 81 "proto/rpki/config.Y"
                                  {
     if (rpki_check_expire_interval((yyvsp[0].i)))
       cf_error(rpki_check_expire_interval((yyvsp[0].i)));
     RPKI_CFG->expire_interval = (yyvsp[0].i);
     RPKI_CFG->keep_expire_interval = (yyvsp[-1].i);
   }
#line 16766 "obj/conf/cf-parse.tab.c"
    break;

  case 2084: /* rpki_proto_item: IGNORE MAX LENGTH bool  */
#line 87 "proto/rpki/config.Y"
                          { RPKI_CFG->ignore_max_length = (yyvsp[0].i); }
#line 16772 "obj/conf/cf-parse.tab.c"
    break;

  case 2085: /* rpki_proto_item: MIN VERSION expr  */
#line 88 "proto/rpki/config.Y"
                    {
     if ((yyvsp[0].i) > RPKI_MAX_VERSION) cf_error("RPKI version %u unsupported, min version must be in range 0-%u", (yyvsp[0].i), RPKI_MAX_VERSION);
     RPKI_CFG->min_version = (yyvsp[0].i);
   }
#line 16781 "obj/conf/cf-parse.tab.c"
    break;

  case 2086: /* rpki_proto_item: MAX VERSION expr  */
#line 92 "proto/rpki/config.Y"
                    {
     if ((yyvsp[0].i) > RPKI_MAX_VERSION) cf_error("RPKI version %u unsupported, max version must be in range 0-%u", (yyvsp[0].i), RPKI_MAX_VERSION);
     RPKI_CFG->max_version = (yyvsp[0].i);
   }
#line 16790 "obj/conf/cf-parse.tab.c"
    break;

  case 2087: /* rpki_keep_interval: %empty  */
#line 99 "proto/rpki/config.Y"
             { (yyval.i) = 0; }
#line 16796 "obj/conf/cf-parse.tab.c"
    break;

  case 2088: /* rpki_keep_interval: KEEP  */
#line 100 "proto/rpki/config.Y"
        { (yyval.i) = 1; }
#line 16802 "obj/conf/cf-parse.tab.c"
    break;

  case 2089: /* rpki_proto_item_port: PORT expr  */
#line 103 "proto/rpki/config.Y"
                                { check_u16((yyvsp[0].i)); RPKI_CFG->port = (yyvsp[0].i); }
#line 16808 "obj/conf/cf-parse.tab.c"
    break;

  case 2090: /* rpki_cache_addr: text_or_ipa  */
#line 106 "proto/rpki/config.Y"
{
  rpki_check_unused_hostname();
  if ((yyvsp[0].v).type == T_STRING)
    RPKI_CFG->hostname = (yyvsp[0].v).val.s;
  else if ((yyvsp[0].v).type == T_IP)
  {
    RPKI_CFG->ip = (yyvsp[0].v).val.ip;

    /* Ensure hostname is filled */
    char *hostname = cfg_allocz(INET6_ADDRSTRLEN + 1);
    bsnprintf(hostname, INET6_ADDRSTRLEN+1, "%I", RPKI_CFG->ip);
    RPKI_CFG->hostname = hostname;
  }
  else bug("Bad text_or_ipa");
}
#line 16828 "obj/conf/cf-parse.tab.c"
    break;

  case 2093: /* rpki_transport_tcp_init: %empty  */
#line 128 "proto/rpki/config.Y"
{
  rpki_check_unused_transport();
  RPKI_CFG->tr_config.spec = cfg_allocz(sizeof(struct rpki_tr_tcp_config));
  RPKI_CFG->tr_config.type = RPKI_TR_TCP;
}
#line 16838 "obj/conf/cf-parse.tab.c"
    break;

  case 2098: /* rpki_transport_tcp_item: AUTHENTICATION NONE  */
#line 145 "proto/rpki/config.Y"
                        { RPKI_TR_TCP_CFG->auth_type = RPKI_TCP_AUTH_NONE; }
#line 16844 "obj/conf/cf-parse.tab.c"
    break;

  case 2099: /* rpki_transport_tcp_item: AUTHENTICATION MD5  */
#line 146 "proto/rpki/config.Y"
                        { RPKI_TR_TCP_CFG->auth_type = RPKI_TCP_AUTH_MD5; }
#line 16850 "obj/conf/cf-parse.tab.c"
    break;

  case 2100: /* rpki_transport_tcp_item: PASSWORD text  */
#line 147 "proto/rpki/config.Y"
                        { RPKI_TR_TCP_CFG->password = (yyvsp[0].t); }
#line 16856 "obj/conf/cf-parse.tab.c"
    break;

  case 2101: /* rpki_transport_tcp_check: %empty  */
#line 151 "proto/rpki/config.Y"
{
  if (!RPKI_TR_TCP_CFG->auth_type != !RPKI_TR_TCP_CFG->password)
    cf_error("Authentication and password options should be used together");
}
#line 16865 "obj/conf/cf-parse.tab.c"
    break;

  case 2102: /* rpki_transport_ssh_init: %empty  */
#line 157 "proto/rpki/config.Y"
{
#if HAVE_LIBSSH
  rpki_check_unused_transport();
  RPKI_CFG->tr_config.spec = cfg_allocz(sizeof(struct rpki_tr_ssh_config));
  RPKI_CFG->tr_config.type = RPKI_TR_SSH;
#else
  cf_error("This build doesn't support SSH");
#endif
}
#line 16879 "obj/conf/cf-parse.tab.c"
    break;

  case 2105: /* rpki_transport_ssh_item: BIRD PRIVATE KEY text  */
#line 173 "proto/rpki/config.Y"
                          { RPKI_TR_SSH_CFG->bird_private_key = (yyvsp[0].t); }
#line 16885 "obj/conf/cf-parse.tab.c"
    break;

  case 2106: /* rpki_transport_ssh_item: REMOTE PUBLIC KEY text  */
#line 174 "proto/rpki/config.Y"
                          { RPKI_TR_SSH_CFG->cache_public_key = (yyvsp[0].t); }
#line 16891 "obj/conf/cf-parse.tab.c"
    break;

  case 2107: /* rpki_transport_ssh_item: USER text  */
#line 175 "proto/rpki/config.Y"
                          { RPKI_TR_SSH_CFG->user = (yyvsp[0].t); }
#line 16897 "obj/conf/cf-parse.tab.c"
    break;

  case 2108: /* rpki_transport_ssh_check: %empty  */
#line 179 "proto/rpki/config.Y"
{
  if (RPKI_TR_SSH_CFG->user == NULL)
    cf_error("User must be set");
}
#line 16906 "obj/conf/cf-parse.tab.c"
    break;

  case 2110: /* static_proto_start: proto_start STATIC  */
#line 59 "proto/static/config.Y"
{
  this_proto = proto_config_new(&proto_static, (yyvsp[-1].i));
  init_list(&STATIC_CFG->routes);
}
#line 16915 "obj/conf/cf-parse.tab.c"
    break;

  case 2113: /* static_proto: static_proto proto_channel ';'  */
#line 67 "proto/static/config.Y"
                                  { this_proto->net_type = (yyvsp[-1].cc)->net_type; }
#line 16921 "obj/conf/cf-parse.tab.c"
    break;

  case 2115: /* static_proto: static_proto CHECK LINK bool ';'  */
#line 69 "proto/static/config.Y"
                                    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 16927 "obj/conf/cf-parse.tab.c"
    break;

  case 2116: /* static_proto: static_proto IGP TABLE rtable ';'  */
#line 70 "proto/static/config.Y"
                                     {
    if ((yyvsp[-1].r)->addr_type == NET_IP4)
      STATIC_CFG->igp_table_ip4 = (yyvsp[-1].r);
    else if ((yyvsp[-1].r)->addr_type == NET_IP6)
      STATIC_CFG->igp_table_ip6 = (yyvsp[-1].r);
    else
      cf_error("Incompatible IGP table type");
   }
#line 16940 "obj/conf/cf-parse.tab.c"
    break;

  case 2117: /* static_proto: static_proto stat_route stat_route_opt_list ';'  */
#line 78 "proto/static/config.Y"
                                                   { static_route_finish(); }
#line 16946 "obj/conf/cf-parse.tab.c"
    break;

  case 2118: /* stat_nexthop: VIA ipa ipa_scope  */
#line 82 "proto/static/config.Y"
                      {
      this_snh = static_nexthop_new();
      this_snh->via = (yyvsp[-1].a);
      this_snh->iface = (yyvsp[0].iface);
    }
#line 16956 "obj/conf/cf-parse.tab.c"
    break;

  case 2119: /* stat_nexthop: VIA TEXT  */
#line 87 "proto/static/config.Y"
             {
      this_snh = static_nexthop_new();
      this_snh->via = IPA_NONE;
      this_snh->iface = if_get_by_name((yyvsp[0].t));
    }
#line 16966 "obj/conf/cf-parse.tab.c"
    break;

  case 2120: /* stat_nexthop: stat_nexthop DEV TEXT  */
#line 92 "proto/static/config.Y"
                          {
      this_snh->iface = if_get_by_name((yyvsp[0].t));
    }
#line 16974 "obj/conf/cf-parse.tab.c"
    break;

  case 2121: /* stat_nexthop: stat_nexthop MPLS label_stack  */
#line 95 "proto/static/config.Y"
                                  {
    this_snh->mls = (yyvsp[0].mls);
  }
#line 16982 "obj/conf/cf-parse.tab.c"
    break;

  case 2122: /* stat_nexthop: stat_nexthop ONLINK bool  */
#line 98 "proto/static/config.Y"
                             {
    this_snh->onlink = (yyvsp[0].i);
    if (this_snh->use_bfd && this_snh->onlink)
      cf_error("Options 'bfd' and 'onlink' cannot be combined");
  }
#line 16992 "obj/conf/cf-parse.tab.c"
    break;

  case 2123: /* stat_nexthop: stat_nexthop WEIGHT expr  */
#line 103 "proto/static/config.Y"
                             {
    this_snh->weight = (yyvsp[0].i) - 1;
    if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256");
  }
#line 17001 "obj/conf/cf-parse.tab.c"
    break;

  case 2124: /* stat_nexthop: stat_nexthop BFD bool  */
#line 107 "proto/static/config.Y"
                          {
    this_snh->use_bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i));
    if (this_snh->use_bfd && this_snh->onlink)
      cf_error("Options 'bfd' and 'onlink' cannot be combined");
  }
#line 17011 "obj/conf/cf-parse.tab.c"
    break;

  case 2128: /* stat_mpls: MPLS expr  */
#line 121 "proto/static/config.Y"
             { this_srt->mpls_label = (yyvsp[0].i); if ((yyvsp[0].i) >= MPLS_MAX_LABEL) cf_error("MPLS label must be less than 2^20"); }
#line 17017 "obj/conf/cf-parse.tab.c"
    break;

  case 2129: /* $@25: %empty  */
#line 124 "proto/static/config.Y"
                           {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->routes, &this_srt->n);
     this_srt->net = (yyvsp[0].net_ptr);
     this_srt->mpls_label = (uint) -1;
     this_srt_cmds = NULL;
     this_srt_last_cmd = NULL;
     this_srt->mp_next = NULL;
     this_snh = NULL;
  }
#line 17032 "obj/conf/cf-parse.tab.c"
    break;

  case 2132: /* stat_route: stat_route0 RECURSIVE ipa  */
#line 138 "proto/static/config.Y"
                             {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 17041 "obj/conf/cf-parse.tab.c"
    break;

  case 2133: /* stat_route: stat_route0 RECURSIVE ipa MPLS label_stack  */
#line 142 "proto/static/config.Y"
                                              {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[-2].a);
      this_srt->mls = (yyvsp[0].mls);
   }
#line 17051 "obj/conf/cf-parse.tab.c"
    break;

  case 2134: /* stat_route: stat_route0  */
#line 147 "proto/static/config.Y"
                                { this_srt->dest = RTD_NONE; }
#line 17057 "obj/conf/cf-parse.tab.c"
    break;

  case 2135: /* stat_route: stat_route0 DROP  */
#line 148 "proto/static/config.Y"
                                { this_srt->dest = RTD_BLACKHOLE; }
#line 17063 "obj/conf/cf-parse.tab.c"
    break;

  case 2136: /* stat_route: stat_route0 REJECT  */
#line 149 "proto/static/config.Y"
                                { this_srt->dest = RTD_UNREACHABLE; }
#line 17069 "obj/conf/cf-parse.tab.c"
    break;

  case 2137: /* stat_route: stat_route0 BLACKHOLE  */
#line 150 "proto/static/config.Y"
                                { this_srt->dest = RTD_BLACKHOLE; }
#line 17075 "obj/conf/cf-parse.tab.c"
    break;

  case 2138: /* stat_route: stat_route0 UNREACHABLE  */
#line 151 "proto/static/config.Y"
                                { this_srt->dest = RTD_UNREACHABLE; }
#line 17081 "obj/conf/cf-parse.tab.c"
    break;

  case 2139: /* stat_route: stat_route0 PROHIBIT  */
#line 152 "proto/static/config.Y"
                                { this_srt->dest = RTD_PROHIBIT; }
#line 17087 "obj/conf/cf-parse.tab.c"
    break;

  case 2140: /* $@26: %empty  */
#line 153 "proto/static/config.Y"
                         {
    if (this_srt->net->type != NET_ASPA) cf_error("Provider settings available only for ASPA");
    this_srt->aspa = cfg_alloc(sizeof (adata) + (this_srt_aspa_max = 8) * sizeof (u32));
    this_srt->aspa->length = 0;
   }
#line 17097 "obj/conf/cf-parse.tab.c"
    break;

  case 2142: /* stat_route: stat_route0 TRANSIT  */
#line 158 "proto/static/config.Y"
                       {
    if (this_srt->net->type != NET_ASPA) cf_error("Transit settings available only for ASPA");
    /* Allocate an explicit zero */
    this_srt->aspa = cfg_alloc(sizeof (adata) + sizeof (u32));
    this_srt->aspa->length = sizeof(u32);
    ((u32 *) this_srt->aspa->data)[0] = 0;
   }
#line 17109 "obj/conf/cf-parse.tab.c"
    break;

  case 2143: /* stat_aspa_provider: NUM  */
#line 167 "proto/static/config.Y"
                        {
  if (this_srt->aspa->length == this_srt_aspa_max * sizeof(u32))
  {
    adata *new = cfg_alloc(sizeof (adata) + (this_srt_aspa_max * 2) * sizeof (u32));
    memcpy(new, this_srt->aspa, this_srt->aspa->length + sizeof(adata));
    this_srt->aspa = new;
    this_srt_aspa_max *= 2;
  }

  ((u32 *) this_srt->aspa->data)[this_srt->aspa->length / sizeof(u32)] = (yyvsp[0].i);
  this_srt->aspa->length += sizeof(u32);
}
#line 17126 "obj/conf/cf-parse.tab.c"
    break;

  case 2146: /* stat_route_item: cmd  */
#line 183 "proto/static/config.Y"
       {
     if (this_srt_last_cmd)
       this_srt_last_cmd->next = (yyvsp[0].x);
     else
       this_srt_cmds = (yyvsp[0].x);
     this_srt_last_cmd = (yyvsp[0].x);
   }
#line 17138 "obj/conf/cf-parse.tab.c"
    break;

  case 2152: /* cmd_SHOW_STATIC: SHOW STATIC optproto END  */
#line 204 "proto/static/config.Y"
{ PROTO_WALK_CMD((yyvsp[-1].s), &proto_static, p) static_show(p); }
#line 17144 "obj/conf/cf-parse.tab.c"
    break;

  case 2154: /* kern_sys_item: KERNEL TABLE expr  */
#line 34 "sysdep/linux/netlink.Y"
                     { THIS_KRT->sys.table_id = (yyvsp[0].i); }
#line 17150 "obj/conf/cf-parse.tab.c"
    break;

  case 2155: /* kern_sys_item: METRIC expr  */
#line 35 "sysdep/linux/netlink.Y"
               { THIS_KRT->sys.metric = (yyvsp[0].i); }
#line 17156 "obj/conf/cf-parse.tab.c"
    break;

  case 2156: /* kern_sys_item: NETLINK RX BUFFER expr  */
#line 36 "sysdep/linux/netlink.Y"
                          { THIS_KRT->sys.netlink_rx_buffer = (yyvsp[0].i); }
#line 17162 "obj/conf/cf-parse.tab.c"
    break;

  case 2157: /* dynamic_attr: KRT_PREFSRC  */
#line 39 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 17168 "obj/conf/cf-parse.tab.c"
    break;

  case 2158: /* dynamic_attr: KRT_REALM  */
#line 40 "sysdep/linux/netlink.Y"
                        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 17174 "obj/conf/cf-parse.tab.c"
    break;

  case 2159: /* dynamic_attr: KRT_SCOPE  */
#line 41 "sysdep/linux/netlink.Y"
                        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SCOPE); }
#line 17180 "obj/conf/cf-parse.tab.c"
    break;

  case 2160: /* dynamic_attr: KRT_MTU  */
#line 43 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); }
#line 17186 "obj/conf/cf-parse.tab.c"
    break;

  case 2161: /* dynamic_attr: KRT_WINDOW  */
#line 44 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); }
#line 17192 "obj/conf/cf-parse.tab.c"
    break;

  case 2162: /* dynamic_attr: KRT_RTT  */
#line 45 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); }
#line 17198 "obj/conf/cf-parse.tab.c"
    break;

  case 2163: /* dynamic_attr: KRT_RTTVAR  */
#line 46 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); }
#line 17204 "obj/conf/cf-parse.tab.c"
    break;

  case 2164: /* dynamic_attr: KRT_SSTHRESH  */
#line 47 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTHRESH); }
#line 17210 "obj/conf/cf-parse.tab.c"
    break;

  case 2165: /* dynamic_attr: KRT_SSTRESH  */
#line 48 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTHRESH);
				  cf_warn("Attribute krt_sstresh is deprecated (typo), use krt_ssthresh"); }
#line 17217 "obj/conf/cf-parse.tab.c"
    break;

  case 2166: /* dynamic_attr: KRT_CWND  */
#line 50 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); }
#line 17223 "obj/conf/cf-parse.tab.c"
    break;

  case 2167: /* dynamic_attr: KRT_ADVMSS  */
#line 51 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); }
#line 17229 "obj/conf/cf-parse.tab.c"
    break;

  case 2168: /* dynamic_attr: KRT_REORDERING  */
#line 52 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); }
#line 17235 "obj/conf/cf-parse.tab.c"
    break;

  case 2169: /* dynamic_attr: KRT_HOPLIMIT  */
#line 53 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); }
#line 17241 "obj/conf/cf-parse.tab.c"
    break;

  case 2170: /* dynamic_attr: KRT_INITCWND  */
#line 54 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); }
#line 17247 "obj/conf/cf-parse.tab.c"
    break;

  case 2171: /* dynamic_attr: KRT_RTO_MIN  */
#line 55 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); }
#line 17253 "obj/conf/cf-parse.tab.c"
    break;

  case 2172: /* dynamic_attr: KRT_INITRWND  */
#line 56 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); }
#line 17259 "obj/conf/cf-parse.tab.c"
    break;

  case 2173: /* dynamic_attr: KRT_QUICKACK  */
#line 57 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); }
#line 17265 "obj/conf/cf-parse.tab.c"
    break;

  case 2174: /* dynamic_attr: KRT_CONGCTL  */
#line 58 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_STRING, T_STRING, EA_KRT_CONGCTL); }
#line 17271 "obj/conf/cf-parse.tab.c"
    break;

  case 2175: /* dynamic_attr: KRT_FASTOPEN_NO_COOKIE  */
#line 59 "sysdep/linux/netlink.Y"
                                     { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_FASTOPEN_NO_COOKIE); }
#line 17277 "obj/conf/cf-parse.tab.c"
    break;

  case 2176: /* dynamic_attr: KRT_LOCK_MTU  */
#line 63 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(2, T_BOOL, EA_KRT_LOCK); }
#line 17283 "obj/conf/cf-parse.tab.c"
    break;

  case 2177: /* dynamic_attr: KRT_LOCK_WINDOW  */
#line 64 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(3, T_BOOL, EA_KRT_LOCK); }
#line 17289 "obj/conf/cf-parse.tab.c"
    break;

  case 2178: /* dynamic_attr: KRT_LOCK_RTT  */
#line 65 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(4, T_BOOL, EA_KRT_LOCK); }
#line 17295 "obj/conf/cf-parse.tab.c"
    break;

  case 2179: /* dynamic_attr: KRT_LOCK_RTTVAR  */
#line 66 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(5, T_BOOL, EA_KRT_LOCK); }
#line 17301 "obj/conf/cf-parse.tab.c"
    break;

  case 2180: /* dynamic_attr: KRT_LOCK_SSTHRESH  */
#line 67 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(6, T_BOOL, EA_KRT_LOCK); }
#line 17307 "obj/conf/cf-parse.tab.c"
    break;

  case 2181: /* dynamic_attr: KRT_LOCK_SSTRESH  */
#line 68 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(6, T_BOOL, EA_KRT_LOCK);
				  cf_warn("Attribute krt_lock_sstresh is deprecated (typo), use krt_lock_ssthresh"); }
#line 17314 "obj/conf/cf-parse.tab.c"
    break;

  case 2182: /* dynamic_attr: KRT_LOCK_CWND  */
#line 70 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(7, T_BOOL, EA_KRT_LOCK); }
#line 17320 "obj/conf/cf-parse.tab.c"
    break;

  case 2183: /* dynamic_attr: KRT_LOCK_ADVMSS  */
#line 71 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(8, T_BOOL, EA_KRT_LOCK); }
#line 17326 "obj/conf/cf-parse.tab.c"
    break;

  case 2184: /* dynamic_attr: KRT_LOCK_REORDERING  */
#line 72 "sysdep/linux/netlink.Y"
                                  { (yyval.fda) = f_new_dynamic_attr_bit(9, T_BOOL, EA_KRT_LOCK); }
#line 17332 "obj/conf/cf-parse.tab.c"
    break;

  case 2185: /* dynamic_attr: KRT_LOCK_HOPLIMIT  */
#line 73 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(10, T_BOOL, EA_KRT_LOCK); }
#line 17338 "obj/conf/cf-parse.tab.c"
    break;

  case 2186: /* dynamic_attr: KRT_LOCK_INITCWND  */
#line 74 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(11, T_BOOL, EA_KRT_LOCK); }
#line 17344 "obj/conf/cf-parse.tab.c"
    break;

  case 2187: /* dynamic_attr: KRT_LOCK_RTO_MIN  */
#line 76 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(13, T_BOOL, EA_KRT_LOCK); }
#line 17350 "obj/conf/cf-parse.tab.c"
    break;

  case 2188: /* dynamic_attr: KRT_LOCK_INITRWND  */
#line 77 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(14, T_BOOL, EA_KRT_LOCK); }
#line 17356 "obj/conf/cf-parse.tab.c"
    break;

  case 2189: /* dynamic_attr: KRT_LOCK_QUICKACK  */
#line 78 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(15, T_BOOL, EA_KRT_LOCK); }
#line 17362 "obj/conf/cf-parse.tab.c"
    break;

  case 2190: /* dynamic_attr: KRT_LOCK_CONGCTL  */
#line 79 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(16, T_BOOL, EA_KRT_LOCK); }
#line 17368 "obj/conf/cf-parse.tab.c"
    break;

  case 2191: /* dynamic_attr: KRT_LOCK_FASTOPEN_NO_COOKIE  */
#line 80 "sysdep/linux/netlink.Y"
                                          { (yyval.fda) = f_new_dynamic_attr_bit(17, T_BOOL, EA_KRT_LOCK); }
#line 17374 "obj/conf/cf-parse.tab.c"
    break;

  case 2192: /* dynamic_attr: KRT_FEATURE_ECN  */
#line 82 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(0, T_BOOL, EA_KRT_FEATURES); }
#line 17380 "obj/conf/cf-parse.tab.c"
    break;

  case 2193: /* dynamic_attr: KRT_FEATURE_ALLFRAG  */
#line 83 "sysdep/linux/netlink.Y"
                                  { (yyval.fda) = f_new_dynamic_attr_bit(3, T_BOOL, EA_KRT_FEATURES); }
#line 17386 "obj/conf/cf-parse.tab.c"
    break;

  case 2196: /* log_begin: %empty  */
#line 36 "sysdep/unix/config.Y"
           { this_log = cfg_allocz(sizeof(struct log_config)); }
#line 17392 "obj/conf/cf-parse.tab.c"
    break;

  case 2197: /* log_config: LOG log_begin log_file log_mask ';'  */
#line 38 "sysdep/unix/config.Y"
                                                {
    this_log->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &this_log->n);
  }
#line 17401 "obj/conf/cf-parse.tab.c"
    break;

  case 2198: /* syslog_name: NAME text  */
#line 45 "sysdep/unix/config.Y"
             { (yyval.t) = (yyvsp[0].t); }
#line 17407 "obj/conf/cf-parse.tab.c"
    break;

  case 2199: /* syslog_name: %empty  */
#line 46 "sysdep/unix/config.Y"
   { (yyval.t) = bird_name; }
#line 17413 "obj/conf/cf-parse.tab.c"
    break;

  case 2201: /* log_limit: expr text  */
#line 51 "sysdep/unix/config.Y"
             { this_log->limit = (yyvsp[-1].i); this_log->backup = (yyvsp[0].t); }
#line 17419 "obj/conf/cf-parse.tab.c"
    break;

  case 2202: /* log_file: text log_limit  */
#line 55 "sysdep/unix/config.Y"
                  {
     if (!parse_and_exit)
     {
       this_log->rf = rf_open(new_config->pool, (yyvsp[-1].t), "a");
       if (!this_log->rf) cf_error("Unable to open log file '%s': %m", (yyvsp[-1].t));
       this_log->fh = rf_file(this_log->rf);
     }
     this_log->pos = -1;
     this_log->filename = (yyvsp[-1].t);
   }
#line 17434 "obj/conf/cf-parse.tab.c"
    break;

  case 2203: /* log_file: SYSLOG syslog_name  */
#line 65 "sysdep/unix/config.Y"
                      { this_log->fh = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 17440 "obj/conf/cf-parse.tab.c"
    break;

  case 2204: /* log_file: STDERR  */
#line 66 "sysdep/unix/config.Y"
          { this_log->fh = stderr; }
#line 17446 "obj/conf/cf-parse.tab.c"
    break;

  case 2205: /* log_file: UDP log_udp_host log_udp_port  */
#line 67 "sysdep/unix/config.Y"
                                 {
     this_log->udp_flag = 1;

     if (!parse_and_exit)
       log_open_udp(this_log, new_config->pool);
   }
#line 17457 "obj/conf/cf-parse.tab.c"
    break;

  case 2206: /* log_udp_host: text_or_ipa  */
#line 76 "sysdep/unix/config.Y"
{
  if ((yyvsp[0].v).type == T_STRING)
    this_log->host = (yyvsp[0].v).val.s;
  else if ((yyvsp[0].v).type == T_IP)
    this_log->ip = (yyvsp[0].v).val.ip;
  else bug("Bad text_or_ipa");
}
#line 17469 "obj/conf/cf-parse.tab.c"
    break;

  case 2207: /* log_udp_port: %empty  */
#line 85 "sysdep/unix/config.Y"
                { this_log->port = 514; }
#line 17475 "obj/conf/cf-parse.tab.c"
    break;

  case 2208: /* log_udp_port: PORT NUM  */
#line 86 "sysdep/unix/config.Y"
             { check_u16((yyvsp[0].i)); this_log->port = (yyvsp[0].i); }
#line 17481 "obj/conf/cf-parse.tab.c"
    break;

  case 2209: /* log_mask: ALL  */
#line 90 "sysdep/unix/config.Y"
       { (yyval.i) = ~0; }
#line 17487 "obj/conf/cf-parse.tab.c"
    break;

  case 2210: /* log_mask: '{' log_mask_list '}'  */
#line 91 "sysdep/unix/config.Y"
                         { (yyval.i) = (yyvsp[-1].i); }
#line 17493 "obj/conf/cf-parse.tab.c"
    break;

  case 2211: /* log_mask_list: log_cat  */
#line 95 "sysdep/unix/config.Y"
           { (yyval.i) = 1 << (yyvsp[0].i); }
#line 17499 "obj/conf/cf-parse.tab.c"
    break;

  case 2212: /* log_mask_list: log_mask_list ',' log_cat  */
#line 96 "sysdep/unix/config.Y"
                             { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 17505 "obj/conf/cf-parse.tab.c"
    break;

  case 2213: /* log_cat: DEBUG  */
#line 100 "sysdep/unix/config.Y"
         { (yyval.i) = L_DEBUG[0]; }
#line 17511 "obj/conf/cf-parse.tab.c"
    break;

  case 2214: /* log_cat: TRACE  */
#line 101 "sysdep/unix/config.Y"
         { (yyval.i) = L_TRACE[0]; }
#line 17517 "obj/conf/cf-parse.tab.c"
    break;

  case 2215: /* log_cat: INFO  */
#line 102 "sysdep/unix/config.Y"
        { (yyval.i) = L_INFO[0]; }
#line 17523 "obj/conf/cf-parse.tab.c"
    break;

  case 2216: /* log_cat: REMOTE  */
#line 103 "sysdep/unix/config.Y"
          { (yyval.i) = L_REMOTE[0]; }
#line 17529 "obj/conf/cf-parse.tab.c"
    break;

  case 2217: /* log_cat: WARNING  */
#line 104 "sysdep/unix/config.Y"
           { (yyval.i) = L_WARN[0]; }
#line 17535 "obj/conf/cf-parse.tab.c"
    break;

  case 2218: /* log_cat: ERROR  */
#line 105 "sysdep/unix/config.Y"
         { (yyval.i) = L_ERR[0]; }
#line 17541 "obj/conf/cf-parse.tab.c"
    break;

  case 2219: /* log_cat: AUTH  */
#line 106 "sysdep/unix/config.Y"
        { (yyval.i) = L_AUTH[0]; }
#line 17547 "obj/conf/cf-parse.tab.c"
    break;

  case 2220: /* log_cat: FATAL  */
#line 107 "sysdep/unix/config.Y"
         { (yyval.i) = L_FATAL[0]; }
#line 17553 "obj/conf/cf-parse.tab.c"
    break;

  case 2221: /* log_cat: BUG  */
#line 108 "sysdep/unix/config.Y"
       { (yyval.i) = L_BUG[0]; }
#line 17559 "obj/conf/cf-parse.tab.c"
    break;

  case 2223: /* mrtdump_base: MRTDUMP PROTOCOLS mrtdump_mask ';'  */
#line 115 "sysdep/unix/config.Y"
                                      { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 17565 "obj/conf/cf-parse.tab.c"
    break;

  case 2224: /* mrtdump_base: MRTDUMP text ';'  */
#line 116 "sysdep/unix/config.Y"
                    {
     if (!parse_and_exit)
     {
       struct rfile *f = rf_open(new_config->pool, (yyvsp[-1].t), "a");
       if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
       new_config->mrtdump_file = rf_fileno(f);
     }
   }
#line 17578 "obj/conf/cf-parse.tab.c"
    break;

  case 2226: /* cli: CLI text cli_opts  */
#line 128 "sysdep/unix/config.Y"
                       {
  this_cli_config->name = (yyvsp[-1].t);
  cli_config_add_tail(&new_config->cli, this_cli_config);
  this_cli_config = NULL;
}
#line 17588 "obj/conf/cf-parse.tab.c"
    break;

  case 2229: /* cli_opts_begin: %empty  */
#line 136 "sysdep/unix/config.Y"
                {
  this_cli_config = cfg_alloc(sizeof *this_cli_config);
  *this_cli_config = (typeof (*this_cli_config)) {
    .config = new_config,
    .mode = 0660,
  };
}
#line 17600 "obj/conf/cf-parse.tab.c"
    break;

  case 2231: /* cli_opts_block: cli_opts_block RESTRICT  */
#line 146 "sysdep/unix/config.Y"
                          { this_cli_config->restricted = 1; }
#line 17606 "obj/conf/cf-parse.tab.c"
    break;

  case 2233: /* debug_unix: DEBUG LATENCY bool  */
#line 152 "sysdep/unix/config.Y"
                      { new_config->latency_debug = (yyvsp[0].i); }
#line 17612 "obj/conf/cf-parse.tab.c"
    break;

  case 2234: /* debug_unix: DEBUG LATENCY LIMIT expr_us  */
#line 153 "sysdep/unix/config.Y"
                               { new_config->latency_limit = (yyvsp[0].time); }
#line 17618 "obj/conf/cf-parse.tab.c"
    break;

  case 2235: /* debug_unix: WATCHDOG WARNING expr_us  */
#line 154 "sysdep/unix/config.Y"
                            { new_config->watchdog_warning = (yyvsp[0].time); }
#line 17624 "obj/conf/cf-parse.tab.c"
    break;

  case 2236: /* debug_unix: WATCHDOG TIMEOUT expr_us  */
#line 155 "sysdep/unix/config.Y"
                            { new_config->watchdog_timeout = ((yyvsp[0].time) + 999999) TO_S; }
#line 17630 "obj/conf/cf-parse.tab.c"
    break;

  case 2238: /* cmd_CONFIGURE: CONFIGURE cfg_name cfg_timeout END  */
#line 164 "sysdep/unix/config.Y"
{ cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 17636 "obj/conf/cf-parse.tab.c"
    break;

  case 2240: /* cmd_CONFIGURE_SOFT: CONFIGURE SOFT cfg_name cfg_timeout END  */
#line 167 "sysdep/unix/config.Y"
{ cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 17642 "obj/conf/cf-parse.tab.c"
    break;

  case 2242: /* cmd_CONFIGURE_CONFIRM: CONFIGURE CONFIRM END  */
#line 174 "sysdep/unix/config.Y"
{ cmd_reconfig_confirm(); }
#line 17648 "obj/conf/cf-parse.tab.c"
    break;

  case 2244: /* cmd_CONFIGURE_UNDO: CONFIGURE UNDO END  */
#line 177 "sysdep/unix/config.Y"
{ cmd_reconfig_undo(); }
#line 17654 "obj/conf/cf-parse.tab.c"
    break;

  case 2246: /* cmd_CONFIGURE_STATUS: CONFIGURE STATUS END  */
#line 180 "sysdep/unix/config.Y"
{ cmd_reconfig_status(); }
#line 17660 "obj/conf/cf-parse.tab.c"
    break;

  case 2248: /* cmd_CONFIGURE_CHECK: CONFIGURE CHECK cfg_name END  */
#line 183 "sysdep/unix/config.Y"
{ cmd_check_config((yyvsp[-1].t)); }
#line 17666 "obj/conf/cf-parse.tab.c"
    break;

  case 2250: /* cmd_DOWN: DOWN END  */
#line 186 "sysdep/unix/config.Y"
{ cmd_shutdown(); }
#line 17672 "obj/conf/cf-parse.tab.c"
    break;

  case 2252: /* cmd_GRACEFUL_RESTART: GRACEFUL RESTART END  */
#line 191 "sysdep/unix/config.Y"
{ cmd_graceful_restart(); }
#line 17678 "obj/conf/cf-parse.tab.c"
    break;

  case 2253: /* cfg_name: %empty  */
#line 195 "sysdep/unix/config.Y"
               { (yyval.t) = NULL; }
#line 17684 "obj/conf/cf-parse.tab.c"
    break;

  case 2255: /* cfg_timeout: %empty  */
#line 200 "sysdep/unix/config.Y"
               { (yyval.i) = 0; }
#line 17690 "obj/conf/cf-parse.tab.c"
    break;

  case 2256: /* cfg_timeout: TIMEOUT  */
#line 201 "sysdep/unix/config.Y"
           { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 17696 "obj/conf/cf-parse.tab.c"
    break;

  case 2257: /* cfg_timeout: TIMEOUT expr  */
#line 202 "sysdep/unix/config.Y"
                { (yyval.i) = (yyvsp[0].i); }
#line 17702 "obj/conf/cf-parse.tab.c"
    break;

  case 2259: /* kern_proto_start: proto_start KERNEL  */
#line 45 "sysdep/unix/krt.Y"
                                     {
     this_proto = krt_init_config((yyvsp[-1].i));
}
#line 17710 "obj/conf/cf-parse.tab.c"
    break;

  case 2262: /* kern_learn: bool  */
#line 54 "sysdep/unix/krt.Y"
        { (yyval.i) = (yyvsp[0].i) ? KRT_LEARN_ALIEN : KRT_LEARN_NONE; }
#line 17716 "obj/conf/cf-parse.tab.c"
    break;

  case 2263: /* kern_learn: ALL  */
#line 55 "sysdep/unix/krt.Y"
        { (yyval.i) = KRT_LEARN_ALL; }
#line 17722 "obj/conf/cf-parse.tab.c"
    break;

  case 2264: /* kern_mp_limit: %empty  */
#line 59 "sysdep/unix/krt.Y"
               { (yyval.i) = KRT_DEFAULT_ECMP_LIMIT; }
#line 17728 "obj/conf/cf-parse.tab.c"
    break;

  case 2265: /* kern_mp_limit: LIMIT expr  */
#line 60 "sysdep/unix/krt.Y"
               { (yyval.i) = (yyvsp[0].i); if (((yyvsp[0].i) <= 0) || ((yyvsp[0].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); }
#line 17734 "obj/conf/cf-parse.tab.c"
    break;

  case 2269: /* kern_item: kern_channel  */
#line 71 "sysdep/unix/krt.Y"
                { this_proto->net_type = (yyvsp[0].cc)->net_type; }
#line 17740 "obj/conf/cf-parse.tab.c"
    break;

  case 2270: /* kern_item: PERSIST bool  */
#line 72 "sysdep/unix/krt.Y"
                { THIS_KRT->persist = (yyvsp[0].i); }
#line 17746 "obj/conf/cf-parse.tab.c"
    break;

  case 2271: /* kern_item: SCAN TIME expr  */
#line 73 "sysdep/unix/krt.Y"
                  {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i) S_;
   }
#line 17755 "obj/conf/cf-parse.tab.c"
    break;

  case 2272: /* kern_item: LEARN kern_learn  */
#line 77 "sysdep/unix/krt.Y"
                    {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported on this platform");
#endif
   }
#line 17767 "obj/conf/cf-parse.tab.c"
    break;

  case 2273: /* kern_item: GRACEFUL RESTART bool  */
#line 84 "sysdep/unix/krt.Y"
                         { THIS_KRT->graceful_restart = (yyvsp[0].i); }
#line 17773 "obj/conf/cf-parse.tab.c"
    break;

  case 2274: /* kern_item: MERGE PATHS bool kern_mp_limit  */
#line 85 "sysdep/unix/krt.Y"
                                  {
      THIS_KRT->merge_paths = (yyvsp[-1].i) ? (yyvsp[0].i) : 0;
#ifndef KRT_ALLOW_MERGE_PATHS
      if ((yyvsp[-1].i))
	cf_error("Path merging not supported on this platform");
#endif
   }
#line 17785 "obj/conf/cf-parse.tab.c"
    break;

  case 2276: /* kif_proto_start: proto_start DEVICE  */
#line 98 "sysdep/unix/krt.Y"
                                    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 17791 "obj/conf/cf-parse.tab.c"
    break;

  case 2281: /* kif_item: SCAN TIME expr  */
#line 107 "sysdep/unix/krt.Y"
                  {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i) S_;
   }
#line 17800 "obj/conf/cf-parse.tab.c"
    break;

  case 2282: /* kif_iface_start: %empty  */
#line 114 "sysdep/unix/krt.Y"
{
  this_ipatt = cfg_allocz(sizeof(struct kif_iface_config));
  add_tail(&THIS_KIF->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
}
#line 17810 "obj/conf/cf-parse.tab.c"
    break;

  case 2283: /* kif_iface_item: PREFERRED ipa  */
#line 121 "sysdep/unix/krt.Y"
                 { kif_set_preferred((yyvsp[0].a)); }
#line 17816 "obj/conf/cf-parse.tab.c"
    break;

  case 2289: /* dynamic_attr: KRT_SOURCE  */
#line 138 "sysdep/unix/krt.Y"
                         { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SOURCE); }
#line 17822 "obj/conf/cf-parse.tab.c"
    break;

  case 2290: /* dynamic_attr: KRT_METRIC  */
#line 139 "sysdep/unix/krt.Y"
                         { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_METRIC); }
#line 17828 "obj/conf/cf-parse.tab.c"
    break;


#line 17832 "obj/conf/cf-parse.tab.c"

        default: break;
      }
    if (yychar_backup != yychar)
      YY_LAC_DISCARD ("yychar change");
  }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yyesa, &yyes, &yyes_capacity, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        if (yychar != YYEMPTY)
          YY_LAC_ESTABLISH;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  /* If the stack popping above didn't lose the initial context for the
     current lookahead token, the shift below will for sure.  */
  YY_LAC_DISCARD ("error recovery");

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yyes != yyesa)
    YYSTACK_FREE (yyes);
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 61 "conf/gen_parser.m4"

#line 456 "conf/confbase.Y"
/* C Code from conf/confbase.Y */

#line 206 "conf/flowspec.Y"
/* C Code from conf/flowspec.Y */

#line 981 "nest/config.Y"
/* C Code from nest/config.Y */

#line 198 "nest/mpls.Y"
/* C Code from nest/mpls.Y */

#line 132 "proto/aggregator/config.Y"
/* C Code from proto/aggregator/config.Y */

#line 262 "proto/bfd/config.Y"
/* C Code from proto/bfd/config.Y */

#line 206 "proto/babel/config.Y"
/* C Code from proto/babel/config.Y */

#line 565 "proto/bgp/config.Y"
/* C Code from proto/bgp/config.Y */

#line 99 "proto/l3vpn/config.Y"
/* C Code from proto/l3vpn/config.Y */

#line 71 "proto/mrt/config.Y"
/* C Code from proto/mrt/config.Y */

#line 571 "proto/ospf/config.Y"
/* C Code from proto/ospf/config.Y */

#line 59 "proto/perf/config.Y"
/* C Code from proto/perf/config.Y */

#line 46 "proto/pipe/config.Y"
/* C Code from proto/pipe/config.Y */

#line 356 "proto/radv/config.Y"
/* C Code from proto/radv/config.Y */

#line 206 "proto/rip/config.Y"
/* C Code from proto/rip/config.Y */

#line 184 "proto/rpki/config.Y"
/* C Code from proto/rpki/config.Y */

#line 206 "proto/static/config.Y"
/* C Code from proto/static/config.Y */

#line 86 "sysdep/linux/netlink.Y"
/* C Code from sysdep/linux/netlink.Y */

#line 205 "sysdep/unix/config.Y"
/* C Code from sysdep/unix/config.Y */

#line 141 "sysdep/unix/krt.Y"
/* C Code from sysdep/unix/krt.Y */

